SET NAMESPACE 'http://www.teiid.org/ext/relational/2012' AS teiid_rel;

CREATE FOREIGN PROCEDURE customerAddressRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN addressId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete customer address by ID.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/addresses/{addressId}');

CREATE FOREIGN PROCEDURE customerCustomerMetadataV1GetAllAttributesMetadataGet() RETURNS TABLE (attribute_code string, backend_type string, data_model string, frontend_class string, frontend_input string, frontend_label string, input_filter string, is_filterable_in_grid boolean, is_searchable_in_grid boolean, is_used_in_grid boolean, is_visible_in_grid boolean, multiline_count string, note string, "options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/value'), "options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/value'), required boolean, sort_order string, store_label string, "system" boolean, user_defined boolean, "validation_rules_customer-data-validation-rule-interface_name" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/name'), "validation_rules_customer-data-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/value'), visible boolean)
OPTIONS (ANNOTATION 'Get all attribute metadata.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/attributeMetadata/customer');

CREATE FOREIGN PROCEDURE customerCustomerMetadataV1GetAttributeMetadataGet(IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (attribute_code string, backend_type string, data_model string, frontend_class string, frontend_input string, frontend_label string, input_filter string, is_filterable_in_grid boolean, is_searchable_in_grid boolean, is_used_in_grid boolean, is_visible_in_grid boolean, multiline_count string, note string, "options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/value'), "options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/value'), required boolean, sort_order string, store_label string, "system" boolean, user_defined boolean, "validation_rules_customer-data-validation-rule-interface_name" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/name'), "validation_rules_customer-data-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/value'), visible boolean)
OPTIONS (ANNOTATION 'Retrieve attribute metadata.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/attributeMetadata/customer/attribute/{attributeCode}');

CREATE FOREIGN PROCEDURE customerCustomerMetadataV1GetCustomAttributesMetadataGet(IN dataInterfaceName string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (attribute_code string, backend_type string, data_model string, frontend_class string, frontend_input string, frontend_label string, input_filter string, is_filterable_in_grid boolean, is_searchable_in_grid boolean, is_used_in_grid boolean, is_visible_in_grid boolean, multiline_count string, note string, "options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/value'), "options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/value'), required boolean, sort_order string, store_label string, "system" boolean, user_defined boolean, "validation_rules_customer-data-validation-rule-interface_name" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/name'), "validation_rules_customer-data-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/value'), visible boolean)
OPTIONS (ANNOTATION 'Get custom attributes metadata for the given data interface.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/attributeMetadata/customer/custom');

CREATE FOREIGN PROCEDURE customerCustomerMetadataV1GetAttributesGet(IN formCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (attribute_code string, backend_type string, data_model string, frontend_class string, frontend_input string, frontend_label string, input_filter string, is_filterable_in_grid boolean, is_searchable_in_grid boolean, is_used_in_grid boolean, is_visible_in_grid boolean, multiline_count string, note string, "options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/value'), "options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/value'), required boolean, sort_order string, store_label string, "system" boolean, user_defined boolean, "validation_rules_customer-data-validation-rule-interface_name" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/name'), "validation_rules_customer-data-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/value'), visible boolean)
OPTIONS (ANNOTATION 'Retrieve all attributes filtered by form code', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/attributeMetadata/customer/form/{formCode}');

CREATE FOREIGN PROCEDURE customerAddressMetadataV1GetAllAttributesMetadataGet() RETURNS TABLE (attribute_code string, backend_type string, data_model string, frontend_class string, frontend_input string, frontend_label string, input_filter string, is_filterable_in_grid boolean, is_searchable_in_grid boolean, is_used_in_grid boolean, is_visible_in_grid boolean, multiline_count string, note string, "options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/value'), "options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/value'), required boolean, sort_order string, store_label string, "system" boolean, user_defined boolean, "validation_rules_customer-data-validation-rule-interface_name" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/name'), "validation_rules_customer-data-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/value'), visible boolean)
OPTIONS (ANNOTATION 'Get all attribute metadata.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/attributeMetadata/customerAddress');

CREATE FOREIGN PROCEDURE customerAddressMetadataV1GetAttributeMetadataGet(IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (attribute_code string, backend_type string, data_model string, frontend_class string, frontend_input string, frontend_label string, input_filter string, is_filterable_in_grid boolean, is_searchable_in_grid boolean, is_used_in_grid boolean, is_visible_in_grid boolean, multiline_count string, note string, "options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/value'), "options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/value'), required boolean, sort_order string, store_label string, "system" boolean, user_defined boolean, "validation_rules_customer-data-validation-rule-interface_name" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/name'), "validation_rules_customer-data-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/value'), visible boolean)
OPTIONS (ANNOTATION 'Retrieve attribute metadata.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/attributeMetadata/customerAddress/attribute/{attributeCode}');

CREATE FOREIGN PROCEDURE customerAddressMetadataV1GetCustomAttributesMetadataGet(IN dataInterfaceName string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (attribute_code string, backend_type string, data_model string, frontend_class string, frontend_input string, frontend_label string, input_filter string, is_filterable_in_grid boolean, is_searchable_in_grid boolean, is_used_in_grid boolean, is_visible_in_grid boolean, multiline_count string, note string, "options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/value'), "options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/value'), required boolean, sort_order string, store_label string, "system" boolean, user_defined boolean, "validation_rules_customer-data-validation-rule-interface_name" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/name'), "validation_rules_customer-data-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/value'), visible boolean)
OPTIONS (ANNOTATION 'Get custom attributes metadata for the given data interface.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/attributeMetadata/customerAddress/custom');

CREATE FOREIGN PROCEDURE customerAddressMetadataV1GetAttributesGet(IN formCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (attribute_code string, backend_type string, data_model string, frontend_class string, frontend_input string, frontend_label string, input_filter string, is_filterable_in_grid boolean, is_searchable_in_grid boolean, is_used_in_grid boolean, is_visible_in_grid boolean, multiline_count string, note string, "options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/value'), "options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/value'), required boolean, sort_order string, store_label string, "system" boolean, user_defined boolean, "validation_rules_customer-data-validation-rule-interface_name" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/name'), "validation_rules_customer-data-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/value'), visible boolean)
OPTIONS (ANNOTATION 'Retrieve all attributes filtered by form code', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/attributeMetadata/customerAddress/form/{formCode}');

CREATE FOREIGN PROCEDURE bundleProductOptionManagementV1SavePost(OUT "return" string RESULT, IN option_option_id string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'option/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_position string NOT NULL OPTIONS (ANNOTATION 'Option position', NAMEINSOURCE 'option/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_product_links_bundle-data-link-interface_can_change_quantity" string NOT NULL OPTIONS (ANNOTATION 'Whether quantity could be changed', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/can_change_quantity', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_product_links_bundle-data-link-interface_id" string NOT NULL OPTIONS (ANNOTATION 'The identifier', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_product_links_bundle-data-link-interface_is_default" boolean NOT NULL OPTIONS (ANNOTATION 'Is default', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/is_default', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_product_links_bundle-data-link-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_product_links_bundle-data-link-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Position', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_product_links_bundle-data-link-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_product_links_bundle-data-link-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_product_links_bundle-data-link-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Qty', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_product_links_bundle-data-link-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Linked product sku', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_required boolean NOT NULL OPTIONS (ANNOTATION 'Is required option', NAMEINSOURCE 'option/required', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_sku string NOT NULL OPTIONS (ANNOTATION 'Product sku', NAMEINSOURCE 'option/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_title string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'option/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_type string NOT NULL OPTIONS (ANNOTATION 'Input type', NAMEINSOURCE 'option/type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Add new option for bundle product', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/bundle-products/options/add');

CREATE FOREIGN PROCEDURE bundleProductOptionTypeListV1GetItemsGet() RETURNS TABLE (code string, label string)
OPTIONS (ANNOTATION 'Get all types for options for bundle products', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/bundle-products/options/types');

CREATE FOREIGN PROCEDURE bundleProductOptionManagementV1SavePut(OUT "return" string RESULT, IN optionId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN option_option_id string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'option/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_position string NOT NULL OPTIONS (ANNOTATION 'Option position', NAMEINSOURCE 'option/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_product_links_bundle-data-link-interface_can_change_quantity" string NOT NULL OPTIONS (ANNOTATION 'Whether quantity could be changed', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/can_change_quantity', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_product_links_bundle-data-link-interface_id" string NOT NULL OPTIONS (ANNOTATION 'The identifier', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_product_links_bundle-data-link-interface_is_default" boolean NOT NULL OPTIONS (ANNOTATION 'Is default', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/is_default', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_product_links_bundle-data-link-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_product_links_bundle-data-link-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Position', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_product_links_bundle-data-link-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_product_links_bundle-data-link-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_product_links_bundle-data-link-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Qty', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_product_links_bundle-data-link-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Linked product sku', NAMEINSOURCE 'option/product_links[]/bundle-data-link-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_required boolean NOT NULL OPTIONS (ANNOTATION 'Is required option', NAMEINSOURCE 'option/required', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_sku string NOT NULL OPTIONS (ANNOTATION 'Product sku', NAMEINSOURCE 'option/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_title string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'option/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_type string NOT NULL OPTIONS (ANNOTATION 'Input type', NAMEINSOURCE 'option/type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Add new option for bundle product', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/bundle-products/options/{optionId}');

CREATE FOREIGN PROCEDURE bundleProductLinkManagementV1GetChildrenGet(IN productSku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN optionId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (can_change_quantity string, id string, is_default boolean, option_id string, position string, price string, price_type string, qty string, sku string)
OPTIONS (ANNOTATION 'Get all children for Bundle product', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/bundle-products/{productSku}/children');

CREATE FOREIGN PROCEDURE bundleProductLinkManagementV1SaveChildPut(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN linkedProduct_can_change_quantity string NOT NULL OPTIONS (ANNOTATION 'Whether quantity could be changed', NAMEINSOURCE 'linkedProduct/can_change_quantity', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN linkedProduct_id string NOT NULL OPTIONS (ANNOTATION 'The identifier', NAMEINSOURCE 'linkedProduct/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN linkedProduct_is_default boolean NOT NULL OPTIONS (ANNOTATION 'Is default', NAMEINSOURCE 'linkedProduct/is_default', "teiid_rest:PARAMETER_TYPE" 'body'), IN linkedProduct_option_id string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'linkedProduct/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN linkedProduct_position string NOT NULL OPTIONS (ANNOTATION 'Position', NAMEINSOURCE 'linkedProduct/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN linkedProduct_price string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'linkedProduct/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN linkedProduct_price_type string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'linkedProduct/price_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN linkedProduct_qty string NOT NULL OPTIONS (ANNOTATION 'Qty', NAMEINSOURCE 'linkedProduct/qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN linkedProduct_sku string NOT NULL OPTIONS (ANNOTATION 'Linked product sku', NAMEINSOURCE 'linkedProduct/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS ("teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/bundle-products/{sku}/links/{id}');

CREATE FOREIGN PROCEDURE bundleProductLinkManagementV1AddChildByProductSkuPost(OUT "return" string RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN optionId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN linkedProduct_can_change_quantity string NOT NULL OPTIONS (ANNOTATION 'Whether quantity could be changed', NAMEINSOURCE 'linkedProduct/can_change_quantity', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN linkedProduct_id string NOT NULL OPTIONS (ANNOTATION 'The identifier', NAMEINSOURCE 'linkedProduct/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN linkedProduct_is_default boolean NOT NULL OPTIONS (ANNOTATION 'Is default', NAMEINSOURCE 'linkedProduct/is_default', "teiid_rest:PARAMETER_TYPE" 'body'), IN linkedProduct_option_id string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'linkedProduct/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN linkedProduct_position string NOT NULL OPTIONS (ANNOTATION 'Position', NAMEINSOURCE 'linkedProduct/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN linkedProduct_price string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'linkedProduct/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN linkedProduct_price_type string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'linkedProduct/price_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN linkedProduct_qty string NOT NULL OPTIONS (ANNOTATION 'Qty', NAMEINSOURCE 'linkedProduct/qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN linkedProduct_sku string NOT NULL OPTIONS (ANNOTATION 'Linked product sku', NAMEINSOURCE 'linkedProduct/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Add child product to specified Bundle option by product sku', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/bundle-products/{sku}/links/{optionId}');

CREATE FOREIGN PROCEDURE bundleProductOptionRepositoryV1GetListGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (option_id string, position string, "product_links_bundle-data-link-interface_can_change_quantity" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/can_change_quantity'), "product_links_bundle-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/id'), "product_links_bundle-data-link-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/is_default'), "product_links_bundle-data-link-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/option_id'), "product_links_bundle-data-link-interface_position" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/position'), "product_links_bundle-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/price'), "product_links_bundle-data-link-interface_price_type" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/price_type'), "product_links_bundle-data-link-interface_qty" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/qty'), "product_links_bundle-data-link-interface_sku" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/sku'), required boolean, sku string, title string, type string)
OPTIONS (ANNOTATION 'Get all options for bundle product', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/bundle-products/{sku}/options/all');

CREATE FOREIGN PROCEDURE bundleProductOptionRepositoryV1GetGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN optionId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (option_id string, position string, "product_links_bundle-data-link-interface_can_change_quantity" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/can_change_quantity'), "product_links_bundle-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/id'), "product_links_bundle-data-link-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/is_default'), "product_links_bundle-data-link-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/option_id'), "product_links_bundle-data-link-interface_position" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/position'), "product_links_bundle-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/price'), "product_links_bundle-data-link-interface_price_type" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/price_type'), "product_links_bundle-data-link-interface_qty" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/qty'), "product_links_bundle-data-link-interface_sku" string OPTIONS (NAMEINSOURCE 'product_links[]/bundle-data-link-interface/sku'), required boolean, sku string, title string, type string)
OPTIONS (ANNOTATION 'Get option for bundle product', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/bundle-products/{sku}/options/{optionId}');

CREATE FOREIGN PROCEDURE bundleProductOptionRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN optionId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove bundle option', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/bundle-products/{sku}/options/{optionId}');

CREATE FOREIGN PROCEDURE bundleProductLinkManagementV1RemoveChildDelete(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN optionId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN childSku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove product from Bundle product option', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/bundle-products/{sku}/options/{optionId}/children/{childSku}');

CREATE FOREIGN PROCEDURE quoteCartManagementV1CreateEmptyCartPost(OUT "return" string RESULT) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Creates an empty cart and quote for a guest.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/');

CREATE FOREIGN PROCEDURE giftCardAccountGuestGiftCardAccountManagementV1CheckGiftCardGet(OUT "return" string RESULT, IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN giftCardCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS ("teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/guest-carts/{cartId}/checkGiftCard/{giftCardCode}');

CREATE FOREIGN PROCEDURE giftCardAccountGuestGiftCardAccountManagementV1AddGiftCardPost(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN giftCardAccountData_base_gift_cards_amount string NOT NULL OPTIONS (ANNOTATION 'Cards amount in base currency', NAMEINSOURCE 'giftCardAccountData/base_gift_cards_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftCardAccountData_base_gift_cards_amount_used string NOT NULL OPTIONS (ANNOTATION 'Cards amount used in base currency', NAMEINSOURCE 'giftCardAccountData/base_gift_cards_amount_used', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftCardAccountData_gift_cards string[] NOT NULL OPTIONS (NAMEINSOURCE 'giftCardAccountData/gift_cards', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftCardAccountData_gift_cards_amount string NOT NULL OPTIONS (ANNOTATION 'Cards amount in quote currency', NAMEINSOURCE 'giftCardAccountData/gift_cards_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftCardAccountData_gift_cards_amount_used string NOT NULL OPTIONS (ANNOTATION 'Cards amount used in quote currency', NAMEINSOURCE 'giftCardAccountData/gift_cards_amount_used', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS ("teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/guest-carts/{cartId}/giftCards');

CREATE FOREIGN PROCEDURE giftCardAccountGuestGiftCardAccountManagementV1DeleteByQuoteIdDelete(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN giftCardCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove GiftCard Account entity', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/guest-carts/{cartId}/giftCards/{giftCardCode}');

CREATE FOREIGN PROCEDURE checkoutAgreementsCheckoutAgreementsRepositoryV1GetListGet() RETURNS TABLE (agreement_id string, checkbox_text string, content string, content_height string, is_active boolean, is_html boolean, mode string, name string)
OPTIONS (ANNOTATION 'Lists active checkout agreements.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/licence');

CREATE FOREIGN PROCEDURE quoteCartManagementV1GetCartForCustomerGet() RETURNS TABLE (billing_address_city string OPTIONS (NAMEINSOURCE 'billing_address/city'), billing_address_company string OPTIONS (NAMEINSOURCE 'billing_address/company'), billing_address_country_id string OPTIONS (NAMEINSOURCE 'billing_address/country_id'), "billing_address_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'billing_address/custom_attributes[]/framework-attribute-interface/attribute_code'), "billing_address_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'billing_address/custom_attributes[]/framework-attribute-interface/value'), billing_address_customer_address_id string OPTIONS (NAMEINSOURCE 'billing_address/customer_address_id'), billing_address_customer_id string OPTIONS (NAMEINSOURCE 'billing_address/customer_id'), billing_address_email string OPTIONS (NAMEINSOURCE 'billing_address/email'), billing_address_extension_attributes_gift_registry_id string OPTIONS (NAMEINSOURCE 'billing_address/extension_attributes/gift_registry_id'), billing_address_fax string OPTIONS (NAMEINSOURCE 'billing_address/fax'), billing_address_firstname string OPTIONS (NAMEINSOURCE 'billing_address/firstname'), billing_address_id string OPTIONS (NAMEINSOURCE 'billing_address/id'), billing_address_lastname string OPTIONS (NAMEINSOURCE 'billing_address/lastname'), billing_address_middlename string OPTIONS (NAMEINSOURCE 'billing_address/middlename'), billing_address_postcode string OPTIONS (NAMEINSOURCE 'billing_address/postcode'), billing_address_prefix string OPTIONS (NAMEINSOURCE 'billing_address/prefix'), billing_address_region string OPTIONS (NAMEINSOURCE 'billing_address/region'), billing_address_region_code string OPTIONS (NAMEINSOURCE 'billing_address/region_code'), billing_address_region_id string OPTIONS (NAMEINSOURCE 'billing_address/region_id'), billing_address_same_as_billing string OPTIONS (NAMEINSOURCE 'billing_address/same_as_billing'), billing_address_save_in_address_book string OPTIONS (NAMEINSOURCE 'billing_address/save_in_address_book'), billing_address_street string[] OPTIONS (NAMEINSOURCE 'billing_address/street'), billing_address_suffix string OPTIONS (NAMEINSOURCE 'billing_address/suffix'), billing_address_telephone string OPTIONS (NAMEINSOURCE 'billing_address/telephone'), billing_address_vat_id string OPTIONS (NAMEINSOURCE 'billing_address/vat_id'), converted_at string, created_at string, currency_base_currency_code string OPTIONS (NAMEINSOURCE 'currency/base_currency_code'), currency_base_to_global_rate string OPTIONS (NAMEINSOURCE 'currency/base_to_global_rate'), currency_base_to_quote_rate string OPTIONS (NAMEINSOURCE 'currency/base_to_quote_rate'), currency_global_currency_code string OPTIONS (NAMEINSOURCE 'currency/global_currency_code'), currency_quote_currency_code string OPTIONS (NAMEINSOURCE 'currency/quote_currency_code'), currency_store_currency_code string OPTIONS (NAMEINSOURCE 'currency/store_currency_code'), currency_store_to_base_rate string OPTIONS (NAMEINSOURCE 'currency/store_to_base_rate'), currency_store_to_quote_rate string OPTIONS (NAMEINSOURCE 'currency/store_to_quote_rate'), "customer_addresses_customer-data-address-interface_city" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/city'), "customer_addresses_customer-data-address-interface_company" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/company'), "customer_addresses_customer-data-address-interface_country_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/country_id'), "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value'), "customer_addresses_customer-data-address-interface_customer_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/customer_id'), "customer_addresses_customer-data-address-interface_default_billing" boolean OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_billing'), "customer_addresses_customer-data-address-interface_default_shipping" boolean OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_shipping'), "customer_addresses_customer-data-address-interface_fax" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/fax'), "customer_addresses_customer-data-address-interface_firstname" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/firstname'), "customer_addresses_customer-data-address-interface_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/id'), "customer_addresses_customer-data-address-interface_lastname" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/lastname'), "customer_addresses_customer-data-address-interface_middlename" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/middlename'), "customer_addresses_customer-data-address-interface_postcode" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/postcode'), "customer_addresses_customer-data-address-interface_prefix" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/prefix'), "customer_addresses_customer-data-address-interface_region_region" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region'), "customer_addresses_customer-data-address-interface_region_region_code" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_code'), "customer_addresses_customer-data-address-interface_region_region_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_id'), "customer_addresses_customer-data-address-interface_region_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region_id'), "customer_addresses_customer-data-address-interface_street" string[] OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/street'), "customer_addresses_customer-data-address-interface_suffix" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/suffix'), "customer_addresses_customer-data-address-interface_telephone" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/telephone'), "customer_addresses_customer-data-address-interface_vat_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/vat_id'), customer_confirmation string OPTIONS (NAMEINSOURCE 'customer/confirmation'), customer_created_at string OPTIONS (NAMEINSOURCE 'customer/created_at'), customer_created_in string OPTIONS (NAMEINSOURCE 'customer/created_in'), "customer_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/attribute_code'), "customer_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/value'), customer_default_billing string OPTIONS (NAMEINSOURCE 'customer/default_billing'), customer_default_shipping string OPTIONS (NAMEINSOURCE 'customer/default_shipping'), customer_disable_auto_group_change string OPTIONS (NAMEINSOURCE 'customer/disable_auto_group_change'), customer_dob string OPTIONS (NAMEINSOURCE 'customer/dob'), customer_email string OPTIONS (NAMEINSOURCE 'customer/email'), customer_extension_attributes_is_subscribed boolean OPTIONS (NAMEINSOURCE 'customer/extension_attributes/is_subscribed'), customer_firstname string OPTIONS (NAMEINSOURCE 'customer/firstname'), customer_gender string OPTIONS (NAMEINSOURCE 'customer/gender'), customer_group_id string OPTIONS (NAMEINSOURCE 'customer/group_id'), customer_id string OPTIONS (NAMEINSOURCE 'customer/id'), customer_lastname string OPTIONS (NAMEINSOURCE 'customer/lastname'), customer_middlename string OPTIONS (NAMEINSOURCE 'customer/middlename'), customer_prefix string OPTIONS (NAMEINSOURCE 'customer/prefix'), customer_store_id string OPTIONS (NAMEINSOURCE 'customer/store_id'), customer_suffix string OPTIONS (NAMEINSOURCE 'customer/suffix'), customer_taxvat string OPTIONS (NAMEINSOURCE 'customer/taxvat'), customer_updated_at string OPTIONS (NAMEINSOURCE 'customer/updated_at'), customer_website_id string OPTIONS (NAMEINSOURCE 'customer/website_id'), customer_is_guest boolean, customer_note string, customer_note_notify boolean, customer_tax_class_id string, "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/item_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/name'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/price'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_type'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/qty'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_quote_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/quote_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/sku'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_city" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/city'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_company" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/company'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_country_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/country_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/custom_attributes[]/framework-attribute-interface/attribute_code'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/custom_attributes[]/framework-attribute-interface/value'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_customer_address_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/customer_address_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_customer_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/customer_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/email'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_extension_attributes_gift_registry_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/extension_attributes/gift_registry_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_fax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/fax'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_firstname" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/firstname'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_lastname" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/lastname'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_middlename" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/middlename'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_postcode" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/postcode'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_prefix" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/prefix'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region_code'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_same_as_billing" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/same_as_billing'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_save_in_address_book" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/save_in_address_book'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_street" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/street'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_suffix" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/suffix'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_telephone" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/telephone'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_vat_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/vat_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_method" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/method'), id string, is_active boolean, is_virtual boolean, "items_quote-data-cart-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/item_id'), "items_quote-data-cart-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/name'), "items_quote-data-cart-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/price'), "items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_quote-data-cart-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_quote-data-cart-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_type'), "items_quote-data-cart-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/qty'), "items_quote-data-cart-item-interface_quote_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/quote_id'), "items_quote-data-cart-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/sku'), items_count string, items_qty string, orig_order_id string, reserved_order_id string, store_id string, updated_at string)
OPTIONS (ANNOTATION 'Returns information for the cart for a specified customer.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine');

CREATE FOREIGN PROCEDURE quoteCartRepositoryV1SavePut(IN quote_billing_address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'quote/billing_address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_billing_address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'quote/billing_address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_billing_address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'quote/billing_address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_billing_address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'quote/billing_address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_billing_address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'quote/billing_address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_billing_address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'quote/billing_address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_billing_address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'quote/billing_address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_billing_address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'quote/billing_address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_billing_address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'quote/billing_address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_billing_address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'quote/billing_address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_billing_address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'quote/billing_address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_billing_address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'quote/billing_address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_billing_address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'quote/billing_address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_billing_address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'quote/billing_address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_billing_address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'quote/billing_address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_billing_address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'quote/billing_address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_billing_address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'quote/billing_address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_billing_address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'quote/billing_address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_billing_address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'quote/billing_address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_billing_address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'quote/billing_address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_billing_address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'quote/billing_address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_billing_address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'quote/billing_address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_billing_address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'quote/billing_address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_billing_address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'quote/billing_address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_billing_address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'quote/billing_address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_converted_at string NOT NULL OPTIONS (ANNOTATION 'Cart conversion date and time. Otherwise, null.', NAMEINSOURCE 'quote/converted_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_created_at string NOT NULL OPTIONS (ANNOTATION 'Cart creation date and time. Otherwise, null.', NAMEINSOURCE 'quote/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_currency_base_currency_code string NOT NULL OPTIONS (ANNOTATION 'Base currency code', NAMEINSOURCE 'quote/currency/base_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_currency_base_to_global_rate string NOT NULL OPTIONS (ANNOTATION 'Base currency to global currency rate', NAMEINSOURCE 'quote/currency/base_to_global_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_currency_base_to_quote_rate string NOT NULL OPTIONS (ANNOTATION 'Base currency to quote currency rate', NAMEINSOURCE 'quote/currency/base_to_quote_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_currency_global_currency_code string NOT NULL OPTIONS (ANNOTATION 'Global currency code', NAMEINSOURCE 'quote/currency/global_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_currency_quote_currency_code string NOT NULL OPTIONS (ANNOTATION 'Quote currency code', NAMEINSOURCE 'quote/currency/quote_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_currency_store_currency_code string NOT NULL OPTIONS (ANNOTATION 'Store currency code', NAMEINSOURCE 'quote/currency/store_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_currency_store_to_base_rate string NOT NULL OPTIONS (ANNOTATION 'Store currency to base currency rate', NAMEINSOURCE 'quote/currency/store_to_base_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_currency_store_to_quote_rate string NOT NULL OPTIONS (ANNOTATION 'Store currency to quote currency rate', NAMEINSOURCE 'quote/currency/store_to_quote_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_city" string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/city', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_company" string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_country_id" string NOT NULL OPTIONS (ANNOTATION 'Country code in ISO_3166-2 format', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/country_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_customer_addresses_customer-data-address-interface_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_default_billing" boolean NOT NULL OPTIONS (ANNOTATION 'If this address is default billing address', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/default_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_default_shipping" boolean NOT NULL OPTIONS (ANNOTATION 'If this address is default shipping address.', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/default_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_fax" string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_firstname" string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/firstname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_id" string NOT NULL OPTIONS (ANNOTATION 'ID', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_lastname" string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/lastname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_middlename" string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_postcode" string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/postcode', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_prefix" string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_region_region" string NOT NULL OPTIONS (ANNOTATION 'Region', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/region/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_customer_addresses_customer-data-address-interface_region_region_code" string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/region/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_customer_addresses_customer-data-address-interface_region_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/region/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_customer_addresses_customer-data-address-interface_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region ID', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/region_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_street" string[] NOT NULL OPTIONS (NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_suffix" string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_telephone" string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/telephone', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_addresses_customer-data-address-interface_vat_id" string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'quote/customer/addresses[]/customer-data-address-interface/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_confirmation string NOT NULL OPTIONS (ANNOTATION 'Confirmation', NAMEINSOURCE 'quote/customer/confirmation', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_created_at string NOT NULL OPTIONS (ANNOTATION 'Created at time', NAMEINSOURCE 'quote/customer/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_created_in string NOT NULL OPTIONS (ANNOTATION 'Created in area', NAMEINSOURCE 'quote/customer/created_in', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_customer_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'quote/customer/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_customer_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'quote/customer/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_customer_default_billing string NOT NULL OPTIONS (ANNOTATION 'Default billing address id', NAMEINSOURCE 'quote/customer/default_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_default_shipping string NOT NULL OPTIONS (ANNOTATION 'Default shipping address id', NAMEINSOURCE 'quote/customer/default_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_disable_auto_group_change string NOT NULL OPTIONS (ANNOTATION 'Disable auto group change flag.', NAMEINSOURCE 'quote/customer/disable_auto_group_change', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_dob string NOT NULL OPTIONS (ANNOTATION 'Date of birth', NAMEINSOURCE 'quote/customer/dob', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_email string NOT NULL OPTIONS (ANNOTATION 'Email address', NAMEINSOURCE 'quote/customer/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_customer_extension_attributes_is_subscribed boolean NOT NULL OPTIONS (NAMEINSOURCE 'quote/customer/extension_attributes/is_subscribed', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'quote/customer/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_customer_gender string NOT NULL OPTIONS (ANNOTATION 'Gender', NAMEINSOURCE 'quote/customer/gender', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_group_id string NOT NULL OPTIONS (ANNOTATION 'Group id', NAMEINSOURCE 'quote/customer/group_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'quote/customer/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'quote/customer/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_customer_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'quote/customer/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'quote/customer/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_store_id string NOT NULL OPTIONS (ANNOTATION 'Store id', NAMEINSOURCE 'quote/customer/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'quote/customer/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_taxvat string NOT NULL OPTIONS (ANNOTATION 'Tax Vat', NAMEINSOURCE 'quote/customer/taxvat', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated at time', NAMEINSOURCE 'quote/customer/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_website_id string NOT NULL OPTIONS (ANNOTATION 'Website id', NAMEINSOURCE 'quote/customer/website_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_is_guest boolean NOT NULL OPTIONS (ANNOTATION 'For guest customers, false for logged in customers', NAMEINSOURCE 'quote/customer_is_guest', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_note string NOT NULL OPTIONS (ANNOTATION 'Notice text', NAMEINSOURCE 'quote/customer_note', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_note_notify boolean NOT NULL OPTIONS (ANNOTATION 'Customer notification flag', NAMEINSOURCE 'quote/customer_note_notify', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_customer_tax_class_id string NOT NULL OPTIONS (ANNOTATION 'Customer tax class ID.', NAMEINSOURCE 'quote/customer_tax_class_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_item_id" string NOT NULL OPTIONS (ANNOTATION 'Item ID. Otherwise, null.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_name" string NOT NULL OPTIONS (ANNOTATION 'Product name. Otherwise, null.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Product price. Otherwise, null.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] NOT NULL OPTIONS (NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_type" string NOT NULL OPTIONS (ANNOTATION 'Product type. Otherwise, null.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Product quantity.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_quote_id" string NOT NULL OPTIONS (ANNOTATION 'Quote id.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/quote_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Product SKU. Otherwise, null.', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_city" string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_company" string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_country_id" string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_customer_address_id" string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_email" string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_extension_attributes_gift_registry_id" string NOT NULL OPTIONS (NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_fax" string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_firstname" string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_id" string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_lastname" string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_middlename" string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_postcode" string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_prefix" string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region" string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region_code" string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_same_as_billing" string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_save_in_address_book" string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_street" string[] NOT NULL OPTIONS (NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_suffix" string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_telephone" string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_vat_id" string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_method" string NOT NULL OPTIONS (ANNOTATION 'Shipping method', NAMEINSOURCE 'quote/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_id string NOT NULL OPTIONS (ANNOTATION 'Cart/quote ID.', NAMEINSOURCE 'quote/id', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_is_active boolean NOT NULL OPTIONS (ANNOTATION 'Active status flag value. Otherwise, null.', NAMEINSOURCE 'quote/is_active', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_is_virtual boolean NOT NULL OPTIONS (ANNOTATION 'Virtual flag value. Otherwise, null.', NAMEINSOURCE 'quote/is_virtual', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_items_quote-data-cart-item-interface_item_id" string NOT NULL OPTIONS (ANNOTATION 'Item ID. Otherwise, null.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_items_quote-data-cart-item-interface_name" string NOT NULL OPTIONS (ANNOTATION 'Product name. Otherwise, null.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_items_quote-data-cart-item-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Product price. Otherwise, null.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] NOT NULL OPTIONS (NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_product_type" string NOT NULL OPTIONS (ANNOTATION 'Product type. Otherwise, null.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "quote_items_quote-data-cart-item-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Product quantity.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_quote_id" string NOT NULL OPTIONS (ANNOTATION 'Quote id.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/quote_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "quote_items_quote-data-cart-item-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Product SKU. Otherwise, null.', NAMEINSOURCE 'quote/items[]/quote-data-cart-item-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_items_count string NOT NULL OPTIONS (ANNOTATION 'Number of different items or products in the cart. Otherwise, null.', NAMEINSOURCE 'quote/items_count', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_items_qty string NOT NULL OPTIONS (ANNOTATION 'Total quantity of all cart items. Otherwise, null.', NAMEINSOURCE 'quote/items_qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_orig_order_id string NOT NULL OPTIONS (ANNOTATION 'Original order ID. Otherwise, null.', NAMEINSOURCE 'quote/orig_order_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_reserved_order_id string NOT NULL OPTIONS (ANNOTATION 'Reserved order ID. Otherwise, null.', NAMEINSOURCE 'quote/reserved_order_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN quote_store_id string NOT NULL OPTIONS (ANNOTATION 'Store identifier', NAMEINSOURCE 'quote/store_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN quote_updated_at string NOT NULL OPTIONS (ANNOTATION 'Cart last update date and time. Otherwise, null.', NAMEINSOURCE 'quote/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Save quote', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine');

CREATE FOREIGN PROCEDURE "V1/carts/mine_POST"(OUT "return" string RESULT) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Creates an empty cart and quote for a specified customer.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine');

CREATE FOREIGN PROCEDURE customerBalanceBalanceManagementV1ApplyPost(OUT "return" boolean RESULT) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Apply store credit', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/balance/apply');

CREATE FOREIGN PROCEDURE "V1/carts/mine/billing-address_GET"() RETURNS TABLE (city string, company string, country_id string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), customer_address_id string, customer_id string, email string, extension_attributes_gift_registry_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_registry_id'), fax string, firstname string, id string, lastname string, middlename string, postcode string, prefix string, region string, region_code string, region_id string, same_as_billing string, save_in_address_book string, street string[], suffix string, telephone string, vat_id string)
OPTIONS (ANNOTATION 'Returns the billing address for a specified quote.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/billing-address');

CREATE FOREIGN PROCEDURE "V1/carts/mine/billing-address_POST"(OUT "return" string RESULT, IN address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN useForShipping boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Assigns a specified billing address to a specified cart.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/billing-address');

CREATE FOREIGN PROCEDURE giftCardAccountGiftCardAccountManagementV1CheckGiftCardGet(OUT "return" string RESULT, IN giftCardCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS ("teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/checkGiftCard/{giftCardCode}');

CREATE FOREIGN PROCEDURE quoteCartTotalManagementV1CollectTotalsPut(IN "additionalData_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'additionalData/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "additionalData_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'additionalData/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_extension_attributes_entity_id" string NOT NULL OPTIONS (NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_extension_attributes_entity_type" string NOT NULL OPTIONS (NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_extension_attributes_wrapping_add_printed_card" boolean NOT NULL OPTIONS (NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_extension_attributes_wrapping_allow_gift_receipt" boolean NOT NULL OPTIONS (NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_extension_attributes_wrapping_id" string NOT NULL OPTIONS (NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_gift_message_id" string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_message" string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_recipient" string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_sender" string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/sender', "teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'paymentMethod/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'paymentMethod/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN shippingCarrierCode string NOT NULL OPTIONS (ANNOTATION 'The carrier code.', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN shippingMethodCode string NOT NULL OPTIONS (ANNOTATION 'The shipping method code.', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (base_currency_code string, base_discount_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_amount string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_subtotal_with_discount string, base_tax_amount string, coupon_code string, discount_amount string, extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_reward_currency_amount'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_currency_amount'), extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_points_balance'), grand_total string, "items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_discount_amount'), "items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price'), "items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price_incl_tax'), "items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total'), "items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_tax_amount'), "items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_amount'), "items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_percent'), "items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/item_id'), "items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/name'), "items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/options'), "items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price'), "items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price_incl_tax'), "items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/qty'), "items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total'), "items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_incl_tax'), "items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_with_discount'), "items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_amount'), "items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_percent'), "items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied'), "items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), items_qty string, quote_currency_code string, shipping_amount string, shipping_discount_amount string, shipping_incl_tax string, shipping_tax_amount string, subtotal string, subtotal_incl_tax string, subtotal_with_discount string, tax_amount string, "total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/area'), "total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/code'), "total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/title'), "total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/value'), weee_tax_applied_amount string)
OPTIONS (ANNOTATION 'Set shipping/billing methods and additional data for cart and collect totals.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/collect-totals');

CREATE FOREIGN PROCEDURE "V1/carts/mine/coupons_GET"(OUT "return" string RESULT) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Returns information for a coupon in a specified cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/coupons');

CREATE FOREIGN PROCEDURE "V1/carts/mine/coupons_DELETE"(OUT "return" boolean RESULT) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Deletes a coupon from a specified cart.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/coupons');

CREATE FOREIGN PROCEDURE "V1/carts/mine/coupons/couponCode"(OUT "return" boolean RESULT, IN couponCode string NOT NULL OPTIONS (ANNOTATION 'The coupon code data.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Adds a coupon by code to a specified cart.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/coupons/{couponCode}');

CREATE FOREIGN PROCEDURE "V1/carts/mine/estimate-shipping-methods"(IN address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (amount string, available boolean, base_amount string, carrier_code string, carrier_title string, error_message string, method_code string, method_title string, price_excl_tax string, price_incl_tax string)
OPTIONS (ANNOTATION 'Estimate shipping by address and return list of available shipping methods', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/estimate-shipping-methods');

CREATE FOREIGN PROCEDURE "V1/carts/mine/estimate-shipping-methods-by-address-id"(IN addressId string NOT NULL OPTIONS (ANNOTATION 'The estimate address id', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (amount string, available boolean, base_amount string, carrier_code string, carrier_title string, error_message string, method_code string, method_title string, price_excl_tax string, price_incl_tax string)
OPTIONS (ANNOTATION 'Estimate shipping', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/estimate-shipping-methods-by-address-id');

CREATE FOREIGN PROCEDURE "V1/carts/mine/gift-message_GET"() RETURNS TABLE (customer_id string, extension_attributes_entity_id string OPTIONS (NAMEINSOURCE 'extension_attributes/entity_id'), extension_attributes_entity_type string OPTIONS (NAMEINSOURCE 'extension_attributes/entity_type'), extension_attributes_wrapping_add_printed_card boolean OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_add_printed_card'), extension_attributes_wrapping_allow_gift_receipt boolean OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_allow_gift_receipt'), extension_attributes_wrapping_id string OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_id'), gift_message_id string, message string, recipient string, sender string)
OPTIONS (ANNOTATION 'Return the gift message for a specified order.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/gift-message');

CREATE FOREIGN PROCEDURE "V1/carts/mine/gift-message_POST"(OUT "return" boolean RESULT, IN giftMessage_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'giftMessage/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_entity_id string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_entity_type string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_add_printed_card boolean NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_allow_gift_receipt boolean NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_id string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_gift_message_id string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'giftMessage/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_message string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'giftMessage/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftMessage_recipient string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'giftMessage/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftMessage_sender string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'giftMessage/sender', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Set the gift message for an entire order.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/gift-message');

CREATE FOREIGN PROCEDURE "V1/carts/mine/gift-message/itemId_GET"(IN itemId string NOT NULL OPTIONS (ANNOTATION 'The item ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (customer_id string, extension_attributes_entity_id string OPTIONS (NAMEINSOURCE 'extension_attributes/entity_id'), extension_attributes_entity_type string OPTIONS (NAMEINSOURCE 'extension_attributes/entity_type'), extension_attributes_wrapping_add_printed_card boolean OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_add_printed_card'), extension_attributes_wrapping_allow_gift_receipt boolean OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_allow_gift_receipt'), extension_attributes_wrapping_id string OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_id'), gift_message_id string, message string, recipient string, sender string)
OPTIONS (ANNOTATION 'Return the gift message for a specified item in a specified shopping cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/gift-message/{itemId}');

CREATE FOREIGN PROCEDURE "V1/carts/mine/gift-message/itemId_POST"(OUT "return" boolean RESULT, IN itemId string NOT NULL OPTIONS (ANNOTATION 'The item ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN giftMessage_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'giftMessage/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_entity_id string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_entity_type string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_add_printed_card boolean NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_allow_gift_receipt boolean NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_id string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_gift_message_id string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'giftMessage/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_message string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'giftMessage/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftMessage_recipient string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'giftMessage/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftMessage_sender string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'giftMessage/sender', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Set the gift message for a specified item in a specified shopping cart.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/gift-message/{itemId}');

CREATE FOREIGN PROCEDURE giftCardAccountGiftCardAccountManagementV1SaveByQuoteIdPost(OUT "return" boolean RESULT, IN giftCardAccountData_base_gift_cards_amount string NOT NULL OPTIONS (ANNOTATION 'Cards amount in base currency', NAMEINSOURCE 'giftCardAccountData/base_gift_cards_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftCardAccountData_base_gift_cards_amount_used string NOT NULL OPTIONS (ANNOTATION 'Cards amount used in base currency', NAMEINSOURCE 'giftCardAccountData/base_gift_cards_amount_used', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftCardAccountData_gift_cards string[] NOT NULL OPTIONS (NAMEINSOURCE 'giftCardAccountData/gift_cards', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftCardAccountData_gift_cards_amount string NOT NULL OPTIONS (ANNOTATION 'Cards amount in quote currency', NAMEINSOURCE 'giftCardAccountData/gift_cards_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftCardAccountData_gift_cards_amount_used string NOT NULL OPTIONS (ANNOTATION 'Cards amount used in quote currency', NAMEINSOURCE 'giftCardAccountData/gift_cards_amount_used', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS ("teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/giftCards');

CREATE FOREIGN PROCEDURE "V1/carts/mine/giftCards/giftCardCode"(OUT "return" boolean RESULT, IN giftCardCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove GiftCard Account entity', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/giftCards/{giftCardCode}');

CREATE FOREIGN PROCEDURE "V1/carts/mine/items_GET"() RETURNS TABLE (item_id string, name string, price string, "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), product_option_extension_attributes_downloadable_option_downloadable_links string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/downloadable_option/downloadable_links'), product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_message string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_message'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), product_type string, qty string, quote_id string, sku string)
OPTIONS (ANNOTATION 'Lists items that are assigned to a specified cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/items');

CREATE FOREIGN PROCEDURE "V1/carts/mine/items_POST"(IN cartItem_item_id string NOT NULL OPTIONS (ANNOTATION 'Item ID. Otherwise, null.', NAMEINSOURCE 'cartItem/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_name string NOT NULL OPTIONS (ANNOTATION 'Product name. Otherwise, null.', NAMEINSOURCE 'cartItem/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_price string NOT NULL OPTIONS (ANNOTATION 'Product price. Otherwise, null.', NAMEINSOURCE 'cartItem/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'cartItem/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'cartItem/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_downloadable_option_downloadable_links string[] NOT NULL OPTIONS (NAMEINSOURCE 'cartItem/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_amount string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_message string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_type string NOT NULL OPTIONS (ANNOTATION 'Product type. Otherwise, null.', NAMEINSOURCE 'cartItem/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_qty string NOT NULL OPTIONS (ANNOTATION 'Product quantity.', NAMEINSOURCE 'cartItem/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_quote_id string NOT NULL OPTIONS (ANNOTATION 'Quote id.', NAMEINSOURCE 'cartItem/quote_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_sku string NOT NULL OPTIONS (ANNOTATION 'Product SKU. Otherwise, null.', NAMEINSOURCE 'cartItem/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (item_id string, name string, price string, "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), product_option_extension_attributes_downloadable_option_downloadable_links string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/downloadable_option/downloadable_links'), product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_message string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_message'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), product_type string, qty string, quote_id string, sku string)
OPTIONS (ANNOTATION 'Add/update the specified cart item.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/items');

CREATE FOREIGN PROCEDURE "V1/carts/mine/items/itemId_PUT"(IN itemId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN cartItem_item_id string NOT NULL OPTIONS (ANNOTATION 'Item ID. Otherwise, null.', NAMEINSOURCE 'cartItem/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_name string NOT NULL OPTIONS (ANNOTATION 'Product name. Otherwise, null.', NAMEINSOURCE 'cartItem/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_price string NOT NULL OPTIONS (ANNOTATION 'Product price. Otherwise, null.', NAMEINSOURCE 'cartItem/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'cartItem/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'cartItem/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_downloadable_option_downloadable_links string[] NOT NULL OPTIONS (NAMEINSOURCE 'cartItem/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_amount string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_message string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_type string NOT NULL OPTIONS (ANNOTATION 'Product type. Otherwise, null.', NAMEINSOURCE 'cartItem/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_qty string NOT NULL OPTIONS (ANNOTATION 'Product quantity.', NAMEINSOURCE 'cartItem/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_quote_id string NOT NULL OPTIONS (ANNOTATION 'Quote id.', NAMEINSOURCE 'cartItem/quote_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_sku string NOT NULL OPTIONS (ANNOTATION 'Product SKU. Otherwise, null.', NAMEINSOURCE 'cartItem/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (item_id string, name string, price string, "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), product_option_extension_attributes_downloadable_option_downloadable_links string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/downloadable_option/downloadable_links'), product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_message string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_message'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), product_type string, qty string, quote_id string, sku string)
OPTIONS (ANNOTATION 'Add/update the specified cart item.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/items/{itemId}');

CREATE FOREIGN PROCEDURE "V1/carts/mine/items/itemId_DELETE"(OUT "return" boolean RESULT, IN itemId string NOT NULL OPTIONS (ANNOTATION 'The item ID of the item to be removed.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Removes the specified item from the specified cart.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/items/{itemId}');

CREATE FOREIGN PROCEDURE "V1/carts/mine/order"(OUT "return" string RESULT, IN paymentMethod_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'paymentMethod/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'paymentMethod/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Places an order for a specified cart.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/order');

CREATE FOREIGN PROCEDURE checkoutPaymentInformationManagementV1GetPaymentInformationGet() RETURNS TABLE ("payment_methods_quote-data-payment-method-interface_code" string OPTIONS (NAMEINSOURCE 'payment_methods[]/quote-data-payment-method-interface/code'), "payment_methods_quote-data-payment-method-interface_title" string OPTIONS (NAMEINSOURCE 'payment_methods[]/quote-data-payment-method-interface/title'), totals_base_currency_code string OPTIONS (NAMEINSOURCE 'totals/base_currency_code'), totals_base_discount_amount string OPTIONS (NAMEINSOURCE 'totals/base_discount_amount'), totals_base_grand_total string OPTIONS (NAMEINSOURCE 'totals/base_grand_total'), totals_base_shipping_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_amount'), totals_base_shipping_discount_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_discount_amount'), totals_base_shipping_incl_tax string OPTIONS (NAMEINSOURCE 'totals/base_shipping_incl_tax'), totals_base_shipping_tax_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_tax_amount'), totals_base_subtotal string OPTIONS (NAMEINSOURCE 'totals/base_subtotal'), totals_base_subtotal_incl_tax string OPTIONS (NAMEINSOURCE 'totals/base_subtotal_incl_tax'), totals_base_subtotal_with_discount string OPTIONS (NAMEINSOURCE 'totals/base_subtotal_with_discount'), totals_base_tax_amount string OPTIONS (NAMEINSOURCE 'totals/base_tax_amount'), totals_coupon_code string OPTIONS (NAMEINSOURCE 'totals/coupon_code'), totals_discount_amount string OPTIONS (NAMEINSOURCE 'totals/discount_amount'), totals_extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/base_customer_balance_amount'), totals_extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/base_reward_currency_amount'), totals_extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/customer_balance_amount'), totals_extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/reward_currency_amount'), totals_extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/reward_points_balance'), totals_grand_total string OPTIONS (NAMEINSOURCE 'totals/grand_total'), "totals_items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_discount_amount'), "totals_items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_price'), "totals_items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_price_incl_tax'), "totals_items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_row_total'), "totals_items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "totals_items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_tax_amount'), "totals_items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/discount_amount'), "totals_items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/discount_percent'), "totals_items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/item_id'), "totals_items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/name'), "totals_items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/options'), "totals_items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/price'), "totals_items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/price_incl_tax'), "totals_items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/qty'), "totals_items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total'), "totals_items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total_incl_tax'), "totals_items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total_with_discount'), "totals_items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/tax_amount'), "totals_items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/tax_percent'), "totals_items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/weee_tax_applied'), "totals_items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), totals_items_qty string OPTIONS (NAMEINSOURCE 'totals/items_qty'), totals_quote_currency_code string OPTIONS (NAMEINSOURCE 'totals/quote_currency_code'), totals_shipping_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_amount'), totals_shipping_discount_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_discount_amount'), totals_shipping_incl_tax string OPTIONS (NAMEINSOURCE 'totals/shipping_incl_tax'), totals_shipping_tax_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_tax_amount'), totals_subtotal string OPTIONS (NAMEINSOURCE 'totals/subtotal'), totals_subtotal_incl_tax string OPTIONS (NAMEINSOURCE 'totals/subtotal_incl_tax'), totals_subtotal_with_discount string OPTIONS (NAMEINSOURCE 'totals/subtotal_with_discount'), totals_tax_amount string OPTIONS (NAMEINSOURCE 'totals/tax_amount'), "totals_total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/area'), "totals_total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/code'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "totals_total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/title'), "totals_total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/value'), totals_weee_tax_applied_amount string OPTIONS (NAMEINSOURCE 'totals/weee_tax_applied_amount'))
OPTIONS (ANNOTATION 'Get payment information', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/payment-information');

CREATE FOREIGN PROCEDURE checkoutPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPost(OUT "return" string RESULT, IN billingAddress_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'billingAddress/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'billingAddress/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'billingAddress/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "billingAddress_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'billingAddress/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "billingAddress_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'billingAddress/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'billingAddress/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'billingAddress/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'billingAddress/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'billingAddress/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'billingAddress/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'billingAddress/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'billingAddress/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'billingAddress/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'billingAddress/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'billingAddress/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'billingAddress/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'billingAddress/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'billingAddress/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'billingAddress/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'billingAddress/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'billingAddress/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'billingAddress/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'billingAddress/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'billingAddress/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'billingAddress/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'paymentMethod/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'paymentMethod/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Set payment information and place order for a specified cart.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/payment-information');

CREATE FOREIGN PROCEDURE "V1/carts/mine/payment-methods"() RETURNS TABLE (code string, title string)
OPTIONS (ANNOTATION 'Lists available payment methods for a specified shopping cart. This call returns an array of objects, but detailed information about each object’s attributes might not be included.  See http://devdocs.magento.com/codelinks/attributes.html#PaymentMethodManagementInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/payment-methods');

CREATE FOREIGN PROCEDURE "V1/carts/mine/selected-payment-method_GET"() RETURNS TABLE (additional_data string[], extension_attributes_agreement_ids string[] OPTIONS (NAMEINSOURCE 'extension_attributes/agreement_ids'), "method" string, po_number string)
OPTIONS (ANNOTATION 'Returns the payment method for a specified shopping cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/selected-payment-method');

CREATE FOREIGN PROCEDURE "V1/carts/mine/selected-payment-method_PUT"(OUT "return" string RESULT, IN method_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'method/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN method_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'method/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN method_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'method/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN method_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'method/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Adds a specified payment method to a specified shopping cart.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/selected-payment-method');

CREATE FOREIGN PROCEDURE checkoutPaymentInformationManagementV1SavePaymentInformationPost(OUT "return" string RESULT, IN billingAddress_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'billingAddress/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'billingAddress/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'billingAddress/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "billingAddress_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'billingAddress/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "billingAddress_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'billingAddress/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'billingAddress/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'billingAddress/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'billingAddress/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'billingAddress/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'billingAddress/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'billingAddress/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'billingAddress/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'billingAddress/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'billingAddress/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'billingAddress/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'billingAddress/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'billingAddress/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'billingAddress/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'billingAddress/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'billingAddress/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'billingAddress/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'billingAddress/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'billingAddress/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'billingAddress/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'billingAddress/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'paymentMethod/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'paymentMethod/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Set payment information for a specified cart.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/set-payment-information');

CREATE FOREIGN PROCEDURE "V1/carts/mine/shipping-information"(IN addressInformation_billing_address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'addressInformation/billing_address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'addressInformation/billing_address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'addressInformation/billing_address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_billing_address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/billing_address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_billing_address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/billing_address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'addressInformation/billing_address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'addressInformation/billing_address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'addressInformation/billing_address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/billing_address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'addressInformation/billing_address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'addressInformation/billing_address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'addressInformation/billing_address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'addressInformation/billing_address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'addressInformation/billing_address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'addressInformation/billing_address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'addressInformation/billing_address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'addressInformation/billing_address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'addressInformation/billing_address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'addressInformation/billing_address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'addressInformation/billing_address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'addressInformation/billing_address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/billing_address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'addressInformation/billing_address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'addressInformation/billing_address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'addressInformation/billing_address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "addressInformation_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'addressInformation/shipping_address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'addressInformation/shipping_address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'addressInformation/shipping_address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_shipping_address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/shipping_address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_shipping_address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/shipping_address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'addressInformation/shipping_address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'addressInformation/shipping_address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'addressInformation/shipping_address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/shipping_address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'addressInformation/shipping_address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'addressInformation/shipping_address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'addressInformation/shipping_address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'addressInformation/shipping_address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'addressInformation/shipping_address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'addressInformation/shipping_address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'addressInformation/shipping_address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'addressInformation/shipping_address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'addressInformation/shipping_address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'addressInformation/shipping_address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'addressInformation/shipping_address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'addressInformation/shipping_address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/shipping_address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'addressInformation/shipping_address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'addressInformation/shipping_address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'addressInformation/shipping_address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_carrier_code string NOT NULL OPTIONS (ANNOTATION 'Carrier code', NAMEINSOURCE 'addressInformation/shipping_carrier_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_method_code string NOT NULL OPTIONS (ANNOTATION 'Shipping method code', NAMEINSOURCE 'addressInformation/shipping_method_code', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE ("payment_methods_quote-data-payment-method-interface_code" string OPTIONS (NAMEINSOURCE 'payment_methods[]/quote-data-payment-method-interface/code'), "payment_methods_quote-data-payment-method-interface_title" string OPTIONS (NAMEINSOURCE 'payment_methods[]/quote-data-payment-method-interface/title'), totals_base_currency_code string OPTIONS (NAMEINSOURCE 'totals/base_currency_code'), totals_base_discount_amount string OPTIONS (NAMEINSOURCE 'totals/base_discount_amount'), totals_base_grand_total string OPTIONS (NAMEINSOURCE 'totals/base_grand_total'), totals_base_shipping_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_amount'), totals_base_shipping_discount_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_discount_amount'), totals_base_shipping_incl_tax string OPTIONS (NAMEINSOURCE 'totals/base_shipping_incl_tax'), totals_base_shipping_tax_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_tax_amount'), totals_base_subtotal string OPTIONS (NAMEINSOURCE 'totals/base_subtotal'), totals_base_subtotal_incl_tax string OPTIONS (NAMEINSOURCE 'totals/base_subtotal_incl_tax'), totals_base_subtotal_with_discount string OPTIONS (NAMEINSOURCE 'totals/base_subtotal_with_discount'), totals_base_tax_amount string OPTIONS (NAMEINSOURCE 'totals/base_tax_amount'), totals_coupon_code string OPTIONS (NAMEINSOURCE 'totals/coupon_code'), totals_discount_amount string OPTIONS (NAMEINSOURCE 'totals/discount_amount'), totals_extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/base_customer_balance_amount'), totals_extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/base_reward_currency_amount'), totals_extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/customer_balance_amount'), totals_extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/reward_currency_amount'), totals_extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/reward_points_balance'), totals_grand_total string OPTIONS (NAMEINSOURCE 'totals/grand_total'), "totals_items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_discount_amount'), "totals_items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_price'), "totals_items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_price_incl_tax'), "totals_items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_row_total'), "totals_items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "totals_items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_tax_amount'), "totals_items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/discount_amount'), "totals_items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/discount_percent'), "totals_items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/item_id'), "totals_items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/name'), "totals_items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/options'), "totals_items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/price'), "totals_items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/price_incl_tax'), "totals_items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/qty'), "totals_items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total'), "totals_items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total_incl_tax'), "totals_items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total_with_discount'), "totals_items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/tax_amount'), "totals_items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/tax_percent'), "totals_items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/weee_tax_applied'), "totals_items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), totals_items_qty string OPTIONS (NAMEINSOURCE 'totals/items_qty'), totals_quote_currency_code string OPTIONS (NAMEINSOURCE 'totals/quote_currency_code'), totals_shipping_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_amount'), totals_shipping_discount_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_discount_amount'), totals_shipping_incl_tax string OPTIONS (NAMEINSOURCE 'totals/shipping_incl_tax'), totals_shipping_tax_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_tax_amount'), totals_subtotal string OPTIONS (NAMEINSOURCE 'totals/subtotal'), totals_subtotal_incl_tax string OPTIONS (NAMEINSOURCE 'totals/subtotal_incl_tax'), totals_subtotal_with_discount string OPTIONS (NAMEINSOURCE 'totals/subtotal_with_discount'), totals_tax_amount string OPTIONS (NAMEINSOURCE 'totals/tax_amount'), "totals_total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/area'), "totals_total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/code'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "totals_total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/title'), "totals_total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/value'), totals_weee_tax_applied_amount string OPTIONS (NAMEINSOURCE 'totals/weee_tax_applied_amount'))
OPTIONS ("teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/shipping-information');

CREATE FOREIGN PROCEDURE "V1/carts/mine/shipping-methods"() RETURNS TABLE (amount string, available boolean, base_amount string, carrier_code string, carrier_title string, error_message string, method_code string, method_title string, price_excl_tax string, price_incl_tax string)
OPTIONS (ANNOTATION 'Lists applicable shipping methods for a specified quote.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/shipping-methods');

CREATE FOREIGN PROCEDURE "V1/carts/mine/totals"() RETURNS TABLE (base_currency_code string, base_discount_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_amount string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_subtotal_with_discount string, base_tax_amount string, coupon_code string, discount_amount string, extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_reward_currency_amount'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_currency_amount'), extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_points_balance'), grand_total string, "items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_discount_amount'), "items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price'), "items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price_incl_tax'), "items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total'), "items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_tax_amount'), "items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_amount'), "items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_percent'), "items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/item_id'), "items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/name'), "items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/options'), "items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price'), "items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price_incl_tax'), "items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/qty'), "items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total'), "items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_incl_tax'), "items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_with_discount'), "items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_amount'), "items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_percent'), "items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied'), "items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), items_qty string, quote_currency_code string, shipping_amount string, shipping_discount_amount string, shipping_incl_tax string, shipping_tax_amount string, subtotal string, subtotal_incl_tax string, subtotal_with_discount string, tax_amount string, "total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/area'), "total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/code'), "total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/title'), "total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/value'), weee_tax_applied_amount string)
OPTIONS (ANNOTATION 'Returns quote totals data for a specified cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/totals');

CREATE FOREIGN PROCEDURE "V1/carts/mine/totals-information"(IN addressInformation_address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'addressInformation/address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'addressInformation/address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'addressInformation/address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'addressInformation/address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'addressInformation/address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'addressInformation/address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'addressInformation/address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'addressInformation/address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'addressInformation/address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'addressInformation/address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'addressInformation/address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'addressInformation/address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'addressInformation/address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'addressInformation/address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'addressInformation/address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'addressInformation/address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'addressInformation/address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'addressInformation/address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'addressInformation/address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'addressInformation/address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'addressInformation/address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "addressInformation_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_carrier_code string NOT NULL OPTIONS (ANNOTATION 'Carrier code', NAMEINSOURCE 'addressInformation/shipping_carrier_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_method_code string NOT NULL OPTIONS (ANNOTATION 'Shipping method code', NAMEINSOURCE 'addressInformation/shipping_method_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (base_currency_code string, base_discount_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_amount string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_subtotal_with_discount string, base_tax_amount string, coupon_code string, discount_amount string, extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_reward_currency_amount'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_currency_amount'), extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_points_balance'), grand_total string, "items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_discount_amount'), "items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price'), "items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price_incl_tax'), "items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total'), "items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_tax_amount'), "items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_amount'), "items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_percent'), "items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/item_id'), "items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/name'), "items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/options'), "items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price'), "items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price_incl_tax'), "items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/qty'), "items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total'), "items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_incl_tax'), "items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_with_discount'), "items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_amount'), "items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_percent'), "items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied'), "items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), items_qty string, quote_currency_code string, shipping_amount string, shipping_discount_amount string, shipping_incl_tax string, shipping_tax_amount string, subtotal string, subtotal_incl_tax string, subtotal_with_discount string, tax_amount string, "total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/area'), "total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/code'), "total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/title'), "total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/value'), weee_tax_applied_amount string)
OPTIONS (ANNOTATION 'Calculate quote totals based on address and shipping method.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/mine/totals-information');

CREATE FOREIGN PROCEDURE quoteCartRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_quote-data-cart-interface_billing_address_city" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/city'), "items_quote-data-cart-interface_billing_address_company" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/company'), "items_quote-data-cart-interface_billing_address_country_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/country_id'), "items_quote-data-cart-interface_billing_address_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_quote-data-cart-interface_billing_address_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/custom_attributes[]/framework-attribute-interface/value'), "items_quote-data-cart-interface_billing_address_customer_address_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/customer_address_id'), "items_quote-data-cart-interface_billing_address_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/customer_id'), "items_quote-data-cart-interface_billing_address_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/email'), "items_quote-data-cart-interface_billing_address_extension_attributes_gift_registry_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/extension_attributes/gift_registry_id'), "items_quote-data-cart-interface_billing_address_fax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/fax'), "items_quote-data-cart-interface_billing_address_firstname" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/firstname'), "items_quote-data-cart-interface_billing_address_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/id'), "items_quote-data-cart-interface_billing_address_lastname" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/lastname'), "items_quote-data-cart-interface_billing_address_middlename" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/middlename'), "items_quote-data-cart-interface_billing_address_postcode" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/postcode'), "items_quote-data-cart-interface_billing_address_prefix" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/prefix'), "items_quote-data-cart-interface_billing_address_region" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/region'), "items_quote-data-cart-interface_billing_address_region_code" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/region_code'), "items_quote-data-cart-interface_billing_address_region_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/region_id'), "items_quote-data-cart-interface_billing_address_same_as_billing" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/same_as_billing'), "items_quote-data-cart-interface_billing_address_save_in_address_book" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/save_in_address_book'), "items_quote-data-cart-interface_billing_address_street" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/street'), "items_quote-data-cart-interface_billing_address_suffix" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/suffix'), "items_quote-data-cart-interface_billing_address_telephone" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/telephone'), "items_quote-data-cart-interface_billing_address_vat_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/billing_address/vat_id'), "items_quote-data-cart-interface_converted_at" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/converted_at'), "items_quote-data-cart-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/created_at'), "items_quote-data-cart-interface_currency_base_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/currency/base_currency_code'), "items_quote-data-cart-interface_currency_base_to_global_rate" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/currency/base_to_global_rate'), "items_quote-data-cart-interface_currency_base_to_quote_rate" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/currency/base_to_quote_rate'), "items_quote-data-cart-interface_currency_global_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/currency/global_currency_code'), "items_quote-data-cart-interface_currency_quote_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/currency/quote_currency_code'), "items_quote-data-cart-interface_currency_store_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/currency/store_currency_code'), "items_quote-data-cart-interface_currency_store_to_base_rate" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/currency/store_to_base_rate'), "items_quote-data-cart-interface_currency_store_to_quote_rate" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/currency/store_to_quote_rate'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_city" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/city'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_company" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/company'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_country_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/country_id'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/customer_id'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_default_billing" boolean OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/default_billing'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_default_shipping" boolean OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/default_shipping'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_fax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/fax'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_firstname" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/firstname'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/id'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_lastname" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/lastname'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_middlename" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/middlename'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_postcode" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/postcode'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_prefix" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/prefix'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_region_region" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/region/region'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_region_region_code" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/region/region_code'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_region_region_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/region/region_id'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_region_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/region_id'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_street" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/street'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_suffix" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/suffix'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_telephone" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/telephone'), "items_quote-data-cart-interface_customer_addresses_customer-data-address-interface_vat_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/addresses[]/customer-data-address-interface/vat_id'), "items_quote-data-cart-interface_customer_confirmation" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/confirmation'), "items_quote-data-cart-interface_customer_created_at" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/created_at'), "items_quote-data-cart-interface_customer_created_in" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/created_in'), "items_quote-data-cart-interface_customer_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_quote-data-cart-interface_customer_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/custom_attributes[]/framework-attribute-interface/value'), "items_quote-data-cart-interface_customer_default_billing" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/default_billing'), "items_quote-data-cart-interface_customer_default_shipping" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/default_shipping'), "items_quote-data-cart-interface_customer_disable_auto_group_change" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/disable_auto_group_change'), "items_quote-data-cart-interface_customer_dob" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/dob'), "items_quote-data-cart-interface_customer_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/email'), "items_quote-data-cart-interface_customer_extension_attributes_is_subscribed" boolean OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/extension_attributes/is_subscribed'), "items_quote-data-cart-interface_customer_firstname" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/firstname'), "items_quote-data-cart-interface_customer_gender" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/gender'), "items_quote-data-cart-interface_customer_group_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/group_id'), "items_quote-data-cart-interface_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/id'), "items_quote-data-cart-interface_customer_lastname" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/lastname'), "items_quote-data-cart-interface_customer_middlename" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/middlename'), "items_quote-data-cart-interface_customer_prefix" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/prefix'), "items_quote-data-cart-interface_customer_store_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/store_id'), "items_quote-data-cart-interface_customer_suffix" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/suffix'), "items_quote-data-cart-interface_customer_taxvat" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/taxvat'), "items_quote-data-cart-interface_customer_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/updated_at'), "items_quote-data-cart-interface_customer_website_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer/website_id'), "items_quote-data-cart-interface_customer_is_guest" boolean OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer_is_guest'), "items_quote-data-cart-interface_customer_note" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer_note'), "items_quote-data-cart-interface_customer_note_notify" boolean OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer_note_notify'), "items_quote-data-cart-interface_customer_tax_class_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/customer_tax_class_id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/item_id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/name'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/price'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_type'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/qty'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_quote_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/quote_id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/sku'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_city" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/city'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_company" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/company'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_country_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/country_id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/custom_attributes[]/framework-attribute-interface/value'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_customer_address_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/customer_address_id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/customer_id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/email'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_extension_attributes_gift_registry_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/extension_attributes/gift_registry_id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_fax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/fax'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_firstname" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/firstname'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_lastname" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/lastname'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_middlename" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/middlename'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_postcode" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/postcode'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_prefix" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/prefix'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region_code" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region_code'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region_id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_same_as_billing" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/same_as_billing'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_save_in_address_book" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/save_in_address_book'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_street" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/street'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_suffix" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/suffix'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_telephone" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/telephone'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_vat_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/vat_id'), "items_quote-data-cart-interface_extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_method" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/method'), "items_quote-data-cart-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/id'), "items_quote-data-cart-interface_is_active" boolean OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/is_active'), "items_quote-data-cart-interface_is_virtual" boolean OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/is_virtual'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/item_id'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/name'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/price'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/product_type'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/qty'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_quote_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/quote_id'), "items_quote-data-cart-interface_items_quote-data-cart-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items[]/quote-data-cart-item-interface/sku'), "items_quote-data-cart-interface_items_count" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items_count'), "items_quote-data-cart-interface_items_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/items_qty'), "items_quote-data-cart-interface_orig_order_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/orig_order_id'), "items_quote-data-cart-interface_reserved_order_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/reserved_order_id'), "items_quote-data-cart-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/store_id'), "items_quote-data-cart-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-interface/updated_at'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Enables administrative users to list carts that match specified search criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included.  See http://devdocs.magento.com/codelinks/attributes.html#CartRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/search');

CREATE FOREIGN PROCEDURE quoteCartRepositoryV1GetGet(IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (billing_address_city string OPTIONS (NAMEINSOURCE 'billing_address/city'), billing_address_company string OPTIONS (NAMEINSOURCE 'billing_address/company'), billing_address_country_id string OPTIONS (NAMEINSOURCE 'billing_address/country_id'), "billing_address_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'billing_address/custom_attributes[]/framework-attribute-interface/attribute_code'), "billing_address_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'billing_address/custom_attributes[]/framework-attribute-interface/value'), billing_address_customer_address_id string OPTIONS (NAMEINSOURCE 'billing_address/customer_address_id'), billing_address_customer_id string OPTIONS (NAMEINSOURCE 'billing_address/customer_id'), billing_address_email string OPTIONS (NAMEINSOURCE 'billing_address/email'), billing_address_extension_attributes_gift_registry_id string OPTIONS (NAMEINSOURCE 'billing_address/extension_attributes/gift_registry_id'), billing_address_fax string OPTIONS (NAMEINSOURCE 'billing_address/fax'), billing_address_firstname string OPTIONS (NAMEINSOURCE 'billing_address/firstname'), billing_address_id string OPTIONS (NAMEINSOURCE 'billing_address/id'), billing_address_lastname string OPTIONS (NAMEINSOURCE 'billing_address/lastname'), billing_address_middlename string OPTIONS (NAMEINSOURCE 'billing_address/middlename'), billing_address_postcode string OPTIONS (NAMEINSOURCE 'billing_address/postcode'), billing_address_prefix string OPTIONS (NAMEINSOURCE 'billing_address/prefix'), billing_address_region string OPTIONS (NAMEINSOURCE 'billing_address/region'), billing_address_region_code string OPTIONS (NAMEINSOURCE 'billing_address/region_code'), billing_address_region_id string OPTIONS (NAMEINSOURCE 'billing_address/region_id'), billing_address_same_as_billing string OPTIONS (NAMEINSOURCE 'billing_address/same_as_billing'), billing_address_save_in_address_book string OPTIONS (NAMEINSOURCE 'billing_address/save_in_address_book'), billing_address_street string[] OPTIONS (NAMEINSOURCE 'billing_address/street'), billing_address_suffix string OPTIONS (NAMEINSOURCE 'billing_address/suffix'), billing_address_telephone string OPTIONS (NAMEINSOURCE 'billing_address/telephone'), billing_address_vat_id string OPTIONS (NAMEINSOURCE 'billing_address/vat_id'), converted_at string, created_at string, currency_base_currency_code string OPTIONS (NAMEINSOURCE 'currency/base_currency_code'), currency_base_to_global_rate string OPTIONS (NAMEINSOURCE 'currency/base_to_global_rate'), currency_base_to_quote_rate string OPTIONS (NAMEINSOURCE 'currency/base_to_quote_rate'), currency_global_currency_code string OPTIONS (NAMEINSOURCE 'currency/global_currency_code'), currency_quote_currency_code string OPTIONS (NAMEINSOURCE 'currency/quote_currency_code'), currency_store_currency_code string OPTIONS (NAMEINSOURCE 'currency/store_currency_code'), currency_store_to_base_rate string OPTIONS (NAMEINSOURCE 'currency/store_to_base_rate'), currency_store_to_quote_rate string OPTIONS (NAMEINSOURCE 'currency/store_to_quote_rate'), "customer_addresses_customer-data-address-interface_city" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/city'), "customer_addresses_customer-data-address-interface_company" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/company'), "customer_addresses_customer-data-address-interface_country_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/country_id'), "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value'), "customer_addresses_customer-data-address-interface_customer_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/customer_id'), "customer_addresses_customer-data-address-interface_default_billing" boolean OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_billing'), "customer_addresses_customer-data-address-interface_default_shipping" boolean OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_shipping'), "customer_addresses_customer-data-address-interface_fax" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/fax'), "customer_addresses_customer-data-address-interface_firstname" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/firstname'), "customer_addresses_customer-data-address-interface_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/id'), "customer_addresses_customer-data-address-interface_lastname" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/lastname'), "customer_addresses_customer-data-address-interface_middlename" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/middlename'), "customer_addresses_customer-data-address-interface_postcode" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/postcode'), "customer_addresses_customer-data-address-interface_prefix" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/prefix'), "customer_addresses_customer-data-address-interface_region_region" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region'), "customer_addresses_customer-data-address-interface_region_region_code" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_code'), "customer_addresses_customer-data-address-interface_region_region_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_id'), "customer_addresses_customer-data-address-interface_region_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region_id'), "customer_addresses_customer-data-address-interface_street" string[] OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/street'), "customer_addresses_customer-data-address-interface_suffix" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/suffix'), "customer_addresses_customer-data-address-interface_telephone" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/telephone'), "customer_addresses_customer-data-address-interface_vat_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/vat_id'), customer_confirmation string OPTIONS (NAMEINSOURCE 'customer/confirmation'), customer_created_at string OPTIONS (NAMEINSOURCE 'customer/created_at'), customer_created_in string OPTIONS (NAMEINSOURCE 'customer/created_in'), "customer_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/attribute_code'), "customer_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/value'), customer_default_billing string OPTIONS (NAMEINSOURCE 'customer/default_billing'), customer_default_shipping string OPTIONS (NAMEINSOURCE 'customer/default_shipping'), customer_disable_auto_group_change string OPTIONS (NAMEINSOURCE 'customer/disable_auto_group_change'), customer_dob string OPTIONS (NAMEINSOURCE 'customer/dob'), customer_email string OPTIONS (NAMEINSOURCE 'customer/email'), customer_extension_attributes_is_subscribed boolean OPTIONS (NAMEINSOURCE 'customer/extension_attributes/is_subscribed'), customer_firstname string OPTIONS (NAMEINSOURCE 'customer/firstname'), customer_gender string OPTIONS (NAMEINSOURCE 'customer/gender'), customer_group_id string OPTIONS (NAMEINSOURCE 'customer/group_id'), customer_id string OPTIONS (NAMEINSOURCE 'customer/id'), customer_lastname string OPTIONS (NAMEINSOURCE 'customer/lastname'), customer_middlename string OPTIONS (NAMEINSOURCE 'customer/middlename'), customer_prefix string OPTIONS (NAMEINSOURCE 'customer/prefix'), customer_store_id string OPTIONS (NAMEINSOURCE 'customer/store_id'), customer_suffix string OPTIONS (NAMEINSOURCE 'customer/suffix'), customer_taxvat string OPTIONS (NAMEINSOURCE 'customer/taxvat'), customer_updated_at string OPTIONS (NAMEINSOURCE 'customer/updated_at'), customer_website_id string OPTIONS (NAMEINSOURCE 'customer/website_id'), customer_is_guest boolean, customer_note string, customer_note_notify boolean, customer_tax_class_id string, "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/item_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/name'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/price'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_type'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/qty'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_quote_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/quote_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/sku'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_city" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/city'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_company" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/company'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_country_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/country_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/custom_attributes[]/framework-attribute-interface/attribute_code'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/custom_attributes[]/framework-attribute-interface/value'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_customer_address_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/customer_address_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_customer_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/customer_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/email'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_extension_attributes_gift_registry_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/extension_attributes/gift_registry_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_fax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/fax'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_firstname" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/firstname'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_lastname" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/lastname'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_middlename" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/middlename'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_postcode" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/postcode'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_prefix" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/prefix'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region_code'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_same_as_billing" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/same_as_billing'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_save_in_address_book" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/save_in_address_book'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_street" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/street'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_suffix" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/suffix'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_telephone" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/telephone'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_vat_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/vat_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_method" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/method'), id string, is_active boolean, is_virtual boolean, "items_quote-data-cart-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/item_id'), "items_quote-data-cart-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/name'), "items_quote-data-cart-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/price'), "items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_quote-data-cart-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_quote-data-cart-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_type'), "items_quote-data-cart-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/qty'), "items_quote-data-cart-item-interface_quote_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/quote_id'), "items_quote-data-cart-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/sku'), items_count string, items_qty string, orig_order_id string, reserved_order_id string, store_id string, updated_at string)
OPTIONS (ANNOTATION 'Enables an administrative user to return information for a specified cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}');

CREATE FOREIGN PROCEDURE quoteCartManagementV1AssignCustomerPut(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN customerId string NOT NULL OPTIONS (ANNOTATION 'The customer ID.', "teiid_rest:PARAMETER_TYPE" 'body'), IN storeId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Assigns a specified customer to a specified shopping cart.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/billing-address_GET"(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (city string, company string, country_id string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), customer_address_id string, customer_id string, email string, extension_attributes_gift_registry_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_registry_id'), fax string, firstname string, id string, lastname string, middlename string, postcode string, prefix string, region string, region_code string, region_id string, same_as_billing string, save_in_address_book string, street string[], suffix string, telephone string, vat_id string)
OPTIONS (ANNOTATION 'Returns the billing address for a specified quote.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/billing-address');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/billing-address_POST"(OUT "return" string RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN useForShipping boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Assigns a specified billing address to a specified cart.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/billing-address');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/coupons_GET"(OUT "return" string RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Returns information for a coupon in a specified cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/coupons');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/coupons_DELETE"(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Deletes a coupon from a specified cart.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/coupons');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/coupons/couponCode"(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN couponCode string NOT NULL OPTIONS (ANNOTATION 'The coupon code data.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Adds a coupon by code to a specified cart.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/coupons/{couponCode}');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/estimate-shipping-methods"(IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (amount string, available boolean, base_amount string, carrier_code string, carrier_title string, error_message string, method_code string, method_title string, price_excl_tax string, price_incl_tax string)
OPTIONS (ANNOTATION 'Estimate shipping by address and return list of available shipping methods', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/estimate-shipping-methods');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/estimate-shipping-methods-by-address-id"(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The shopping cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN addressId string NOT NULL OPTIONS (ANNOTATION 'The estimate address id', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (amount string, available boolean, base_amount string, carrier_code string, carrier_title string, error_message string, method_code string, method_title string, price_excl_tax string, price_incl_tax string)
OPTIONS (ANNOTATION 'Estimate shipping', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/estimate-shipping-methods-by-address-id');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/gift-message_GET"(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The shopping cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (customer_id string, extension_attributes_entity_id string OPTIONS (NAMEINSOURCE 'extension_attributes/entity_id'), extension_attributes_entity_type string OPTIONS (NAMEINSOURCE 'extension_attributes/entity_type'), extension_attributes_wrapping_add_printed_card boolean OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_add_printed_card'), extension_attributes_wrapping_allow_gift_receipt boolean OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_allow_gift_receipt'), extension_attributes_wrapping_id string OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_id'), gift_message_id string, message string, recipient string, sender string)
OPTIONS (ANNOTATION 'Return the gift message for a specified order.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/gift-message');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/gift-message_POST"(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN giftMessage_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'giftMessage/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_entity_id string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_entity_type string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_add_printed_card boolean NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_allow_gift_receipt boolean NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_id string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_gift_message_id string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'giftMessage/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_message string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'giftMessage/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftMessage_recipient string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'giftMessage/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftMessage_sender string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'giftMessage/sender', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Set the gift message for an entire order.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/gift-message');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/gift-message/itemId_GET"(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The shopping cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN itemId string NOT NULL OPTIONS (ANNOTATION 'The item ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (customer_id string, extension_attributes_entity_id string OPTIONS (NAMEINSOURCE 'extension_attributes/entity_id'), extension_attributes_entity_type string OPTIONS (NAMEINSOURCE 'extension_attributes/entity_type'), extension_attributes_wrapping_add_printed_card boolean OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_add_printed_card'), extension_attributes_wrapping_allow_gift_receipt boolean OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_allow_gift_receipt'), extension_attributes_wrapping_id string OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_id'), gift_message_id string, message string, recipient string, sender string)
OPTIONS (ANNOTATION 'Return the gift message for a specified item in a specified shopping cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/gift-message/{itemId}');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/gift-message/itemId_POST"(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN itemId string NOT NULL OPTIONS (ANNOTATION 'The item ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN giftMessage_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'giftMessage/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_entity_id string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_entity_type string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_add_printed_card boolean NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_allow_gift_receipt boolean NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_id string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_gift_message_id string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'giftMessage/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_message string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'giftMessage/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftMessage_recipient string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'giftMessage/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftMessage_sender string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'giftMessage/sender', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Set the gift message for a specified item in a specified shopping cart.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/gift-message/{itemId}');

CREATE FOREIGN PROCEDURE giftCardAccountGiftCardAccountManagementV1SaveByQuoteIdPut(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN giftCardAccountData_base_gift_cards_amount string NOT NULL OPTIONS (ANNOTATION 'Cards amount in base currency', NAMEINSOURCE 'giftCardAccountData/base_gift_cards_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftCardAccountData_base_gift_cards_amount_used string NOT NULL OPTIONS (ANNOTATION 'Cards amount used in base currency', NAMEINSOURCE 'giftCardAccountData/base_gift_cards_amount_used', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftCardAccountData_gift_cards string[] NOT NULL OPTIONS (NAMEINSOURCE 'giftCardAccountData/gift_cards', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftCardAccountData_gift_cards_amount string NOT NULL OPTIONS (ANNOTATION 'Cards amount in quote currency', NAMEINSOURCE 'giftCardAccountData/gift_cards_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftCardAccountData_gift_cards_amount_used string NOT NULL OPTIONS (ANNOTATION 'Cards amount used in quote currency', NAMEINSOURCE 'giftCardAccountData/gift_cards_amount_used', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS ("teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/giftCards');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/giftCards/giftCardCode"(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN giftCardCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove GiftCard Account entity', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/giftCards/{giftCardCode}');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/items"(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (item_id string, name string, price string, "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), product_option_extension_attributes_downloadable_option_downloadable_links string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/downloadable_option/downloadable_links'), product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_message string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_message'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), product_type string, qty string, quote_id string, sku string)
OPTIONS (ANNOTATION 'Lists items that are assigned to a specified cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/items');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/items/itemId_PUT"(IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN itemId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN cartItem_item_id string NOT NULL OPTIONS (ANNOTATION 'Item ID. Otherwise, null.', NAMEINSOURCE 'cartItem/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_name string NOT NULL OPTIONS (ANNOTATION 'Product name. Otherwise, null.', NAMEINSOURCE 'cartItem/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_price string NOT NULL OPTIONS (ANNOTATION 'Product price. Otherwise, null.', NAMEINSOURCE 'cartItem/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'cartItem/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'cartItem/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_downloadable_option_downloadable_links string[] NOT NULL OPTIONS (NAMEINSOURCE 'cartItem/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_amount string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_message string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_type string NOT NULL OPTIONS (ANNOTATION 'Product type. Otherwise, null.', NAMEINSOURCE 'cartItem/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_qty string NOT NULL OPTIONS (ANNOTATION 'Product quantity.', NAMEINSOURCE 'cartItem/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_quote_id string NOT NULL OPTIONS (ANNOTATION 'Quote id.', NAMEINSOURCE 'cartItem/quote_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_sku string NOT NULL OPTIONS (ANNOTATION 'Product SKU. Otherwise, null.', NAMEINSOURCE 'cartItem/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (item_id string, name string, price string, "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), product_option_extension_attributes_downloadable_option_downloadable_links string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/downloadable_option/downloadable_links'), product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_message string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_message'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), product_type string, qty string, quote_id string, sku string)
OPTIONS (ANNOTATION 'Add/update the specified cart item.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/items/{itemId}');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/items/itemId_DELETE"(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN itemId string NOT NULL OPTIONS (ANNOTATION 'The item ID of the item to be removed.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Removes the specified item from the specified cart.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/items/{itemId}');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/order"(OUT "return" string RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN paymentMethod_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'paymentMethod/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'paymentMethod/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Places an order for a specified cart.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/order');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/payment-methods"(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, title string)
OPTIONS (ANNOTATION 'Lists available payment methods for a specified shopping cart. This call returns an array of objects, but detailed information about each object’s attributes might not be included.  See http://devdocs.magento.com/codelinks/attributes.html#PaymentMethodManagementInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/payment-methods');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/selected-payment-method_GET"(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (additional_data string[], extension_attributes_agreement_ids string[] OPTIONS (NAMEINSOURCE 'extension_attributes/agreement_ids'), "method" string, po_number string)
OPTIONS (ANNOTATION 'Returns the payment method for a specified shopping cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/selected-payment-method');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/selected-payment-method_PUT"(OUT "return" string RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN method_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'method/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN method_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'method/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN method_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'method/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN method_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'method/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Adds a specified payment method to a specified shopping cart.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/selected-payment-method');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/shipping-information"(IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN addressInformation_billing_address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'addressInformation/billing_address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'addressInformation/billing_address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'addressInformation/billing_address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_billing_address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/billing_address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_billing_address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/billing_address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'addressInformation/billing_address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'addressInformation/billing_address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'addressInformation/billing_address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/billing_address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'addressInformation/billing_address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'addressInformation/billing_address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'addressInformation/billing_address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'addressInformation/billing_address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'addressInformation/billing_address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'addressInformation/billing_address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'addressInformation/billing_address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'addressInformation/billing_address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'addressInformation/billing_address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'addressInformation/billing_address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'addressInformation/billing_address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'addressInformation/billing_address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/billing_address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'addressInformation/billing_address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'addressInformation/billing_address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'addressInformation/billing_address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "addressInformation_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'addressInformation/shipping_address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'addressInformation/shipping_address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'addressInformation/shipping_address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_shipping_address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/shipping_address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_shipping_address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/shipping_address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'addressInformation/shipping_address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'addressInformation/shipping_address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'addressInformation/shipping_address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/shipping_address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'addressInformation/shipping_address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'addressInformation/shipping_address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'addressInformation/shipping_address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'addressInformation/shipping_address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'addressInformation/shipping_address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'addressInformation/shipping_address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'addressInformation/shipping_address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'addressInformation/shipping_address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'addressInformation/shipping_address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'addressInformation/shipping_address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'addressInformation/shipping_address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'addressInformation/shipping_address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/shipping_address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'addressInformation/shipping_address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'addressInformation/shipping_address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'addressInformation/shipping_address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_carrier_code string NOT NULL OPTIONS (ANNOTATION 'Carrier code', NAMEINSOURCE 'addressInformation/shipping_carrier_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_method_code string NOT NULL OPTIONS (ANNOTATION 'Shipping method code', NAMEINSOURCE 'addressInformation/shipping_method_code', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE ("payment_methods_quote-data-payment-method-interface_code" string OPTIONS (NAMEINSOURCE 'payment_methods[]/quote-data-payment-method-interface/code'), "payment_methods_quote-data-payment-method-interface_title" string OPTIONS (NAMEINSOURCE 'payment_methods[]/quote-data-payment-method-interface/title'), totals_base_currency_code string OPTIONS (NAMEINSOURCE 'totals/base_currency_code'), totals_base_discount_amount string OPTIONS (NAMEINSOURCE 'totals/base_discount_amount'), totals_base_grand_total string OPTIONS (NAMEINSOURCE 'totals/base_grand_total'), totals_base_shipping_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_amount'), totals_base_shipping_discount_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_discount_amount'), totals_base_shipping_incl_tax string OPTIONS (NAMEINSOURCE 'totals/base_shipping_incl_tax'), totals_base_shipping_tax_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_tax_amount'), totals_base_subtotal string OPTIONS (NAMEINSOURCE 'totals/base_subtotal'), totals_base_subtotal_incl_tax string OPTIONS (NAMEINSOURCE 'totals/base_subtotal_incl_tax'), totals_base_subtotal_with_discount string OPTIONS (NAMEINSOURCE 'totals/base_subtotal_with_discount'), totals_base_tax_amount string OPTIONS (NAMEINSOURCE 'totals/base_tax_amount'), totals_coupon_code string OPTIONS (NAMEINSOURCE 'totals/coupon_code'), totals_discount_amount string OPTIONS (NAMEINSOURCE 'totals/discount_amount'), totals_extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/base_customer_balance_amount'), totals_extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/base_reward_currency_amount'), totals_extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/customer_balance_amount'), totals_extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/reward_currency_amount'), totals_extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/reward_points_balance'), totals_grand_total string OPTIONS (NAMEINSOURCE 'totals/grand_total'), "totals_items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_discount_amount'), "totals_items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_price'), "totals_items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_price_incl_tax'), "totals_items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_row_total'), "totals_items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "totals_items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_tax_amount'), "totals_items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/discount_amount'), "totals_items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/discount_percent'), "totals_items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/item_id'), "totals_items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/name'), "totals_items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/options'), "totals_items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/price'), "totals_items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/price_incl_tax'), "totals_items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/qty'), "totals_items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total'), "totals_items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total_incl_tax'), "totals_items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total_with_discount'), "totals_items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/tax_amount'), "totals_items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/tax_percent'), "totals_items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/weee_tax_applied'), "totals_items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), totals_items_qty string OPTIONS (NAMEINSOURCE 'totals/items_qty'), totals_quote_currency_code string OPTIONS (NAMEINSOURCE 'totals/quote_currency_code'), totals_shipping_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_amount'), totals_shipping_discount_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_discount_amount'), totals_shipping_incl_tax string OPTIONS (NAMEINSOURCE 'totals/shipping_incl_tax'), totals_shipping_tax_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_tax_amount'), totals_subtotal string OPTIONS (NAMEINSOURCE 'totals/subtotal'), totals_subtotal_incl_tax string OPTIONS (NAMEINSOURCE 'totals/subtotal_incl_tax'), totals_subtotal_with_discount string OPTIONS (NAMEINSOURCE 'totals/subtotal_with_discount'), totals_tax_amount string OPTIONS (NAMEINSOURCE 'totals/tax_amount'), "totals_total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/area'), "totals_total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/code'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "totals_total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/title'), "totals_total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/value'), totals_weee_tax_applied_amount string OPTIONS (NAMEINSOURCE 'totals/weee_tax_applied_amount'))
OPTIONS ("teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/shipping-information');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/shipping-methods"(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The shopping cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (amount string, available boolean, base_amount string, carrier_code string, carrier_title string, error_message string, method_code string, method_title string, price_excl_tax string, price_incl_tax string)
OPTIONS (ANNOTATION 'Lists applicable shipping methods for a specified quote.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/shipping-methods');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/totals"(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (base_currency_code string, base_discount_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_amount string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_subtotal_with_discount string, base_tax_amount string, coupon_code string, discount_amount string, extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_reward_currency_amount'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_currency_amount'), extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_points_balance'), grand_total string, "items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_discount_amount'), "items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price'), "items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price_incl_tax'), "items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total'), "items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_tax_amount'), "items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_amount'), "items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_percent'), "items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/item_id'), "items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/name'), "items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/options'), "items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price'), "items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price_incl_tax'), "items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/qty'), "items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total'), "items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_incl_tax'), "items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_with_discount'), "items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_amount'), "items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_percent'), "items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied'), "items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), items_qty string, quote_currency_code string, shipping_amount string, shipping_discount_amount string, shipping_incl_tax string, shipping_tax_amount string, subtotal string, subtotal_incl_tax string, subtotal_with_discount string, tax_amount string, "total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/area'), "total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/code'), "total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/title'), "total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/value'), weee_tax_applied_amount string)
OPTIONS (ANNOTATION 'Returns quote totals data for a specified cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/totals');

CREATE FOREIGN PROCEDURE "V1/carts/cartId/totals-information"(IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN addressInformation_address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'addressInformation/address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'addressInformation/address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'addressInformation/address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'addressInformation/address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'addressInformation/address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'addressInformation/address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'addressInformation/address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'addressInformation/address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'addressInformation/address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'addressInformation/address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'addressInformation/address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'addressInformation/address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'addressInformation/address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'addressInformation/address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'addressInformation/address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'addressInformation/address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'addressInformation/address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'addressInformation/address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'addressInformation/address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'addressInformation/address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'addressInformation/address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "addressInformation_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_carrier_code string NOT NULL OPTIONS (ANNOTATION 'Carrier code', NAMEINSOURCE 'addressInformation/shipping_carrier_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_method_code string NOT NULL OPTIONS (ANNOTATION 'Shipping method code', NAMEINSOURCE 'addressInformation/shipping_method_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (base_currency_code string, base_discount_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_amount string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_subtotal_with_discount string, base_tax_amount string, coupon_code string, discount_amount string, extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_reward_currency_amount'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_currency_amount'), extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_points_balance'), grand_total string, "items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_discount_amount'), "items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price'), "items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price_incl_tax'), "items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total'), "items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_tax_amount'), "items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_amount'), "items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_percent'), "items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/item_id'), "items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/name'), "items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/options'), "items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price'), "items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price_incl_tax'), "items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/qty'), "items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total'), "items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_incl_tax'), "items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_with_discount'), "items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_amount'), "items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_percent'), "items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied'), "items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), items_qty string, quote_currency_code string, shipping_amount string, shipping_discount_amount string, shipping_incl_tax string, shipping_tax_amount string, subtotal string, subtotal_incl_tax string, subtotal_with_discount string, tax_amount string, "total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/area'), "total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/code'), "total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/title'), "total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/value'), weee_tax_applied_amount string)
OPTIONS (ANNOTATION 'Calculate quote totals based on address and shipping method.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{cartId}/totals-information');

CREATE FOREIGN PROCEDURE giftCardAccountGiftCardAccountManagementV1GetListByQuoteIdGet(IN quoteId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (base_gift_cards_amount string, base_gift_cards_amount_used string, gift_cards string[], gift_cards_amount string, gift_cards_amount_used string)
OPTIONS (ANNOTATION 'Return GiftCard Account cards', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{quoteId}/giftCards');

CREATE FOREIGN PROCEDURE "V1/carts/quoteId/items"(IN quoteId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN cartItem_item_id string NOT NULL OPTIONS (ANNOTATION 'Item ID. Otherwise, null.', NAMEINSOURCE 'cartItem/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_name string NOT NULL OPTIONS (ANNOTATION 'Product name. Otherwise, null.', NAMEINSOURCE 'cartItem/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_price string NOT NULL OPTIONS (ANNOTATION 'Product price. Otherwise, null.', NAMEINSOURCE 'cartItem/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'cartItem/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'cartItem/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_downloadable_option_downloadable_links string[] NOT NULL OPTIONS (NAMEINSOURCE 'cartItem/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_amount string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_message string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_type string NOT NULL OPTIONS (ANNOTATION 'Product type. Otherwise, null.', NAMEINSOURCE 'cartItem/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_qty string NOT NULL OPTIONS (ANNOTATION 'Product quantity.', NAMEINSOURCE 'cartItem/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_quote_id string NOT NULL OPTIONS (ANNOTATION 'Quote id.', NAMEINSOURCE 'cartItem/quote_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_sku string NOT NULL OPTIONS (ANNOTATION 'Product SKU. Otherwise, null.', NAMEINSOURCE 'cartItem/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (item_id string, name string, price string, "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), product_option_extension_attributes_downloadable_option_downloadable_links string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/downloadable_option/downloadable_links'), product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_message string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_message'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), product_type string, qty string, quote_id string, sku string)
OPTIONS (ANNOTATION 'Add/update the specified cart item.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/carts/{quoteId}/items');

CREATE FOREIGN PROCEDURE catalogCategoryManagementV1GetTreeGet(IN rootCategoryId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN depth string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("children_data_catalog-data-category-tree-interface_id" string OPTIONS (NAMEINSOURCE 'children_data[]/catalog-data-category-tree-interface/id'), "children_data_catalog-data-category-tree-interface_is_active" boolean OPTIONS (NAMEINSOURCE 'children_data[]/catalog-data-category-tree-interface/is_active'), "children_data_catalog-data-category-tree-interface_level" string OPTIONS (NAMEINSOURCE 'children_data[]/catalog-data-category-tree-interface/level'), "children_data_catalog-data-category-tree-interface_name" string OPTIONS (NAMEINSOURCE 'children_data[]/catalog-data-category-tree-interface/name'), "children_data_catalog-data-category-tree-interface_parent_id" string OPTIONS (NAMEINSOURCE 'children_data[]/catalog-data-category-tree-interface/parent_id'), "children_data_catalog-data-category-tree-interface_position" string OPTIONS (NAMEINSOURCE 'children_data[]/catalog-data-category-tree-interface/position'), "children_data_catalog-data-category-tree-interface_product_count" string OPTIONS (NAMEINSOURCE 'children_data[]/catalog-data-category-tree-interface/product_count'), id string, is_active boolean, level string, name string, parent_id string, position string, product_count string)
OPTIONS (ANNOTATION 'Retrieve list of categories', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories');

CREATE FOREIGN PROCEDURE catalogCategoryRepositoryV1SavePost(IN category_available_sort_by string[] NOT NULL OPTIONS (NAMEINSOURCE 'category/available_sort_by', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_children string NOT NULL OPTIONS (NAMEINSOURCE 'category/children', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_created_at string NOT NULL OPTIONS (NAMEINSOURCE 'category/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "category_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'category/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "category_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'category/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN category_id string NOT NULL OPTIONS (NAMEINSOURCE 'category/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_include_in_menu boolean NOT NULL OPTIONS (NAMEINSOURCE 'category/include_in_menu', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_is_active boolean NOT NULL OPTIONS (ANNOTATION 'Whether category is active', NAMEINSOURCE 'category/is_active', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_level string NOT NULL OPTIONS (ANNOTATION 'Category level', NAMEINSOURCE 'category/level', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_name string NOT NULL OPTIONS (ANNOTATION 'Category name', NAMEINSOURCE 'category/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN category_parent_id string NOT NULL OPTIONS (ANNOTATION 'Parent category ID', NAMEINSOURCE 'category/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_path string NOT NULL OPTIONS (NAMEINSOURCE 'category/path', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_position string NOT NULL OPTIONS (ANNOTATION 'Category position', NAMEINSOURCE 'category/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_updated_at string NOT NULL OPTIONS (NAMEINSOURCE 'category/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (available_sort_by string[], children string, created_at string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), id string, include_in_menu boolean, is_active boolean, level string, name string, parent_id string, path string, position string, updated_at string)
OPTIONS (ANNOTATION 'Create category service', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories');

CREATE FOREIGN PROCEDURE catalogCategoryAttributeRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_catalog-data-category-attribute-interface_apply_to" string[] OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/apply_to'), "items_catalog-data-category-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/attribute_code'), "items_catalog-data-category-attribute-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/attribute_id'), "items_catalog-data-category-attribute-interface_backend_model" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/backend_model'), "items_catalog-data-category-attribute-interface_backend_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/backend_type'), "items_catalog-data-category-attribute-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_catalog-data-category-attribute-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/custom_attributes[]/framework-attribute-interface/value'), "items_catalog-data-category-attribute-interface_default_frontend_label" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/default_frontend_label'), "items_catalog-data-category-attribute-interface_default_value" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/default_value'), "items_catalog-data-category-attribute-interface_entity_type_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/entity_type_id'), "items_catalog-data-category-attribute-interface_frontend_class" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/frontend_class'), "items_catalog-data-category-attribute-interface_frontend_input" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/frontend_input'), "items_catalog-data-category-attribute-interface_frontend_labels_eav-data-attribute-frontend-label-interface_label" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/frontend_labels[]/eav-data-attribute-frontend-label-interface/label'), "items_catalog-data-category-attribute-interface_frontend_labels_eav-data-attribute-frontend-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/frontend_labels[]/eav-data-attribute-frontend-label-interface/store_id'), "items_catalog-data-category-attribute-interface_is_comparable" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_comparable'), "items_catalog-data-category-attribute-interface_is_filterable" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_filterable'), "items_catalog-data-category-attribute-interface_is_filterable_in_grid" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_filterable_in_grid'), "items_catalog-data-category-attribute-interface_is_filterable_in_search" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_filterable_in_search'), "items_catalog-data-category-attribute-interface_is_html_allowed_on_front" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_html_allowed_on_front'), "items_catalog-data-category-attribute-interface_is_required" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_required'), "items_catalog-data-category-attribute-interface_is_searchable" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_searchable'), "items_catalog-data-category-attribute-interface_is_unique" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_unique'), "items_catalog-data-category-attribute-interface_is_used_for_promo_rules" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_used_for_promo_rules'), "items_catalog-data-category-attribute-interface_is_used_in_grid" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_used_in_grid'), "items_catalog-data-category-attribute-interface_is_user_defined" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_user_defined'), "items_catalog-data-category-attribute-interface_is_visible" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_visible'), "items_catalog-data-category-attribute-interface_is_visible_in_advanced_search" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_visible_in_advanced_search'), "items_catalog-data-category-attribute-interface_is_visible_in_grid" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_visible_in_grid'), "items_catalog-data-category-attribute-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_visible_on_front'), "items_catalog-data-category-attribute-interface_is_wysiwyg_enabled" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/is_wysiwyg_enabled'), "items_catalog-data-category-attribute-interface_note" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/note'), "items_catalog-data-category-attribute-interface_options_eav-data-attribute-option-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/options[]/eav-data-attribute-option-interface/is_default'), "items_catalog-data-category-attribute-interface_options_eav-data-attribute-option-interface_label" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/options[]/eav-data-attribute-option-interface/label'), "items_catalog-data-category-attribute-interface_options_eav-data-attribute-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/options[]/eav-data-attribute-option-interface/sort_order'), "items_catalog-data-category-attribute-interface_options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_label" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/label'), "items_catalog-data-category-attribute-interface_options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/store_id'), "items_catalog-data-category-attribute-interface_options_eav-data-attribute-option-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/options[]/eav-data-attribute-option-interface/value'), "items_catalog-data-category-attribute-interface_position" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/position'), "items_catalog-data-category-attribute-interface_scope" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/scope'), "items_catalog-data-category-attribute-interface_source_model" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/source_model'), "items_catalog-data-category-attribute-interface_used_for_sort_by" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/used_for_sort_by'), "items_catalog-data-category-attribute-interface_used_in_product_listing" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/used_in_product_listing'), "items_catalog-data-category-attribute-interface_validation_rules_eav-data-attribute-validation-rule-interface_key" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/validation_rules[]/eav-data-attribute-validation-rule-interface/key'), "items_catalog-data-category-attribute-interface_validation_rules_eav-data-attribute-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-category-attribute-interface/validation_rules[]/eav-data-attribute-validation-rule-interface/value'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Retrieve all attributes for entity type', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories/attributes');

CREATE FOREIGN PROCEDURE catalogCategoryAttributeRepositoryV1GetGet(IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (apply_to string[], attribute_code string, attribute_id string, backend_model string, backend_type string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_frontend_label string, default_value string, entity_type_id string, frontend_class string, frontend_input string, "frontend_labels_eav-data-attribute-frontend-label-interface_label" string OPTIONS (NAMEINSOURCE 'frontend_labels[]/eav-data-attribute-frontend-label-interface/label'), "frontend_labels_eav-data-attribute-frontend-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'frontend_labels[]/eav-data-attribute-frontend-label-interface/store_id'), is_comparable string, is_filterable boolean, is_filterable_in_grid boolean, is_filterable_in_search boolean, is_html_allowed_on_front boolean, is_required boolean, is_searchable string, is_unique string, is_used_for_promo_rules string, is_used_in_grid boolean, is_user_defined boolean, is_visible boolean, is_visible_in_advanced_search string, is_visible_in_grid boolean, is_visible_on_front string, is_wysiwyg_enabled boolean, note string, "options_eav-data-attribute-option-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/is_default'), "options_eav-data-attribute-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/label'), "options_eav-data-attribute-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/sort_order'), "options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/label'), "options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/store_id'), "options_eav-data-attribute-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/value'), position string, scope string, source_model string, used_for_sort_by boolean, used_in_product_listing string, "validation_rules_eav-data-attribute-validation-rule-interface_key" string OPTIONS (NAMEINSOURCE 'validation_rules[]/eav-data-attribute-validation-rule-interface/key'), "validation_rules_eav-data-attribute-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/eav-data-attribute-validation-rule-interface/value'))
OPTIONS (ANNOTATION 'Retrieve specific attribute', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories/attributes/{attributeCode}');

CREATE FOREIGN PROCEDURE catalogCategoryAttributeOptionManagementV1GetItemsGet(IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (is_default boolean, label string, sort_order string, "store_labels_eav-data-attribute-option-label-interface_label" string OPTIONS (NAMEINSOURCE 'store_labels[]/eav-data-attribute-option-label-interface/label'), "store_labels_eav-data-attribute-option-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'store_labels[]/eav-data-attribute-option-label-interface/store_id'), "value" string)
OPTIONS (ANNOTATION 'Retrieve list of attribute options', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories/attributes/{attributeCode}/options');

CREATE FOREIGN PROCEDURE catalogCategoryRepositoryV1GetGet(IN categoryId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN storeId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (available_sort_by string[], children string, created_at string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), id string, include_in_menu boolean, is_active boolean, level string, name string, parent_id string, path string, position string, updated_at string)
OPTIONS (ANNOTATION 'Get info about category by category id', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories/{categoryId}');

CREATE FOREIGN PROCEDURE catalogCategoryRepositoryV1DeleteByIdentifierDelete(OUT "return" boolean RESULT, IN categoryId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete category by identifier', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories/{categoryId}');

CREATE FOREIGN PROCEDURE catalogCategoryManagementV1MovePut(OUT "return" boolean RESULT, IN categoryId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN afterId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN parentId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Move category', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories/{categoryId}/move');

CREATE FOREIGN PROCEDURE catalogCategoryLinkManagementV1GetAssignedProductsGet(IN categoryId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (category_id string, position string, sku string)
OPTIONS (ANNOTATION 'Get products assigned to category', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories/{categoryId}/products');

CREATE FOREIGN PROCEDURE catalogCategoryLinkRepositoryV1SavePut(OUT "return" boolean RESULT, IN categoryId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN productLink_category_id string NOT NULL OPTIONS (ANNOTATION 'Category id', NAMEINSOURCE 'productLink/category_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN productLink_position string NOT NULL OPTIONS (NAMEINSOURCE 'productLink/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN productLink_sku string NOT NULL OPTIONS (NAMEINSOURCE 'productLink/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Assign a product to the required category', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories/{categoryId}/products');

CREATE FOREIGN PROCEDURE catalogCategoryLinkRepositoryV1SavePost(OUT "return" boolean RESULT, IN categoryId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN productLink_category_id string NOT NULL OPTIONS (ANNOTATION 'Category id', NAMEINSOURCE 'productLink/category_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN productLink_position string NOT NULL OPTIONS (NAMEINSOURCE 'productLink/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN productLink_sku string NOT NULL OPTIONS (NAMEINSOURCE 'productLink/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Assign a product to the required category', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories/{categoryId}/products');

CREATE FOREIGN PROCEDURE catalogCategoryLinkRepositoryV1DeleteByIdsDelete(OUT "return" boolean RESULT, IN categoryId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove the product assignment from the category by category id and sku', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories/{categoryId}/products/{sku}');

CREATE FOREIGN PROCEDURE catalogCategoryRepositoryV1SavePut(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN category_available_sort_by string[] NOT NULL OPTIONS (NAMEINSOURCE 'category/available_sort_by', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_children string NOT NULL OPTIONS (NAMEINSOURCE 'category/children', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_created_at string NOT NULL OPTIONS (NAMEINSOURCE 'category/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "category_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'category/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "category_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'category/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN category_id string NOT NULL OPTIONS (NAMEINSOURCE 'category/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_include_in_menu boolean NOT NULL OPTIONS (NAMEINSOURCE 'category/include_in_menu', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_is_active boolean NOT NULL OPTIONS (ANNOTATION 'Whether category is active', NAMEINSOURCE 'category/is_active', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_level string NOT NULL OPTIONS (ANNOTATION 'Category level', NAMEINSOURCE 'category/level', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_name string NOT NULL OPTIONS (ANNOTATION 'Category name', NAMEINSOURCE 'category/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN category_parent_id string NOT NULL OPTIONS (ANNOTATION 'Parent category ID', NAMEINSOURCE 'category/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_path string NOT NULL OPTIONS (NAMEINSOURCE 'category/path', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_position string NOT NULL OPTIONS (ANNOTATION 'Category position', NAMEINSOURCE 'category/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN category_updated_at string NOT NULL OPTIONS (NAMEINSOURCE 'category/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (available_sort_by string[], children string, created_at string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), id string, include_in_menu boolean, is_active boolean, level string, name string, parent_id string, path string, position string, updated_at string)
OPTIONS (ANNOTATION 'Create category service', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/categories/{id}');

CREATE FOREIGN PROCEDURE cmsBlockRepositoryV1SavePost(IN block_active boolean NOT NULL OPTIONS (ANNOTATION 'Active', NAMEINSOURCE 'block/active', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN block_content string NOT NULL OPTIONS (ANNOTATION 'Content', NAMEINSOURCE 'block/content', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN block_creation_time string NOT NULL OPTIONS (ANNOTATION 'Creation time', NAMEINSOURCE 'block/creation_time', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN block_id string NOT NULL OPTIONS (ANNOTATION 'ID', NAMEINSOURCE 'block/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN block_identifier string NOT NULL OPTIONS (ANNOTATION 'Identifier', NAMEINSOURCE 'block/identifier', "teiid_rest:PARAMETER_TYPE" 'body'), IN block_title string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'block/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN block_update_time string NOT NULL OPTIONS (ANNOTATION 'Update time', NAMEINSOURCE 'block/update_time', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (active boolean, content string, creation_time string, id string, identifier string, title string, update_time string)
OPTIONS (ANNOTATION 'Save block.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/cmsBlock');

CREATE FOREIGN PROCEDURE cmsBlockRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_cms-data-block-interface_active" boolean OPTIONS (NAMEINSOURCE 'items[]/cms-data-block-interface/active'), "items_cms-data-block-interface_content" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-block-interface/content'), "items_cms-data-block-interface_creation_time" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-block-interface/creation_time'), "items_cms-data-block-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-block-interface/id'), "items_cms-data-block-interface_identifier" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-block-interface/identifier'), "items_cms-data-block-interface_title" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-block-interface/title'), "items_cms-data-block-interface_update_time" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-block-interface/update_time'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Retrieve blocks matching the specified criteria.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/cmsBlock/search');

CREATE FOREIGN PROCEDURE cmsBlockRepositoryV1GetByIdGet(IN blockId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (active boolean, content string, creation_time string, id string, identifier string, title string, update_time string)
OPTIONS (ANNOTATION 'Retrieve block.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/cmsBlock/{blockId}');

CREATE FOREIGN PROCEDURE cmsBlockRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN blockId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete block by ID.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/cmsBlock/{blockId}');

CREATE FOREIGN PROCEDURE cmsBlockRepositoryV1SavePut(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN block_active boolean NOT NULL OPTIONS (ANNOTATION 'Active', NAMEINSOURCE 'block/active', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN block_content string NOT NULL OPTIONS (ANNOTATION 'Content', NAMEINSOURCE 'block/content', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN block_creation_time string NOT NULL OPTIONS (ANNOTATION 'Creation time', NAMEINSOURCE 'block/creation_time', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN block_id string NOT NULL OPTIONS (ANNOTATION 'ID', NAMEINSOURCE 'block/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN block_identifier string NOT NULL OPTIONS (ANNOTATION 'Identifier', NAMEINSOURCE 'block/identifier', "teiid_rest:PARAMETER_TYPE" 'body'), IN block_title string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'block/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN block_update_time string NOT NULL OPTIONS (ANNOTATION 'Update time', NAMEINSOURCE 'block/update_time', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (active boolean, content string, creation_time string, id string, identifier string, title string, update_time string)
OPTIONS (ANNOTATION 'Save block.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/cmsBlock/{id}');

CREATE FOREIGN PROCEDURE cmsPageRepositoryV1SavePost(IN page_active boolean NOT NULL OPTIONS (ANNOTATION 'Active', NAMEINSOURCE 'page/active', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_content string NOT NULL OPTIONS (ANNOTATION 'Content', NAMEINSOURCE 'page/content', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_content_heading string NOT NULL OPTIONS (ANNOTATION 'Content heading', NAMEINSOURCE 'page/content_heading', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_creation_time string NOT NULL OPTIONS (ANNOTATION 'Creation time', NAMEINSOURCE 'page/creation_time', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_custom_layout_update_xml string NOT NULL OPTIONS (ANNOTATION 'Custom layout update xml', NAMEINSOURCE 'page/custom_layout_update_xml', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_custom_root_template string NOT NULL OPTIONS (ANNOTATION 'Custom root template', NAMEINSOURCE 'page/custom_root_template', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_custom_theme string NOT NULL OPTIONS (ANNOTATION 'Custom theme', NAMEINSOURCE 'page/custom_theme', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_custom_theme_from string NOT NULL OPTIONS (ANNOTATION 'Custom theme from', NAMEINSOURCE 'page/custom_theme_from', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_custom_theme_to string NOT NULL OPTIONS (ANNOTATION 'Custom theme to', NAMEINSOURCE 'page/custom_theme_to', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_id string NOT NULL OPTIONS (ANNOTATION 'ID', NAMEINSOURCE 'page/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_identifier string NOT NULL OPTIONS (ANNOTATION 'Identifier', NAMEINSOURCE 'page/identifier', "teiid_rest:PARAMETER_TYPE" 'body'), IN page_layout_update_xml string NOT NULL OPTIONS (ANNOTATION 'Layout update xml', NAMEINSOURCE 'page/layout_update_xml', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_meta_description string NOT NULL OPTIONS (ANNOTATION 'Meta description', NAMEINSOURCE 'page/meta_description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_meta_keywords string NOT NULL OPTIONS (ANNOTATION 'Meta keywords', NAMEINSOURCE 'page/meta_keywords', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_meta_title string NOT NULL OPTIONS (ANNOTATION 'Meta title', NAMEINSOURCE 'page/meta_title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_page_layout string NOT NULL OPTIONS (ANNOTATION 'Page layout', NAMEINSOURCE 'page/page_layout', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_sort_order string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'page/sort_order', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_title string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'page/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_update_time string NOT NULL OPTIONS (ANNOTATION 'Update time', NAMEINSOURCE 'page/update_time', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (active boolean, content string, content_heading string, creation_time string, custom_layout_update_xml string, custom_root_template string, custom_theme string, custom_theme_from string, custom_theme_to string, id string, identifier string, layout_update_xml string, meta_description string, meta_keywords string, meta_title string, page_layout string, sort_order string, title string, update_time string)
OPTIONS (ANNOTATION 'Save page.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/cmsPage');

CREATE FOREIGN PROCEDURE cmsPageRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_cms-data-page-interface_active" boolean OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/active'), "items_cms-data-page-interface_content" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/content'), "items_cms-data-page-interface_content_heading" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/content_heading'), "items_cms-data-page-interface_creation_time" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/creation_time'), "items_cms-data-page-interface_custom_layout_update_xml" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/custom_layout_update_xml'), "items_cms-data-page-interface_custom_root_template" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/custom_root_template'), "items_cms-data-page-interface_custom_theme" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/custom_theme'), "items_cms-data-page-interface_custom_theme_from" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/custom_theme_from'), "items_cms-data-page-interface_custom_theme_to" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/custom_theme_to'), "items_cms-data-page-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/id'), "items_cms-data-page-interface_identifier" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/identifier'), "items_cms-data-page-interface_layout_update_xml" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/layout_update_xml'), "items_cms-data-page-interface_meta_description" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/meta_description'), "items_cms-data-page-interface_meta_keywords" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/meta_keywords'), "items_cms-data-page-interface_meta_title" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/meta_title'), "items_cms-data-page-interface_page_layout" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/page_layout'), "items_cms-data-page-interface_sort_order" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/sort_order'), "items_cms-data-page-interface_title" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/title'), "items_cms-data-page-interface_update_time" string OPTIONS (NAMEINSOURCE 'items[]/cms-data-page-interface/update_time'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Retrieve pages matching the specified criteria.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/cmsPage/search');

CREATE FOREIGN PROCEDURE cmsPageRepositoryV1SavePut(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN page_active boolean NOT NULL OPTIONS (ANNOTATION 'Active', NAMEINSOURCE 'page/active', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_content string NOT NULL OPTIONS (ANNOTATION 'Content', NAMEINSOURCE 'page/content', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_content_heading string NOT NULL OPTIONS (ANNOTATION 'Content heading', NAMEINSOURCE 'page/content_heading', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_creation_time string NOT NULL OPTIONS (ANNOTATION 'Creation time', NAMEINSOURCE 'page/creation_time', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_custom_layout_update_xml string NOT NULL OPTIONS (ANNOTATION 'Custom layout update xml', NAMEINSOURCE 'page/custom_layout_update_xml', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_custom_root_template string NOT NULL OPTIONS (ANNOTATION 'Custom root template', NAMEINSOURCE 'page/custom_root_template', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_custom_theme string NOT NULL OPTIONS (ANNOTATION 'Custom theme', NAMEINSOURCE 'page/custom_theme', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_custom_theme_from string NOT NULL OPTIONS (ANNOTATION 'Custom theme from', NAMEINSOURCE 'page/custom_theme_from', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_custom_theme_to string NOT NULL OPTIONS (ANNOTATION 'Custom theme to', NAMEINSOURCE 'page/custom_theme_to', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_id string NOT NULL OPTIONS (ANNOTATION 'ID', NAMEINSOURCE 'page/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_identifier string NOT NULL OPTIONS (ANNOTATION 'Identifier', NAMEINSOURCE 'page/identifier', "teiid_rest:PARAMETER_TYPE" 'body'), IN page_layout_update_xml string NOT NULL OPTIONS (ANNOTATION 'Layout update xml', NAMEINSOURCE 'page/layout_update_xml', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_meta_description string NOT NULL OPTIONS (ANNOTATION 'Meta description', NAMEINSOURCE 'page/meta_description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_meta_keywords string NOT NULL OPTIONS (ANNOTATION 'Meta keywords', NAMEINSOURCE 'page/meta_keywords', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_meta_title string NOT NULL OPTIONS (ANNOTATION 'Meta title', NAMEINSOURCE 'page/meta_title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_page_layout string NOT NULL OPTIONS (ANNOTATION 'Page layout', NAMEINSOURCE 'page/page_layout', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_sort_order string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'page/sort_order', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_title string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'page/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN page_update_time string NOT NULL OPTIONS (ANNOTATION 'Update time', NAMEINSOURCE 'page/update_time', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (active boolean, content string, content_heading string, creation_time string, custom_layout_update_xml string, custom_root_template string, custom_theme string, custom_theme_from string, custom_theme_to string, id string, identifier string, layout_update_xml string, meta_description string, meta_keywords string, meta_title string, page_layout string, sort_order string, title string, update_time string)
OPTIONS (ANNOTATION 'Save page.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/cmsPage/{id}');

CREATE FOREIGN PROCEDURE cmsPageRepositoryV1GetByIdGet(IN pageId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (active boolean, content string, content_heading string, creation_time string, custom_layout_update_xml string, custom_root_template string, custom_theme string, custom_theme_from string, custom_theme_to string, id string, identifier string, layout_update_xml string, meta_description string, meta_keywords string, meta_title string, page_layout string, sort_order string, title string, update_time string)
OPTIONS (ANNOTATION 'Retrieve page.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/cmsPage/{pageId}');

CREATE FOREIGN PROCEDURE cmsPageRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN pageId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete page by ID.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/cmsPage/{pageId}');

CREATE FOREIGN PROCEDURE configurableProductConfigurableProductManagementV1GenerateVariationPut(IN "options_configurable-product-data-option-interface_attribute_id" string NOT NULL OPTIONS (NAMEINSOURCE 'options[]/configurable-product-data-option-interface/attribute_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "options_configurable-product-data-option-interface_id" string NOT NULL OPTIONS (NAMEINSOURCE 'options[]/configurable-product-data-option-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "options_configurable-product-data-option-interface_is_use_default" boolean NOT NULL OPTIONS (NAMEINSOURCE 'options[]/configurable-product-data-option-interface/is_use_default', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "options_configurable-product-data-option-interface_label" string NOT NULL OPTIONS (NAMEINSOURCE 'options[]/configurable-product-data-option-interface/label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "options_configurable-product-data-option-interface_position" string NOT NULL OPTIONS (NAMEINSOURCE 'options[]/configurable-product-data-option-interface/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "options_configurable-product-data-option-interface_product_id" string NOT NULL OPTIONS (NAMEINSOURCE 'options[]/configurable-product-data-option-interface/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "options_configurable-product-data-option-interface_values_configurable-product-data-option-value-interface_value_index" string NOT NULL OPTIONS (NAMEINSOURCE 'options[]/configurable-product-data-option-interface/values[]/configurable-product-data-option-value-interface/value_index', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_attribute_set_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set id', NAMEINSOURCE 'product/attribute_set_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_created_at string NOT NULL OPTIONS (ANNOTATION 'Created date', NAMEINSOURCE 'product/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'product/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'product/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Option position', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_can_change_quantity" string NOT NULL OPTIONS (ANNOTATION 'Whether quantity could be changed', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/can_change_quantity', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_id" string NOT NULL OPTIONS (ANNOTATION 'The identifier', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_is_default" boolean NOT NULL OPTIONS (ANNOTATION 'Is default', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/is_default', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Position', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Qty', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Linked product sku', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_required" boolean NOT NULL OPTIONS (ANNOTATION 'Is required option', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/required', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Product sku', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_type" string NOT NULL OPTIONS (ANNOTATION 'Input type', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_extension_attributes_configurable_product_links string[] NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_attribute_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/attribute_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_is_use_default" boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/is_use_default', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_label" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_position" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_product_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_values_configurable-product-data-option-value-interface_value_index" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/values[]/configurable-product-data-option-value-interface/value_index', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_id" string NOT NULL OPTIONS (ANNOTATION 'Sample(or link) id', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_is_shareable" string NOT NULL OPTIONS (ANNOTATION 'Shareable status', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/is_shareable', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file" string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_file_data" string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_name" string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_type" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_url" string NOT NULL OPTIONS (ANNOTATION 'Link url or null when type is ''file''', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_number_of_downloads" string NOT NULL OPTIONS (ANNOTATION 'Of downloads per user', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/number_of_downloads', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file" string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_file_data" string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_name" string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_type" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_url" string NOT NULL OPTIONS (ANNOTATION 'file URL', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sort_order" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_title" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_id" string NOT NULL OPTIONS (ANNOTATION 'Sample(or link) id', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file" string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_file_data" string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_name" string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_type" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_url" string NOT NULL OPTIONS (ANNOTATION 'file URL', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Order index for sample', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_attribute_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/attribute_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_value" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_value" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_backorders string NOT NULL OPTIONS (ANNOTATION 'Backorders status', NAMEINSOURCE 'product/extension_attributes/stock_item/backorders', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_enable_qty_increments boolean NOT NULL OPTIONS (ANNOTATION 'Whether Quantity Increments is enabled', NAMEINSOURCE 'product/extension_attributes/stock_item/enable_qty_increments', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_is_decimal_divided boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/is_decimal_divided', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_is_in_stock boolean NOT NULL OPTIONS (ANNOTATION 'Stock Availability', NAMEINSOURCE 'product/extension_attributes/stock_item/is_in_stock', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_is_qty_decimal boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/is_qty_decimal', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_item_id string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_extension_attributes_stock_item_low_stock_date string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/low_stock_date', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_manage_stock boolean NOT NULL OPTIONS (ANNOTATION 'Can Manage Stock', NAMEINSOURCE 'product/extension_attributes/stock_item/manage_stock', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_max_sale_qty string NOT NULL OPTIONS (ANNOTATION 'Maximum Qty Allowed in Shopping Cart data wrapper', NAMEINSOURCE 'product/extension_attributes/stock_item/max_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_min_qty string NOT NULL OPTIONS (ANNOTATION 'Minimal quantity available for item status in stock', NAMEINSOURCE 'product/extension_attributes/stock_item/min_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_min_sale_qty string NOT NULL OPTIONS (ANNOTATION 'Minimum Qty Allowed in Shopping Cart or NULL when there is no limitation', NAMEINSOURCE 'product/extension_attributes/stock_item/min_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_notify_stock_qty string NOT NULL OPTIONS (ANNOTATION 'Notify for Quantity Below data wrapper', NAMEINSOURCE 'product/extension_attributes/stock_item/notify_stock_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_product_id string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_extension_attributes_stock_item_qty string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_qty_increments string NOT NULL OPTIONS (ANNOTATION 'Quantity Increments data wrapper', NAMEINSOURCE 'product/extension_attributes/stock_item/qty_increments', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_show_default_notification_message boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/show_default_notification_message', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_stock_id string NOT NULL OPTIONS (ANNOTATION 'Stock identifier', NAMEINSOURCE 'product/extension_attributes/stock_item/stock_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_extension_attributes_stock_item_stock_status_changed_auto string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/stock_status_changed_auto', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_backorders boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_backorders', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_enable_qty_inc boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_enable_qty_inc', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_manage_stock boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_manage_stock', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_max_sale_qty boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_max_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_min_qty boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_min_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_min_sale_qty string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_min_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_notify_stock_qty boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_notify_stock_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_qty_increments boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_qty_increments', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'product/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_disabled" boolean NOT NULL OPTIONS (ANNOTATION 'If gallery entry is hidden from product page', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/disabled', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_media_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/media_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_description" string NOT NULL OPTIONS (ANNOTATION 'Video Description', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_description', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_metadata" string NOT NULL OPTIONS (ANNOTATION 'Metadata', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_metadata', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_provider" string NOT NULL OPTIONS (ANNOTATION 'Provider', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_provider', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_url" string NOT NULL OPTIONS (ANNOTATION 'Video URL', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_url', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_file" string NOT NULL OPTIONS (ANNOTATION 'File path', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_id" string NOT NULL OPTIONS (ANNOTATION 'Gallery entry ID', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_label" string NOT NULL OPTIONS (ANNOTATION 'Gallery entry alternative text', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/label', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_media_type" string NOT NULL OPTIONS (ANNOTATION 'Media type', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/media_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Gallery entry position (sort order)', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/position', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_types" string[] NOT NULL OPTIONS (NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/types', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_name string NOT NULL OPTIONS (ANNOTATION 'Name', NAMEINSOURCE 'product/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_file_extension" string NOT NULL OPTIONS (NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/file_extension', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_image_size_x" string NOT NULL OPTIONS (NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/image_size_x', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_image_size_y" string NOT NULL OPTIONS (NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/image_size_y', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_is_require" boolean NOT NULL OPTIONS (ANNOTATION 'Is require', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/is_require', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_max_characters" string NOT NULL OPTIONS (NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/max_characters', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_product_sku" string NOT NULL OPTIONS (ANNOTATION 'Product SKU', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/product_sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_type" string NOT NULL OPTIONS (ANNOTATION 'Option type', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_option_type_id" string NOT NULL OPTIONS (ANNOTATION 'Option type id', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/option_type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_price string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_product_links_catalog-data-product-link-interface_extension_attributes_qty" string NOT NULL OPTIONS (NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/extension_attributes/qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_product_links_catalog-data-product-link-interface_link_type" string NOT NULL OPTIONS (ANNOTATION 'Link type', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/link_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_product_links_catalog-data-product-link-interface_linked_product_sku" string NOT NULL OPTIONS (ANNOTATION 'Linked product sku', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/linked_product_sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_product_links_catalog-data-product-link-interface_linked_product_type" string NOT NULL OPTIONS (ANNOTATION 'Linked product type (simple, virtual, etc)', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/linked_product_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_product_links_catalog-data-product-link-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Linked item position', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/position', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_product_links_catalog-data-product-link-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_sku string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'product/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_status string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'product/status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_tier_prices_catalog-data-product-tier-price-interface_customer_group_id" string NOT NULL OPTIONS (ANNOTATION 'Customer group id', NAMEINSOURCE 'product/tier_prices[]/catalog-data-product-tier-price-interface/customer_group_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_tier_prices_catalog-data-product-tier-price-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Tier qty', NAMEINSOURCE 'product/tier_prices[]/catalog-data-product-tier-price-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_tier_prices_catalog-data-product-tier-price-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Price value', NAMEINSOURCE 'product/tier_prices[]/catalog-data-product-tier-price-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_type_id string NOT NULL OPTIONS (ANNOTATION 'Type id', NAMEINSOURCE 'product/type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated date', NAMEINSOURCE 'product/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_visibility string NOT NULL OPTIONS (ANNOTATION 'Visibility', NAMEINSOURCE 'product/visibility', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_weight string NOT NULL OPTIONS (ANNOTATION 'Weight', NAMEINSOURCE 'product/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (attribute_set_id string, created_at string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), "extension_attributes_bundle_product_options_bundle-data-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/option_id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/position'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_can_change_quantity" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/can_change_quantity'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/is_default'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/option_id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/position'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price_type'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/qty'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/sku'), "extension_attributes_bundle_product_options_bundle-data-option-interface_required" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/required'), "extension_attributes_bundle_product_options_bundle-data-option-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/sku'), "extension_attributes_bundle_product_options_bundle-data-option-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/title'), "extension_attributes_bundle_product_options_bundle-data-option-interface_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/type'), extension_attributes_configurable_product_links string[] OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_links'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/attribute_id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_is_use_default" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/is_use_default'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/label'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/position'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_product_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/product_id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_values_configurable-product-data-option-value-interface_value_index" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/values[]/configurable-product-data-option-value-interface/value_index'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/id'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_is_shareable" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/is_shareable'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/file_data'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/name'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_type'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_url'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_number_of_downloads" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/number_of_downloads'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/price'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/file_data'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/name'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_type'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_url'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sort_order" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sort_order'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/title'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/id'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/file_data'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/name'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_type'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_url'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sort_order" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sort_order'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/title'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/attribute_id'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/value'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_id'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_value'), extension_attributes_stock_item_backorders string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/backorders'), extension_attributes_stock_item_enable_qty_increments boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/enable_qty_increments'), extension_attributes_stock_item_is_decimal_divided boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_decimal_divided'), extension_attributes_stock_item_is_in_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_in_stock'), extension_attributes_stock_item_is_qty_decimal boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_qty_decimal'), extension_attributes_stock_item_item_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/item_id'), extension_attributes_stock_item_low_stock_date string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/low_stock_date'), extension_attributes_stock_item_manage_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/manage_stock'), extension_attributes_stock_item_max_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/max_sale_qty'), extension_attributes_stock_item_min_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/min_qty'), extension_attributes_stock_item_min_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/min_sale_qty'), extension_attributes_stock_item_notify_stock_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/notify_stock_qty'), extension_attributes_stock_item_product_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/product_id'), extension_attributes_stock_item_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/qty'), extension_attributes_stock_item_qty_increments string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/qty_increments'), extension_attributes_stock_item_show_default_notification_message boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/show_default_notification_message'), extension_attributes_stock_item_stock_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/stock_id'), extension_attributes_stock_item_stock_status_changed_auto string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/stock_status_changed_auto'), extension_attributes_stock_item_use_config_backorders boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_backorders'), extension_attributes_stock_item_use_config_enable_qty_inc boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_enable_qty_inc'), extension_attributes_stock_item_use_config_manage_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_manage_stock'), extension_attributes_stock_item_use_config_max_sale_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_max_sale_qty'), extension_attributes_stock_item_use_config_min_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_min_qty'), extension_attributes_stock_item_use_config_min_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_min_sale_qty'), extension_attributes_stock_item_use_config_notify_stock_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_notify_stock_qty'), extension_attributes_stock_item_use_config_qty_increments boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_qty_increments'), id string, "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/base64_encoded_data'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_name" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/name'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_disabled" boolean OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/disabled'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_media_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/media_type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_description" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_description'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_metadata" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_metadata'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_provider" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_provider'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_title" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_title'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_url" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_url'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_file" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/file'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_id" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/id'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_label" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/label'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_media_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/media_type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_position" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/position'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_types" string[] OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/types'), name string, "options_catalog-data-product-custom-option-interface_file_extension" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/file_extension'), "options_catalog-data-product-custom-option-interface_image_size_x" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/image_size_x'), "options_catalog-data-product-custom-option-interface_image_size_y" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/image_size_y'), "options_catalog-data-product-custom-option-interface_is_require" boolean OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/is_require'), "options_catalog-data-product-custom-option-interface_max_characters" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/max_characters'), "options_catalog-data-product-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/option_id'), "options_catalog-data-product-custom-option-interface_price" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/price'), "options_catalog-data-product-custom-option-interface_price_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/price_type'), "options_catalog-data-product-custom-option-interface_product_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/product_sku'), "options_catalog-data-product-custom-option-interface_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/sku'), "options_catalog-data-product-custom-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/sort_order'), "options_catalog-data-product-custom-option-interface_title" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/title'), "options_catalog-data-product-custom-option-interface_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/type'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_option_type_id" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/option_type_id'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price_type'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sku'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sort_order'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_title" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/title'), price string, "product_links_catalog-data-product-link-interface_extension_attributes_qty" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/extension_attributes/qty'), "product_links_catalog-data-product-link-interface_link_type" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/link_type'), "product_links_catalog-data-product-link-interface_linked_product_sku" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/linked_product_sku'), "product_links_catalog-data-product-link-interface_linked_product_type" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/linked_product_type'), "product_links_catalog-data-product-link-interface_position" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/position'), "product_links_catalog-data-product-link-interface_sku" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/sku'), sku string, status string, "tier_prices_catalog-data-product-tier-price-interface_customer_group_id" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/customer_group_id'), "tier_prices_catalog-data-product-tier-price-interface_qty" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/qty'), "tier_prices_catalog-data-product-tier-price-interface_value" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/value'), type_id string, updated_at string, visibility string, weight string)
OPTIONS (ANNOTATION 'Generate variation based on same product', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/configurable-products/variation');

CREATE FOREIGN PROCEDURE configurableProductLinkManagementV1AddChildPost(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN childSku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS ("teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/configurable-products/{sku}/child');

CREATE FOREIGN PROCEDURE configurableProductLinkManagementV1GetChildrenGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (attribute_set_id string, created_at string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), "extension_attributes_bundle_product_options_bundle-data-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/option_id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/position'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_can_change_quantity" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/can_change_quantity'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/is_default'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/option_id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/position'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price_type'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/qty'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/sku'), "extension_attributes_bundle_product_options_bundle-data-option-interface_required" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/required'), "extension_attributes_bundle_product_options_bundle-data-option-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/sku'), "extension_attributes_bundle_product_options_bundle-data-option-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/title'), "extension_attributes_bundle_product_options_bundle-data-option-interface_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/type'), extension_attributes_configurable_product_links string[] OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_links'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/attribute_id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_is_use_default" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/is_use_default'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/label'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/position'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_product_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/product_id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_values_configurable-product-data-option-value-interface_value_index" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/values[]/configurable-product-data-option-value-interface/value_index'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/id'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_is_shareable" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/is_shareable'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/file_data'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/name'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_type'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_url'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_number_of_downloads" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/number_of_downloads'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/price'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/file_data'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/name'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_type'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_url'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sort_order" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sort_order'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/title'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/id'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/file_data'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/name'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_type'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_url'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sort_order" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sort_order'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/title'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/attribute_id'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/value'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_id'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_value'), extension_attributes_stock_item_backorders string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/backorders'), extension_attributes_stock_item_enable_qty_increments boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/enable_qty_increments'), extension_attributes_stock_item_is_decimal_divided boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_decimal_divided'), extension_attributes_stock_item_is_in_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_in_stock'), extension_attributes_stock_item_is_qty_decimal boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_qty_decimal'), extension_attributes_stock_item_item_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/item_id'), extension_attributes_stock_item_low_stock_date string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/low_stock_date'), extension_attributes_stock_item_manage_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/manage_stock'), extension_attributes_stock_item_max_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/max_sale_qty'), extension_attributes_stock_item_min_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/min_qty'), extension_attributes_stock_item_min_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/min_sale_qty'), extension_attributes_stock_item_notify_stock_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/notify_stock_qty'), extension_attributes_stock_item_product_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/product_id'), extension_attributes_stock_item_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/qty'), extension_attributes_stock_item_qty_increments string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/qty_increments'), extension_attributes_stock_item_show_default_notification_message boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/show_default_notification_message'), extension_attributes_stock_item_stock_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/stock_id'), extension_attributes_stock_item_stock_status_changed_auto string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/stock_status_changed_auto'), extension_attributes_stock_item_use_config_backorders boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_backorders'), extension_attributes_stock_item_use_config_enable_qty_inc boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_enable_qty_inc'), extension_attributes_stock_item_use_config_manage_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_manage_stock'), extension_attributes_stock_item_use_config_max_sale_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_max_sale_qty'), extension_attributes_stock_item_use_config_min_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_min_qty'), extension_attributes_stock_item_use_config_min_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_min_sale_qty'), extension_attributes_stock_item_use_config_notify_stock_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_notify_stock_qty'), extension_attributes_stock_item_use_config_qty_increments boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_qty_increments'), id string, "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/base64_encoded_data'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_name" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/name'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_disabled" boolean OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/disabled'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_media_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/media_type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_description" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_description'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_metadata" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_metadata'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_provider" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_provider'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_title" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_title'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_url" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_url'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_file" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/file'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_id" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/id'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_label" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/label'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_media_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/media_type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_position" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/position'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_types" string[] OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/types'), name string, "options_catalog-data-product-custom-option-interface_file_extension" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/file_extension'), "options_catalog-data-product-custom-option-interface_image_size_x" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/image_size_x'), "options_catalog-data-product-custom-option-interface_image_size_y" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/image_size_y'), "options_catalog-data-product-custom-option-interface_is_require" boolean OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/is_require'), "options_catalog-data-product-custom-option-interface_max_characters" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/max_characters'), "options_catalog-data-product-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/option_id'), "options_catalog-data-product-custom-option-interface_price" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/price'), "options_catalog-data-product-custom-option-interface_price_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/price_type'), "options_catalog-data-product-custom-option-interface_product_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/product_sku'), "options_catalog-data-product-custom-option-interface_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/sku'), "options_catalog-data-product-custom-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/sort_order'), "options_catalog-data-product-custom-option-interface_title" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/title'), "options_catalog-data-product-custom-option-interface_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/type'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_option_type_id" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/option_type_id'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price_type'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sku'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sort_order'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_title" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/title'), price string, "product_links_catalog-data-product-link-interface_extension_attributes_qty" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/extension_attributes/qty'), "product_links_catalog-data-product-link-interface_link_type" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/link_type'), "product_links_catalog-data-product-link-interface_linked_product_sku" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/linked_product_sku'), "product_links_catalog-data-product-link-interface_linked_product_type" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/linked_product_type'), "product_links_catalog-data-product-link-interface_position" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/position'), "product_links_catalog-data-product-link-interface_sku" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/sku'), sku string, status string, "tier_prices_catalog-data-product-tier-price-interface_customer_group_id" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/customer_group_id'), "tier_prices_catalog-data-product-tier-price-interface_qty" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/qty'), "tier_prices_catalog-data-product-tier-price-interface_value" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/value'), type_id string, updated_at string, visibility string, weight string)
OPTIONS (ANNOTATION 'Get all children for Configurable product', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/configurable-products/{sku}/children');

CREATE FOREIGN PROCEDURE configurableProductLinkManagementV1RemoveChildDelete(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN childSku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove configurable product option', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/configurable-products/{sku}/children/{childSku}');

CREATE FOREIGN PROCEDURE configurableProductOptionRepositoryV1SavePost(OUT "return" string RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN option_attribute_id string NOT NULL OPTIONS (NAMEINSOURCE 'option/attribute_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_id string NOT NULL OPTIONS (NAMEINSOURCE 'option/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_is_use_default boolean NOT NULL OPTIONS (NAMEINSOURCE 'option/is_use_default', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_label string NOT NULL OPTIONS (NAMEINSOURCE 'option/label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_position string NOT NULL OPTIONS (NAMEINSOURCE 'option/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_product_id string NOT NULL OPTIONS (NAMEINSOURCE 'option/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_values_configurable-product-data-option-value-interface_value_index" string NOT NULL OPTIONS (NAMEINSOURCE 'option/values[]/configurable-product-data-option-value-interface/value_index', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Save option', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/configurable-products/{sku}/options');

CREATE FOREIGN PROCEDURE configurableProductOptionRepositoryV1GetListGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (attribute_id string, id string, is_use_default boolean, label string, position string, product_id string, "values_configurable-product-data-option-value-interface_value_index" string OPTIONS (NAMEINSOURCE 'values[]/configurable-product-data-option-value-interface/value_index'))
OPTIONS (ANNOTATION 'Get all options for configurable product', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/configurable-products/{sku}/options/all');

CREATE FOREIGN PROCEDURE configurableProductOptionRepositoryV1GetGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (attribute_id string, id string, is_use_default boolean, label string, position string, product_id string, "values_configurable-product-data-option-value-interface_value_index" string OPTIONS (NAMEINSOURCE 'values[]/configurable-product-data-option-value-interface/value_index'))
OPTIONS (ANNOTATION 'Get option for configurable product', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/configurable-products/{sku}/options/{id}');

CREATE FOREIGN PROCEDURE configurableProductOptionRepositoryV1SavePut(OUT "return" string RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN option_attribute_id string NOT NULL OPTIONS (NAMEINSOURCE 'option/attribute_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_id string NOT NULL OPTIONS (NAMEINSOURCE 'option/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_is_use_default boolean NOT NULL OPTIONS (NAMEINSOURCE 'option/is_use_default', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_label string NOT NULL OPTIONS (NAMEINSOURCE 'option/label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_position string NOT NULL OPTIONS (NAMEINSOURCE 'option/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_product_id string NOT NULL OPTIONS (NAMEINSOURCE 'option/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_values_configurable-product-data-option-value-interface_value_index" string NOT NULL OPTIONS (NAMEINSOURCE 'option/values[]/configurable-product-data-option-value-interface/value_index', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Save option', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/configurable-products/{sku}/options/{id}');

CREATE FOREIGN PROCEDURE configurableProductOptionRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove option from configurable product', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/configurable-products/{sku}/options/{id}');

CREATE FOREIGN PROCEDURE salesRuleCouponRepositoryV1SavePost(IN coupon_code string NOT NULL OPTIONS (ANNOTATION 'Coupon code', NAMEINSOURCE 'coupon/code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN coupon_coupon_id string NOT NULL OPTIONS (ANNOTATION 'Coupon id', NAMEINSOURCE 'coupon/coupon_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN coupon_created_at string NOT NULL OPTIONS (ANNOTATION 'When the coupon is created', NAMEINSOURCE 'coupon/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN coupon_expiration_date string NOT NULL OPTIONS (ANNOTATION 'Expiration date', NAMEINSOURCE 'coupon/expiration_date', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN coupon_is_primary boolean NOT NULL OPTIONS (ANNOTATION 'The coupon is primary coupon for the rule that it''s associated with', NAMEINSOURCE 'coupon/is_primary', "teiid_rest:PARAMETER_TYPE" 'body'), IN coupon_rule_id string NOT NULL OPTIONS (ANNOTATION 'The id of the rule associated with the coupon', NAMEINSOURCE 'coupon/rule_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN coupon_times_used string NOT NULL OPTIONS (ANNOTATION 'The number of times the coupon has been used', NAMEINSOURCE 'coupon/times_used', "teiid_rest:PARAMETER_TYPE" 'body'), IN coupon_type string NOT NULL OPTIONS (ANNOTATION 'Of coupon', NAMEINSOURCE 'coupon/type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN coupon_usage_limit string NOT NULL OPTIONS (ANNOTATION 'Usage limit', NAMEINSOURCE 'coupon/usage_limit', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN coupon_usage_per_customer string NOT NULL OPTIONS (ANNOTATION 'Usage limit per customer', NAMEINSOURCE 'coupon/usage_per_customer', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, coupon_id string, created_at string, expiration_date string, is_primary boolean, rule_id string, times_used string, type string, usage_limit string, usage_per_customer string)
OPTIONS (ANNOTATION 'Save a coupon.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/coupons');

CREATE FOREIGN PROCEDURE salesRuleCouponManagementV1DeleteByCodesPost(IN codes string[] NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN ignoreInvalidCoupons boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (failed_items string[], missing_items string[])
OPTIONS (ANNOTATION 'Delete coupon by coupon codes.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/coupons/deleteByCodes');

CREATE FOREIGN PROCEDURE salesRuleCouponManagementV1DeleteByIdsPost(IN ids string[] NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN ignoreInvalidCoupons boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (failed_items string[], missing_items string[])
OPTIONS (ANNOTATION 'Delete coupon by coupon ids.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/coupons/deleteByIds');

CREATE FOREIGN PROCEDURE salesRuleCouponManagementV1GeneratePost(OUT "return" string[] RESULT, IN couponSpec_delimiter string NOT NULL OPTIONS (ANNOTATION 'The delimiter', NAMEINSOURCE 'couponSpec/delimiter', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN couponSpec_delimiter_at_every string NOT NULL OPTIONS (ANNOTATION 'The spacing where the delimiter should exist', NAMEINSOURCE 'couponSpec/delimiter_at_every', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN couponSpec_format string NOT NULL OPTIONS (ANNOTATION 'Format of generated coupon code', NAMEINSOURCE 'couponSpec/format', "teiid_rest:PARAMETER_TYPE" 'body'), IN couponSpec_length string NOT NULL OPTIONS (ANNOTATION 'Length of coupon code', NAMEINSOURCE 'couponSpec/length', "teiid_rest:PARAMETER_TYPE" 'body'), IN couponSpec_prefix string NOT NULL OPTIONS (ANNOTATION 'The prefix', NAMEINSOURCE 'couponSpec/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN couponSpec_quantity string NOT NULL OPTIONS (ANNOTATION 'Of coupons to generate', NAMEINSOURCE 'couponSpec/quantity', "teiid_rest:PARAMETER_TYPE" 'body'), IN couponSpec_rule_id string NOT NULL OPTIONS (ANNOTATION 'The id of the rule associated with the coupon', NAMEINSOURCE 'couponSpec/rule_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN couponSpec_suffix string NOT NULL OPTIONS (ANNOTATION 'The suffix', NAMEINSOURCE 'couponSpec/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Generate coupon for a rule', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/coupons/generate');

CREATE FOREIGN PROCEDURE salesRuleCouponRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_sales-rule-data-coupon-interface_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-coupon-interface/code'), "items_sales-rule-data-coupon-interface_coupon_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-coupon-interface/coupon_id'), "items_sales-rule-data-coupon-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-coupon-interface/created_at'), "items_sales-rule-data-coupon-interface_expiration_date" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-coupon-interface/expiration_date'), "items_sales-rule-data-coupon-interface_is_primary" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-coupon-interface/is_primary'), "items_sales-rule-data-coupon-interface_rule_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-coupon-interface/rule_id'), "items_sales-rule-data-coupon-interface_times_used" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-coupon-interface/times_used'), "items_sales-rule-data-coupon-interface_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-coupon-interface/type'), "items_sales-rule-data-coupon-interface_usage_limit" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-coupon-interface/usage_limit'), "items_sales-rule-data-coupon-interface_usage_per_customer" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-coupon-interface/usage_per_customer'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Retrieve a coupon using the specified search criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#CouponRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/coupons/search');

CREATE FOREIGN PROCEDURE salesRuleCouponRepositoryV1GetByIdGet(IN couponId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, coupon_id string, created_at string, expiration_date string, is_primary boolean, rule_id string, times_used string, type string, usage_limit string, usage_per_customer string)
OPTIONS (ANNOTATION 'Get coupon by coupon id.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/coupons/{couponId}');

CREATE FOREIGN PROCEDURE salesRuleCouponRepositoryV1SavePut(IN couponId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN coupon_code string NOT NULL OPTIONS (ANNOTATION 'Coupon code', NAMEINSOURCE 'coupon/code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN coupon_coupon_id string NOT NULL OPTIONS (ANNOTATION 'Coupon id', NAMEINSOURCE 'coupon/coupon_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN coupon_created_at string NOT NULL OPTIONS (ANNOTATION 'When the coupon is created', NAMEINSOURCE 'coupon/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN coupon_expiration_date string NOT NULL OPTIONS (ANNOTATION 'Expiration date', NAMEINSOURCE 'coupon/expiration_date', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN coupon_is_primary boolean NOT NULL OPTIONS (ANNOTATION 'The coupon is primary coupon for the rule that it''s associated with', NAMEINSOURCE 'coupon/is_primary', "teiid_rest:PARAMETER_TYPE" 'body'), IN coupon_rule_id string NOT NULL OPTIONS (ANNOTATION 'The id of the rule associated with the coupon', NAMEINSOURCE 'coupon/rule_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN coupon_times_used string NOT NULL OPTIONS (ANNOTATION 'The number of times the coupon has been used', NAMEINSOURCE 'coupon/times_used', "teiid_rest:PARAMETER_TYPE" 'body'), IN coupon_type string NOT NULL OPTIONS (ANNOTATION 'Of coupon', NAMEINSOURCE 'coupon/type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN coupon_usage_limit string NOT NULL OPTIONS (ANNOTATION 'Usage limit', NAMEINSOURCE 'coupon/usage_limit', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN coupon_usage_per_customer string NOT NULL OPTIONS (ANNOTATION 'Usage limit per customer', NAMEINSOURCE 'coupon/usage_per_customer', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, coupon_id string, created_at string, expiration_date string, is_primary boolean, rule_id string, times_used string, type string, usage_limit string, usage_per_customer string)
OPTIONS (ANNOTATION 'Save a coupon.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/coupons/{couponId}');

CREATE FOREIGN PROCEDURE salesRuleCouponRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN couponId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete coupon by coupon id.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/coupons/{couponId}');

CREATE FOREIGN PROCEDURE salesCreditmemoRepositoryV1SavePost(IN entity_adjustment string NOT NULL OPTIONS (ANNOTATION 'Credit memo adjustment.', NAMEINSOURCE 'entity/adjustment', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_adjustment_negative string NOT NULL OPTIONS (ANNOTATION 'Credit memo negative adjustment.', NAMEINSOURCE 'entity/adjustment_negative', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_adjustment_positive string NOT NULL OPTIONS (ANNOTATION 'Credit memo positive adjustment.', NAMEINSOURCE 'entity/adjustment_positive', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_adjustment string NOT NULL OPTIONS (ANNOTATION 'Credit memo base adjustment.', NAMEINSOURCE 'entity/base_adjustment', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_adjustment_negative string NOT NULL OPTIONS (ANNOTATION 'Credit memo negative base adjustment.', NAMEINSOURCE 'entity/base_adjustment_negative', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_adjustment_positive string NOT NULL OPTIONS (ANNOTATION 'Credit memo positive base adjustment.', NAMEINSOURCE 'entity/base_adjustment_positive', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_currency_code string NOT NULL OPTIONS (ANNOTATION 'Credit memo base currency code.', NAMEINSOURCE 'entity/base_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo base discount amount.', NAMEINSOURCE 'entity/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo base discount tax compensation amount.', NAMEINSOURCE 'entity/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_grand_total string NOT NULL OPTIONS (ANNOTATION 'Credit memo base grand total.', NAMEINSOURCE 'entity/base_grand_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo base shipping amount.', NAMEINSOURCE 'entity/base_shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_discount_tax_compensation_amnt string NOT NULL OPTIONS (ANNOTATION 'Credit memo base shipping discount tax compensation amount.', NAMEINSOURCE 'entity/base_shipping_discount_tax_compensation_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Credit memo base shipping including tax.', NAMEINSOURCE 'entity/base_shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo base shipping tax amount.', NAMEINSOURCE 'entity/base_shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal string NOT NULL OPTIONS (ANNOTATION 'Credit memo base subtotal.', NAMEINSOURCE 'entity/base_subtotal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Credit memo base subtotal including tax.', NAMEINSOURCE 'entity/base_subtotal_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo base tax amount.', NAMEINSOURCE 'entity/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_to_global_rate string NOT NULL OPTIONS (ANNOTATION 'Credit memo base-to-global rate.', NAMEINSOURCE 'entity/base_to_global_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_to_order_rate string NOT NULL OPTIONS (ANNOTATION 'Credit memo base-to-order rate.', NAMEINSOURCE 'entity/base_to_order_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo billing address ID.', NAMEINSOURCE 'entity/billing_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_comments_sales-data-creditmemo-comment-interface_comment" string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'entity/comments[]/sales-data-creditmemo-comment-interface/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_comments_sales-data-creditmemo-comment-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/comments[]/sales-data-creditmemo-comment-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_comments_sales-data-creditmemo-comment-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Credit memo ID.', NAMEINSOURCE 'entity/comments[]/sales-data-creditmemo-comment-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_comments_sales-data-creditmemo-comment-interface_is_customer_notified" string NOT NULL OPTIONS (ANNOTATION 'Is-customer-notified flag value.', NAMEINSOURCE 'entity/comments[]/sales-data-creditmemo-comment-interface/is_customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_comments_sales-data-creditmemo-comment-interface_is_visible_on_front" string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'entity/comments[]/sales-data-creditmemo-comment-interface/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_comments_sales-data-creditmemo-comment-interface_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/comments[]/sales-data-creditmemo-comment-interface/parent_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_created_at string NOT NULL OPTIONS (ANNOTATION 'Credit memo created-at timestamp.', NAMEINSOURCE 'entity/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_creditmemo_status string NOT NULL OPTIONS (ANNOTATION 'Credit memo status.', NAMEINSOURCE 'entity/creditmemo_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo discount amount.', NAMEINSOURCE 'entity/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_description string NOT NULL OPTIONS (ANNOTATION 'Credit memo discount description.', NAMEINSOURCE 'entity/discount_description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo discount tax compensation amount.', NAMEINSOURCE 'entity/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_email_sent string NOT NULL OPTIONS (ANNOTATION 'Credit memo email sent flag value.', NAMEINSOURCE 'entity/email_sent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_entity_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo ID.', NAMEINSOURCE 'entity/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_global_currency_code string NOT NULL OPTIONS (ANNOTATION 'Credit memo global currency code.', NAMEINSOURCE 'entity/global_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_grand_total string NOT NULL OPTIONS (ANNOTATION 'Credit memo grand total.', NAMEINSOURCE 'entity/grand_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_increment_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo increment ID.', NAMEINSOURCE 'entity/increment_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_invoice_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo invoice ID.', NAMEINSOURCE 'entity/invoice_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_additional_data" string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_base_cost" string NOT NULL OPTIONS (ANNOTATION 'The base cost for a credit memo item.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/base_cost', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-creditmemo-item-interface_base_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'The base discount amount for a credit memo item.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_base_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'The base discount tax compensation amount for a credit memo item.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_base_price" string NOT NULL OPTIONS (ANNOTATION 'The base price for a credit memo item.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/base_price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-creditmemo-item-interface_base_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base price including tax.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_base_row_total" string NOT NULL OPTIONS (ANNOTATION 'Base row total.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/base_row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_base_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base row total including tax.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/base_row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_base_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied amount.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/base_weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_base_weee_tax_applied_row_amnt" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied row amount.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/base_weee_tax_applied_row_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_base_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax disposition.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/base_weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_base_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax row disposition.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/base_weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Credit memo item ID.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-creditmemo-item-interface_name" string NOT NULL OPTIONS (ANNOTATION 'Name.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'Order item ID.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/order_item_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-creditmemo-item-interface_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Price including tax.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_product_id" string NOT NULL OPTIONS (ANNOTATION 'Product ID.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Quantity.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-creditmemo-item-interface_row_total" string NOT NULL OPTIONS (ANNOTATION 'Row total.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Row total including tax.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_weee_tax_applied" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/weee_tax_applied', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied amount.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_weee_tax_applied_row_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied row amount.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/weee_tax_applied_row_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax disposition.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-creditmemo-item-interface_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax row disposition.', NAMEINSOURCE 'entity/items[]/sales-data-creditmemo-item-interface/weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_order_currency_code string NOT NULL OPTIONS (ANNOTATION 'Credit memo order currency code.', NAMEINSOURCE 'entity/order_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_order_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo order ID.', NAMEINSOURCE 'entity/order_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_shipping_address_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo shipping address ID.', NAMEINSOURCE 'entity/shipping_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo shipping amount.', NAMEINSOURCE 'entity/shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo shipping discount tax compensation amount.', NAMEINSOURCE 'entity/shipping_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Credit memo shipping including tax.', NAMEINSOURCE 'entity/shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo shipping tax amount.', NAMEINSOURCE 'entity/shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_state string NOT NULL OPTIONS (ANNOTATION 'Credit memo state.', NAMEINSOURCE 'entity/state', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_currency_code string NOT NULL OPTIONS (ANNOTATION 'Credit memo store currency code.', NAMEINSOURCE 'entity/store_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo store ID.', NAMEINSOURCE 'entity/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_to_base_rate string NOT NULL OPTIONS (ANNOTATION 'Credit memo store-to-base rate.', NAMEINSOURCE 'entity/store_to_base_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_to_order_rate string NOT NULL OPTIONS (ANNOTATION 'Credit memo store-to-order rate.', NAMEINSOURCE 'entity/store_to_order_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal string NOT NULL OPTIONS (ANNOTATION 'Credit memo subtotal.', NAMEINSOURCE 'entity/subtotal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Credit memo subtotal including tax.', NAMEINSOURCE 'entity/subtotal_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo tax amount.', NAMEINSOURCE 'entity/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_transaction_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo transaction ID.', NAMEINSOURCE 'entity/transaction_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_updated_at string NOT NULL OPTIONS (ANNOTATION 'Credit memo updated-at timestamp.', NAMEINSOURCE 'entity/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (adjustment string, adjustment_negative string, adjustment_positive string, base_adjustment string, base_adjustment_negative string, base_adjustment_positive string, base_currency_code string, base_discount_amount string, base_discount_tax_compensation_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_tax_compensation_amnt string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_tax_amount string, base_to_global_rate string, base_to_order_rate string, billing_address_id string, "comments_sales-data-creditmemo-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/comment'), "comments_sales-data-creditmemo-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/created_at'), "comments_sales-data-creditmemo-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/entity_id'), "comments_sales-data-creditmemo-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/is_customer_notified'), "comments_sales-data-creditmemo-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/is_visible_on_front'), "comments_sales-data-creditmemo-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/parent_id'), created_at string, creditmemo_status string, discount_amount string, discount_description string, discount_tax_compensation_amount string, email_sent string, entity_id string, global_currency_code string, grand_total string, increment_id string, invoice_id string, "items_sales-data-creditmemo-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/additional_data'), "items_sales-data-creditmemo-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_cost'), "items_sales-data-creditmemo-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_discount_amount'), "items_sales-data-creditmemo-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-creditmemo-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_price'), "items_sales-data-creditmemo-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_price_incl_tax'), "items_sales-data-creditmemo-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_row_total'), "items_sales-data-creditmemo-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_row_total_incl_tax'), "items_sales-data-creditmemo-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_tax_amount'), "items_sales-data-creditmemo-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_weee_tax_applied_amount'), "items_sales-data-creditmemo-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_weee_tax_applied_row_amnt'), "items_sales-data-creditmemo-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_weee_tax_disposition'), "items_sales-data-creditmemo-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_weee_tax_row_disposition'), "items_sales-data-creditmemo-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/description'), "items_sales-data-creditmemo-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/discount_amount'), "items_sales-data-creditmemo-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/discount_tax_compensation_amount'), "items_sales-data-creditmemo-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/entity_id'), "items_sales-data-creditmemo-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/name'), "items_sales-data-creditmemo-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/order_item_id'), "items_sales-data-creditmemo-item-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/parent_id'), "items_sales-data-creditmemo-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/price'), "items_sales-data-creditmemo-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/price_incl_tax'), "items_sales-data-creditmemo-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/product_id'), "items_sales-data-creditmemo-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/qty'), "items_sales-data-creditmemo-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/row_total'), "items_sales-data-creditmemo-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/row_total_incl_tax'), "items_sales-data-creditmemo-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/sku'), "items_sales-data-creditmemo-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/tax_amount'), "items_sales-data-creditmemo-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_applied'), "items_sales-data-creditmemo-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_applied_amount'), "items_sales-data-creditmemo-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_applied_row_amount'), "items_sales-data-creditmemo-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_disposition'), "items_sales-data-creditmemo-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_row_disposition'), order_currency_code string, order_id string, shipping_address_id string, shipping_amount string, shipping_discount_tax_compensation_amount string, shipping_incl_tax string, shipping_tax_amount string, state string, store_currency_code string, store_id string, store_to_base_rate string, store_to_order_rate string, subtotal string, subtotal_incl_tax string, tax_amount string, transaction_id string, updated_at string)
OPTIONS (ANNOTATION 'Performs persist operations for a specified credit memo.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/creditmemo');

CREATE FOREIGN PROCEDURE salesCreditmemoManagementV1RefundPost(IN creditmemo_adjustment string NOT NULL OPTIONS (ANNOTATION 'Credit memo adjustment.', NAMEINSOURCE 'creditmemo/adjustment', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_adjustment_negative string NOT NULL OPTIONS (ANNOTATION 'Credit memo negative adjustment.', NAMEINSOURCE 'creditmemo/adjustment_negative', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_adjustment_positive string NOT NULL OPTIONS (ANNOTATION 'Credit memo positive adjustment.', NAMEINSOURCE 'creditmemo/adjustment_positive', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_adjustment string NOT NULL OPTIONS (ANNOTATION 'Credit memo base adjustment.', NAMEINSOURCE 'creditmemo/base_adjustment', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_adjustment_negative string NOT NULL OPTIONS (ANNOTATION 'Credit memo negative base adjustment.', NAMEINSOURCE 'creditmemo/base_adjustment_negative', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_adjustment_positive string NOT NULL OPTIONS (ANNOTATION 'Credit memo positive base adjustment.', NAMEINSOURCE 'creditmemo/base_adjustment_positive', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_currency_code string NOT NULL OPTIONS (ANNOTATION 'Credit memo base currency code.', NAMEINSOURCE 'creditmemo/base_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo base discount amount.', NAMEINSOURCE 'creditmemo/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo base discount tax compensation amount.', NAMEINSOURCE 'creditmemo/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_grand_total string NOT NULL OPTIONS (ANNOTATION 'Credit memo base grand total.', NAMEINSOURCE 'creditmemo/base_grand_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo base shipping amount.', NAMEINSOURCE 'creditmemo/base_shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_shipping_discount_tax_compensation_amnt string NOT NULL OPTIONS (ANNOTATION 'Credit memo base shipping discount tax compensation amount.', NAMEINSOURCE 'creditmemo/base_shipping_discount_tax_compensation_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_shipping_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Credit memo base shipping including tax.', NAMEINSOURCE 'creditmemo/base_shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_shipping_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo base shipping tax amount.', NAMEINSOURCE 'creditmemo/base_shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_subtotal string NOT NULL OPTIONS (ANNOTATION 'Credit memo base subtotal.', NAMEINSOURCE 'creditmemo/base_subtotal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_subtotal_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Credit memo base subtotal including tax.', NAMEINSOURCE 'creditmemo/base_subtotal_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo base tax amount.', NAMEINSOURCE 'creditmemo/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_to_global_rate string NOT NULL OPTIONS (ANNOTATION 'Credit memo base-to-global rate.', NAMEINSOURCE 'creditmemo/base_to_global_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_base_to_order_rate string NOT NULL OPTIONS (ANNOTATION 'Credit memo base-to-order rate.', NAMEINSOURCE 'creditmemo/base_to_order_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_billing_address_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo billing address ID.', NAMEINSOURCE 'creditmemo/billing_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_comments_sales-data-creditmemo-comment-interface_comment" string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'creditmemo/comments[]/sales-data-creditmemo-comment-interface/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN "creditmemo_comments_sales-data-creditmemo-comment-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'creditmemo/comments[]/sales-data-creditmemo-comment-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_comments_sales-data-creditmemo-comment-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Credit memo ID.', NAMEINSOURCE 'creditmemo/comments[]/sales-data-creditmemo-comment-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_comments_sales-data-creditmemo-comment-interface_is_customer_notified" string NOT NULL OPTIONS (ANNOTATION 'Is-customer-notified flag value.', NAMEINSOURCE 'creditmemo/comments[]/sales-data-creditmemo-comment-interface/is_customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN "creditmemo_comments_sales-data-creditmemo-comment-interface_is_visible_on_front" string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'creditmemo/comments[]/sales-data-creditmemo-comment-interface/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN "creditmemo_comments_sales-data-creditmemo-comment-interface_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'creditmemo/comments[]/sales-data-creditmemo-comment-interface/parent_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN creditmemo_created_at string NOT NULL OPTIONS (ANNOTATION 'Credit memo created-at timestamp.', NAMEINSOURCE 'creditmemo/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_creditmemo_status string NOT NULL OPTIONS (ANNOTATION 'Credit memo status.', NAMEINSOURCE 'creditmemo/creditmemo_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo discount amount.', NAMEINSOURCE 'creditmemo/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_discount_description string NOT NULL OPTIONS (ANNOTATION 'Credit memo discount description.', NAMEINSOURCE 'creditmemo/discount_description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo discount tax compensation amount.', NAMEINSOURCE 'creditmemo/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_email_sent string NOT NULL OPTIONS (ANNOTATION 'Credit memo email sent flag value.', NAMEINSOURCE 'creditmemo/email_sent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_entity_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo ID.', NAMEINSOURCE 'creditmemo/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_global_currency_code string NOT NULL OPTIONS (ANNOTATION 'Credit memo global currency code.', NAMEINSOURCE 'creditmemo/global_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_grand_total string NOT NULL OPTIONS (ANNOTATION 'Credit memo grand total.', NAMEINSOURCE 'creditmemo/grand_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_increment_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo increment ID.', NAMEINSOURCE 'creditmemo/increment_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_invoice_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo invoice ID.', NAMEINSOURCE 'creditmemo/invoice_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_additional_data" string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_base_cost" string NOT NULL OPTIONS (ANNOTATION 'The base cost for a credit memo item.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/base_cost', "teiid_rest:PARAMETER_TYPE" 'body'), IN "creditmemo_items_sales-data-creditmemo-item-interface_base_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'The base discount amount for a credit memo item.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_base_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'The base discount tax compensation amount for a credit memo item.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_base_price" string NOT NULL OPTIONS (ANNOTATION 'The base price for a credit memo item.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/base_price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "creditmemo_items_sales-data-creditmemo-item-interface_base_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base price including tax.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_base_row_total" string NOT NULL OPTIONS (ANNOTATION 'Base row total.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/base_row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_base_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base row total including tax.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/base_row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_base_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied amount.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/base_weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_base_weee_tax_applied_row_amnt" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied row amount.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/base_weee_tax_applied_row_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_base_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax disposition.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/base_weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_base_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax row disposition.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/base_weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Credit memo item ID.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "creditmemo_items_sales-data-creditmemo-item-interface_name" string NOT NULL OPTIONS (ANNOTATION 'Name.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'Order item ID.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/order_item_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "creditmemo_items_sales-data-creditmemo-item-interface_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Price including tax.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_product_id" string NOT NULL OPTIONS (ANNOTATION 'Product ID.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Quantity.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "creditmemo_items_sales-data-creditmemo-item-interface_row_total" string NOT NULL OPTIONS (ANNOTATION 'Row total.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Row total including tax.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_weee_tax_applied" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/weee_tax_applied', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied amount.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_weee_tax_applied_row_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied row amount.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/weee_tax_applied_row_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax disposition.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "creditmemo_items_sales-data-creditmemo-item-interface_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax row disposition.', NAMEINSOURCE 'creditmemo/items[]/sales-data-creditmemo-item-interface/weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_order_currency_code string NOT NULL OPTIONS (ANNOTATION 'Credit memo order currency code.', NAMEINSOURCE 'creditmemo/order_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_order_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo order ID.', NAMEINSOURCE 'creditmemo/order_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN creditmemo_shipping_address_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo shipping address ID.', NAMEINSOURCE 'creditmemo/shipping_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo shipping amount.', NAMEINSOURCE 'creditmemo/shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_shipping_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo shipping discount tax compensation amount.', NAMEINSOURCE 'creditmemo/shipping_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_shipping_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Credit memo shipping including tax.', NAMEINSOURCE 'creditmemo/shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_shipping_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo shipping tax amount.', NAMEINSOURCE 'creditmemo/shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_state string NOT NULL OPTIONS (ANNOTATION 'Credit memo state.', NAMEINSOURCE 'creditmemo/state', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_store_currency_code string NOT NULL OPTIONS (ANNOTATION 'Credit memo store currency code.', NAMEINSOURCE 'creditmemo/store_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_store_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo store ID.', NAMEINSOURCE 'creditmemo/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_store_to_base_rate string NOT NULL OPTIONS (ANNOTATION 'Credit memo store-to-base rate.', NAMEINSOURCE 'creditmemo/store_to_base_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_store_to_order_rate string NOT NULL OPTIONS (ANNOTATION 'Credit memo store-to-order rate.', NAMEINSOURCE 'creditmemo/store_to_order_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_subtotal string NOT NULL OPTIONS (ANNOTATION 'Credit memo subtotal.', NAMEINSOURCE 'creditmemo/subtotal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_subtotal_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Credit memo subtotal including tax.', NAMEINSOURCE 'creditmemo/subtotal_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo tax amount.', NAMEINSOURCE 'creditmemo/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_transaction_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo transaction ID.', NAMEINSOURCE 'creditmemo/transaction_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN creditmemo_updated_at string NOT NULL OPTIONS (ANNOTATION 'Credit memo updated-at timestamp.', NAMEINSOURCE 'creditmemo/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN offlineRequested boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (adjustment string, adjustment_negative string, adjustment_positive string, base_adjustment string, base_adjustment_negative string, base_adjustment_positive string, base_currency_code string, base_discount_amount string, base_discount_tax_compensation_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_tax_compensation_amnt string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_tax_amount string, base_to_global_rate string, base_to_order_rate string, billing_address_id string, "comments_sales-data-creditmemo-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/comment'), "comments_sales-data-creditmemo-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/created_at'), "comments_sales-data-creditmemo-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/entity_id'), "comments_sales-data-creditmemo-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/is_customer_notified'), "comments_sales-data-creditmemo-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/is_visible_on_front'), "comments_sales-data-creditmemo-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/parent_id'), created_at string, creditmemo_status string, discount_amount string, discount_description string, discount_tax_compensation_amount string, email_sent string, entity_id string, global_currency_code string, grand_total string, increment_id string, invoice_id string, "items_sales-data-creditmemo-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/additional_data'), "items_sales-data-creditmemo-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_cost'), "items_sales-data-creditmemo-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_discount_amount'), "items_sales-data-creditmemo-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-creditmemo-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_price'), "items_sales-data-creditmemo-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_price_incl_tax'), "items_sales-data-creditmemo-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_row_total'), "items_sales-data-creditmemo-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_row_total_incl_tax'), "items_sales-data-creditmemo-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_tax_amount'), "items_sales-data-creditmemo-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_weee_tax_applied_amount'), "items_sales-data-creditmemo-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_weee_tax_applied_row_amnt'), "items_sales-data-creditmemo-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_weee_tax_disposition'), "items_sales-data-creditmemo-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_weee_tax_row_disposition'), "items_sales-data-creditmemo-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/description'), "items_sales-data-creditmemo-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/discount_amount'), "items_sales-data-creditmemo-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/discount_tax_compensation_amount'), "items_sales-data-creditmemo-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/entity_id'), "items_sales-data-creditmemo-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/name'), "items_sales-data-creditmemo-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/order_item_id'), "items_sales-data-creditmemo-item-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/parent_id'), "items_sales-data-creditmemo-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/price'), "items_sales-data-creditmemo-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/price_incl_tax'), "items_sales-data-creditmemo-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/product_id'), "items_sales-data-creditmemo-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/qty'), "items_sales-data-creditmemo-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/row_total'), "items_sales-data-creditmemo-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/row_total_incl_tax'), "items_sales-data-creditmemo-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/sku'), "items_sales-data-creditmemo-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/tax_amount'), "items_sales-data-creditmemo-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_applied'), "items_sales-data-creditmemo-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_applied_amount'), "items_sales-data-creditmemo-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_applied_row_amount'), "items_sales-data-creditmemo-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_disposition'), "items_sales-data-creditmemo-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_row_disposition'), order_currency_code string, order_id string, shipping_address_id string, shipping_amount string, shipping_discount_tax_compensation_amount string, shipping_incl_tax string, shipping_tax_amount string, state string, store_currency_code string, store_id string, store_to_base_rate string, store_to_order_rate string, subtotal string, subtotal_incl_tax string, tax_amount string, transaction_id string, updated_at string)
OPTIONS (ANNOTATION 'Prepare creditmemo to refund and save it.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/creditmemo/refund');

CREATE FOREIGN PROCEDURE salesCreditmemoRepositoryV1GetGet(IN id string NOT NULL OPTIONS (ANNOTATION 'The credit memo ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (adjustment string, adjustment_negative string, adjustment_positive string, base_adjustment string, base_adjustment_negative string, base_adjustment_positive string, base_currency_code string, base_discount_amount string, base_discount_tax_compensation_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_tax_compensation_amnt string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_tax_amount string, base_to_global_rate string, base_to_order_rate string, billing_address_id string, "comments_sales-data-creditmemo-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/comment'), "comments_sales-data-creditmemo-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/created_at'), "comments_sales-data-creditmemo-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/entity_id'), "comments_sales-data-creditmemo-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/is_customer_notified'), "comments_sales-data-creditmemo-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/is_visible_on_front'), "comments_sales-data-creditmemo-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-creditmemo-comment-interface/parent_id'), created_at string, creditmemo_status string, discount_amount string, discount_description string, discount_tax_compensation_amount string, email_sent string, entity_id string, global_currency_code string, grand_total string, increment_id string, invoice_id string, "items_sales-data-creditmemo-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/additional_data'), "items_sales-data-creditmemo-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_cost'), "items_sales-data-creditmemo-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_discount_amount'), "items_sales-data-creditmemo-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-creditmemo-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_price'), "items_sales-data-creditmemo-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_price_incl_tax'), "items_sales-data-creditmemo-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_row_total'), "items_sales-data-creditmemo-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_row_total_incl_tax'), "items_sales-data-creditmemo-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_tax_amount'), "items_sales-data-creditmemo-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_weee_tax_applied_amount'), "items_sales-data-creditmemo-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_weee_tax_applied_row_amnt'), "items_sales-data-creditmemo-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_weee_tax_disposition'), "items_sales-data-creditmemo-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/base_weee_tax_row_disposition'), "items_sales-data-creditmemo-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/description'), "items_sales-data-creditmemo-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/discount_amount'), "items_sales-data-creditmemo-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/discount_tax_compensation_amount'), "items_sales-data-creditmemo-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/entity_id'), "items_sales-data-creditmemo-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/name'), "items_sales-data-creditmemo-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/order_item_id'), "items_sales-data-creditmemo-item-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/parent_id'), "items_sales-data-creditmemo-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/price'), "items_sales-data-creditmemo-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/price_incl_tax'), "items_sales-data-creditmemo-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/product_id'), "items_sales-data-creditmemo-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/qty'), "items_sales-data-creditmemo-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/row_total'), "items_sales-data-creditmemo-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/row_total_incl_tax'), "items_sales-data-creditmemo-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/sku'), "items_sales-data-creditmemo-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/tax_amount'), "items_sales-data-creditmemo-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_applied'), "items_sales-data-creditmemo-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_applied_amount'), "items_sales-data-creditmemo-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_applied_row_amount'), "items_sales-data-creditmemo-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_disposition'), "items_sales-data-creditmemo-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-item-interface/weee_tax_row_disposition'), order_currency_code string, order_id string, shipping_address_id string, shipping_amount string, shipping_discount_tax_compensation_amount string, shipping_incl_tax string, shipping_tax_amount string, state string, store_currency_code string, store_id string, store_to_base_rate string, store_to_order_rate string, subtotal string, subtotal_incl_tax string, tax_amount string, transaction_id string, updated_at string)
OPTIONS (ANNOTATION 'Loads a specified credit memo.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/creditmemo/{id}');

CREATE FOREIGN PROCEDURE salesCreditmemoManagementV1CancelPut(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The credit memo ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Cancels a specified credit memo.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/creditmemo/{id}');

CREATE FOREIGN PROCEDURE salesCreditmemoManagementV1GetCommentsListGet(IN id string NOT NULL OPTIONS (ANNOTATION 'The credit memo ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE ("items_sales-data-creditmemo-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-comment-interface/comment'), "items_sales-data-creditmemo-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-comment-interface/created_at'), "items_sales-data-creditmemo-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-comment-interface/entity_id'), "items_sales-data-creditmemo-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-comment-interface/is_customer_notified'), "items_sales-data-creditmemo-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-comment-interface/is_visible_on_front'), "items_sales-data-creditmemo-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-comment-interface/parent_id'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Lists comments for a specified credit memo.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/creditmemo/{id}/comments');

CREATE FOREIGN PROCEDURE salesCreditmemoCommentRepositoryV1SavePost(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN entity_comment string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'entity/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_created_at string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_entity_id string NOT NULL OPTIONS (ANNOTATION 'Credit memo ID.', NAMEINSOURCE 'entity/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_is_customer_notified string NOT NULL OPTIONS (ANNOTATION 'Is-customer-notified flag value.', NAMEINSOURCE 'entity/is_customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_is_visible_on_front string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'entity/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_parent_id string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/parent_id', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (comment string, created_at string, entity_id string, is_customer_notified string, is_visible_on_front string, parent_id string)
OPTIONS (ANNOTATION 'Performs persist operations for a specified entity.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/creditmemo/{id}/comments');

CREATE FOREIGN PROCEDURE salesCreditmemoManagementV1NotifyPost(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The credit memo ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Emails a user a specified credit memo.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/creditmemo/{id}/emails');

CREATE FOREIGN PROCEDURE salesCreditmemoRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_sales-data-creditmemo-interface_adjustment" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/adjustment'), "items_sales-data-creditmemo-interface_adjustment_negative" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/adjustment_negative'), "items_sales-data-creditmemo-interface_adjustment_positive" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/adjustment_positive'), "items_sales-data-creditmemo-interface_base_adjustment" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_adjustment'), "items_sales-data-creditmemo-interface_base_adjustment_negative" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_adjustment_negative'), "items_sales-data-creditmemo-interface_base_adjustment_positive" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_adjustment_positive'), "items_sales-data-creditmemo-interface_base_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_currency_code'), "items_sales-data-creditmemo-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_discount_amount'), "items_sales-data-creditmemo-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_discount_tax_compensation_amount'), "items_sales-data-creditmemo-interface_base_grand_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_grand_total'), "items_sales-data-creditmemo-interface_base_shipping_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_shipping_amount'), "items_sales-data-creditmemo-interface_base_shipping_discount_tax_compensation_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_shipping_discount_tax_compensation_amnt'), "items_sales-data-creditmemo-interface_base_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_shipping_incl_tax'), "items_sales-data-creditmemo-interface_base_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_shipping_tax_amount'), "items_sales-data-creditmemo-interface_base_subtotal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_subtotal'), "items_sales-data-creditmemo-interface_base_subtotal_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_subtotal_incl_tax'), "items_sales-data-creditmemo-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_tax_amount'), "items_sales-data-creditmemo-interface_base_to_global_rate" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_to_global_rate'), "items_sales-data-creditmemo-interface_base_to_order_rate" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/base_to_order_rate'), "items_sales-data-creditmemo-interface_billing_address_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/billing_address_id'), "items_sales-data-creditmemo-interface_comments_sales-data-creditmemo-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/comments[]/sales-data-creditmemo-comment-interface/comment'), "items_sales-data-creditmemo-interface_comments_sales-data-creditmemo-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/comments[]/sales-data-creditmemo-comment-interface/created_at'), "items_sales-data-creditmemo-interface_comments_sales-data-creditmemo-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/comments[]/sales-data-creditmemo-comment-interface/entity_id'), "items_sales-data-creditmemo-interface_comments_sales-data-creditmemo-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/comments[]/sales-data-creditmemo-comment-interface/is_customer_notified'), "items_sales-data-creditmemo-interface_comments_sales-data-creditmemo-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/comments[]/sales-data-creditmemo-comment-interface/is_visible_on_front'), "items_sales-data-creditmemo-interface_comments_sales-data-creditmemo-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/comments[]/sales-data-creditmemo-comment-interface/parent_id'), "items_sales-data-creditmemo-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/created_at'), "items_sales-data-creditmemo-interface_creditmemo_status" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/creditmemo_status'), "items_sales-data-creditmemo-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/discount_amount'), "items_sales-data-creditmemo-interface_discount_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/discount_description'), "items_sales-data-creditmemo-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/discount_tax_compensation_amount'), "items_sales-data-creditmemo-interface_email_sent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/email_sent'), "items_sales-data-creditmemo-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/entity_id'), "items_sales-data-creditmemo-interface_global_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/global_currency_code'), "items_sales-data-creditmemo-interface_grand_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/grand_total'), "items_sales-data-creditmemo-interface_increment_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/increment_id'), "items_sales-data-creditmemo-interface_invoice_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/invoice_id'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/additional_data'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/base_cost'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/base_discount_amount'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/base_price'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/base_price_incl_tax'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/base_row_total'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/base_row_total_incl_tax'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/base_tax_amount'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/base_weee_tax_applied_amount'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/base_weee_tax_applied_row_amnt'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/base_weee_tax_disposition'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/base_weee_tax_row_disposition'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/description'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/discount_amount'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/discount_tax_compensation_amount'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/entity_id'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/name'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/order_item_id'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/parent_id'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/price'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/price_incl_tax'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/product_id'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/qty'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/row_total'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/row_total_incl_tax'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/sku'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/tax_amount'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/weee_tax_applied'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/weee_tax_applied_amount'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/weee_tax_applied_row_amount'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/weee_tax_disposition'), "items_sales-data-creditmemo-interface_items_sales-data-creditmemo-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/items[]/sales-data-creditmemo-item-interface/weee_tax_row_disposition'), "items_sales-data-creditmemo-interface_order_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/order_currency_code'), "items_sales-data-creditmemo-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/order_id'), "items_sales-data-creditmemo-interface_shipping_address_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/shipping_address_id'), "items_sales-data-creditmemo-interface_shipping_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/shipping_amount'), "items_sales-data-creditmemo-interface_shipping_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/shipping_discount_tax_compensation_amount'), "items_sales-data-creditmemo-interface_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/shipping_incl_tax'), "items_sales-data-creditmemo-interface_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/shipping_tax_amount'), "items_sales-data-creditmemo-interface_state" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/state'), "items_sales-data-creditmemo-interface_store_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/store_currency_code'), "items_sales-data-creditmemo-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/store_id'), "items_sales-data-creditmemo-interface_store_to_base_rate" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/store_to_base_rate'), "items_sales-data-creditmemo-interface_store_to_order_rate" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/store_to_order_rate'), "items_sales-data-creditmemo-interface_subtotal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/subtotal'), "items_sales-data-creditmemo-interface_subtotal_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/subtotal_incl_tax'), "items_sales-data-creditmemo-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/tax_amount'), "items_sales-data-creditmemo-interface_transaction_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/transaction_id'), "items_sales-data-creditmemo-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-creditmemo-interface/updated_at'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Lists credit memos that match specified search criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#CreditmemoRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/creditmemos');

CREATE FOREIGN PROCEDURE customerGroupRepositoryV1SavePost(IN group_code string NOT NULL OPTIONS (ANNOTATION 'Code', NAMEINSOURCE 'group/code', "teiid_rest:PARAMETER_TYPE" 'body'), IN group_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'group/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN group_tax_class_id string NOT NULL OPTIONS (ANNOTATION 'Tax class id', NAMEINSOURCE 'group/tax_class_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN group_tax_class_name string NOT NULL OPTIONS (ANNOTATION 'Tax class name', NAMEINSOURCE 'group/tax_class_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, id string, tax_class_id string, tax_class_name string)
OPTIONS (ANNOTATION 'Save customer group.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customerGroups');

CREATE FOREIGN PROCEDURE "V1/customerGroups/default"(IN storeId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, id string, tax_class_id string, tax_class_name string)
OPTIONS (ANNOTATION 'Get default customer group.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customerGroups/default');

CREATE FOREIGN PROCEDURE "V1/customerGroups/default/storeId"(IN storeId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, id string, tax_class_id string, tax_class_name string)
OPTIONS (ANNOTATION 'Get default customer group.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customerGroups/default/{storeId}');

CREATE FOREIGN PROCEDURE customerGroupRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_customer-data-group-interface_code" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-group-interface/code'), "items_customer-data-group-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-group-interface/id'), "items_customer-data-group-interface_tax_class_id" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-group-interface/tax_class_id'), "items_customer-data-group-interface_tax_class_name" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-group-interface/tax_class_name'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Retrieve customer groups. The list of groups can be filtered to exclude the NOT_LOGGED_IN group using the first parameter and/or it can be filtered by tax class. This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#GroupRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customerGroups/search');

CREATE FOREIGN PROCEDURE customerGroupRepositoryV1GetByIdGet(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, id string, tax_class_id string, tax_class_name string)
OPTIONS (ANNOTATION 'Get customer group by group ID.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customerGroups/{id}');

CREATE FOREIGN PROCEDURE customerGroupRepositoryV1SavePut(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN group_code string NOT NULL OPTIONS (ANNOTATION 'Code', NAMEINSOURCE 'group/code', "teiid_rest:PARAMETER_TYPE" 'body'), IN group_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'group/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN group_tax_class_id string NOT NULL OPTIONS (ANNOTATION 'Tax class id', NAMEINSOURCE 'group/tax_class_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN group_tax_class_name string NOT NULL OPTIONS (ANNOTATION 'Tax class name', NAMEINSOURCE 'group/tax_class_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, id string, tax_class_id string, tax_class_name string)
OPTIONS (ANNOTATION 'Save customer group.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customerGroups/{id}');

CREATE FOREIGN PROCEDURE customerGroupRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete customer group by ID.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customerGroups/{id}');

CREATE FOREIGN PROCEDURE customerGroupManagementV1IsReadonlyGet(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Check if customer group can be deleted.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customerGroups/{id}/permissions');

CREATE FOREIGN PROCEDURE customerAccountManagementV1CreateAccountPost(IN "customer_addresses_customer-data-address-interface_city" string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/city', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_company" string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_country_id" string NOT NULL OPTIONS (ANNOTATION 'Country code in ISO_3166-2 format', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/country_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_default_billing" boolean NOT NULL OPTIONS (ANNOTATION 'If this address is default billing address', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_default_shipping" boolean NOT NULL OPTIONS (ANNOTATION 'If this address is default shipping address.', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_fax" string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_firstname" string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/firstname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_id" string NOT NULL OPTIONS (ANNOTATION 'ID', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_lastname" string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/lastname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_middlename" string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_postcode" string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/postcode', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_prefix" string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_region_region" string NOT NULL OPTIONS (ANNOTATION 'Region', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_region_region_code" string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_region_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region ID', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_street" string[] NOT NULL OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_suffix" string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_telephone" string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/telephone', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_vat_id" string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_confirmation string NOT NULL OPTIONS (ANNOTATION 'Confirmation', NAMEINSOURCE 'customer/confirmation', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_created_at string NOT NULL OPTIONS (ANNOTATION 'Created at time', NAMEINSOURCE 'customer/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_created_in string NOT NULL OPTIONS (ANNOTATION 'Created in area', NAMEINSOURCE 'customer/created_in', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_default_billing string NOT NULL OPTIONS (ANNOTATION 'Default billing address id', NAMEINSOURCE 'customer/default_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_default_shipping string NOT NULL OPTIONS (ANNOTATION 'Default shipping address id', NAMEINSOURCE 'customer/default_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_disable_auto_group_change string NOT NULL OPTIONS (ANNOTATION 'Disable auto group change flag.', NAMEINSOURCE 'customer/disable_auto_group_change', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_dob string NOT NULL OPTIONS (ANNOTATION 'Date of birth', NAMEINSOURCE 'customer/dob', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_email string NOT NULL OPTIONS (ANNOTATION 'Email address', NAMEINSOURCE 'customer/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_extension_attributes_is_subscribed boolean NOT NULL OPTIONS (NAMEINSOURCE 'customer/extension_attributes/is_subscribed', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'customer/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_gender string NOT NULL OPTIONS (ANNOTATION 'Gender', NAMEINSOURCE 'customer/gender', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_group_id string NOT NULL OPTIONS (ANNOTATION 'Group id', NAMEINSOURCE 'customer/group_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'customer/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'customer/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'customer/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'customer/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_store_id string NOT NULL OPTIONS (ANNOTATION 'Store id', NAMEINSOURCE 'customer/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'customer/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_taxvat string NOT NULL OPTIONS (ANNOTATION 'Tax Vat', NAMEINSOURCE 'customer/taxvat', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated at time', NAMEINSOURCE 'customer/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_website_id string NOT NULL OPTIONS (ANNOTATION 'Website id', NAMEINSOURCE 'customer/website_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN password string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN redirectUrl string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("addresses_customer-data-address-interface_city" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/city'), "addresses_customer-data-address-interface_company" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/company'), "addresses_customer-data-address-interface_country_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/country_id'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value'), "addresses_customer-data-address-interface_customer_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/customer_id'), "addresses_customer-data-address-interface_default_billing" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_billing'), "addresses_customer-data-address-interface_default_shipping" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_shipping'), "addresses_customer-data-address-interface_fax" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/fax'), "addresses_customer-data-address-interface_firstname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/firstname'), "addresses_customer-data-address-interface_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/id'), "addresses_customer-data-address-interface_lastname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/lastname'), "addresses_customer-data-address-interface_middlename" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/middlename'), "addresses_customer-data-address-interface_postcode" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/postcode'), "addresses_customer-data-address-interface_prefix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/prefix'), "addresses_customer-data-address-interface_region_region" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region'), "addresses_customer-data-address-interface_region_region_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_code'), "addresses_customer-data-address-interface_region_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_id'), "addresses_customer-data-address-interface_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region_id'), "addresses_customer-data-address-interface_street" string[] OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/street'), "addresses_customer-data-address-interface_suffix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/suffix'), "addresses_customer-data-address-interface_telephone" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/telephone'), "addresses_customer-data-address-interface_vat_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/vat_id'), confirmation string, created_at string, created_in string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_billing string, default_shipping string, disable_auto_group_change string, dob string, email string, extension_attributes_is_subscribed boolean OPTIONS (NAMEINSOURCE 'extension_attributes/is_subscribed'), firstname string, gender string, group_id string, id string, lastname string, middlename string, prefix string, store_id string, suffix string, taxvat string, updated_at string, website_id string)
OPTIONS (ANNOTATION 'Create customer account. Perform necessary business operations like sending email.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers');

CREATE FOREIGN PROCEDURE customerAddressRepositoryV1GetByIdGet(IN addressId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (city string, company string, country_id string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), customer_id string, default_billing boolean, default_shipping boolean, fax string, firstname string, id string, lastname string, middlename string, postcode string, prefix string, region_region string OPTIONS (NAMEINSOURCE 'region/region'), region_region_code string OPTIONS (NAMEINSOURCE 'region/region_code'), region_region_id string OPTIONS (NAMEINSOURCE 'region/region_id'), region_id string, street string[], suffix string, telephone string, vat_id string)
OPTIONS (ANNOTATION 'Retrieve customer address.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/addresses/{addressId}');

CREATE FOREIGN PROCEDURE customerAccountManagementV1ResendConfirmationPost(OUT "return" boolean RESULT, IN email string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN redirectUrl string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN websiteId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Resend confirmation email.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/confirm');

CREATE FOREIGN PROCEDURE customerAccountManagementV1IsEmailAvailablePost(OUT "return" boolean RESULT, IN customerEmail string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN websiteId string NOT NULL OPTIONS (ANNOTATION 'If not set, will use the current websiteId', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Check if given email is associated with a customer account in given website.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/isEmailAvailable');

CREATE FOREIGN PROCEDURE "V1/customers/me_GET"() RETURNS TABLE ("addresses_customer-data-address-interface_city" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/city'), "addresses_customer-data-address-interface_company" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/company'), "addresses_customer-data-address-interface_country_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/country_id'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value'), "addresses_customer-data-address-interface_customer_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/customer_id'), "addresses_customer-data-address-interface_default_billing" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_billing'), "addresses_customer-data-address-interface_default_shipping" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_shipping'), "addresses_customer-data-address-interface_fax" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/fax'), "addresses_customer-data-address-interface_firstname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/firstname'), "addresses_customer-data-address-interface_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/id'), "addresses_customer-data-address-interface_lastname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/lastname'), "addresses_customer-data-address-interface_middlename" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/middlename'), "addresses_customer-data-address-interface_postcode" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/postcode'), "addresses_customer-data-address-interface_prefix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/prefix'), "addresses_customer-data-address-interface_region_region" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region'), "addresses_customer-data-address-interface_region_region_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_code'), "addresses_customer-data-address-interface_region_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_id'), "addresses_customer-data-address-interface_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region_id'), "addresses_customer-data-address-interface_street" string[] OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/street'), "addresses_customer-data-address-interface_suffix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/suffix'), "addresses_customer-data-address-interface_telephone" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/telephone'), "addresses_customer-data-address-interface_vat_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/vat_id'), confirmation string, created_at string, created_in string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_billing string, default_shipping string, disable_auto_group_change string, dob string, email string, extension_attributes_is_subscribed boolean OPTIONS (NAMEINSOURCE 'extension_attributes/is_subscribed'), firstname string, gender string, group_id string, id string, lastname string, middlename string, prefix string, store_id string, suffix string, taxvat string, updated_at string, website_id string)
OPTIONS (ANNOTATION 'Get customer by customer ID.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/me');

CREATE FOREIGN PROCEDURE "V1/customers/me_PUT"(IN "customer_addresses_customer-data-address-interface_city" string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/city', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_company" string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_country_id" string NOT NULL OPTIONS (ANNOTATION 'Country code in ISO_3166-2 format', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/country_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_default_billing" boolean NOT NULL OPTIONS (ANNOTATION 'If this address is default billing address', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_default_shipping" boolean NOT NULL OPTIONS (ANNOTATION 'If this address is default shipping address.', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_fax" string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_firstname" string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/firstname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_id" string NOT NULL OPTIONS (ANNOTATION 'ID', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_lastname" string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/lastname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_middlename" string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_postcode" string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/postcode', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_prefix" string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_region_region" string NOT NULL OPTIONS (ANNOTATION 'Region', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_region_region_code" string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_region_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region ID', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_street" string[] NOT NULL OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_suffix" string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_telephone" string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/telephone', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_vat_id" string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_confirmation string NOT NULL OPTIONS (ANNOTATION 'Confirmation', NAMEINSOURCE 'customer/confirmation', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_created_at string NOT NULL OPTIONS (ANNOTATION 'Created at time', NAMEINSOURCE 'customer/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_created_in string NOT NULL OPTIONS (ANNOTATION 'Created in area', NAMEINSOURCE 'customer/created_in', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_default_billing string NOT NULL OPTIONS (ANNOTATION 'Default billing address id', NAMEINSOURCE 'customer/default_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_default_shipping string NOT NULL OPTIONS (ANNOTATION 'Default shipping address id', NAMEINSOURCE 'customer/default_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_disable_auto_group_change string NOT NULL OPTIONS (ANNOTATION 'Disable auto group change flag.', NAMEINSOURCE 'customer/disable_auto_group_change', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_dob string NOT NULL OPTIONS (ANNOTATION 'Date of birth', NAMEINSOURCE 'customer/dob', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_email string NOT NULL OPTIONS (ANNOTATION 'Email address', NAMEINSOURCE 'customer/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_extension_attributes_is_subscribed boolean NOT NULL OPTIONS (NAMEINSOURCE 'customer/extension_attributes/is_subscribed', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'customer/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_gender string NOT NULL OPTIONS (ANNOTATION 'Gender', NAMEINSOURCE 'customer/gender', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_group_id string NOT NULL OPTIONS (ANNOTATION 'Group id', NAMEINSOURCE 'customer/group_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'customer/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'customer/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'customer/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'customer/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_store_id string NOT NULL OPTIONS (ANNOTATION 'Store id', NAMEINSOURCE 'customer/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'customer/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_taxvat string NOT NULL OPTIONS (ANNOTATION 'Tax Vat', NAMEINSOURCE 'customer/taxvat', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated at time', NAMEINSOURCE 'customer/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_website_id string NOT NULL OPTIONS (ANNOTATION 'Website id', NAMEINSOURCE 'customer/website_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN passwordHash string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("addresses_customer-data-address-interface_city" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/city'), "addresses_customer-data-address-interface_company" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/company'), "addresses_customer-data-address-interface_country_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/country_id'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value'), "addresses_customer-data-address-interface_customer_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/customer_id'), "addresses_customer-data-address-interface_default_billing" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_billing'), "addresses_customer-data-address-interface_default_shipping" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_shipping'), "addresses_customer-data-address-interface_fax" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/fax'), "addresses_customer-data-address-interface_firstname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/firstname'), "addresses_customer-data-address-interface_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/id'), "addresses_customer-data-address-interface_lastname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/lastname'), "addresses_customer-data-address-interface_middlename" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/middlename'), "addresses_customer-data-address-interface_postcode" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/postcode'), "addresses_customer-data-address-interface_prefix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/prefix'), "addresses_customer-data-address-interface_region_region" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region'), "addresses_customer-data-address-interface_region_region_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_code'), "addresses_customer-data-address-interface_region_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_id'), "addresses_customer-data-address-interface_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region_id'), "addresses_customer-data-address-interface_street" string[] OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/street'), "addresses_customer-data-address-interface_suffix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/suffix'), "addresses_customer-data-address-interface_telephone" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/telephone'), "addresses_customer-data-address-interface_vat_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/vat_id'), confirmation string, created_at string, created_in string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_billing string, default_shipping string, disable_auto_group_change string, dob string, email string, extension_attributes_is_subscribed boolean OPTIONS (NAMEINSOURCE 'extension_attributes/is_subscribed'), firstname string, gender string, group_id string, id string, lastname string, middlename string, prefix string, store_id string, suffix string, taxvat string, updated_at string, website_id string)
OPTIONS (ANNOTATION 'Create or update a customer.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/me');

CREATE FOREIGN PROCEDURE customerAccountManagementV1ActivateByIdPut(IN confirmationKey string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE ("addresses_customer-data-address-interface_city" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/city'), "addresses_customer-data-address-interface_company" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/company'), "addresses_customer-data-address-interface_country_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/country_id'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value'), "addresses_customer-data-address-interface_customer_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/customer_id'), "addresses_customer-data-address-interface_default_billing" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_billing'), "addresses_customer-data-address-interface_default_shipping" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_shipping'), "addresses_customer-data-address-interface_fax" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/fax'), "addresses_customer-data-address-interface_firstname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/firstname'), "addresses_customer-data-address-interface_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/id'), "addresses_customer-data-address-interface_lastname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/lastname'), "addresses_customer-data-address-interface_middlename" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/middlename'), "addresses_customer-data-address-interface_postcode" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/postcode'), "addresses_customer-data-address-interface_prefix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/prefix'), "addresses_customer-data-address-interface_region_region" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region'), "addresses_customer-data-address-interface_region_region_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_code'), "addresses_customer-data-address-interface_region_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_id'), "addresses_customer-data-address-interface_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region_id'), "addresses_customer-data-address-interface_street" string[] OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/street'), "addresses_customer-data-address-interface_suffix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/suffix'), "addresses_customer-data-address-interface_telephone" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/telephone'), "addresses_customer-data-address-interface_vat_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/vat_id'), confirmation string, created_at string, created_in string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_billing string, default_shipping string, disable_auto_group_change string, dob string, email string, extension_attributes_is_subscribed boolean OPTIONS (NAMEINSOURCE 'extension_attributes/is_subscribed'), firstname string, gender string, group_id string, id string, lastname string, middlename string, prefix string, store_id string, suffix string, taxvat string, updated_at string, website_id string)
OPTIONS (ANNOTATION 'Activate a customer account using a key that was sent in a confirmation email.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/me/activate');

CREATE FOREIGN PROCEDURE "V1/customers/me/billingAddress"() RETURNS TABLE (city string, company string, country_id string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), customer_id string, default_billing boolean, default_shipping boolean, fax string, firstname string, id string, lastname string, middlename string, postcode string, prefix string, region_region string OPTIONS (NAMEINSOURCE 'region/region'), region_region_code string OPTIONS (NAMEINSOURCE 'region/region_code'), region_region_id string OPTIONS (NAMEINSOURCE 'region/region_id'), region_id string, street string[], suffix string, telephone string, vat_id string)
OPTIONS (ANNOTATION 'Retrieve default billing address for the given customerId.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/me/billingAddress');

CREATE FOREIGN PROCEDURE customerAccountManagementV1ChangePasswordByIdPut(OUT "return" boolean RESULT, IN currentPassword string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN newPassword string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Change customer password.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/me/password');

CREATE FOREIGN PROCEDURE "V1/customers/me/shippingAddress"() RETURNS TABLE (city string, company string, country_id string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), customer_id string, default_billing boolean, default_shipping boolean, fax string, firstname string, id string, lastname string, middlename string, postcode string, prefix string, region_region string OPTIONS (NAMEINSOURCE 'region/region'), region_region_code string OPTIONS (NAMEINSOURCE 'region/region_code'), region_region_id string OPTIONS (NAMEINSOURCE 'region/region_id'), region_id string, street string[], suffix string, telephone string, vat_id string)
OPTIONS (ANNOTATION 'Retrieve default shipping address for the given customerId.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/me/shippingAddress');

CREATE FOREIGN PROCEDURE customerAccountManagementV1InitiatePasswordResetPut(OUT "return" boolean RESULT, IN email string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN template string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN websiteId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Send an email to the customer with a password reset link.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/password');

CREATE FOREIGN PROCEDURE customerCustomerRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_customer-data-customer-interface_addresses_customer-data-address-interface_city" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/city'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_company" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/company'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_country_id" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/country_id'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/customer_id'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_default_billing" boolean OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/default_billing'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_default_shipping" boolean OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/default_shipping'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_fax" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/fax'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_firstname" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/firstname'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/id'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_lastname" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/lastname'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_middlename" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/middlename'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_postcode" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/postcode'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_prefix" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/prefix'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_region_region" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/region/region'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_region_region_code" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/region/region_code'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_region_region_id" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/region/region_id'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_region_id" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/region_id'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_street" string[] OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/street'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_suffix" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/suffix'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_telephone" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/telephone'), "items_customer-data-customer-interface_addresses_customer-data-address-interface_vat_id" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/addresses[]/customer-data-address-interface/vat_id'), "items_customer-data-customer-interface_confirmation" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/confirmation'), "items_customer-data-customer-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/created_at'), "items_customer-data-customer-interface_created_in" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/created_in'), "items_customer-data-customer-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_customer-data-customer-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/custom_attributes[]/framework-attribute-interface/value'), "items_customer-data-customer-interface_default_billing" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/default_billing'), "items_customer-data-customer-interface_default_shipping" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/default_shipping'), "items_customer-data-customer-interface_disable_auto_group_change" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/disable_auto_group_change'), "items_customer-data-customer-interface_dob" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/dob'), "items_customer-data-customer-interface_email" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/email'), "items_customer-data-customer-interface_extension_attributes_is_subscribed" boolean OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/extension_attributes/is_subscribed'), "items_customer-data-customer-interface_firstname" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/firstname'), "items_customer-data-customer-interface_gender" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/gender'), "items_customer-data-customer-interface_group_id" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/group_id'), "items_customer-data-customer-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/id'), "items_customer-data-customer-interface_lastname" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/lastname'), "items_customer-data-customer-interface_middlename" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/middlename'), "items_customer-data-customer-interface_prefix" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/prefix'), "items_customer-data-customer-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/store_id'), "items_customer-data-customer-interface_suffix" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/suffix'), "items_customer-data-customer-interface_taxvat" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/taxvat'), "items_customer-data-customer-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/updated_at'), "items_customer-data-customer-interface_website_id" string OPTIONS (NAMEINSOURCE 'items[]/customer-data-customer-interface/website_id'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Retrieve customers which match a specified criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#CustomerRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/search');

CREATE FOREIGN PROCEDURE customerAccountManagementV1ValidatePut(IN "customer_addresses_customer-data-address-interface_city" string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/city', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_company" string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_country_id" string NOT NULL OPTIONS (ANNOTATION 'Country code in ISO_3166-2 format', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/country_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_default_billing" boolean NOT NULL OPTIONS (ANNOTATION 'If this address is default billing address', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_default_shipping" boolean NOT NULL OPTIONS (ANNOTATION 'If this address is default shipping address.', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_fax" string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_firstname" string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/firstname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_id" string NOT NULL OPTIONS (ANNOTATION 'ID', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_lastname" string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/lastname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_middlename" string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_postcode" string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/postcode', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_prefix" string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_region_region" string NOT NULL OPTIONS (ANNOTATION 'Region', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_region_region_code" string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_region_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region ID', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_street" string[] NOT NULL OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_suffix" string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_telephone" string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/telephone', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_vat_id" string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_confirmation string NOT NULL OPTIONS (ANNOTATION 'Confirmation', NAMEINSOURCE 'customer/confirmation', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_created_at string NOT NULL OPTIONS (ANNOTATION 'Created at time', NAMEINSOURCE 'customer/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_created_in string NOT NULL OPTIONS (ANNOTATION 'Created in area', NAMEINSOURCE 'customer/created_in', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_default_billing string NOT NULL OPTIONS (ANNOTATION 'Default billing address id', NAMEINSOURCE 'customer/default_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_default_shipping string NOT NULL OPTIONS (ANNOTATION 'Default shipping address id', NAMEINSOURCE 'customer/default_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_disable_auto_group_change string NOT NULL OPTIONS (ANNOTATION 'Disable auto group change flag.', NAMEINSOURCE 'customer/disable_auto_group_change', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_dob string NOT NULL OPTIONS (ANNOTATION 'Date of birth', NAMEINSOURCE 'customer/dob', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_email string NOT NULL OPTIONS (ANNOTATION 'Email address', NAMEINSOURCE 'customer/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_extension_attributes_is_subscribed boolean NOT NULL OPTIONS (NAMEINSOURCE 'customer/extension_attributes/is_subscribed', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'customer/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_gender string NOT NULL OPTIONS (ANNOTATION 'Gender', NAMEINSOURCE 'customer/gender', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_group_id string NOT NULL OPTIONS (ANNOTATION 'Group id', NAMEINSOURCE 'customer/group_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'customer/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'customer/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'customer/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'customer/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_store_id string NOT NULL OPTIONS (ANNOTATION 'Store id', NAMEINSOURCE 'customer/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'customer/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_taxvat string NOT NULL OPTIONS (ANNOTATION 'Tax Vat', NAMEINSOURCE 'customer/taxvat', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated at time', NAMEINSOURCE 'customer/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_website_id string NOT NULL OPTIONS (ANNOTATION 'Website id', NAMEINSOURCE 'customer/website_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (messages string[], valid boolean)
OPTIONS (ANNOTATION 'Validate customer data.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/validate');

CREATE FOREIGN PROCEDURE "V1/customers/customerId_GET"(IN customerId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE ("addresses_customer-data-address-interface_city" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/city'), "addresses_customer-data-address-interface_company" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/company'), "addresses_customer-data-address-interface_country_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/country_id'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value'), "addresses_customer-data-address-interface_customer_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/customer_id'), "addresses_customer-data-address-interface_default_billing" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_billing'), "addresses_customer-data-address-interface_default_shipping" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_shipping'), "addresses_customer-data-address-interface_fax" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/fax'), "addresses_customer-data-address-interface_firstname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/firstname'), "addresses_customer-data-address-interface_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/id'), "addresses_customer-data-address-interface_lastname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/lastname'), "addresses_customer-data-address-interface_middlename" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/middlename'), "addresses_customer-data-address-interface_postcode" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/postcode'), "addresses_customer-data-address-interface_prefix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/prefix'), "addresses_customer-data-address-interface_region_region" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region'), "addresses_customer-data-address-interface_region_region_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_code'), "addresses_customer-data-address-interface_region_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_id'), "addresses_customer-data-address-interface_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region_id'), "addresses_customer-data-address-interface_street" string[] OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/street'), "addresses_customer-data-address-interface_suffix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/suffix'), "addresses_customer-data-address-interface_telephone" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/telephone'), "addresses_customer-data-address-interface_vat_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/vat_id'), confirmation string, created_at string, created_in string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_billing string, default_shipping string, disable_auto_group_change string, dob string, email string, extension_attributes_is_subscribed boolean OPTIONS (NAMEINSOURCE 'extension_attributes/is_subscribed'), firstname string, gender string, group_id string, id string, lastname string, middlename string, prefix string, store_id string, suffix string, taxvat string, updated_at string, website_id string)
OPTIONS (ANNOTATION 'Get customer by customer ID.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/{customerId}');

CREATE FOREIGN PROCEDURE customerCustomerRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN customerId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete customer by ID.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/{customerId}');

CREATE FOREIGN PROCEDURE "V1/customers/customerId/billingAddress"(IN customerId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (city string, company string, country_id string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), customer_id string, default_billing boolean, default_shipping boolean, fax string, firstname string, id string, lastname string, middlename string, postcode string, prefix string, region_region string OPTIONS (NAMEINSOURCE 'region/region'), region_region_code string OPTIONS (NAMEINSOURCE 'region/region_code'), region_region_id string OPTIONS (NAMEINSOURCE 'region/region_id'), region_id string, street string[], suffix string, telephone string, vat_id string)
OPTIONS (ANNOTATION 'Retrieve default billing address for the given customerId.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/{customerId}/billingAddress');

CREATE FOREIGN PROCEDURE "V1/customers/customerId/carts"(OUT "return" string RESULT, IN customerId string NOT NULL OPTIONS (ANNOTATION 'The customer ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Creates an empty cart and quote for a specified customer.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/{customerId}/carts');

CREATE FOREIGN PROCEDURE customerAccountManagementV1GetConfirmationStatusGet(OUT "return" string RESULT, IN customerId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Gets the account confirmation status.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/{customerId}/confirm');

CREATE FOREIGN PROCEDURE customerAccountManagementV1ValidateResetPasswordLinkTokenGet(OUT "return" boolean RESULT, IN customerId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN resetPasswordLinkToken string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Check if password reset token is valid.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/{customerId}/password/resetLinkToken/{resetPasswordLinkToken}');

CREATE FOREIGN PROCEDURE customerAccountManagementV1IsReadonlyGet(OUT "return" boolean RESULT, IN customerId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Check if customer can be deleted.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/{customerId}/permissions/readonly');

CREATE FOREIGN PROCEDURE "V1/customers/customerId/shippingAddress"(IN customerId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (city string, company string, country_id string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), customer_id string, default_billing boolean, default_shipping boolean, fax string, firstname string, id string, lastname string, middlename string, postcode string, prefix string, region_region string OPTIONS (NAMEINSOURCE 'region/region'), region_region_code string OPTIONS (NAMEINSOURCE 'region/region_code'), region_region_id string OPTIONS (NAMEINSOURCE 'region/region_id'), region_id string, street string[], suffix string, telephone string, vat_id string)
OPTIONS (ANNOTATION 'Retrieve default shipping address for the given customerId.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/{customerId}/shippingAddress');

CREATE FOREIGN PROCEDURE customerAccountManagementV1ActivatePut(IN email string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN confirmationKey string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE ("addresses_customer-data-address-interface_city" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/city'), "addresses_customer-data-address-interface_company" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/company'), "addresses_customer-data-address-interface_country_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/country_id'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value'), "addresses_customer-data-address-interface_customer_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/customer_id'), "addresses_customer-data-address-interface_default_billing" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_billing'), "addresses_customer-data-address-interface_default_shipping" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_shipping'), "addresses_customer-data-address-interface_fax" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/fax'), "addresses_customer-data-address-interface_firstname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/firstname'), "addresses_customer-data-address-interface_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/id'), "addresses_customer-data-address-interface_lastname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/lastname'), "addresses_customer-data-address-interface_middlename" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/middlename'), "addresses_customer-data-address-interface_postcode" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/postcode'), "addresses_customer-data-address-interface_prefix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/prefix'), "addresses_customer-data-address-interface_region_region" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region'), "addresses_customer-data-address-interface_region_region_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_code'), "addresses_customer-data-address-interface_region_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_id'), "addresses_customer-data-address-interface_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region_id'), "addresses_customer-data-address-interface_street" string[] OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/street'), "addresses_customer-data-address-interface_suffix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/suffix'), "addresses_customer-data-address-interface_telephone" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/telephone'), "addresses_customer-data-address-interface_vat_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/vat_id'), confirmation string, created_at string, created_in string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_billing string, default_shipping string, disable_auto_group_change string, dob string, email string, extension_attributes_is_subscribed boolean OPTIONS (NAMEINSOURCE 'extension_attributes/is_subscribed'), firstname string, gender string, group_id string, id string, lastname string, middlename string, prefix string, store_id string, suffix string, taxvat string, updated_at string, website_id string)
OPTIONS (ANNOTATION 'Activate a customer account using a key that was sent in a confirmation email.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/{email}/activate');

CREATE FOREIGN PROCEDURE "V1/customers/id"(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN "customer_addresses_customer-data-address-interface_city" string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/city', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_company" string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_country_id" string NOT NULL OPTIONS (ANNOTATION 'Country code in ISO_3166-2 format', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/country_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_default_billing" boolean NOT NULL OPTIONS (ANNOTATION 'If this address is default billing address', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_default_shipping" boolean NOT NULL OPTIONS (ANNOTATION 'If this address is default shipping address.', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_fax" string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_firstname" string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/firstname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_id" string NOT NULL OPTIONS (ANNOTATION 'ID', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_lastname" string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/lastname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_middlename" string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_postcode" string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/postcode', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_prefix" string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_region_region" string NOT NULL OPTIONS (ANNOTATION 'Region', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_region_region_code" string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_region_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_addresses_customer-data-address-interface_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region ID', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_street" string[] NOT NULL OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_suffix" string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_telephone" string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/telephone', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_addresses_customer-data-address-interface_vat_id" string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_confirmation string NOT NULL OPTIONS (ANNOTATION 'Confirmation', NAMEINSOURCE 'customer/confirmation', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_created_at string NOT NULL OPTIONS (ANNOTATION 'Created at time', NAMEINSOURCE 'customer/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_created_in string NOT NULL OPTIONS (ANNOTATION 'Created in area', NAMEINSOURCE 'customer/created_in', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "customer_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "customer_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_default_billing string NOT NULL OPTIONS (ANNOTATION 'Default billing address id', NAMEINSOURCE 'customer/default_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_default_shipping string NOT NULL OPTIONS (ANNOTATION 'Default shipping address id', NAMEINSOURCE 'customer/default_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_disable_auto_group_change string NOT NULL OPTIONS (ANNOTATION 'Disable auto group change flag.', NAMEINSOURCE 'customer/disable_auto_group_change', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_dob string NOT NULL OPTIONS (ANNOTATION 'Date of birth', NAMEINSOURCE 'customer/dob', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_email string NOT NULL OPTIONS (ANNOTATION 'Email address', NAMEINSOURCE 'customer/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_extension_attributes_is_subscribed boolean NOT NULL OPTIONS (NAMEINSOURCE 'customer/extension_attributes/is_subscribed', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'customer/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_gender string NOT NULL OPTIONS (ANNOTATION 'Gender', NAMEINSOURCE 'customer/gender', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_group_id string NOT NULL OPTIONS (ANNOTATION 'Group id', NAMEINSOURCE 'customer/group_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'customer/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'customer/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN customer_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'customer/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'customer/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_store_id string NOT NULL OPTIONS (ANNOTATION 'Store id', NAMEINSOURCE 'customer/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'customer/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_taxvat string NOT NULL OPTIONS (ANNOTATION 'Tax Vat', NAMEINSOURCE 'customer/taxvat', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated at time', NAMEINSOURCE 'customer/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN customer_website_id string NOT NULL OPTIONS (ANNOTATION 'Website id', NAMEINSOURCE 'customer/website_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN passwordHash string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("addresses_customer-data-address-interface_city" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/city'), "addresses_customer-data-address-interface_company" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/company'), "addresses_customer-data-address-interface_country_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/country_id'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value'), "addresses_customer-data-address-interface_customer_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/customer_id'), "addresses_customer-data-address-interface_default_billing" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_billing'), "addresses_customer-data-address-interface_default_shipping" boolean OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/default_shipping'), "addresses_customer-data-address-interface_fax" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/fax'), "addresses_customer-data-address-interface_firstname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/firstname'), "addresses_customer-data-address-interface_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/id'), "addresses_customer-data-address-interface_lastname" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/lastname'), "addresses_customer-data-address-interface_middlename" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/middlename'), "addresses_customer-data-address-interface_postcode" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/postcode'), "addresses_customer-data-address-interface_prefix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/prefix'), "addresses_customer-data-address-interface_region_region" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region'), "addresses_customer-data-address-interface_region_region_code" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_code'), "addresses_customer-data-address-interface_region_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region/region_id'), "addresses_customer-data-address-interface_region_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/region_id'), "addresses_customer-data-address-interface_street" string[] OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/street'), "addresses_customer-data-address-interface_suffix" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/suffix'), "addresses_customer-data-address-interface_telephone" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/telephone'), "addresses_customer-data-address-interface_vat_id" string OPTIONS (NAMEINSOURCE 'addresses[]/customer-data-address-interface/vat_id'), confirmation string, created_at string, created_in string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_billing string, default_shipping string, disable_auto_group_change string, dob string, email string, extension_attributes_is_subscribed boolean OPTIONS (NAMEINSOURCE 'extension_attributes/is_subscribed'), firstname string, gender string, group_id string, id string, lastname string, middlename string, prefix string, store_id string, suffix string, taxvat string, updated_at string, website_id string)
OPTIONS (ANNOTATION 'Create or update a customer.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/customers/{id}');

CREATE FOREIGN PROCEDURE directoryCountryInformationAcquirerV1GetCountriesInfoGet() RETURNS TABLE ("available_regions_directory-data-region-information-interface_code" string OPTIONS (NAMEINSOURCE 'available_regions[]/directory-data-region-information-interface/code'), "available_regions_directory-data-region-information-interface_id" string OPTIONS (NAMEINSOURCE 'available_regions[]/directory-data-region-information-interface/id'), "available_regions_directory-data-region-information-interface_name" string OPTIONS (NAMEINSOURCE 'available_regions[]/directory-data-region-information-interface/name'), full_name_english string, full_name_locale string, id string, three_letter_abbreviation string, two_letter_abbreviation string)
OPTIONS (ANNOTATION 'Get all countries and regions information for the store.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/directory/countries');

CREATE FOREIGN PROCEDURE directoryCountryInformationAcquirerV1GetCountryInfoGet(IN countryId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE ("available_regions_directory-data-region-information-interface_code" string OPTIONS (NAMEINSOURCE 'available_regions[]/directory-data-region-information-interface/code'), "available_regions_directory-data-region-information-interface_id" string OPTIONS (NAMEINSOURCE 'available_regions[]/directory-data-region-information-interface/id'), "available_regions_directory-data-region-information-interface_name" string OPTIONS (NAMEINSOURCE 'available_regions[]/directory-data-region-information-interface/name'), full_name_english string, full_name_locale string, id string, three_letter_abbreviation string, two_letter_abbreviation string)
OPTIONS (ANNOTATION 'Get country and region information for the store.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/directory/countries/{countryId}');

CREATE FOREIGN PROCEDURE directoryCurrencyInformationAcquirerV1GetCurrencyInfoGet() RETURNS TABLE (available_currency_codes string[], base_currency_code string, base_currency_symbol string, default_display_currency_code string, default_display_currency_symbol string, "exchange_rates_directory-data-exchange-rate-interface_currency_to" string OPTIONS (NAMEINSOURCE 'exchange_rates[]/directory-data-exchange-rate-interface/currency_to'), "exchange_rates_directory-data-exchange-rate-interface_rate" string OPTIONS (NAMEINSOURCE 'exchange_rates[]/directory-data-exchange-rate-interface/rate'))
OPTIONS (ANNOTATION 'Get currency information for the store.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/directory/currency');

CREATE FOREIGN PROCEDURE eavAttributeSetManagementV1CreatePost(IN attributeSet_attribute_set_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set ID', NAMEINSOURCE 'attributeSet/attribute_set_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attributeSet_attribute_set_name string NOT NULL OPTIONS (ANNOTATION 'Attribute set name', NAMEINSOURCE 'attributeSet/attribute_set_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN attributeSet_entity_type_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set entity type id', NAMEINSOURCE 'attributeSet/entity_type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attributeSet_sort_order string NOT NULL OPTIONS (ANNOTATION 'Attribute set sort order index', NAMEINSOURCE 'attributeSet/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN entityTypeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN skeletonId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (attribute_set_id string, attribute_set_name string, entity_type_id string, sort_order string)
OPTIONS (ANNOTATION 'Create attribute set from data', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/eav/attribute-sets');

CREATE FOREIGN PROCEDURE eavAttributeSetRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_eav-data-attribute-set-interface_attribute_set_id" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-set-interface/attribute_set_id'), "items_eav-data-attribute-set-interface_attribute_set_name" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-set-interface/attribute_set_name'), "items_eav-data-attribute-set-interface_entity_type_id" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-set-interface/entity_type_id'), "items_eav-data-attribute-set-interface_sort_order" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-set-interface/sort_order'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Retrieve list of Attribute Sets This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#AttributeSetRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/eav/attribute-sets/list');

CREATE FOREIGN PROCEDURE eavAttributeSetRepositoryV1GetGet(IN attributeSetId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (attribute_set_id string, attribute_set_name string, entity_type_id string, sort_order string)
OPTIONS (ANNOTATION 'Retrieve attribute set information based on given ID', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/eav/attribute-sets/{attributeSetId}');

CREATE FOREIGN PROCEDURE eavAttributeSetRepositoryV1SavePut(IN attributeSetId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN attributeSet_attribute_set_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set ID', NAMEINSOURCE 'attributeSet/attribute_set_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attributeSet_attribute_set_name string NOT NULL OPTIONS (ANNOTATION 'Attribute set name', NAMEINSOURCE 'attributeSet/attribute_set_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN attributeSet_entity_type_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set entity type id', NAMEINSOURCE 'attributeSet/entity_type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attributeSet_sort_order string NOT NULL OPTIONS (ANNOTATION 'Attribute set sort order index', NAMEINSOURCE 'attributeSet/sort_order', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (attribute_set_id string, attribute_set_name string, entity_type_id string, sort_order string)
OPTIONS (ANNOTATION 'Save attribute set data', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/eav/attribute-sets/{attributeSetId}');

CREATE FOREIGN PROCEDURE eavAttributeSetRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN attributeSetId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove attribute set by given ID', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/eav/attribute-sets/{attributeSetId}');

CREATE FOREIGN PROCEDURE giftWrappingWrappingRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_gift-wrapping-data-wrapping-interface_base_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/gift-wrapping-data-wrapping-interface/base_currency_code'), "items_gift-wrapping-data-wrapping-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/gift-wrapping-data-wrapping-interface/base_price'), "items_gift-wrapping-data-wrapping-interface_design" string OPTIONS (NAMEINSOURCE 'items[]/gift-wrapping-data-wrapping-interface/design'), "items_gift-wrapping-data-wrapping-interface_image_base64_content" string OPTIONS (NAMEINSOURCE 'items[]/gift-wrapping-data-wrapping-interface/image_base64_content'), "items_gift-wrapping-data-wrapping-interface_image_name" string OPTIONS (NAMEINSOURCE 'items[]/gift-wrapping-data-wrapping-interface/image_name'), "items_gift-wrapping-data-wrapping-interface_image_url" string OPTIONS (NAMEINSOURCE 'items[]/gift-wrapping-data-wrapping-interface/image_url'), "items_gift-wrapping-data-wrapping-interface_status" string OPTIONS (NAMEINSOURCE 'items[]/gift-wrapping-data-wrapping-interface/status'), "items_gift-wrapping-data-wrapping-interface_website_ids" string[] OPTIONS (NAMEINSOURCE 'items[]/gift-wrapping-data-wrapping-interface/website_ids'), "items_gift-wrapping-data-wrapping-interface_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/gift-wrapping-data-wrapping-interface/wrapping_id'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Return list of gift wrapping data objects based on search criteria', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/gift-wrappings');

CREATE FOREIGN PROCEDURE giftWrappingWrappingRepositoryV1SavePost(IN data_base_currency_code string NOT NULL OPTIONS (NAMEINSOURCE 'data/base_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN data_base_price string NOT NULL OPTIONS (NAMEINSOURCE 'data/base_price', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_design string NOT NULL OPTIONS (NAMEINSOURCE 'data/design', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_image_base64_content string NOT NULL OPTIONS (NAMEINSOURCE 'data/image_base64_content', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN data_image_name string NOT NULL OPTIONS (NAMEINSOURCE 'data/image_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN data_image_url string NOT NULL OPTIONS (ANNOTATION 'Wrapping image URL.', NAMEINSOURCE 'data/image_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN data_status string NOT NULL OPTIONS (NAMEINSOURCE 'data/status', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_website_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'data/website_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN data_wrapping_id string NOT NULL OPTIONS (NAMEINSOURCE 'data/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN storeId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (base_currency_code string, base_price string, design string, image_base64_content string, image_name string, image_url string, status string, website_ids string[], wrapping_id string)
OPTIONS (ANNOTATION 'Create/Update new gift wrapping with data object values', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/gift-wrappings');

CREATE FOREIGN PROCEDURE giftWrappingWrappingRepositoryV1GetGet(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN storeId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (base_currency_code string, base_price string, design string, image_base64_content string, image_name string, image_url string, status string, website_ids string[], wrapping_id string)
OPTIONS (ANNOTATION 'Return data object for specified wrapping ID and store.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/gift-wrappings/{id}');

CREATE FOREIGN PROCEDURE giftWrappingWrappingRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete gift wrapping', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/gift-wrappings/{id}');

CREATE FOREIGN PROCEDURE giftWrappingWrappingRepositoryV1SavePut(IN wrappingId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN data_base_currency_code string NOT NULL OPTIONS (NAMEINSOURCE 'data/base_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN data_base_price string NOT NULL OPTIONS (NAMEINSOURCE 'data/base_price', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_design string NOT NULL OPTIONS (NAMEINSOURCE 'data/design', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_image_base64_content string NOT NULL OPTIONS (NAMEINSOURCE 'data/image_base64_content', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN data_image_name string NOT NULL OPTIONS (NAMEINSOURCE 'data/image_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN data_image_url string NOT NULL OPTIONS (ANNOTATION 'Wrapping image URL.', NAMEINSOURCE 'data/image_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN data_status string NOT NULL OPTIONS (NAMEINSOURCE 'data/status', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_website_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'data/website_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN data_wrapping_id string NOT NULL OPTIONS (NAMEINSOURCE 'data/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN storeId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (base_currency_code string, base_price string, design string, image_base64_content string, image_name string, image_url string, status string, website_ids string[], wrapping_id string)
OPTIONS (ANNOTATION 'Create/Update new gift wrapping with data object values', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/gift-wrappings/{wrappingId}');

CREATE FOREIGN PROCEDURE giftRegistryShippingMethodManagementV1EstimateByRegistryIdPost(IN registryId string NOT NULL OPTIONS (ANNOTATION 'The estimate registry id', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (amount string, available boolean, base_amount string, carrier_code string, carrier_title string, error_message string, method_code string, method_title string, price_excl_tax string, price_incl_tax string)
OPTIONS (ANNOTATION 'Estimate shipping', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/giftregistry/mine/estimate-shipping-methods');

CREATE FOREIGN PROCEDURE quoteGuestCartManagementV1CreateEmptyCartPost(OUT "return" string RESULT) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Enable an customer or guest user to create an empty cart and quote for an anonymous customer.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts');

CREATE FOREIGN PROCEDURE quoteGuestCartRepositoryV1GetGet(IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (billing_address_city string OPTIONS (NAMEINSOURCE 'billing_address/city'), billing_address_company string OPTIONS (NAMEINSOURCE 'billing_address/company'), billing_address_country_id string OPTIONS (NAMEINSOURCE 'billing_address/country_id'), "billing_address_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'billing_address/custom_attributes[]/framework-attribute-interface/attribute_code'), "billing_address_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'billing_address/custom_attributes[]/framework-attribute-interface/value'), billing_address_customer_address_id string OPTIONS (NAMEINSOURCE 'billing_address/customer_address_id'), billing_address_customer_id string OPTIONS (NAMEINSOURCE 'billing_address/customer_id'), billing_address_email string OPTIONS (NAMEINSOURCE 'billing_address/email'), billing_address_extension_attributes_gift_registry_id string OPTIONS (NAMEINSOURCE 'billing_address/extension_attributes/gift_registry_id'), billing_address_fax string OPTIONS (NAMEINSOURCE 'billing_address/fax'), billing_address_firstname string OPTIONS (NAMEINSOURCE 'billing_address/firstname'), billing_address_id string OPTIONS (NAMEINSOURCE 'billing_address/id'), billing_address_lastname string OPTIONS (NAMEINSOURCE 'billing_address/lastname'), billing_address_middlename string OPTIONS (NAMEINSOURCE 'billing_address/middlename'), billing_address_postcode string OPTIONS (NAMEINSOURCE 'billing_address/postcode'), billing_address_prefix string OPTIONS (NAMEINSOURCE 'billing_address/prefix'), billing_address_region string OPTIONS (NAMEINSOURCE 'billing_address/region'), billing_address_region_code string OPTIONS (NAMEINSOURCE 'billing_address/region_code'), billing_address_region_id string OPTIONS (NAMEINSOURCE 'billing_address/region_id'), billing_address_same_as_billing string OPTIONS (NAMEINSOURCE 'billing_address/same_as_billing'), billing_address_save_in_address_book string OPTIONS (NAMEINSOURCE 'billing_address/save_in_address_book'), billing_address_street string[] OPTIONS (NAMEINSOURCE 'billing_address/street'), billing_address_suffix string OPTIONS (NAMEINSOURCE 'billing_address/suffix'), billing_address_telephone string OPTIONS (NAMEINSOURCE 'billing_address/telephone'), billing_address_vat_id string OPTIONS (NAMEINSOURCE 'billing_address/vat_id'), converted_at string, created_at string, currency_base_currency_code string OPTIONS (NAMEINSOURCE 'currency/base_currency_code'), currency_base_to_global_rate string OPTIONS (NAMEINSOURCE 'currency/base_to_global_rate'), currency_base_to_quote_rate string OPTIONS (NAMEINSOURCE 'currency/base_to_quote_rate'), currency_global_currency_code string OPTIONS (NAMEINSOURCE 'currency/global_currency_code'), currency_quote_currency_code string OPTIONS (NAMEINSOURCE 'currency/quote_currency_code'), currency_store_currency_code string OPTIONS (NAMEINSOURCE 'currency/store_currency_code'), currency_store_to_base_rate string OPTIONS (NAMEINSOURCE 'currency/store_to_base_rate'), currency_store_to_quote_rate string OPTIONS (NAMEINSOURCE 'currency/store_to_quote_rate'), "customer_addresses_customer-data-address-interface_city" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/city'), "customer_addresses_customer-data-address-interface_company" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/company'), "customer_addresses_customer-data-address-interface_country_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/country_id'), "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "customer_addresses_customer-data-address-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/custom_attributes[]/framework-attribute-interface/value'), "customer_addresses_customer-data-address-interface_customer_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/customer_id'), "customer_addresses_customer-data-address-interface_default_billing" boolean OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_billing'), "customer_addresses_customer-data-address-interface_default_shipping" boolean OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/default_shipping'), "customer_addresses_customer-data-address-interface_fax" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/fax'), "customer_addresses_customer-data-address-interface_firstname" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/firstname'), "customer_addresses_customer-data-address-interface_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/id'), "customer_addresses_customer-data-address-interface_lastname" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/lastname'), "customer_addresses_customer-data-address-interface_middlename" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/middlename'), "customer_addresses_customer-data-address-interface_postcode" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/postcode'), "customer_addresses_customer-data-address-interface_prefix" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/prefix'), "customer_addresses_customer-data-address-interface_region_region" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region'), "customer_addresses_customer-data-address-interface_region_region_code" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_code'), "customer_addresses_customer-data-address-interface_region_region_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region/region_id'), "customer_addresses_customer-data-address-interface_region_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/region_id'), "customer_addresses_customer-data-address-interface_street" string[] OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/street'), "customer_addresses_customer-data-address-interface_suffix" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/suffix'), "customer_addresses_customer-data-address-interface_telephone" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/telephone'), "customer_addresses_customer-data-address-interface_vat_id" string OPTIONS (NAMEINSOURCE 'customer/addresses[]/customer-data-address-interface/vat_id'), customer_confirmation string OPTIONS (NAMEINSOURCE 'customer/confirmation'), customer_created_at string OPTIONS (NAMEINSOURCE 'customer/created_at'), customer_created_in string OPTIONS (NAMEINSOURCE 'customer/created_in'), "customer_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/attribute_code'), "customer_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'customer/custom_attributes[]/framework-attribute-interface/value'), customer_default_billing string OPTIONS (NAMEINSOURCE 'customer/default_billing'), customer_default_shipping string OPTIONS (NAMEINSOURCE 'customer/default_shipping'), customer_disable_auto_group_change string OPTIONS (NAMEINSOURCE 'customer/disable_auto_group_change'), customer_dob string OPTIONS (NAMEINSOURCE 'customer/dob'), customer_email string OPTIONS (NAMEINSOURCE 'customer/email'), customer_extension_attributes_is_subscribed boolean OPTIONS (NAMEINSOURCE 'customer/extension_attributes/is_subscribed'), customer_firstname string OPTIONS (NAMEINSOURCE 'customer/firstname'), customer_gender string OPTIONS (NAMEINSOURCE 'customer/gender'), customer_group_id string OPTIONS (NAMEINSOURCE 'customer/group_id'), customer_id string OPTIONS (NAMEINSOURCE 'customer/id'), customer_lastname string OPTIONS (NAMEINSOURCE 'customer/lastname'), customer_middlename string OPTIONS (NAMEINSOURCE 'customer/middlename'), customer_prefix string OPTIONS (NAMEINSOURCE 'customer/prefix'), customer_store_id string OPTIONS (NAMEINSOURCE 'customer/store_id'), customer_suffix string OPTIONS (NAMEINSOURCE 'customer/suffix'), customer_taxvat string OPTIONS (NAMEINSOURCE 'customer/taxvat'), customer_updated_at string OPTIONS (NAMEINSOURCE 'customer/updated_at'), customer_website_id string OPTIONS (NAMEINSOURCE 'customer/website_id'), customer_is_guest boolean, customer_note string, customer_note_notify boolean, customer_tax_class_id string, "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/item_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/name'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/price'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/product_type'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/qty'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_quote_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/quote_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_items_quote-data-cart-item-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/items[]/quote-data-cart-item-interface/sku'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_city" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/city'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_company" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/company'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_country_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/country_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/custom_attributes[]/framework-attribute-interface/attribute_code'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/custom_attributes[]/framework-attribute-interface/value'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_customer_address_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/customer_address_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_customer_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/customer_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/email'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_extension_attributes_gift_registry_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/extension_attributes/gift_registry_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_fax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/fax'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_firstname" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/firstname'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_lastname" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/lastname'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_middlename" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/middlename'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_postcode" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/postcode'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_prefix" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/prefix'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region_code'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_region_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/region_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_same_as_billing" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/same_as_billing'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_save_in_address_book" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/save_in_address_book'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_street" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/street'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_suffix" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/suffix'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_telephone" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/telephone'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_address_vat_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/address/vat_id'), "extension_attributes_shipping_assignments_quote-data-shipping-assignment-interface_shipping_method" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/quote-data-shipping-assignment-interface/shipping/method'), id string, is_active boolean, is_virtual boolean, "items_quote-data-cart-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/item_id'), "items_quote-data-cart-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/name'), "items_quote-data-cart-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/price'), "items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_quote-data-cart-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_quote-data-cart-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_quote-data-cart-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_quote-data-cart-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_quote-data-cart-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_quote-data-cart-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/product_type'), "items_quote-data-cart-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/qty'), "items_quote-data-cart-item-interface_quote_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/quote_id'), "items_quote-data-cart-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-cart-item-interface/sku'), items_count string, items_qty string, orig_order_id string, reserved_order_id string, store_id string, updated_at string)
OPTIONS (ANNOTATION 'Enable a guest user to return information for a specified cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}');

CREATE FOREIGN PROCEDURE quoteGuestCartManagementV1AssignCustomerPut(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN customerId string NOT NULL OPTIONS (ANNOTATION 'The customer ID.', "teiid_rest:PARAMETER_TYPE" 'body'), IN storeId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Assign a specified customer to a specified shopping cart.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}');

CREATE FOREIGN PROCEDURE quoteGuestBillingAddressManagementV1GetGet(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (city string, company string, country_id string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), customer_address_id string, customer_id string, email string, extension_attributes_gift_registry_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_registry_id'), fax string, firstname string, id string, lastname string, middlename string, postcode string, prefix string, region string, region_code string, region_id string, same_as_billing string, save_in_address_book string, street string[], suffix string, telephone string, vat_id string)
OPTIONS (ANNOTATION 'Return the billing address for a specified quote.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/billing-address');

CREATE FOREIGN PROCEDURE quoteGuestBillingAddressManagementV1AssignPost(OUT "return" string RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Assign a specified billing address to a specified cart.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/billing-address');

CREATE FOREIGN PROCEDURE quoteGuestCartTotalManagementV1CollectTotalsPut(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN "additionalData_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'additionalData/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "additionalData_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'additionalData/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_extension_attributes_entity_id" string NOT NULL OPTIONS (NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_extension_attributes_entity_type" string NOT NULL OPTIONS (NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_extension_attributes_wrapping_add_printed_card" boolean NOT NULL OPTIONS (NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_extension_attributes_wrapping_allow_gift_receipt" boolean NOT NULL OPTIONS (NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_extension_attributes_wrapping_id" string NOT NULL OPTIONS (NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_gift_message_id" string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_message" string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_recipient" string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN "additionalData_extension_attributes_gift_messages_gift-message-data-message-interface_sender" string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'additionalData/extension_attributes/gift_messages[]/gift-message-data-message-interface/sender', "teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'paymentMethod/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'paymentMethod/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN shippingCarrierCode string NOT NULL OPTIONS (ANNOTATION 'The carrier code.', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN shippingMethodCode string NOT NULL OPTIONS (ANNOTATION 'The shipping method code.', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (base_currency_code string, base_discount_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_amount string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_subtotal_with_discount string, base_tax_amount string, coupon_code string, discount_amount string, extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_reward_currency_amount'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_currency_amount'), extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_points_balance'), grand_total string, "items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_discount_amount'), "items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price'), "items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price_incl_tax'), "items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total'), "items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_tax_amount'), "items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_amount'), "items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_percent'), "items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/item_id'), "items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/name'), "items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/options'), "items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price'), "items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price_incl_tax'), "items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/qty'), "items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total'), "items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_incl_tax'), "items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_with_discount'), "items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_amount'), "items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_percent'), "items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied'), "items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), items_qty string, quote_currency_code string, shipping_amount string, shipping_discount_amount string, shipping_incl_tax string, shipping_tax_amount string, subtotal string, subtotal_incl_tax string, subtotal_with_discount string, tax_amount string, "total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/area'), "total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/code'), "total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/title'), "total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/value'), weee_tax_applied_amount string)
OPTIONS (ANNOTATION 'Set shipping/billing methods and additional data for cart and collect totals for guest.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/collect-totals');

CREATE FOREIGN PROCEDURE quoteGuestCouponManagementV1GetGet(OUT "return" string RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Return information for a coupon in a specified cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/coupons');

CREATE FOREIGN PROCEDURE quoteGuestCouponManagementV1RemoveDelete(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete a coupon from a specified cart.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/coupons');

CREATE FOREIGN PROCEDURE quoteGuestCouponManagementV1SetPut(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN couponCode string NOT NULL OPTIONS (ANNOTATION 'The coupon code data.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Add a coupon by code to a specified cart.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/coupons/{couponCode}');

CREATE FOREIGN PROCEDURE quoteGuestShipmentEstimationV1EstimateByExtendedAddressPost(IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (amount string, available boolean, base_amount string, carrier_code string, carrier_title string, error_message string, method_code string, method_title string, price_excl_tax string, price_incl_tax string)
OPTIONS (ANNOTATION 'Estimate shipping by address and return list of available shipping methods', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/estimate-shipping-methods');

CREATE FOREIGN PROCEDURE giftMessageGuestCartRepositoryV1GetGet(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The shopping cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (customer_id string, extension_attributes_entity_id string OPTIONS (NAMEINSOURCE 'extension_attributes/entity_id'), extension_attributes_entity_type string OPTIONS (NAMEINSOURCE 'extension_attributes/entity_type'), extension_attributes_wrapping_add_printed_card boolean OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_add_printed_card'), extension_attributes_wrapping_allow_gift_receipt boolean OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_allow_gift_receipt'), extension_attributes_wrapping_id string OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_id'), gift_message_id string, message string, recipient string, sender string)
OPTIONS (ANNOTATION 'Return the gift message for a specified order.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/gift-message');

CREATE FOREIGN PROCEDURE giftMessageGuestCartRepositoryV1SavePost(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN giftMessage_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'giftMessage/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_entity_id string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_entity_type string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_add_printed_card boolean NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_allow_gift_receipt boolean NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_id string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_gift_message_id string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'giftMessage/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_message string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'giftMessage/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftMessage_recipient string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'giftMessage/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftMessage_sender string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'giftMessage/sender', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Set the gift message for an entire order.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/gift-message');

CREATE FOREIGN PROCEDURE giftMessageGuestItemRepositoryV1GetGet(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The shopping cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN itemId string NOT NULL OPTIONS (ANNOTATION 'The item ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (customer_id string, extension_attributes_entity_id string OPTIONS (NAMEINSOURCE 'extension_attributes/entity_id'), extension_attributes_entity_type string OPTIONS (NAMEINSOURCE 'extension_attributes/entity_type'), extension_attributes_wrapping_add_printed_card boolean OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_add_printed_card'), extension_attributes_wrapping_allow_gift_receipt boolean OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_allow_gift_receipt'), extension_attributes_wrapping_id string OPTIONS (NAMEINSOURCE 'extension_attributes/wrapping_id'), gift_message_id string, message string, recipient string, sender string)
OPTIONS (ANNOTATION 'Return the gift message for a specified item in a specified shopping cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/gift-message/{itemId}');

CREATE FOREIGN PROCEDURE giftMessageGuestItemRepositoryV1SavePost(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN itemId string NOT NULL OPTIONS (ANNOTATION 'The item ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN giftMessage_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'giftMessage/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_entity_id string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_entity_type string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_add_printed_card boolean NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_allow_gift_receipt boolean NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_extension_attributes_wrapping_id string NOT NULL OPTIONS (NAMEINSOURCE 'giftMessage/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_gift_message_id string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'giftMessage/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN giftMessage_message string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'giftMessage/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftMessage_recipient string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'giftMessage/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN giftMessage_sender string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'giftMessage/sender', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Set the gift message for a specified item in a specified shopping cart.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/gift-message/{itemId}');

CREATE FOREIGN PROCEDURE quoteGuestCartItemRepositoryV1GetListGet(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (item_id string, name string, price string, "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), product_option_extension_attributes_downloadable_option_downloadable_links string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/downloadable_option/downloadable_links'), product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_message string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_message'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), product_type string, qty string, quote_id string, sku string)
OPTIONS (ANNOTATION 'List items that are assigned to a specified cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/items');

CREATE FOREIGN PROCEDURE quoteGuestCartItemRepositoryV1SavePost(IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN cartItem_item_id string NOT NULL OPTIONS (ANNOTATION 'Item ID. Otherwise, null.', NAMEINSOURCE 'cartItem/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_name string NOT NULL OPTIONS (ANNOTATION 'Product name. Otherwise, null.', NAMEINSOURCE 'cartItem/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_price string NOT NULL OPTIONS (ANNOTATION 'Product price. Otherwise, null.', NAMEINSOURCE 'cartItem/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'cartItem/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'cartItem/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_downloadable_option_downloadable_links string[] NOT NULL OPTIONS (NAMEINSOURCE 'cartItem/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_amount string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_message string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_type string NOT NULL OPTIONS (ANNOTATION 'Product type. Otherwise, null.', NAMEINSOURCE 'cartItem/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_qty string NOT NULL OPTIONS (ANNOTATION 'Product quantity.', NAMEINSOURCE 'cartItem/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_quote_id string NOT NULL OPTIONS (ANNOTATION 'Quote id.', NAMEINSOURCE 'cartItem/quote_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_sku string NOT NULL OPTIONS (ANNOTATION 'Product SKU. Otherwise, null.', NAMEINSOURCE 'cartItem/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (item_id string, name string, price string, "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), product_option_extension_attributes_downloadable_option_downloadable_links string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/downloadable_option/downloadable_links'), product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_message string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_message'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), product_type string, qty string, quote_id string, sku string)
OPTIONS (ANNOTATION 'Add the specified item to the specified cart.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/items');

CREATE FOREIGN PROCEDURE quoteGuestCartItemRepositoryV1SavePut(IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN itemId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN cartItem_item_id string NOT NULL OPTIONS (ANNOTATION 'Item ID. Otherwise, null.', NAMEINSOURCE 'cartItem/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_name string NOT NULL OPTIONS (ANNOTATION 'Product name. Otherwise, null.', NAMEINSOURCE 'cartItem/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_price string NOT NULL OPTIONS (ANNOTATION 'Product price. Otherwise, null.', NAMEINSOURCE 'cartItem/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'cartItem/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'cartItem/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'cartItem/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "cartItem_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'cartItem/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_downloadable_option_downloadable_links string[] NOT NULL OPTIONS (NAMEINSOURCE 'cartItem/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_amount string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_message string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'cartItem/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_product_type string NOT NULL OPTIONS (ANNOTATION 'Product type. Otherwise, null.', NAMEINSOURCE 'cartItem/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN cartItem_qty string NOT NULL OPTIONS (ANNOTATION 'Product quantity.', NAMEINSOURCE 'cartItem/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_quote_id string NOT NULL OPTIONS (ANNOTATION 'Quote id.', NAMEINSOURCE 'cartItem/quote_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN cartItem_sku string NOT NULL OPTIONS (ANNOTATION 'Product SKU. Otherwise, null.', NAMEINSOURCE 'cartItem/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (item_id string, name string, price string, "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), product_option_extension_attributes_downloadable_option_downloadable_links string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/downloadable_option/downloadable_links'), product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_message string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_message'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), product_type string, qty string, quote_id string, sku string)
OPTIONS (ANNOTATION 'Add the specified item to the specified cart.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/items/{itemId}');

CREATE FOREIGN PROCEDURE quoteGuestCartItemRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN itemId string NOT NULL OPTIONS (ANNOTATION 'The item ID of the item to be removed.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove the specified item from the specified cart.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/items/{itemId}');

CREATE FOREIGN PROCEDURE quoteGuestCartManagementV1PlaceOrderPut(OUT "return" string RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN paymentMethod_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'paymentMethod/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'paymentMethod/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Place an order for a specified cart.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/order');

CREATE FOREIGN PROCEDURE checkoutGuestPaymentInformationManagementV1GetPaymentInformationGet(IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE ("payment_methods_quote-data-payment-method-interface_code" string OPTIONS (NAMEINSOURCE 'payment_methods[]/quote-data-payment-method-interface/code'), "payment_methods_quote-data-payment-method-interface_title" string OPTIONS (NAMEINSOURCE 'payment_methods[]/quote-data-payment-method-interface/title'), totals_base_currency_code string OPTIONS (NAMEINSOURCE 'totals/base_currency_code'), totals_base_discount_amount string OPTIONS (NAMEINSOURCE 'totals/base_discount_amount'), totals_base_grand_total string OPTIONS (NAMEINSOURCE 'totals/base_grand_total'), totals_base_shipping_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_amount'), totals_base_shipping_discount_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_discount_amount'), totals_base_shipping_incl_tax string OPTIONS (NAMEINSOURCE 'totals/base_shipping_incl_tax'), totals_base_shipping_tax_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_tax_amount'), totals_base_subtotal string OPTIONS (NAMEINSOURCE 'totals/base_subtotal'), totals_base_subtotal_incl_tax string OPTIONS (NAMEINSOURCE 'totals/base_subtotal_incl_tax'), totals_base_subtotal_with_discount string OPTIONS (NAMEINSOURCE 'totals/base_subtotal_with_discount'), totals_base_tax_amount string OPTIONS (NAMEINSOURCE 'totals/base_tax_amount'), totals_coupon_code string OPTIONS (NAMEINSOURCE 'totals/coupon_code'), totals_discount_amount string OPTIONS (NAMEINSOURCE 'totals/discount_amount'), totals_extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/base_customer_balance_amount'), totals_extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/base_reward_currency_amount'), totals_extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/customer_balance_amount'), totals_extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/reward_currency_amount'), totals_extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/reward_points_balance'), totals_grand_total string OPTIONS (NAMEINSOURCE 'totals/grand_total'), "totals_items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_discount_amount'), "totals_items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_price'), "totals_items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_price_incl_tax'), "totals_items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_row_total'), "totals_items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "totals_items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_tax_amount'), "totals_items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/discount_amount'), "totals_items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/discount_percent'), "totals_items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/item_id'), "totals_items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/name'), "totals_items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/options'), "totals_items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/price'), "totals_items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/price_incl_tax'), "totals_items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/qty'), "totals_items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total'), "totals_items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total_incl_tax'), "totals_items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total_with_discount'), "totals_items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/tax_amount'), "totals_items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/tax_percent'), "totals_items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/weee_tax_applied'), "totals_items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), totals_items_qty string OPTIONS (NAMEINSOURCE 'totals/items_qty'), totals_quote_currency_code string OPTIONS (NAMEINSOURCE 'totals/quote_currency_code'), totals_shipping_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_amount'), totals_shipping_discount_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_discount_amount'), totals_shipping_incl_tax string OPTIONS (NAMEINSOURCE 'totals/shipping_incl_tax'), totals_shipping_tax_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_tax_amount'), totals_subtotal string OPTIONS (NAMEINSOURCE 'totals/subtotal'), totals_subtotal_incl_tax string OPTIONS (NAMEINSOURCE 'totals/subtotal_incl_tax'), totals_subtotal_with_discount string OPTIONS (NAMEINSOURCE 'totals/subtotal_with_discount'), totals_tax_amount string OPTIONS (NAMEINSOURCE 'totals/tax_amount'), "totals_total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/area'), "totals_total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/code'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "totals_total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/title'), "totals_total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/value'), totals_weee_tax_applied_amount string OPTIONS (NAMEINSOURCE 'totals/weee_tax_applied_amount'))
OPTIONS (ANNOTATION 'Get payment information', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/payment-information');

CREATE FOREIGN PROCEDURE checkoutGuestPaymentInformationManagementV1SavePaymentInformationAndPlaceOrderPost(OUT "return" string RESULT, IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN billingAddress_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'billingAddress/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'billingAddress/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'billingAddress/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "billingAddress_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'billingAddress/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "billingAddress_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'billingAddress/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'billingAddress/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'billingAddress/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'billingAddress/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'billingAddress/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'billingAddress/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'billingAddress/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'billingAddress/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'billingAddress/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'billingAddress/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'billingAddress/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'billingAddress/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'billingAddress/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'billingAddress/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'billingAddress/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'billingAddress/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'billingAddress/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'billingAddress/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'billingAddress/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'billingAddress/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'billingAddress/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN email string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'paymentMethod/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'paymentMethod/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Set payment information and place order for a specified cart.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/payment-information');

CREATE FOREIGN PROCEDURE quoteGuestPaymentMethodManagementV1GetListGet(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, title string)
OPTIONS (ANNOTATION 'List available payment methods for a specified shopping cart. This call returns an array of objects, but detailed information about each object’s attributes might not be included.  See http://devdocs.magento.com/codelinks/attributes.html#GuestPaymentMethodManagementInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/payment-methods');

CREATE FOREIGN PROCEDURE quoteGuestPaymentMethodManagementV1GetGet(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (additional_data string[], extension_attributes_agreement_ids string[] OPTIONS (NAMEINSOURCE 'extension_attributes/agreement_ids'), "method" string, po_number string)
OPTIONS (ANNOTATION 'Return the payment method for a specified shopping cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/selected-payment-method');

CREATE FOREIGN PROCEDURE quoteGuestPaymentMethodManagementV1SetPut(OUT "return" string RESULT, IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN method_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'method/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN method_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'method/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN method_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'method/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN method_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'method/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Add a specified payment method to a specified shopping cart.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/selected-payment-method');

CREATE FOREIGN PROCEDURE checkoutGuestPaymentInformationManagementV1SavePaymentInformationPost(OUT "return" string RESULT, IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN billingAddress_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'billingAddress/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'billingAddress/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'billingAddress/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "billingAddress_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'billingAddress/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "billingAddress_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'billingAddress/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'billingAddress/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'billingAddress/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'billingAddress/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'billingAddress/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'billingAddress/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'billingAddress/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'billingAddress/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'billingAddress/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'billingAddress/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'billingAddress/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'billingAddress/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'billingAddress/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'billingAddress/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'billingAddress/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'billingAddress/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'billingAddress/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'billingAddress/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'billingAddress/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'billingAddress/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'billingAddress/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN email string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'paymentMethod/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'paymentMethod/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Set payment information for a specified cart.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/set-payment-information');

CREATE FOREIGN PROCEDURE checkoutGuestShippingInformationManagementV1SaveAddressInformationPost(IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN addressInformation_billing_address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'addressInformation/billing_address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'addressInformation/billing_address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'addressInformation/billing_address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_billing_address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/billing_address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_billing_address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/billing_address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'addressInformation/billing_address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'addressInformation/billing_address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'addressInformation/billing_address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/billing_address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'addressInformation/billing_address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'addressInformation/billing_address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'addressInformation/billing_address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'addressInformation/billing_address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'addressInformation/billing_address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'addressInformation/billing_address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'addressInformation/billing_address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'addressInformation/billing_address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'addressInformation/billing_address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'addressInformation/billing_address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'addressInformation/billing_address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'addressInformation/billing_address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/billing_address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'addressInformation/billing_address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_billing_address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'addressInformation/billing_address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_billing_address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'addressInformation/billing_address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "addressInformation_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'addressInformation/shipping_address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'addressInformation/shipping_address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'addressInformation/shipping_address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_shipping_address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/shipping_address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_shipping_address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/shipping_address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'addressInformation/shipping_address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'addressInformation/shipping_address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'addressInformation/shipping_address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/shipping_address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'addressInformation/shipping_address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'addressInformation/shipping_address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'addressInformation/shipping_address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'addressInformation/shipping_address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'addressInformation/shipping_address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'addressInformation/shipping_address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'addressInformation/shipping_address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'addressInformation/shipping_address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'addressInformation/shipping_address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'addressInformation/shipping_address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'addressInformation/shipping_address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'addressInformation/shipping_address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/shipping_address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'addressInformation/shipping_address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'addressInformation/shipping_address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'addressInformation/shipping_address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_carrier_code string NOT NULL OPTIONS (ANNOTATION 'Carrier code', NAMEINSOURCE 'addressInformation/shipping_carrier_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_method_code string NOT NULL OPTIONS (ANNOTATION 'Shipping method code', NAMEINSOURCE 'addressInformation/shipping_method_code', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE ("payment_methods_quote-data-payment-method-interface_code" string OPTIONS (NAMEINSOURCE 'payment_methods[]/quote-data-payment-method-interface/code'), "payment_methods_quote-data-payment-method-interface_title" string OPTIONS (NAMEINSOURCE 'payment_methods[]/quote-data-payment-method-interface/title'), totals_base_currency_code string OPTIONS (NAMEINSOURCE 'totals/base_currency_code'), totals_base_discount_amount string OPTIONS (NAMEINSOURCE 'totals/base_discount_amount'), totals_base_grand_total string OPTIONS (NAMEINSOURCE 'totals/base_grand_total'), totals_base_shipping_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_amount'), totals_base_shipping_discount_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_discount_amount'), totals_base_shipping_incl_tax string OPTIONS (NAMEINSOURCE 'totals/base_shipping_incl_tax'), totals_base_shipping_tax_amount string OPTIONS (NAMEINSOURCE 'totals/base_shipping_tax_amount'), totals_base_subtotal string OPTIONS (NAMEINSOURCE 'totals/base_subtotal'), totals_base_subtotal_incl_tax string OPTIONS (NAMEINSOURCE 'totals/base_subtotal_incl_tax'), totals_base_subtotal_with_discount string OPTIONS (NAMEINSOURCE 'totals/base_subtotal_with_discount'), totals_base_tax_amount string OPTIONS (NAMEINSOURCE 'totals/base_tax_amount'), totals_coupon_code string OPTIONS (NAMEINSOURCE 'totals/coupon_code'), totals_discount_amount string OPTIONS (NAMEINSOURCE 'totals/discount_amount'), totals_extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/base_customer_balance_amount'), totals_extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/base_reward_currency_amount'), totals_extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/customer_balance_amount'), totals_extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/reward_currency_amount'), totals_extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'totals/extension_attributes/reward_points_balance'), totals_grand_total string OPTIONS (NAMEINSOURCE 'totals/grand_total'), "totals_items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_discount_amount'), "totals_items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_price'), "totals_items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_price_incl_tax'), "totals_items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_row_total'), "totals_items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "totals_items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/base_tax_amount'), "totals_items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/discount_amount'), "totals_items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/discount_percent'), "totals_items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/item_id'), "totals_items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/name'), "totals_items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/options'), "totals_items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/price'), "totals_items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/price_incl_tax'), "totals_items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/qty'), "totals_items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total'), "totals_items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total_incl_tax'), "totals_items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/row_total_with_discount'), "totals_items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/tax_amount'), "totals_items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/tax_percent'), "totals_items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/weee_tax_applied'), "totals_items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'totals/items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), totals_items_qty string OPTIONS (NAMEINSOURCE 'totals/items_qty'), totals_quote_currency_code string OPTIONS (NAMEINSOURCE 'totals/quote_currency_code'), totals_shipping_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_amount'), totals_shipping_discount_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_discount_amount'), totals_shipping_incl_tax string OPTIONS (NAMEINSOURCE 'totals/shipping_incl_tax'), totals_shipping_tax_amount string OPTIONS (NAMEINSOURCE 'totals/shipping_tax_amount'), totals_subtotal string OPTIONS (NAMEINSOURCE 'totals/subtotal'), totals_subtotal_incl_tax string OPTIONS (NAMEINSOURCE 'totals/subtotal_incl_tax'), totals_subtotal_with_discount string OPTIONS (NAMEINSOURCE 'totals/subtotal_with_discount'), totals_tax_amount string OPTIONS (NAMEINSOURCE 'totals/tax_amount'), "totals_total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/area'), "totals_total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/code'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "totals_total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "totals_total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/title'), "totals_total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'totals/total_segments[]/quote-data-total-segment-interface/value'), totals_weee_tax_applied_amount string OPTIONS (NAMEINSOURCE 'totals/weee_tax_applied_amount'))
OPTIONS ("teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/shipping-information');

CREATE FOREIGN PROCEDURE quoteGuestShippingMethodManagementV1GetListGet(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The shopping cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (amount string, available boolean, base_amount string, carrier_code string, carrier_title string, error_message string, method_code string, method_title string, price_excl_tax string, price_incl_tax string)
OPTIONS (ANNOTATION 'List applicable shipping methods for a specified quote.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/shipping-methods');

CREATE FOREIGN PROCEDURE quoteGuestCartTotalRepositoryV1GetGet(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The cart ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (base_currency_code string, base_discount_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_amount string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_subtotal_with_discount string, base_tax_amount string, coupon_code string, discount_amount string, extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_reward_currency_amount'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_currency_amount'), extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_points_balance'), grand_total string, "items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_discount_amount'), "items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price'), "items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price_incl_tax'), "items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total'), "items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_tax_amount'), "items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_amount'), "items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_percent'), "items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/item_id'), "items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/name'), "items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/options'), "items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price'), "items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price_incl_tax'), "items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/qty'), "items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total'), "items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_incl_tax'), "items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_with_discount'), "items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_amount'), "items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_percent'), "items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied'), "items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), items_qty string, quote_currency_code string, shipping_amount string, shipping_discount_amount string, shipping_incl_tax string, shipping_tax_amount string, subtotal string, subtotal_incl_tax string, subtotal_with_discount string, tax_amount string, "total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/area'), "total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/code'), "total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/title'), "total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/value'), weee_tax_applied_amount string)
OPTIONS (ANNOTATION 'Return quote totals data for a specified cart.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/totals');

CREATE FOREIGN PROCEDURE checkoutGuestTotalsInformationManagementV1CalculatePost(IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN addressInformation_address_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'addressInformation/address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'addressInformation/address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'addressInformation/address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_address_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/address/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_address_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/address/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'addressInformation/address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'addressInformation/address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'addressInformation/address/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/address/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'addressInformation/address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'addressInformation/address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'addressInformation/address/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'addressInformation/address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'addressInformation/address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'addressInformation/address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'addressInformation/address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'addressInformation/address/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'addressInformation/address/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'addressInformation/address/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'addressInformation/address/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'addressInformation/address/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'addressInformation/address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'addressInformation/address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'addressInformation/address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_address_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'addressInformation/address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "addressInformation_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'addressInformation/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "addressInformation_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'addressInformation/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN addressInformation_shipping_carrier_code string NOT NULL OPTIONS (ANNOTATION 'Carrier code', NAMEINSOURCE 'addressInformation/shipping_carrier_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN addressInformation_shipping_method_code string NOT NULL OPTIONS (ANNOTATION 'Shipping method code', NAMEINSOURCE 'addressInformation/shipping_method_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (base_currency_code string, base_discount_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_amount string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_subtotal_with_discount string, base_tax_amount string, coupon_code string, discount_amount string, extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_base_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_reward_currency_amount'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_reward_currency_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_currency_amount'), extension_attributes_reward_points_balance string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_points_balance'), grand_total string, "items_quote-data-totals-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_discount_amount'), "items_quote-data-totals-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price'), "items_quote-data-totals-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_price_incl_tax'), "items_quote-data-totals-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total'), "items_quote-data-totals-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_row_total_incl_tax'), "items_quote-data-totals-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/base_tax_amount'), "items_quote-data-totals-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_amount'), "items_quote-data-totals-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/discount_percent'), "items_quote-data-totals-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/item_id'), "items_quote-data-totals-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/name'), "items_quote-data-totals-item-interface_options" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/options'), "items_quote-data-totals-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price'), "items_quote-data-totals-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/price_incl_tax'), "items_quote-data-totals-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/qty'), "items_quote-data-totals-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total'), "items_quote-data-totals-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_incl_tax'), "items_quote-data-totals-item-interface_row_total_with_discount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/row_total_with_discount'), "items_quote-data-totals-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_amount'), "items_quote-data-totals-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/tax_percent'), "items_quote-data-totals-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied'), "items_quote-data-totals-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/quote-data-totals-item-interface/weee_tax_applied_amount'), items_qty string, quote_currency_code string, shipping_amount string, shipping_discount_amount string, shipping_incl_tax string, shipping_tax_amount string, subtotal string, subtotal_incl_tax string, subtotal_with_discount string, tax_amount string, "total_segments_quote-data-total-segment-interface_area" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/area'), "total_segments_quote-data-total-segment-interface_code" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/code'), "total_segments_quote-data-total-segment-interface_extension_attributes_gift_cards" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gift_cards'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_add_card'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_allow_gift_receipt'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_card_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_item_ids" string[] OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_item_ids'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_base_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_items_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_order_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_order_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_price_incl_tax'), "total_segments_quote-data-total-segment-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/gw_tax_amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_amount" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/amount'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_group_id" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/group_id'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_percent" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/percent'), "total_segments_quote-data-total-segment-interface_extension_attributes_tax_grandtotal_details_tax-data-grand-total-details-interface_rates_tax-data-grand-total-rates-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/extension_attributes/tax_grandtotal_details[]/tax-data-grand-total-details-interface/rates[]/tax-data-grand-total-rates-interface/title'), "total_segments_quote-data-total-segment-interface_title" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/title'), "total_segments_quote-data-total-segment-interface_value" string OPTIONS (NAMEINSOURCE 'total_segments[]/quote-data-total-segment-interface/value'), weee_tax_applied_amount string)
OPTIONS (ANNOTATION 'Calculate quote totals based on address and shipping method.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-carts/{cartId}/totals-information');

CREATE FOREIGN PROCEDURE giftRegistryGuestCartShippingMethodManagementV1EstimateByRegistryIdPost(IN cartId string NOT NULL OPTIONS (ANNOTATION 'The shopping cart ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN registryId string NOT NULL OPTIONS (ANNOTATION 'The estimate registry id', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (amount string, available boolean, base_amount string, carrier_code string, carrier_title string, error_message string, method_code string, method_title string, price_excl_tax string, price_incl_tax string)
OPTIONS (ANNOTATION 'Estimate shipping', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/guest-giftregistry/{cartId}/estimate-shipping-methods');

CREATE FOREIGN PROCEDURE integrationAdminTokenServiceV1CreateAdminAccessTokenPost(OUT "return" string RESULT, IN password string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN username string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Create access token for admin given the admin credentials.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/integration/admin/token');

CREATE FOREIGN PROCEDURE integrationCustomerTokenServiceV1CreateCustomerAccessTokenPost(OUT "return" string RESULT, IN password string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN username string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Create access token for admin given the customer credentials.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/integration/customer/token');

CREATE FOREIGN PROCEDURE salesRefundInvoiceV1ExecutePost(OUT "return" string RESULT, IN invoiceId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN appendComment boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN arguments_adjustment_negative string NOT NULL OPTIONS (ANNOTATION 'Credit memo negative adjustment.', NAMEINSOURCE 'arguments/adjustment_negative', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN arguments_adjustment_positive string NOT NULL OPTIONS (ANNOTATION 'Credit memo positive adjustment.', NAMEINSOURCE 'arguments/adjustment_positive', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN arguments_extension_attributes_return_to_stock_items string[] NOT NULL OPTIONS (NAMEINSOURCE 'arguments/extension_attributes/return_to_stock_items', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN arguments_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo shipping amount.', NAMEINSOURCE 'arguments/shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN comment_comment string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'comment/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN comment_is_visible_on_front string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'comment/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN isOnline boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "items_sales-data-creditmemo-item-creation-interface_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'Order item ID.', NAMEINSOURCE 'items[]/sales-data-creditmemo-item-creation-interface/order_item_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "items_sales-data-creditmemo-item-creation-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Quantity.', NAMEINSOURCE 'items[]/sales-data-creditmemo-item-creation-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN notify boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Create refund for invoice', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/invoice/{invoiceId}/refund');

CREATE FOREIGN PROCEDURE salesInvoiceRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_sales-data-invoice-interface_base_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_currency_code'), "items_sales-data-invoice-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_discount_amount'), "items_sales-data-invoice-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_discount_tax_compensation_amount'), "items_sales-data-invoice-interface_base_grand_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_grand_total'), "items_sales-data-invoice-interface_base_shipping_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_shipping_amount'), "items_sales-data-invoice-interface_base_shipping_discount_tax_compensation_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_shipping_discount_tax_compensation_amnt'), "items_sales-data-invoice-interface_base_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_shipping_incl_tax'), "items_sales-data-invoice-interface_base_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_shipping_tax_amount'), "items_sales-data-invoice-interface_base_subtotal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_subtotal'), "items_sales-data-invoice-interface_base_subtotal_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_subtotal_incl_tax'), "items_sales-data-invoice-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_tax_amount'), "items_sales-data-invoice-interface_base_to_global_rate" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_to_global_rate'), "items_sales-data-invoice-interface_base_to_order_rate" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_to_order_rate'), "items_sales-data-invoice-interface_base_total_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/base_total_refunded'), "items_sales-data-invoice-interface_billing_address_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/billing_address_id'), "items_sales-data-invoice-interface_can_void_flag" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/can_void_flag'), "items_sales-data-invoice-interface_comments_sales-data-invoice-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/comments[]/sales-data-invoice-comment-interface/comment'), "items_sales-data-invoice-interface_comments_sales-data-invoice-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/comments[]/sales-data-invoice-comment-interface/created_at'), "items_sales-data-invoice-interface_comments_sales-data-invoice-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/comments[]/sales-data-invoice-comment-interface/entity_id'), "items_sales-data-invoice-interface_comments_sales-data-invoice-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/comments[]/sales-data-invoice-comment-interface/is_customer_notified'), "items_sales-data-invoice-interface_comments_sales-data-invoice-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/comments[]/sales-data-invoice-comment-interface/is_visible_on_front'), "items_sales-data-invoice-interface_comments_sales-data-invoice-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/comments[]/sales-data-invoice-comment-interface/parent_id'), "items_sales-data-invoice-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/created_at'), "items_sales-data-invoice-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/discount_amount'), "items_sales-data-invoice-interface_discount_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/discount_description'), "items_sales-data-invoice-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/discount_tax_compensation_amount'), "items_sales-data-invoice-interface_email_sent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/email_sent'), "items_sales-data-invoice-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/entity_id'), "items_sales-data-invoice-interface_extension_attributes_base_customer_balance_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/extension_attributes/base_customer_balance_amount'), "items_sales-data-invoice-interface_extension_attributes_base_gift_cards_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/extension_attributes/base_gift_cards_amount'), "items_sales-data-invoice-interface_extension_attributes_customer_balance_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/extension_attributes/customer_balance_amount'), "items_sales-data-invoice-interface_extension_attributes_gift_cards_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/extension_attributes/gift_cards_amount'), "items_sales-data-invoice-interface_global_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/global_currency_code'), "items_sales-data-invoice-interface_grand_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/grand_total'), "items_sales-data-invoice-interface_increment_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/increment_id'), "items_sales-data-invoice-interface_is_used_for_refund" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/is_used_for_refund'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/additional_data'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/base_cost'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/base_discount_amount'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/base_price'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/base_price_incl_tax'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/base_row_total'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/base_row_total_incl_tax'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/base_tax_amount'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/description'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/discount_amount'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/discount_tax_compensation_amount'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/entity_id'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/name'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/order_item_id'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/parent_id'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/price'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/price_incl_tax'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/product_id'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/qty'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/row_total'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/row_total_incl_tax'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/sku'), "items_sales-data-invoice-interface_items_sales-data-invoice-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/items[]/sales-data-invoice-item-interface/tax_amount'), "items_sales-data-invoice-interface_order_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/order_currency_code'), "items_sales-data-invoice-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/order_id'), "items_sales-data-invoice-interface_shipping_address_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/shipping_address_id'), "items_sales-data-invoice-interface_shipping_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/shipping_amount'), "items_sales-data-invoice-interface_shipping_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/shipping_discount_tax_compensation_amount'), "items_sales-data-invoice-interface_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/shipping_incl_tax'), "items_sales-data-invoice-interface_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/shipping_tax_amount'), "items_sales-data-invoice-interface_state" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/state'), "items_sales-data-invoice-interface_store_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/store_currency_code'), "items_sales-data-invoice-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/store_id'), "items_sales-data-invoice-interface_store_to_base_rate" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/store_to_base_rate'), "items_sales-data-invoice-interface_store_to_order_rate" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/store_to_order_rate'), "items_sales-data-invoice-interface_subtotal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/subtotal'), "items_sales-data-invoice-interface_subtotal_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/subtotal_incl_tax'), "items_sales-data-invoice-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/tax_amount'), "items_sales-data-invoice-interface_total_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/total_qty'), "items_sales-data-invoice-interface_transaction_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/transaction_id'), "items_sales-data-invoice-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-interface/updated_at'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Lists invoices that match specified search criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#InvoiceRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/invoices');

CREATE FOREIGN PROCEDURE salesInvoiceRepositoryV1SavePost(IN entity_base_currency_code string NOT NULL OPTIONS (ANNOTATION 'Base currency code.', NAMEINSOURCE 'entity/base_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Base discount amount.', NAMEINSOURCE 'entity/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation amount.', NAMEINSOURCE 'entity/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_grand_total string NOT NULL OPTIONS (ANNOTATION 'Base grand total.', NAMEINSOURCE 'entity/base_grand_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Base shipping amount.', NAMEINSOURCE 'entity/base_shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_discount_tax_compensation_amnt string NOT NULL OPTIONS (ANNOTATION 'Base shipping discount tax compensation amount.', NAMEINSOURCE 'entity/base_shipping_discount_tax_compensation_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Base shipping including tax.', NAMEINSOURCE 'entity/base_shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Base shipping tax amount.', NAMEINSOURCE 'entity/base_shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal string NOT NULL OPTIONS (ANNOTATION 'Base subtotal.', NAMEINSOURCE 'entity/base_subtotal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Base subtotal including tax.', NAMEINSOURCE 'entity/base_subtotal_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_to_global_rate string NOT NULL OPTIONS (ANNOTATION 'Base-to-global rate.', NAMEINSOURCE 'entity/base_to_global_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_to_order_rate string NOT NULL OPTIONS (ANNOTATION 'Base-to-order rate.', NAMEINSOURCE 'entity/base_to_order_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_refunded string NOT NULL OPTIONS (ANNOTATION 'Base total refunded.', NAMEINSOURCE 'entity/base_total_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_id string NOT NULL OPTIONS (ANNOTATION 'Billing address ID.', NAMEINSOURCE 'entity/billing_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_can_void_flag string NOT NULL OPTIONS (ANNOTATION 'Can void flag value.', NAMEINSOURCE 'entity/can_void_flag', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_comments_sales-data-invoice-comment-interface_comment" string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'entity/comments[]/sales-data-invoice-comment-interface/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_comments_sales-data-invoice-comment-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/comments[]/sales-data-invoice-comment-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_comments_sales-data-invoice-comment-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Invoice ID.', NAMEINSOURCE 'entity/comments[]/sales-data-invoice-comment-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_comments_sales-data-invoice-comment-interface_is_customer_notified" string NOT NULL OPTIONS (ANNOTATION 'Is-customer-notified flag value.', NAMEINSOURCE 'entity/comments[]/sales-data-invoice-comment-interface/is_customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_comments_sales-data-invoice-comment-interface_is_visible_on_front" string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'entity/comments[]/sales-data-invoice-comment-interface/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_comments_sales-data-invoice-comment-interface_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/comments[]/sales-data-invoice-comment-interface/parent_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_created_at string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_description string NOT NULL OPTIONS (ANNOTATION 'Discount description.', NAMEINSOURCE 'entity/discount_description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_email_sent string NOT NULL OPTIONS (ANNOTATION 'Email-sent flag value.', NAMEINSOURCE 'entity/email_sent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_entity_id string NOT NULL OPTIONS (ANNOTATION 'Invoice ID.', NAMEINSOURCE 'entity/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_base_customer_balance_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/base_customer_balance_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_base_gift_cards_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/base_gift_cards_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_customer_balance_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/customer_balance_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_cards_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gift_cards_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_global_currency_code string NOT NULL OPTIONS (ANNOTATION 'Global currency code.', NAMEINSOURCE 'entity/global_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_grand_total string NOT NULL OPTIONS (ANNOTATION 'Grand total.', NAMEINSOURCE 'entity/grand_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_increment_id string NOT NULL OPTIONS (ANNOTATION 'Increment ID.', NAMEINSOURCE 'entity/increment_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_is_used_for_refund string NOT NULL OPTIONS (ANNOTATION 'Is-used-for-refund flag value.', NAMEINSOURCE 'entity/is_used_for_refund', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_additional_data" string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_base_cost" string NOT NULL OPTIONS (ANNOTATION 'Base cost.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/base_cost', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_base_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount amount.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_base_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation amount.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_base_price" string NOT NULL OPTIONS (ANNOTATION 'Base price.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_base_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base price including tax.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_base_row_total" string NOT NULL OPTIONS (ANNOTATION 'Base row total.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/base_row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_base_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base row total including tax.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/base_row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Invoice item ID.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_name" string NOT NULL OPTIONS (ANNOTATION 'Name.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'Order item ID.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/order_item_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-invoice-item-interface_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Price including tax.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_product_id" string NOT NULL OPTIONS (ANNOTATION 'Product ID.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Quantity.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-invoice-item-interface_row_total" string NOT NULL OPTIONS (ANNOTATION 'Row total.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Row total including tax.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-invoice-item-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-invoice-item-interface_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-invoice-item-interface/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_order_currency_code string NOT NULL OPTIONS (ANNOTATION 'Order currency code.', NAMEINSOURCE 'entity/order_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_order_id string NOT NULL OPTIONS (ANNOTATION 'Order ID.', NAMEINSOURCE 'entity/order_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_shipping_address_id string NOT NULL OPTIONS (ANNOTATION 'Shipping address ID.', NAMEINSOURCE 'entity/shipping_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping amount.', NAMEINSOURCE 'entity/shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping discount tax compensation amount.', NAMEINSOURCE 'entity/shipping_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Shipping including tax.', NAMEINSOURCE 'entity/shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping tax amount.', NAMEINSOURCE 'entity/shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_state string NOT NULL OPTIONS (ANNOTATION 'State.', NAMEINSOURCE 'entity/state', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_currency_code string NOT NULL OPTIONS (ANNOTATION 'Store currency code.', NAMEINSOURCE 'entity/store_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_id string NOT NULL OPTIONS (ANNOTATION 'Store ID.', NAMEINSOURCE 'entity/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_to_base_rate string NOT NULL OPTIONS (ANNOTATION 'Store-to-base rate.', NAMEINSOURCE 'entity/store_to_base_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_to_order_rate string NOT NULL OPTIONS (ANNOTATION 'Store-to-order rate.', NAMEINSOURCE 'entity/store_to_order_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal string NOT NULL OPTIONS (ANNOTATION 'Subtotal.', NAMEINSOURCE 'entity/subtotal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Subtotal including tax.', NAMEINSOURCE 'entity/subtotal_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_qty string NOT NULL OPTIONS (ANNOTATION 'Total quantity.', NAMEINSOURCE 'entity/total_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_transaction_id string NOT NULL OPTIONS (ANNOTATION 'Transaction ID.', NAMEINSOURCE 'entity/transaction_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (base_currency_code string, base_discount_amount string, base_discount_tax_compensation_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_tax_compensation_amnt string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_tax_amount string, base_to_global_rate string, base_to_order_rate string, base_total_refunded string, billing_address_id string, can_void_flag string, "comments_sales-data-invoice-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-invoice-comment-interface/comment'), "comments_sales-data-invoice-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-invoice-comment-interface/created_at'), "comments_sales-data-invoice-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-invoice-comment-interface/entity_id'), "comments_sales-data-invoice-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-invoice-comment-interface/is_customer_notified'), "comments_sales-data-invoice-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-invoice-comment-interface/is_visible_on_front'), "comments_sales-data-invoice-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-invoice-comment-interface/parent_id'), created_at string, discount_amount string, discount_description string, discount_tax_compensation_amount string, email_sent string, entity_id string, extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_base_gift_cards_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_gift_cards_amount'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_gift_cards_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_cards_amount'), global_currency_code string, grand_total string, increment_id string, is_used_for_refund string, "items_sales-data-invoice-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/additional_data'), "items_sales-data-invoice-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_cost'), "items_sales-data-invoice-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_discount_amount'), "items_sales-data-invoice-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-invoice-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_price'), "items_sales-data-invoice-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_price_incl_tax'), "items_sales-data-invoice-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_row_total'), "items_sales-data-invoice-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_row_total_incl_tax'), "items_sales-data-invoice-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_tax_amount'), "items_sales-data-invoice-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/description'), "items_sales-data-invoice-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/discount_amount'), "items_sales-data-invoice-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/discount_tax_compensation_amount'), "items_sales-data-invoice-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/entity_id'), "items_sales-data-invoice-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/name'), "items_sales-data-invoice-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/order_item_id'), "items_sales-data-invoice-item-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/parent_id'), "items_sales-data-invoice-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/price'), "items_sales-data-invoice-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/price_incl_tax'), "items_sales-data-invoice-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/product_id'), "items_sales-data-invoice-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/qty'), "items_sales-data-invoice-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/row_total'), "items_sales-data-invoice-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/row_total_incl_tax'), "items_sales-data-invoice-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/sku'), "items_sales-data-invoice-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/tax_amount'), order_currency_code string, order_id string, shipping_address_id string, shipping_amount string, shipping_discount_tax_compensation_amount string, shipping_incl_tax string, shipping_tax_amount string, state string, store_currency_code string, store_id string, store_to_base_rate string, store_to_order_rate string, subtotal string, subtotal_incl_tax string, tax_amount string, total_qty string, transaction_id string, updated_at string)
OPTIONS (ANNOTATION 'Performs persist operations for a specified invoice.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/invoices/');

CREATE FOREIGN PROCEDURE salesInvoiceCommentRepositoryV1SavePost(IN entity_comment string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'entity/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_created_at string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_entity_id string NOT NULL OPTIONS (ANNOTATION 'Invoice ID.', NAMEINSOURCE 'entity/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_is_customer_notified string NOT NULL OPTIONS (ANNOTATION 'Is-customer-notified flag value.', NAMEINSOURCE 'entity/is_customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_is_visible_on_front string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'entity/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_parent_id string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/parent_id', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (comment string, created_at string, entity_id string, is_customer_notified string, is_visible_on_front string, parent_id string)
OPTIONS (ANNOTATION 'Performs persist operations for a specified invoice comment.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/invoices/comments');

CREATE FOREIGN PROCEDURE salesInvoiceRepositoryV1GetGet(IN id string NOT NULL OPTIONS (ANNOTATION 'The invoice ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (base_currency_code string, base_discount_amount string, base_discount_tax_compensation_amount string, base_grand_total string, base_shipping_amount string, base_shipping_discount_tax_compensation_amnt string, base_shipping_incl_tax string, base_shipping_tax_amount string, base_subtotal string, base_subtotal_incl_tax string, base_tax_amount string, base_to_global_rate string, base_to_order_rate string, base_total_refunded string, billing_address_id string, can_void_flag string, "comments_sales-data-invoice-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-invoice-comment-interface/comment'), "comments_sales-data-invoice-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-invoice-comment-interface/created_at'), "comments_sales-data-invoice-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-invoice-comment-interface/entity_id'), "comments_sales-data-invoice-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-invoice-comment-interface/is_customer_notified'), "comments_sales-data-invoice-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-invoice-comment-interface/is_visible_on_front'), "comments_sales-data-invoice-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-invoice-comment-interface/parent_id'), created_at string, discount_amount string, discount_description string, discount_tax_compensation_amount string, email_sent string, entity_id string, extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_base_gift_cards_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_gift_cards_amount'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_gift_cards_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_cards_amount'), global_currency_code string, grand_total string, increment_id string, is_used_for_refund string, "items_sales-data-invoice-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/additional_data'), "items_sales-data-invoice-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_cost'), "items_sales-data-invoice-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_discount_amount'), "items_sales-data-invoice-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-invoice-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_price'), "items_sales-data-invoice-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_price_incl_tax'), "items_sales-data-invoice-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_row_total'), "items_sales-data-invoice-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_row_total_incl_tax'), "items_sales-data-invoice-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/base_tax_amount'), "items_sales-data-invoice-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/description'), "items_sales-data-invoice-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/discount_amount'), "items_sales-data-invoice-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/discount_tax_compensation_amount'), "items_sales-data-invoice-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/entity_id'), "items_sales-data-invoice-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/name'), "items_sales-data-invoice-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/order_item_id'), "items_sales-data-invoice-item-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/parent_id'), "items_sales-data-invoice-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/price'), "items_sales-data-invoice-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/price_incl_tax'), "items_sales-data-invoice-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/product_id'), "items_sales-data-invoice-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/qty'), "items_sales-data-invoice-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/row_total'), "items_sales-data-invoice-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/row_total_incl_tax'), "items_sales-data-invoice-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/sku'), "items_sales-data-invoice-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-item-interface/tax_amount'), order_currency_code string, order_id string, shipping_address_id string, shipping_amount string, shipping_discount_tax_compensation_amount string, shipping_incl_tax string, shipping_tax_amount string, state string, store_currency_code string, store_id string, store_to_base_rate string, store_to_order_rate string, subtotal string, subtotal_incl_tax string, tax_amount string, total_qty string, transaction_id string, updated_at string)
OPTIONS (ANNOTATION 'Loads a specified invoice.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/invoices/{id}');

CREATE FOREIGN PROCEDURE salesInvoiceManagementV1SetCapturePost(OUT "return" string RESULT, IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Sets invoice capture.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/invoices/{id}/capture');

CREATE FOREIGN PROCEDURE salesInvoiceManagementV1GetCommentsListGet(IN id string NOT NULL OPTIONS (ANNOTATION 'The invoice ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE ("items_sales-data-invoice-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-comment-interface/comment'), "items_sales-data-invoice-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-comment-interface/created_at'), "items_sales-data-invoice-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-comment-interface/entity_id'), "items_sales-data-invoice-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-comment-interface/is_customer_notified'), "items_sales-data-invoice-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-comment-interface/is_visible_on_front'), "items_sales-data-invoice-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-invoice-comment-interface/parent_id'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Lists comments for a specified invoice.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/invoices/{id}/comments');

CREATE FOREIGN PROCEDURE salesInvoiceManagementV1NotifyPost(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The invoice ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Emails a user a specified invoice.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/invoices/{id}/emails');

CREATE FOREIGN PROCEDURE salesInvoiceManagementV1SetVoidPost(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The invoice ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Voids a specified invoice.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/invoices/{id}/void');

CREATE FOREIGN PROCEDURE backendModuleServiceV1GetModulesGet(OUT "return" string[] RESULT) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Returns an array of enabled modules', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/modules');

CREATE FOREIGN PROCEDURE salesInvoiceOrderV1ExecutePost(OUT "return" string RESULT, IN orderId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN appendComment boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN capture boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN comment_comment string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'comment/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN comment_is_visible_on_front string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'comment/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN "items_sales-data-invoice-item-creation-interface_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'Order item ID.', NAMEINSOURCE 'items[]/sales-data-invoice-item-creation-interface/order_item_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "items_sales-data-invoice-item-creation-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Quantity.', NAMEINSOURCE 'items[]/sales-data-invoice-item-creation-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN notify boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS ("teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/order/{orderId}/invoice');

CREATE FOREIGN PROCEDURE salesRefundOrderV1ExecutePost(OUT "return" string RESULT, IN orderId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN appendComment boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN arguments_adjustment_negative string NOT NULL OPTIONS (ANNOTATION 'Credit memo negative adjustment.', NAMEINSOURCE 'arguments/adjustment_negative', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN arguments_adjustment_positive string NOT NULL OPTIONS (ANNOTATION 'Credit memo positive adjustment.', NAMEINSOURCE 'arguments/adjustment_positive', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN arguments_extension_attributes_return_to_stock_items string[] NOT NULL OPTIONS (NAMEINSOURCE 'arguments/extension_attributes/return_to_stock_items', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN arguments_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Credit memo shipping amount.', NAMEINSOURCE 'arguments/shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN comment_comment string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'comment/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN comment_is_visible_on_front string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'comment/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN "items_sales-data-creditmemo-item-creation-interface_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'Order item ID.', NAMEINSOURCE 'items[]/sales-data-creditmemo-item-creation-interface/order_item_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "items_sales-data-creditmemo-item-creation-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Quantity.', NAMEINSOURCE 'items[]/sales-data-creditmemo-item-creation-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN notify boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Create offline refund for order', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/order/{orderId}/refund');

CREATE FOREIGN PROCEDURE salesShipOrderV1ExecutePost(OUT "return" string RESULT, IN orderId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN appendComment boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN comment_comment string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'comment/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN comment_is_visible_on_front string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'comment/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN "items_sales-data-shipment-item-creation-interface_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'Order item ID.', NAMEINSOURCE 'items[]/sales-data-shipment-item-creation-interface/order_item_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "items_sales-data-shipment-item-creation-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Quantity.', NAMEINSOURCE 'items[]/sales-data-shipment-item-creation-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN notify boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "tracks_sales-data-shipment-track-creation-interface_carrier_code" string NOT NULL OPTIONS (ANNOTATION 'Carrier code.', NAMEINSOURCE 'tracks[]/sales-data-shipment-track-creation-interface/carrier_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "tracks_sales-data-shipment-track-creation-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title.', NAMEINSOURCE 'tracks[]/sales-data-shipment-track-creation-interface/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "tracks_sales-data-shipment-track-creation-interface_track_number" string NOT NULL OPTIONS (ANNOTATION 'Track number.', NAMEINSOURCE 'tracks[]/sales-data-shipment-track-creation-interface/track_number', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Creates new Shipment for given Order.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/order/{orderId}/ship');

CREATE FOREIGN PROCEDURE salesOrderRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_sales-data-order-interface_adjustment_negative" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/adjustment_negative'), "items_sales-data-order-interface_adjustment_positive" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/adjustment_positive'), "items_sales-data-order-interface_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/applied_rule_ids'), "items_sales-data-order-interface_base_adjustment_negative" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_adjustment_negative'), "items_sales-data-order-interface_base_adjustment_positive" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_adjustment_positive'), "items_sales-data-order-interface_base_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_currency_code'), "items_sales-data-order-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_discount_amount'), "items_sales-data-order-interface_base_discount_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_discount_canceled'), "items_sales-data-order-interface_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_discount_invoiced'), "items_sales-data-order-interface_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_discount_refunded'), "items_sales-data-order-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_discount_tax_compensation_amount'), "items_sales-data-order-interface_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_discount_tax_compensation_invoiced'), "items_sales-data-order-interface_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_discount_tax_compensation_refunded'), "items_sales-data-order-interface_base_grand_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_grand_total'), "items_sales-data-order-interface_base_shipping_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_shipping_amount'), "items_sales-data-order-interface_base_shipping_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_shipping_canceled'), "items_sales-data-order-interface_base_shipping_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_shipping_discount_amount'), "items_sales-data-order-interface_base_shipping_discount_tax_compensation_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_shipping_discount_tax_compensation_amnt'), "items_sales-data-order-interface_base_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_shipping_incl_tax'), "items_sales-data-order-interface_base_shipping_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_shipping_invoiced'), "items_sales-data-order-interface_base_shipping_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_shipping_refunded'), "items_sales-data-order-interface_base_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_shipping_tax_amount'), "items_sales-data-order-interface_base_shipping_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_shipping_tax_refunded'), "items_sales-data-order-interface_base_subtotal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_subtotal'), "items_sales-data-order-interface_base_subtotal_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_subtotal_canceled'), "items_sales-data-order-interface_base_subtotal_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_subtotal_incl_tax'), "items_sales-data-order-interface_base_subtotal_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_subtotal_invoiced'), "items_sales-data-order-interface_base_subtotal_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_subtotal_refunded'), "items_sales-data-order-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_tax_amount'), "items_sales-data-order-interface_base_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_tax_canceled'), "items_sales-data-order-interface_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_tax_invoiced'), "items_sales-data-order-interface_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_tax_refunded'), "items_sales-data-order-interface_base_to_global_rate" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_to_global_rate'), "items_sales-data-order-interface_base_to_order_rate" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_to_order_rate'), "items_sales-data-order-interface_base_total_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_total_canceled'), "items_sales-data-order-interface_base_total_due" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_total_due'), "items_sales-data-order-interface_base_total_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_total_invoiced'), "items_sales-data-order-interface_base_total_invoiced_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_total_invoiced_cost'), "items_sales-data-order-interface_base_total_offline_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_total_offline_refunded'), "items_sales-data-order-interface_base_total_online_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_total_online_refunded'), "items_sales-data-order-interface_base_total_paid" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_total_paid'), "items_sales-data-order-interface_base_total_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_total_qty_ordered'), "items_sales-data-order-interface_base_total_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/base_total_refunded'), "items_sales-data-order-interface_billing_address_address_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/address_type'), "items_sales-data-order-interface_billing_address_city" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/city'), "items_sales-data-order-interface_billing_address_company" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/company'), "items_sales-data-order-interface_billing_address_country_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/country_id'), "items_sales-data-order-interface_billing_address_customer_address_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/customer_address_id'), "items_sales-data-order-interface_billing_address_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/customer_id'), "items_sales-data-order-interface_billing_address_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/email'), "items_sales-data-order-interface_billing_address_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/entity_id'), "items_sales-data-order-interface_billing_address_fax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/fax'), "items_sales-data-order-interface_billing_address_firstname" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/firstname'), "items_sales-data-order-interface_billing_address_lastname" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/lastname'), "items_sales-data-order-interface_billing_address_middlename" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/middlename'), "items_sales-data-order-interface_billing_address_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/parent_id'), "items_sales-data-order-interface_billing_address_postcode" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/postcode'), "items_sales-data-order-interface_billing_address_prefix" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/prefix'), "items_sales-data-order-interface_billing_address_region" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/region'), "items_sales-data-order-interface_billing_address_region_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/region_code'), "items_sales-data-order-interface_billing_address_region_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/region_id'), "items_sales-data-order-interface_billing_address_street" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/street'), "items_sales-data-order-interface_billing_address_suffix" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/suffix'), "items_sales-data-order-interface_billing_address_telephone" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/telephone'), "items_sales-data-order-interface_billing_address_vat_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/vat_id'), "items_sales-data-order-interface_billing_address_vat_is_valid" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/vat_is_valid'), "items_sales-data-order-interface_billing_address_vat_request_date" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/vat_request_date'), "items_sales-data-order-interface_billing_address_vat_request_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/vat_request_id'), "items_sales-data-order-interface_billing_address_vat_request_success" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address/vat_request_success'), "items_sales-data-order-interface_billing_address_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/billing_address_id'), "items_sales-data-order-interface_can_ship_partially" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/can_ship_partially'), "items_sales-data-order-interface_can_ship_partially_item" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/can_ship_partially_item'), "items_sales-data-order-interface_coupon_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/coupon_code'), "items_sales-data-order-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/created_at'), "items_sales-data-order-interface_customer_dob" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_dob'), "items_sales-data-order-interface_customer_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_email'), "items_sales-data-order-interface_customer_firstname" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_firstname'), "items_sales-data-order-interface_customer_gender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_gender'), "items_sales-data-order-interface_customer_group_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_group_id'), "items_sales-data-order-interface_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_id'), "items_sales-data-order-interface_customer_is_guest" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_is_guest'), "items_sales-data-order-interface_customer_lastname" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_lastname'), "items_sales-data-order-interface_customer_middlename" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_middlename'), "items_sales-data-order-interface_customer_note" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_note'), "items_sales-data-order-interface_customer_note_notify" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_note_notify'), "items_sales-data-order-interface_customer_prefix" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_prefix'), "items_sales-data-order-interface_customer_suffix" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_suffix'), "items_sales-data-order-interface_customer_taxvat" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/customer_taxvat'), "items_sales-data-order-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/discount_amount'), "items_sales-data-order-interface_discount_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/discount_canceled'), "items_sales-data-order-interface_discount_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/discount_description'), "items_sales-data-order-interface_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/discount_invoiced'), "items_sales-data-order-interface_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/discount_refunded'), "items_sales-data-order-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/discount_tax_compensation_amount'), "items_sales-data-order-interface_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/discount_tax_compensation_invoiced'), "items_sales-data-order-interface_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/discount_tax_compensation_refunded'), "items_sales-data-order-interface_edit_increment" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/edit_increment'), "items_sales-data-order-interface_email_sent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/email_sent'), "items_sales-data-order-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/entity_id'), "items_sales-data-order-interface_ext_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/ext_customer_id'), "items_sales-data-order-interface_ext_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/ext_order_id'), "items_sales-data-order-interface_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/amount'), "items_sales-data-order-interface_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_base_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/base_amount'), "items_sales-data-order-interface_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/code'), "items_sales-data-order-interface_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/code'), "items_sales-data-order-interface_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/percent'), "items_sales-data-order-interface_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_title" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/title'), "items_sales-data-order-interface_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/percent'), "items_sales-data-order-interface_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_title" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/title'), "items_sales-data-order-interface_extension_attributes_base_customer_balance_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/base_customer_balance_amount'), "items_sales-data-order-interface_extension_attributes_converting_from_quote" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/converting_from_quote'), "items_sales-data-order-interface_extension_attributes_customer_balance_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/customer_balance_amount'), "items_sales-data-order-interface_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gift_message/customer_id'), "items_sales-data-order-interface_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-interface_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-interface_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-interface_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gift_message/message'), "items_sales-data-order-interface_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gift_message/recipient'), "items_sales-data-order-interface_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gift_message/sender'), "items_sales-data-order-interface_extension_attributes_gw_add_card" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_add_card'), "items_sales-data-order-interface_extension_attributes_gw_allow_gift_receipt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_allow_gift_receipt'), "items_sales-data-order-interface_extension_attributes_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_base_price'), "items_sales-data-order-interface_extension_attributes_gw_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_base_price_incl_tax'), "items_sales-data-order-interface_extension_attributes_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_base_tax_amount'), "items_sales-data-order-interface_extension_attributes_gw_card_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_card_base_price'), "items_sales-data-order-interface_extension_attributes_gw_card_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_card_base_price_incl_tax'), "items_sales-data-order-interface_extension_attributes_gw_card_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_card_base_tax_amount'), "items_sales-data-order-interface_extension_attributes_gw_card_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_card_price'), "items_sales-data-order-interface_extension_attributes_gw_card_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_card_price_incl_tax'), "items_sales-data-order-interface_extension_attributes_gw_card_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_card_tax_amount'), "items_sales-data-order-interface_extension_attributes_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_id'), "items_sales-data-order-interface_extension_attributes_gw_items_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_items_base_price'), "items_sales-data-order-interface_extension_attributes_gw_items_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_items_base_price_incl_tax'), "items_sales-data-order-interface_extension_attributes_gw_items_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_items_base_tax_amount'), "items_sales-data-order-interface_extension_attributes_gw_items_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_items_price'), "items_sales-data-order-interface_extension_attributes_gw_items_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_items_price_incl_tax'), "items_sales-data-order-interface_extension_attributes_gw_items_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_items_tax_amount'), "items_sales-data-order-interface_extension_attributes_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_price'), "items_sales-data-order-interface_extension_attributes_gw_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_price_incl_tax'), "items_sales-data-order-interface_extension_attributes_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/gw_tax_amount'), "items_sales-data-order-interface_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/amount'), "items_sales-data-order-interface_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_base_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/base_amount'), "items_sales-data-order-interface_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/code'), "items_sales-data-order-interface_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/code'), "items_sales-data-order-interface_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/percent'), "items_sales-data-order-interface_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_title" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/title'), "items_sales-data-order-interface_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/percent'), "items_sales-data-order-interface_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_title" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/title'), "items_sales-data-order-interface_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_associated_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/associated_item_id'), "items_sales-data-order-interface_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/item_id'), "items_sales-data-order-interface_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/type'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/additional_data'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/amount_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/applied_rule_ids'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_amount_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_cost'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_original_price'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_price'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_price_incl_tax'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_total'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_total_incl_tax'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_before_discount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_disposition'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_row_disposition'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/created_at'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/description'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_percent'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_canceled'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_event_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/event_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/ext_order_item_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/message'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/free_shipping'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/is_qty_decimal'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/is_virtual'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/item_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/locked_do_invoice'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_locked_do_ship" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/locked_do_ship'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/name'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_no_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/no_discount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/order_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/original_price'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/additional_data'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/amount_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/applied_rule_ids'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_amount_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_cost'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_original_price'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_price'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/created_at'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/description'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_percent'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_event_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/event_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/ext_order_item_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/free_shipping'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/is_qty_decimal'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/is_virtual'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/item_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_invoice'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_locked_do_ship" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_ship'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/name'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_no_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/no_discount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/order_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/original_price'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_parent_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/parent_item_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/price'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/price_incl_tax'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_type'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_backordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_backordered'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_canceled'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_ordered'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_returned'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_shipped" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_shipped'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_quote_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/quote_item_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_total'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_weight'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/sku'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/store_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_before_discount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_canceled'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_percent'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/updated_at'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weight'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/price'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/price_incl_tax'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_type'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_backordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_backordered'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_canceled'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_ordered'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_returned'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_shipped" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_shipped'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_quote_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/quote_item_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_total'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_total_incl_tax'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_weight'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/sku'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/store_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_before_discount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_canceled'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_percent'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/updated_at'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied_row_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_disposition'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_row_disposition'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weight'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_address_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/address_type'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_city" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/city'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_company" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/company'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_country_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/country_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_customer_address_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/customer_address_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/customer_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/email'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/entity_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_fax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/fax'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_firstname" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/firstname'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_lastname" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/lastname'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_middlename" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/middlename'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/parent_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_postcode" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/postcode'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_prefix" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/prefix'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region_code'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_street" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/street'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_suffix" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/suffix'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_telephone" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/telephone'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_is_valid" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_is_valid'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_date" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_date'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_id'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_success" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_success'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_method" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/method'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_canceled'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_discount_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_discount_tax_compensation_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_discount_tax_compensation_amnt'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_incl_tax'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_tax_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_tax_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_canceled'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_discount_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_discount_tax_compensation_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_incl_tax'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_invoiced'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_tax_amount'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_tax_refunded'), "items_sales-data-order-interface_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_stock_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/stock_id'), "items_sales-data-order-interface_forced_shipment_with_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/forced_shipment_with_invoice'), "items_sales-data-order-interface_global_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/global_currency_code'), "items_sales-data-order-interface_grand_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/grand_total'), "items_sales-data-order-interface_hold_before_state" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/hold_before_state'), "items_sales-data-order-interface_hold_before_status" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/hold_before_status'), "items_sales-data-order-interface_increment_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/increment_id'), "items_sales-data-order-interface_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/is_virtual'), "items_sales-data-order-interface_items_sales-data-order-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/additional_data'), "items_sales-data-order-interface_items_sales-data-order-item-interface_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/amount_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/applied_rule_ids'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_amount_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_cost'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_discount_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_discount_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_discount_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_original_price'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_price'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_price_incl_tax'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_row_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_row_total'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_row_total_incl_tax'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_tax_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_tax_before_discount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_tax_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_tax_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_weee_tax_disposition'), "items_sales-data-order-interface_items_sales-data-order-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/base_weee_tax_row_disposition'), "items_sales-data-order-interface_items_sales-data-order-item-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/created_at'), "items_sales-data-order-interface_items_sales-data-order-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/description'), "items_sales-data-order-interface_items_sales-data-order-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/discount_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/discount_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/discount_percent'), "items_sales-data-order-interface_items_sales-data-order-item-interface_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/discount_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_canceled'), "items_sales-data-order-interface_items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_event_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/event_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/ext_order_item_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/message'), "items_sales-data-order-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient'), "items_sales-data-order-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender'), "items_sales-data-order-interface_items_sales-data-order-item-interface_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/free_shipping'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_base_price'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_base_price_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_base_price_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_price'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_price_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_price_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_tax_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_tax_amount_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/gw_tax_amount_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/is_qty_decimal'), "items_sales-data-order-interface_items_sales-data-order-item-interface_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/is_virtual'), "items_sales-data-order-interface_items_sales-data-order-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/item_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/locked_do_invoice'), "items_sales-data-order-interface_items_sales-data-order-item-interface_locked_do_ship" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/locked_do_ship'), "items_sales-data-order-interface_items_sales-data-order-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/name'), "items_sales-data-order-interface_items_sales-data-order-item-interface_no_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/no_discount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/order_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/original_price'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/additional_data'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/amount_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/applied_rule_ids'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_amount_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_cost'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_original_price'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_price'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_row_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/created_at'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/description'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/discount_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/discount_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/discount_percent'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/discount_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_event_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/event_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/ext_order_item_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/free_shipping'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_price'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/is_qty_decimal'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/is_virtual'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/item_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_invoice'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_locked_do_ship" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_ship'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/name'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_no_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/no_discount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/order_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/original_price'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_parent_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/parent_item_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/price'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/price_incl_tax'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_product_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/product_type'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_qty_backordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/qty_backordered'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_qty_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/qty_canceled'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_qty_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/qty_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/qty_ordered'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_qty_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/qty_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/qty_returned'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_qty_shipped" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/qty_shipped'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_quote_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/quote_item_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/row_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/row_total'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_row_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/row_weight'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/sku'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/store_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/tax_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/tax_before_discount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/tax_canceled'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/tax_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/tax_percent'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/tax_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/updated_at'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item/weight'), "items_sales-data-order-interface_items_sales-data-order-item-interface_parent_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/parent_item_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/price'), "items_sales-data-order-interface_items_sales-data-order-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/price_incl_tax'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_sales-data-order-interface_items_sales-data-order-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/product_type'), "items_sales-data-order-interface_items_sales-data-order-item-interface_qty_backordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/qty_backordered'), "items_sales-data-order-interface_items_sales-data-order-item-interface_qty_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/qty_canceled'), "items_sales-data-order-interface_items_sales-data-order-item-interface_qty_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/qty_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/qty_ordered'), "items_sales-data-order-interface_items_sales-data-order-item-interface_qty_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/qty_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/qty_returned'), "items_sales-data-order-interface_items_sales-data-order-item-interface_qty_shipped" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/qty_shipped'), "items_sales-data-order-interface_items_sales-data-order-item-interface_quote_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/quote_item_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/row_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/row_total'), "items_sales-data-order-interface_items_sales-data-order-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/row_total_incl_tax'), "items_sales-data-order-interface_items_sales-data-order-item-interface_row_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/row_weight'), "items_sales-data-order-interface_items_sales-data-order-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/sku'), "items_sales-data-order-interface_items_sales-data-order-item-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/store_id'), "items_sales-data-order-interface_items_sales-data-order-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/tax_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/tax_before_discount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/tax_canceled'), "items_sales-data-order-interface_items_sales-data-order-item-interface_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/tax_invoiced'), "items_sales-data-order-interface_items_sales-data-order-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/tax_percent'), "items_sales-data-order-interface_items_sales-data-order-item-interface_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/tax_refunded'), "items_sales-data-order-interface_items_sales-data-order-item-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/updated_at'), "items_sales-data-order-interface_items_sales-data-order-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/weee_tax_applied'), "items_sales-data-order-interface_items_sales-data-order-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/weee_tax_applied_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/weee_tax_applied_row_amount'), "items_sales-data-order-interface_items_sales-data-order-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/weee_tax_disposition'), "items_sales-data-order-interface_items_sales-data-order-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/weee_tax_row_disposition'), "items_sales-data-order-interface_items_sales-data-order-item-interface_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/items[]/sales-data-order-item-interface/weight'), "items_sales-data-order-interface_order_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/order_currency_code'), "items_sales-data-order-interface_original_increment_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/original_increment_id'), "items_sales-data-order-interface_payment_account_status" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/account_status'), "items_sales-data-order-interface_payment_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/additional_data'), "items_sales-data-order-interface_payment_additional_information" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/additional_information'), "items_sales-data-order-interface_payment_address_status" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/address_status'), "items_sales-data-order-interface_payment_amount_authorized" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/amount_authorized'), "items_sales-data-order-interface_payment_amount_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/amount_canceled'), "items_sales-data-order-interface_payment_amount_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/amount_ordered'), "items_sales-data-order-interface_payment_amount_paid" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/amount_paid'), "items_sales-data-order-interface_payment_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/amount_refunded'), "items_sales-data-order-interface_payment_anet_trans_method" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/anet_trans_method'), "items_sales-data-order-interface_payment_base_amount_authorized" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/base_amount_authorized'), "items_sales-data-order-interface_payment_base_amount_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/base_amount_canceled'), "items_sales-data-order-interface_payment_base_amount_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/base_amount_ordered'), "items_sales-data-order-interface_payment_base_amount_paid" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/base_amount_paid'), "items_sales-data-order-interface_payment_base_amount_paid_online" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/base_amount_paid_online'), "items_sales-data-order-interface_payment_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/base_amount_refunded'), "items_sales-data-order-interface_payment_base_amount_refunded_online" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/base_amount_refunded_online'), "items_sales-data-order-interface_payment_base_shipping_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/base_shipping_amount'), "items_sales-data-order-interface_payment_base_shipping_captured" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/base_shipping_captured'), "items_sales-data-order-interface_payment_base_shipping_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/base_shipping_refunded'), "items_sales-data-order-interface_payment_cc_approval" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_approval'), "items_sales-data-order-interface_payment_cc_avs_status" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_avs_status'), "items_sales-data-order-interface_payment_cc_cid_status" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_cid_status'), "items_sales-data-order-interface_payment_cc_debug_request_body" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_debug_request_body'), "items_sales-data-order-interface_payment_cc_debug_response_body" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_debug_response_body'), "items_sales-data-order-interface_payment_cc_debug_response_serialized" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_debug_response_serialized'), "items_sales-data-order-interface_payment_cc_exp_month" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_exp_month'), "items_sales-data-order-interface_payment_cc_exp_year" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_exp_year'), "items_sales-data-order-interface_payment_cc_last4" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_last4'), "items_sales-data-order-interface_payment_cc_number_enc" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_number_enc'), "items_sales-data-order-interface_payment_cc_owner" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_owner'), "items_sales-data-order-interface_payment_cc_secure_verify" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_secure_verify'), "items_sales-data-order-interface_payment_cc_ss_issue" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_ss_issue'), "items_sales-data-order-interface_payment_cc_ss_start_month" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_ss_start_month'), "items_sales-data-order-interface_payment_cc_ss_start_year" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_ss_start_year'), "items_sales-data-order-interface_payment_cc_status" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_status'), "items_sales-data-order-interface_payment_cc_status_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_status_description'), "items_sales-data-order-interface_payment_cc_trans_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_trans_id'), "items_sales-data-order-interface_payment_cc_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/cc_type'), "items_sales-data-order-interface_payment_echeck_account_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/echeck_account_name'), "items_sales-data-order-interface_payment_echeck_account_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/echeck_account_type'), "items_sales-data-order-interface_payment_echeck_bank_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/echeck_bank_name'), "items_sales-data-order-interface_payment_echeck_routing_number" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/echeck_routing_number'), "items_sales-data-order-interface_payment_echeck_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/echeck_type'), "items_sales-data-order-interface_payment_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/entity_id'), "items_sales-data-order-interface_payment_extension_attributes_vault_payment_token_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/extension_attributes/vault_payment_token/created_at'), "items_sales-data-order-interface_payment_extension_attributes_vault_payment_token_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/extension_attributes/vault_payment_token/customer_id'), "items_sales-data-order-interface_payment_extension_attributes_vault_payment_token_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/extension_attributes/vault_payment_token/entity_id'), "items_sales-data-order-interface_payment_extension_attributes_vault_payment_token_expires_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/extension_attributes/vault_payment_token/expires_at'), "items_sales-data-order-interface_payment_extension_attributes_vault_payment_token_gateway_token" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/extension_attributes/vault_payment_token/gateway_token'), "items_sales-data-order-interface_payment_extension_attributes_vault_payment_token_is_active" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/extension_attributes/vault_payment_token/is_active'), "items_sales-data-order-interface_payment_extension_attributes_vault_payment_token_is_visible" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/extension_attributes/vault_payment_token/is_visible'), "items_sales-data-order-interface_payment_extension_attributes_vault_payment_token_payment_method_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/extension_attributes/vault_payment_token/payment_method_code'), "items_sales-data-order-interface_payment_extension_attributes_vault_payment_token_public_hash" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/extension_attributes/vault_payment_token/public_hash'), "items_sales-data-order-interface_payment_extension_attributes_vault_payment_token_token_details" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/extension_attributes/vault_payment_token/token_details'), "items_sales-data-order-interface_payment_extension_attributes_vault_payment_token_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/extension_attributes/vault_payment_token/type'), "items_sales-data-order-interface_payment_last_trans_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/last_trans_id'), "items_sales-data-order-interface_payment_method" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/method'), "items_sales-data-order-interface_payment_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/parent_id'), "items_sales-data-order-interface_payment_po_number" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/po_number'), "items_sales-data-order-interface_payment_protection_eligibility" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/protection_eligibility'), "items_sales-data-order-interface_payment_quote_payment_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/quote_payment_id'), "items_sales-data-order-interface_payment_shipping_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/shipping_amount'), "items_sales-data-order-interface_payment_shipping_captured" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/shipping_captured'), "items_sales-data-order-interface_payment_shipping_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment/shipping_refunded'), "items_sales-data-order-interface_payment_auth_expiration" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment_auth_expiration'), "items_sales-data-order-interface_payment_authorization_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/payment_authorization_amount'), "items_sales-data-order-interface_protect_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/protect_code'), "items_sales-data-order-interface_quote_address_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/quote_address_id'), "items_sales-data-order-interface_quote_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/quote_id'), "items_sales-data-order-interface_relation_child_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/relation_child_id'), "items_sales-data-order-interface_relation_child_real_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/relation_child_real_id'), "items_sales-data-order-interface_relation_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/relation_parent_id'), "items_sales-data-order-interface_relation_parent_real_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/relation_parent_real_id'), "items_sales-data-order-interface_remote_ip" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/remote_ip'), "items_sales-data-order-interface_shipping_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/shipping_amount'), "items_sales-data-order-interface_shipping_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/shipping_canceled'), "items_sales-data-order-interface_shipping_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/shipping_description'), "items_sales-data-order-interface_shipping_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/shipping_discount_amount'), "items_sales-data-order-interface_shipping_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/shipping_discount_tax_compensation_amount'), "items_sales-data-order-interface_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/shipping_incl_tax'), "items_sales-data-order-interface_shipping_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/shipping_invoiced'), "items_sales-data-order-interface_shipping_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/shipping_refunded'), "items_sales-data-order-interface_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/shipping_tax_amount'), "items_sales-data-order-interface_shipping_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/shipping_tax_refunded'), "items_sales-data-order-interface_state" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/state'), "items_sales-data-order-interface_status" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/status'), "items_sales-data-order-interface_status_histories_sales-data-order-status-history-interface_comment" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/status_histories[]/sales-data-order-status-history-interface/comment'), "items_sales-data-order-interface_status_histories_sales-data-order-status-history-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/status_histories[]/sales-data-order-status-history-interface/created_at'), "items_sales-data-order-interface_status_histories_sales-data-order-status-history-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/status_histories[]/sales-data-order-status-history-interface/entity_id'), "items_sales-data-order-interface_status_histories_sales-data-order-status-history-interface_entity_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/status_histories[]/sales-data-order-status-history-interface/entity_name'), "items_sales-data-order-interface_status_histories_sales-data-order-status-history-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/status_histories[]/sales-data-order-status-history-interface/is_customer_notified'), "items_sales-data-order-interface_status_histories_sales-data-order-status-history-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/status_histories[]/sales-data-order-status-history-interface/is_visible_on_front'), "items_sales-data-order-interface_status_histories_sales-data-order-status-history-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/status_histories[]/sales-data-order-status-history-interface/parent_id'), "items_sales-data-order-interface_status_histories_sales-data-order-status-history-interface_status" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/status_histories[]/sales-data-order-status-history-interface/status'), "items_sales-data-order-interface_store_currency_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/store_currency_code'), "items_sales-data-order-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/store_id'), "items_sales-data-order-interface_store_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/store_name'), "items_sales-data-order-interface_store_to_base_rate" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/store_to_base_rate'), "items_sales-data-order-interface_store_to_order_rate" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/store_to_order_rate'), "items_sales-data-order-interface_subtotal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/subtotal'), "items_sales-data-order-interface_subtotal_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/subtotal_canceled'), "items_sales-data-order-interface_subtotal_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/subtotal_incl_tax'), "items_sales-data-order-interface_subtotal_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/subtotal_invoiced'), "items_sales-data-order-interface_subtotal_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/subtotal_refunded'), "items_sales-data-order-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/tax_amount'), "items_sales-data-order-interface_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/tax_canceled'), "items_sales-data-order-interface_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/tax_invoiced'), "items_sales-data-order-interface_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/tax_refunded'), "items_sales-data-order-interface_total_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/total_canceled'), "items_sales-data-order-interface_total_due" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/total_due'), "items_sales-data-order-interface_total_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/total_invoiced'), "items_sales-data-order-interface_total_item_count" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/total_item_count'), "items_sales-data-order-interface_total_offline_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/total_offline_refunded'), "items_sales-data-order-interface_total_online_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/total_online_refunded'), "items_sales-data-order-interface_total_paid" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/total_paid'), "items_sales-data-order-interface_total_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/total_qty_ordered'), "items_sales-data-order-interface_total_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/total_refunded'), "items_sales-data-order-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/updated_at'), "items_sales-data-order-interface_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/weight'), "items_sales-data-order-interface_x_forwarded_for" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-interface/x_forwarded_for'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Lists orders that match specified search criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#OrderRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders');

CREATE FOREIGN PROCEDURE salesOrderRepositoryV1SavePost(IN entity_adjustment_negative string NOT NULL OPTIONS (ANNOTATION 'Negative adjustment value.', NAMEINSOURCE 'entity/adjustment_negative', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_adjustment_positive string NOT NULL OPTIONS (ANNOTATION 'Positive adjustment value.', NAMEINSOURCE 'entity/adjustment_positive', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_applied_rule_ids string NOT NULL OPTIONS (ANNOTATION 'Applied rule IDs.', NAMEINSOURCE 'entity/applied_rule_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_adjustment_negative string NOT NULL OPTIONS (ANNOTATION 'Base negative adjustment value.', NAMEINSOURCE 'entity/base_adjustment_negative', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_adjustment_positive string NOT NULL OPTIONS (ANNOTATION 'Base positive adjustment value.', NAMEINSOURCE 'entity/base_adjustment_positive', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_currency_code string NOT NULL OPTIONS (ANNOTATION 'Base currency code.', NAMEINSOURCE 'entity/base_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Base discount amount.', NAMEINSOURCE 'entity/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_canceled string NOT NULL OPTIONS (ANNOTATION 'Base discount canceled.', NAMEINSOURCE 'entity/base_discount_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_invoiced string NOT NULL OPTIONS (ANNOTATION 'Base discount invoiced.', NAMEINSOURCE 'entity/base_discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_refunded string NOT NULL OPTIONS (ANNOTATION 'Base discount refunded.', NAMEINSOURCE 'entity/base_discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation amount.', NAMEINSOURCE 'entity/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_tax_compensation_invoiced string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation invoiced.', NAMEINSOURCE 'entity/base_discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_tax_compensation_refunded string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation refunded.', NAMEINSOURCE 'entity/base_discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_grand_total string NOT NULL OPTIONS (ANNOTATION 'Base grand total.', NAMEINSOURCE 'entity/base_grand_total', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_base_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Base shipping amount.', NAMEINSOURCE 'entity/base_shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_canceled string NOT NULL OPTIONS (ANNOTATION 'Base shipping canceled.', NAMEINSOURCE 'entity/base_shipping_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Base shipping discount amount.', NAMEINSOURCE 'entity/base_shipping_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_discount_tax_compensation_amnt string NOT NULL OPTIONS (ANNOTATION 'Base shipping discount tax compensation amount.', NAMEINSOURCE 'entity/base_shipping_discount_tax_compensation_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Base shipping including tax.', NAMEINSOURCE 'entity/base_shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_invoiced string NOT NULL OPTIONS (ANNOTATION 'Base shipping invoiced.', NAMEINSOURCE 'entity/base_shipping_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_refunded string NOT NULL OPTIONS (ANNOTATION 'Base shipping refunded.', NAMEINSOURCE 'entity/base_shipping_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Base shipping tax amount.', NAMEINSOURCE 'entity/base_shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_tax_refunded string NOT NULL OPTIONS (ANNOTATION 'Base shipping tax refunded.', NAMEINSOURCE 'entity/base_shipping_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal string NOT NULL OPTIONS (ANNOTATION 'Base subtotal.', NAMEINSOURCE 'entity/base_subtotal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal_canceled string NOT NULL OPTIONS (ANNOTATION 'Base subtotal canceled.', NAMEINSOURCE 'entity/base_subtotal_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Base subtotal including tax.', NAMEINSOURCE 'entity/base_subtotal_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal_invoiced string NOT NULL OPTIONS (ANNOTATION 'Base subtotal invoiced.', NAMEINSOURCE 'entity/base_subtotal_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal_refunded string NOT NULL OPTIONS (ANNOTATION 'Base subtotal refunded.', NAMEINSOURCE 'entity/base_subtotal_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_tax_canceled string NOT NULL OPTIONS (ANNOTATION 'Base tax canceled.', NAMEINSOURCE 'entity/base_tax_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_tax_invoiced string NOT NULL OPTIONS (ANNOTATION 'Base tax invoiced.', NAMEINSOURCE 'entity/base_tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_tax_refunded string NOT NULL OPTIONS (ANNOTATION 'Base tax refunded.', NAMEINSOURCE 'entity/base_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_to_global_rate string NOT NULL OPTIONS (ANNOTATION 'Base-to-global rate.', NAMEINSOURCE 'entity/base_to_global_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_to_order_rate string NOT NULL OPTIONS (ANNOTATION 'Base-to-order rate.', NAMEINSOURCE 'entity/base_to_order_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_canceled string NOT NULL OPTIONS (ANNOTATION 'Base total canceled.', NAMEINSOURCE 'entity/base_total_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_due string NOT NULL OPTIONS (ANNOTATION 'Base total due.', NAMEINSOURCE 'entity/base_total_due', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_invoiced string NOT NULL OPTIONS (ANNOTATION 'Base total invoiced.', NAMEINSOURCE 'entity/base_total_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_invoiced_cost string NOT NULL OPTIONS (ANNOTATION 'Base total invoiced cost.', NAMEINSOURCE 'entity/base_total_invoiced_cost', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_offline_refunded string NOT NULL OPTIONS (ANNOTATION 'Base total offline refunded.', NAMEINSOURCE 'entity/base_total_offline_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_online_refunded string NOT NULL OPTIONS (ANNOTATION 'Base total online refunded.', NAMEINSOURCE 'entity/base_total_online_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_paid string NOT NULL OPTIONS (ANNOTATION 'Base total paid.', NAMEINSOURCE 'entity/base_total_paid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_qty_ordered string NOT NULL OPTIONS (ANNOTATION 'Base total quantity ordered.', NAMEINSOURCE 'entity/base_total_qty_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_refunded string NOT NULL OPTIONS (ANNOTATION 'Base total refunded.', NAMEINSOURCE 'entity/base_total_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_address_type string NOT NULL OPTIONS (ANNOTATION 'Address type.', NAMEINSOURCE 'entity/billing_address/address_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_city string NOT NULL OPTIONS (ANNOTATION 'City.', NAMEINSOURCE 'entity/billing_address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_company string NOT NULL OPTIONS (ANNOTATION 'Company.', NAMEINSOURCE 'entity/billing_address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country ID.', NAMEINSOURCE 'entity/billing_address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Country address ID.', NAMEINSOURCE 'entity/billing_address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID.', NAMEINSOURCE 'entity/billing_address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_email string NOT NULL OPTIONS (ANNOTATION 'Email address.', NAMEINSOURCE 'entity/billing_address/email', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_entity_id string NOT NULL OPTIONS (ANNOTATION 'Order address ID.', NAMEINSOURCE 'entity/billing_address/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number.', NAMEINSOURCE 'entity/billing_address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name.', NAMEINSOURCE 'entity/billing_address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name.', NAMEINSOURCE 'entity/billing_address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name.', NAMEINSOURCE 'entity/billing_address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_parent_id string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/billing_address/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postal code.', NAMEINSOURCE 'entity/billing_address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix.', NAMEINSOURCE 'entity/billing_address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_region string NOT NULL OPTIONS (ANNOTATION 'Region.', NAMEINSOURCE 'entity/billing_address/region', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code.', NAMEINSOURCE 'entity/billing_address/region_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region ID.', NAMEINSOURCE 'entity/billing_address/region_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/billing_address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix.', NAMEINSOURCE 'entity/billing_address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number.', NAMEINSOURCE 'entity/billing_address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_vat_id string NOT NULL OPTIONS (ANNOTATION 'VAT ID.', NAMEINSOURCE 'entity/billing_address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_vat_is_valid string NOT NULL OPTIONS (ANNOTATION 'VAT-is-valid flag value.', NAMEINSOURCE 'entity/billing_address/vat_is_valid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_vat_request_date string NOT NULL OPTIONS (ANNOTATION 'VAT request date.', NAMEINSOURCE 'entity/billing_address/vat_request_date', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_vat_request_id string NOT NULL OPTIONS (ANNOTATION 'VAT request ID.', NAMEINSOURCE 'entity/billing_address/vat_request_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_vat_request_success string NOT NULL OPTIONS (ANNOTATION 'VAT-request-success flag value.', NAMEINSOURCE 'entity/billing_address/vat_request_success', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_id string NOT NULL OPTIONS (ANNOTATION 'Billing address ID.', NAMEINSOURCE 'entity/billing_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_can_ship_partially string NOT NULL OPTIONS (ANNOTATION 'Can-ship-partially flag value.', NAMEINSOURCE 'entity/can_ship_partially', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_can_ship_partially_item string NOT NULL OPTIONS (ANNOTATION 'Can-ship-partially-item flag value.', NAMEINSOURCE 'entity/can_ship_partially_item', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_coupon_code string NOT NULL OPTIONS (ANNOTATION 'Coupon code.', NAMEINSOURCE 'entity/coupon_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_created_at string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_dob string NOT NULL OPTIONS (ANNOTATION 'Customer date-of-birth (DOB).', NAMEINSOURCE 'entity/customer_dob', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_email string NOT NULL OPTIONS (ANNOTATION 'Customer email address.', NAMEINSOURCE 'entity/customer_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_customer_firstname string NOT NULL OPTIONS (ANNOTATION 'Customer first name.', NAMEINSOURCE 'entity/customer_firstname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_gender string NOT NULL OPTIONS (ANNOTATION 'Customer gender.', NAMEINSOURCE 'entity/customer_gender', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_group_id string NOT NULL OPTIONS (ANNOTATION 'Customer group ID.', NAMEINSOURCE 'entity/customer_group_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID.', NAMEINSOURCE 'entity/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_is_guest string NOT NULL OPTIONS (ANNOTATION 'Customer-is-guest flag value.', NAMEINSOURCE 'entity/customer_is_guest', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_lastname string NOT NULL OPTIONS (ANNOTATION 'Customer last name.', NAMEINSOURCE 'entity/customer_lastname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_middlename string NOT NULL OPTIONS (ANNOTATION 'Customer middle name.', NAMEINSOURCE 'entity/customer_middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_note string NOT NULL OPTIONS (ANNOTATION 'Customer note.', NAMEINSOURCE 'entity/customer_note', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_note_notify string NOT NULL OPTIONS (ANNOTATION 'Customer-note-notify flag value.', NAMEINSOURCE 'entity/customer_note_notify', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_prefix string NOT NULL OPTIONS (ANNOTATION 'Customer prefix.', NAMEINSOURCE 'entity/customer_prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_suffix string NOT NULL OPTIONS (ANNOTATION 'Customer suffix.', NAMEINSOURCE 'entity/customer_suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_taxvat string NOT NULL OPTIONS (ANNOTATION 'Customer value-added tax (VAT).', NAMEINSOURCE 'entity/customer_taxvat', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_canceled string NOT NULL OPTIONS (ANNOTATION 'Discount canceled.', NAMEINSOURCE 'entity/discount_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_description string NOT NULL OPTIONS (ANNOTATION 'Discount description.', NAMEINSOURCE 'entity/discount_description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_invoiced string NOT NULL OPTIONS (ANNOTATION 'Discount invoiced.', NAMEINSOURCE 'entity/discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_refunded string NOT NULL OPTIONS (ANNOTATION 'Discount refunded amount.', NAMEINSOURCE 'entity/discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_tax_compensation_invoiced string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation invoiced amount.', NAMEINSOURCE 'entity/discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_tax_compensation_refunded string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation refunded amount.', NAMEINSOURCE 'entity/discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_edit_increment string NOT NULL OPTIONS (ANNOTATION 'Edit increment value.', NAMEINSOURCE 'entity/edit_increment', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_email_sent string NOT NULL OPTIONS (ANNOTATION 'Email-sent flag value.', NAMEINSOURCE 'entity/email_sent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_entity_id string NOT NULL OPTIONS (ANNOTATION 'Order ID.', NAMEINSOURCE 'entity/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_ext_customer_id string NOT NULL OPTIONS (ANNOTATION 'External customer ID.', NAMEINSOURCE 'entity/ext_customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_ext_order_id string NOT NULL OPTIONS (ANNOTATION 'External order ID.', NAMEINSOURCE 'entity/ext_order_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_base_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount in base currency', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/base_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_code" string NOT NULL OPTIONS (ANNOTATION 'Code', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_code" string NOT NULL OPTIONS (ANNOTATION 'Code', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax Percent', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax Percent', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_base_customer_balance_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/base_customer_balance_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_converting_from_quote boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/converting_from_quote', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_customer_balance_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/customer_balance_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'entity/extension_attributes/gift_message/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_extension_attributes_entity_id string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gift_message/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_extension_attributes_entity_type string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gift_message/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_extension_attributes_wrapping_id string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gift_message/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_gift_message_id string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'entity/extension_attributes/gift_message/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_message string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'entity/extension_attributes/gift_message/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_extension_attributes_gift_message_recipient string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'entity/extension_attributes/gift_message/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_extension_attributes_gift_message_sender string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'entity/extension_attributes/gift_message/sender', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_extension_attributes_gw_add_card string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_add_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_allow_gift_receipt string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_base_price string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_base_price_incl_tax string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_base_tax_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_card_base_price string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_card_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_card_base_price_incl_tax string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_card_base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_card_base_tax_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_card_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_card_price string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_card_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_card_price_incl_tax string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_card_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_card_tax_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_card_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_id string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_items_base_price string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_items_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_items_base_price_incl_tax string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_items_base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_items_base_tax_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_items_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_items_price string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_items_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_items_price_incl_tax string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_items_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_items_tax_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_items_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_price string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_price_incl_tax string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_tax_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_base_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount in base currency', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/base_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_code" string NOT NULL OPTIONS (ANNOTATION 'Code', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_code" string NOT NULL OPTIONS (ANNOTATION 'Code', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax Percent', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax Percent', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_associated_item_id" string NOT NULL OPTIONS (ANNOTATION 'Associated item id if this item is associated with another item, null otherwise', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/associated_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_item_id" string NOT NULL OPTIONS (ANNOTATION 'Item id if this item is a product', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_type" string NOT NULL OPTIONS (ANNOTATION 'Type (shipping, product, weee, gift wrapping, etc)', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_additional_data" string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_applied_rule_ids" string NOT NULL OPTIONS (ANNOTATION 'Applied rule IDs.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/applied_rule_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_cost" string NOT NULL OPTIONS (ANNOTATION 'Base cost.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_cost', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_original_price" string NOT NULL OPTIONS (ANNOTATION 'Base original price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_price" string NOT NULL OPTIONS (ANNOTATION 'Base price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base price including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base row invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_total" string NOT NULL OPTIONS (ANNOTATION 'Base row total.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base row total including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Base tax before discount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base tax invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base tax refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied row amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax row disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_percent" string NOT NULL OPTIONS (ANNOTATION 'Discount percent.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_canceled" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_event_id" string NOT NULL OPTIONS (ANNOTATION 'Event ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/event_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_ext_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'External order item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/ext_order_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_message" string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_free_shipping" string NOT NULL OPTIONS (ANNOTATION 'Free-shipping flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/free_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price" string NOT NULL OPTIONS (ANNOTATION 'GW base price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base price invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base price refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_id" string NOT NULL OPTIONS (ANNOTATION 'GW ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price" string NOT NULL OPTIONS (ANNOTATION 'GW price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW price invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW price refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_is_qty_decimal" string NOT NULL OPTIONS (ANNOTATION 'Is-quantity-decimal flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/is_qty_decimal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_is_virtual" string NOT NULL OPTIONS (ANNOTATION 'Is-virtual flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/is_virtual', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_item_id" string NOT NULL OPTIONS (ANNOTATION 'Item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_locked_do_invoice" string NOT NULL OPTIONS (ANNOTATION 'Locked DO invoice flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/locked_do_invoice', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_locked_do_ship" string NOT NULL OPTIONS (ANNOTATION 'Locked DO ship flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/locked_do_ship', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_name" string NOT NULL OPTIONS (ANNOTATION 'Name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_no_discount" string NOT NULL OPTIONS (ANNOTATION 'No-discount flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/no_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_order_id" string NOT NULL OPTIONS (ANNOTATION 'Order ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/order_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_original_price" string NOT NULL OPTIONS (ANNOTATION 'Original price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_additional_data" string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_applied_rule_ids" string NOT NULL OPTIONS (ANNOTATION 'Applied rule IDs.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/applied_rule_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_cost" string NOT NULL OPTIONS (ANNOTATION 'Base cost.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_cost', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_original_price" string NOT NULL OPTIONS (ANNOTATION 'Base original price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_price" string NOT NULL OPTIONS (ANNOTATION 'Base price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base price including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base row invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_total" string NOT NULL OPTIONS (ANNOTATION 'Base row total.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base row total including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Base tax before discount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base tax invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base tax refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied row amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax row disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_percent" string NOT NULL OPTIONS (ANNOTATION 'Discount percent.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_event_id" string NOT NULL OPTIONS (ANNOTATION 'Event ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/event_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_ext_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'External order item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/ext_order_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_free_shipping" string NOT NULL OPTIONS (ANNOTATION 'Free-shipping flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/free_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price" string NOT NULL OPTIONS (ANNOTATION 'GW base price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base price invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base price refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_id" string NOT NULL OPTIONS (ANNOTATION 'GW ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price" string NOT NULL OPTIONS (ANNOTATION 'GW price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW price invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW price refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_is_qty_decimal" string NOT NULL OPTIONS (ANNOTATION 'Is-quantity-decimal flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/is_qty_decimal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_is_virtual" string NOT NULL OPTIONS (ANNOTATION 'Is-virtual flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/is_virtual', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_item_id" string NOT NULL OPTIONS (ANNOTATION 'Item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_locked_do_invoice" string NOT NULL OPTIONS (ANNOTATION 'Locked DO invoice flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_invoice', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_locked_do_ship" string NOT NULL OPTIONS (ANNOTATION 'Locked DO ship flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_ship', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_name" string NOT NULL OPTIONS (ANNOTATION 'Name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_no_discount" string NOT NULL OPTIONS (ANNOTATION 'No-discount flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/no_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_order_id" string NOT NULL OPTIONS (ANNOTATION 'Order ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/order_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_original_price" string NOT NULL OPTIONS (ANNOTATION 'Original price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_parent_item_id" string NOT NULL OPTIONS (ANNOTATION 'Parent item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/parent_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_price" string NOT NULL OPTIONS (ANNOTATION 'Price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Price including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_id" string NOT NULL OPTIONS (ANNOTATION 'Product ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_type" string NOT NULL OPTIONS (ANNOTATION 'Product type.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_backordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity backordered.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_backordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_canceled" string NOT NULL OPTIONS (ANNOTATION 'Quantity canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Quantity invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_ordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity ordered.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_refunded" string NOT NULL OPTIONS (ANNOTATION 'Quantity refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_returned" string NOT NULL OPTIONS (ANNOTATION 'Quantity returned.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_returned', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_shipped" string NOT NULL OPTIONS (ANNOTATION 'Quantity shipped.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_shipped', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_quote_item_id" string NOT NULL OPTIONS (ANNOTATION 'Quote item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/quote_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Row invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_total" string NOT NULL OPTIONS (ANNOTATION 'Row total.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Row total including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_weight" string NOT NULL OPTIONS (ANNOTATION 'Row weight.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Tax before discount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_canceled" string NOT NULL OPTIONS (ANNOTATION 'Tax canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Tax invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax percent.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Tax refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_updated_at" string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied row amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax row disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weight" string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_id" string NOT NULL OPTIONS (ANNOTATION 'Parent item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Price including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_id" string NOT NULL OPTIONS (ANNOTATION 'Product ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_type" string NOT NULL OPTIONS (ANNOTATION 'Product type.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_backordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity backordered.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_backordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_canceled" string NOT NULL OPTIONS (ANNOTATION 'Quantity canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Quantity invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_ordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity ordered.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_refunded" string NOT NULL OPTIONS (ANNOTATION 'Quantity refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_returned" string NOT NULL OPTIONS (ANNOTATION 'Quantity returned.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_returned', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_shipped" string NOT NULL OPTIONS (ANNOTATION 'Quantity shipped.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_shipped', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_quote_item_id" string NOT NULL OPTIONS (ANNOTATION 'Quote item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/quote_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Row invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_total" string NOT NULL OPTIONS (ANNOTATION 'Row total.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Row total including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_weight" string NOT NULL OPTIONS (ANNOTATION 'Row weight.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Tax before discount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_canceled" string NOT NULL OPTIONS (ANNOTATION 'Tax canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Tax invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax percent.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Tax refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_updated_at" string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied_row_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied row amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied_row_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax row disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weight" string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_address_type" string NOT NULL OPTIONS (ANNOTATION 'Address type.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/address_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_city" string NOT NULL OPTIONS (ANNOTATION 'City.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_company" string NOT NULL OPTIONS (ANNOTATION 'Company.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_country_id" string NOT NULL OPTIONS (ANNOTATION 'Country ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_customer_address_id" string NOT NULL OPTIONS (ANNOTATION 'Country address ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_email" string NOT NULL OPTIONS (ANNOTATION 'Email address.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/email', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Order address ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_fax" string NOT NULL OPTIONS (ANNOTATION 'Fax number.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_firstname" string NOT NULL OPTIONS (ANNOTATION 'First name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_lastname" string NOT NULL OPTIONS (ANNOTATION 'Last name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_middlename" string NOT NULL OPTIONS (ANNOTATION 'Middle name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_postcode" string NOT NULL OPTIONS (ANNOTATION 'Postal code.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_prefix" string NOT NULL OPTIONS (ANNOTATION 'Prefix.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region" string NOT NULL OPTIONS (ANNOTATION 'Region.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region_code" string NOT NULL OPTIONS (ANNOTATION 'Region code.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_street" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_suffix" string NOT NULL OPTIONS (ANNOTATION 'Suffix.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_telephone" string NOT NULL OPTIONS (ANNOTATION 'Telephone number.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_id" string NOT NULL OPTIONS (ANNOTATION 'VAT ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_is_valid" string NOT NULL OPTIONS (ANNOTATION 'VAT-is-valid flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_is_valid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_date" string NOT NULL OPTIONS (ANNOTATION 'VAT request date.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_date', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_id" string NOT NULL OPTIONS (ANNOTATION 'VAT request ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_success" string NOT NULL OPTIONS (ANNOTATION 'VAT-request-success flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_success', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_method" string NOT NULL OPTIONS (ANNOTATION 'Shipping method', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/method', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_amount" string NOT NULL OPTIONS (ANNOTATION 'Base shipping amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_canceled" string NOT NULL OPTIONS (ANNOTATION 'Base shipping canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Base shipping discount amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_discount_tax_compensation_amnt" string NOT NULL OPTIONS (ANNOTATION 'Base shipping discount tax compensation amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_discount_tax_compensation_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base shipping including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base shipping invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base shipping refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base shipping tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base shipping tax refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_amount" string NOT NULL OPTIONS (ANNOTATION 'Shipping amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_canceled" string NOT NULL OPTIONS (ANNOTATION 'Shipping canceled amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Shipping discount amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Shipping discount tax compensation amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Shipping including tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Shipping invoiced amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_refunded" string NOT NULL OPTIONS (ANNOTATION 'Shipping refunded amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Shipping tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Shipping tax refunded amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_stock_id" string NOT NULL OPTIONS (ANNOTATION 'Stock id', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/stock_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_forced_shipment_with_invoice string NOT NULL OPTIONS (ANNOTATION 'Forced-shipment-with-invoice flag value.', NAMEINSOURCE 'entity/forced_shipment_with_invoice', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_global_currency_code string NOT NULL OPTIONS (ANNOTATION 'Global currency code.', NAMEINSOURCE 'entity/global_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_grand_total string NOT NULL OPTIONS (ANNOTATION 'Grand total.', NAMEINSOURCE 'entity/grand_total', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_hold_before_state string NOT NULL OPTIONS (ANNOTATION 'Hold before state.', NAMEINSOURCE 'entity/hold_before_state', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_hold_before_status string NOT NULL OPTIONS (ANNOTATION 'Hold before status.', NAMEINSOURCE 'entity/hold_before_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_increment_id string NOT NULL OPTIONS (ANNOTATION 'Increment ID.', NAMEINSOURCE 'entity/increment_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_is_virtual string NOT NULL OPTIONS (ANNOTATION 'Is-virtual flag value.', NAMEINSOURCE 'entity/is_virtual', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_additional_data" string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_applied_rule_ids" string NOT NULL OPTIONS (ANNOTATION 'Applied rule IDs.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/applied_rule_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_cost" string NOT NULL OPTIONS (ANNOTATION 'Base cost.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_cost', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_original_price" string NOT NULL OPTIONS (ANNOTATION 'Base original price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_price" string NOT NULL OPTIONS (ANNOTATION 'Base price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base price including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base row invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_row_total" string NOT NULL OPTIONS (ANNOTATION 'Base row total.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base row total including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Base tax before discount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base tax invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base tax refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied row amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax row disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_percent" string NOT NULL OPTIONS (ANNOTATION 'Discount percent.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_tax_compensation_canceled" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation canceled.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_tax_compensation_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_event_id" string NOT NULL OPTIONS (ANNOTATION 'Event ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/event_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_ext_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'External order item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/ext_order_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_message" string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_free_shipping" string NOT NULL OPTIONS (ANNOTATION 'Free-shipping flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/free_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_base_price" string NOT NULL OPTIONS (ANNOTATION 'GW base price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_base_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base price invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_base_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_base_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base price refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_base_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_id" string NOT NULL OPTIONS (ANNOTATION 'GW ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_price" string NOT NULL OPTIONS (ANNOTATION 'GW price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW price invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW price refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_is_qty_decimal" string NOT NULL OPTIONS (ANNOTATION 'Is-quantity-decimal flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/is_qty_decimal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_is_virtual" string NOT NULL OPTIONS (ANNOTATION 'Is-virtual flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/is_virtual', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_item_id" string NOT NULL OPTIONS (ANNOTATION 'Item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_locked_do_invoice" string NOT NULL OPTIONS (ANNOTATION 'Locked DO invoice flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/locked_do_invoice', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_locked_do_ship" string NOT NULL OPTIONS (ANNOTATION 'Locked DO ship flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/locked_do_ship', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_name" string NOT NULL OPTIONS (ANNOTATION 'Name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_no_discount" string NOT NULL OPTIONS (ANNOTATION 'No-discount flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/no_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_order_id" string NOT NULL OPTIONS (ANNOTATION 'Order ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/order_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_original_price" string NOT NULL OPTIONS (ANNOTATION 'Original price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_additional_data" string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_applied_rule_ids" string NOT NULL OPTIONS (ANNOTATION 'Applied rule IDs.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/applied_rule_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_cost" string NOT NULL OPTIONS (ANNOTATION 'Base cost.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_cost', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_original_price" string NOT NULL OPTIONS (ANNOTATION 'Base original price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_price" string NOT NULL OPTIONS (ANNOTATION 'Base price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base price including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base row invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_row_total" string NOT NULL OPTIONS (ANNOTATION 'Base row total.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base row total including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Base tax before discount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base tax invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base tax refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied row amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax row disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_percent" string NOT NULL OPTIONS (ANNOTATION 'Discount percent.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation canceled.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_event_id" string NOT NULL OPTIONS (ANNOTATION 'Event ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/event_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_ext_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'External order item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/ext_order_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_free_shipping" string NOT NULL OPTIONS (ANNOTATION 'Free-shipping flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/free_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_base_price" string NOT NULL OPTIONS (ANNOTATION 'GW base price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base price invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base price refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_id" string NOT NULL OPTIONS (ANNOTATION 'GW ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_price" string NOT NULL OPTIONS (ANNOTATION 'GW price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW price invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW price refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_is_qty_decimal" string NOT NULL OPTIONS (ANNOTATION 'Is-quantity-decimal flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/is_qty_decimal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_is_virtual" string NOT NULL OPTIONS (ANNOTATION 'Is-virtual flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/is_virtual', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_item_id" string NOT NULL OPTIONS (ANNOTATION 'Item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_locked_do_invoice" string NOT NULL OPTIONS (ANNOTATION 'Locked DO invoice flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/locked_do_invoice', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_locked_do_ship" string NOT NULL OPTIONS (ANNOTATION 'Locked DO ship flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/locked_do_ship', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_name" string NOT NULL OPTIONS (ANNOTATION 'Name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_no_discount" string NOT NULL OPTIONS (ANNOTATION 'No-discount flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/no_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_order_id" string NOT NULL OPTIONS (ANNOTATION 'Order ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/order_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_original_price" string NOT NULL OPTIONS (ANNOTATION 'Original price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_parent_item_id" string NOT NULL OPTIONS (ANNOTATION 'Parent item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/parent_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_price" string NOT NULL OPTIONS (ANNOTATION 'Price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Price including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_id" string NOT NULL OPTIONS (ANNOTATION 'Product ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_type" string NOT NULL OPTIONS (ANNOTATION 'Product type.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_backordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity backordered.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_backordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_canceled" string NOT NULL OPTIONS (ANNOTATION 'Quantity canceled.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Quantity invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_ordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity ordered.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_refunded" string NOT NULL OPTIONS (ANNOTATION 'Quantity refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_returned" string NOT NULL OPTIONS (ANNOTATION 'Quantity returned.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_returned', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_shipped" string NOT NULL OPTIONS (ANNOTATION 'Quantity shipped.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_shipped', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_quote_item_id" string NOT NULL OPTIONS (ANNOTATION 'Quote item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/quote_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Row invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_row_total" string NOT NULL OPTIONS (ANNOTATION 'Row total.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Row total including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_row_weight" string NOT NULL OPTIONS (ANNOTATION 'Row weight.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/row_weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Tax before discount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_tax_canceled" string NOT NULL OPTIONS (ANNOTATION 'Tax canceled.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/tax_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Tax invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_tax_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax percent.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/tax_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Tax refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_updated_at" string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_weee_tax_applied" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied row amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax row disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_weight" string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_id" string NOT NULL OPTIONS (ANNOTATION 'Parent item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Price including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_id" string NOT NULL OPTIONS (ANNOTATION 'Product ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_type" string NOT NULL OPTIONS (ANNOTATION 'Product type.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_backordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity backordered.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_backordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_canceled" string NOT NULL OPTIONS (ANNOTATION 'Quantity canceled.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Quantity invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_ordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity ordered.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_refunded" string NOT NULL OPTIONS (ANNOTATION 'Quantity refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_returned" string NOT NULL OPTIONS (ANNOTATION 'Quantity returned.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_returned', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_shipped" string NOT NULL OPTIONS (ANNOTATION 'Quantity shipped.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_shipped', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_quote_item_id" string NOT NULL OPTIONS (ANNOTATION 'Quote item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/quote_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Row invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_row_total" string NOT NULL OPTIONS (ANNOTATION 'Row total.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Row total including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_row_weight" string NOT NULL OPTIONS (ANNOTATION 'Row weight.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/row_weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Tax before discount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_tax_canceled" string NOT NULL OPTIONS (ANNOTATION 'Tax canceled.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/tax_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Tax invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_tax_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax percent.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/tax_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Tax refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_updated_at" string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_weee_tax_applied" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/weee_tax_applied', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_weee_tax_applied_row_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied row amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/weee_tax_applied_row_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax row disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_weight" string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_order_currency_code string NOT NULL OPTIONS (ANNOTATION 'Order currency code.', NAMEINSOURCE 'entity/order_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_original_increment_id string NOT NULL OPTIONS (ANNOTATION 'Original increment ID.', NAMEINSOURCE 'entity/original_increment_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_account_status string NOT NULL OPTIONS (ANNOTATION 'Account status.', NAMEINSOURCE 'entity/payment/account_status', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_additional_data string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/payment/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_additional_information string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/payment/additional_information', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_address_status string NOT NULL OPTIONS (ANNOTATION 'Address status.', NAMEINSOURCE 'entity/payment/address_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_amount_authorized string NOT NULL OPTIONS (ANNOTATION 'Amount authorized.', NAMEINSOURCE 'entity/payment/amount_authorized', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_amount_canceled string NOT NULL OPTIONS (ANNOTATION 'Amount canceled.', NAMEINSOURCE 'entity/payment/amount_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_amount_ordered string NOT NULL OPTIONS (ANNOTATION 'Amount ordered.', NAMEINSOURCE 'entity/payment/amount_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_amount_paid string NOT NULL OPTIONS (ANNOTATION 'Amount paid.', NAMEINSOURCE 'entity/payment/amount_paid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_amount_refunded string NOT NULL OPTIONS (ANNOTATION 'Amount refunded.', NAMEINSOURCE 'entity/payment/amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_anet_trans_method string NOT NULL OPTIONS (ANNOTATION 'Anet transaction method.', NAMEINSOURCE 'entity/payment/anet_trans_method', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_authorized string NOT NULL OPTIONS (ANNOTATION 'Base amount authorized.', NAMEINSOURCE 'entity/payment/base_amount_authorized', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_canceled string NOT NULL OPTIONS (ANNOTATION 'Base amount canceled.', NAMEINSOURCE 'entity/payment/base_amount_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_ordered string NOT NULL OPTIONS (ANNOTATION 'Base amount ordered.', NAMEINSOURCE 'entity/payment/base_amount_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_paid string NOT NULL OPTIONS (ANNOTATION 'Base amount paid.', NAMEINSOURCE 'entity/payment/base_amount_paid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_paid_online string NOT NULL OPTIONS (ANNOTATION 'Base amount paid online.', NAMEINSOURCE 'entity/payment/base_amount_paid_online', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_refunded string NOT NULL OPTIONS (ANNOTATION 'Base amount refunded.', NAMEINSOURCE 'entity/payment/base_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_refunded_online string NOT NULL OPTIONS (ANNOTATION 'Base amount refunded online.', NAMEINSOURCE 'entity/payment/base_amount_refunded_online', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Base shipping amount.', NAMEINSOURCE 'entity/payment/base_shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_shipping_captured string NOT NULL OPTIONS (ANNOTATION 'Base shipping captured amount.', NAMEINSOURCE 'entity/payment/base_shipping_captured', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_shipping_refunded string NOT NULL OPTIONS (ANNOTATION 'Base shipping refunded amount.', NAMEINSOURCE 'entity/payment/base_shipping_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_approval string NOT NULL OPTIONS (ANNOTATION 'Credit card approval.', NAMEINSOURCE 'entity/payment/cc_approval', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_avs_status string NOT NULL OPTIONS (ANNOTATION 'Credit card avs status.', NAMEINSOURCE 'entity/payment/cc_avs_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_cid_status string NOT NULL OPTIONS (ANNOTATION 'Credit card CID status.', NAMEINSOURCE 'entity/payment/cc_cid_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_debug_request_body string NOT NULL OPTIONS (ANNOTATION 'Credit card debug request body.', NAMEINSOURCE 'entity/payment/cc_debug_request_body', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_debug_response_body string NOT NULL OPTIONS (ANNOTATION 'Credit card debug response body.', NAMEINSOURCE 'entity/payment/cc_debug_response_body', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_debug_response_serialized string NOT NULL OPTIONS (ANNOTATION 'Credit card debug response serialized.', NAMEINSOURCE 'entity/payment/cc_debug_response_serialized', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_exp_month string NOT NULL OPTIONS (ANNOTATION 'Credit card expiration month.', NAMEINSOURCE 'entity/payment/cc_exp_month', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_exp_year string NOT NULL OPTIONS (ANNOTATION 'Credit card expiration year.', NAMEINSOURCE 'entity/payment/cc_exp_year', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_last4 string NOT NULL OPTIONS (ANNOTATION 'Last four digits of the credit card.', NAMEINSOURCE 'entity/payment/cc_last4', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_cc_number_enc string NOT NULL OPTIONS (ANNOTATION 'Encrypted credit card number.', NAMEINSOURCE 'entity/payment/cc_number_enc', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_owner string NOT NULL OPTIONS (ANNOTATION 'Credit card number.', NAMEINSOURCE 'entity/payment/cc_owner', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_secure_verify string NOT NULL OPTIONS (ANNOTATION 'Credit card secure verify.', NAMEINSOURCE 'entity/payment/cc_secure_verify', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_ss_issue string NOT NULL OPTIONS (ANNOTATION 'Credit card SS issue.', NAMEINSOURCE 'entity/payment/cc_ss_issue', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_ss_start_month string NOT NULL OPTIONS (ANNOTATION 'Credit card SS start month.', NAMEINSOURCE 'entity/payment/cc_ss_start_month', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_ss_start_year string NOT NULL OPTIONS (ANNOTATION 'Credit card SS start year.', NAMEINSOURCE 'entity/payment/cc_ss_start_year', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_status string NOT NULL OPTIONS (ANNOTATION 'Credit card status.', NAMEINSOURCE 'entity/payment/cc_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_status_description string NOT NULL OPTIONS (ANNOTATION 'Credit card status description.', NAMEINSOURCE 'entity/payment/cc_status_description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_trans_id string NOT NULL OPTIONS (ANNOTATION 'Credit card transaction ID.', NAMEINSOURCE 'entity/payment/cc_trans_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_type string NOT NULL OPTIONS (ANNOTATION 'Credit card type.', NAMEINSOURCE 'entity/payment/cc_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_echeck_account_name string NOT NULL OPTIONS (ANNOTATION 'eCheck account name.', NAMEINSOURCE 'entity/payment/echeck_account_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_echeck_account_type string NOT NULL OPTIONS (ANNOTATION 'eCheck account type.', NAMEINSOURCE 'entity/payment/echeck_account_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_echeck_bank_name string NOT NULL OPTIONS (ANNOTATION 'eCheck bank name.', NAMEINSOURCE 'entity/payment/echeck_bank_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_echeck_routing_number string NOT NULL OPTIONS (ANNOTATION 'eCheck routing number.', NAMEINSOURCE 'entity/payment/echeck_routing_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_echeck_type string NOT NULL OPTIONS (ANNOTATION 'eCheck type.', NAMEINSOURCE 'entity/payment/echeck_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_entity_id string NOT NULL OPTIONS (ANNOTATION 'Entity ID.', NAMEINSOURCE 'entity/payment/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_extension_attributes_vault_payment_token_created_at string NOT NULL OPTIONS (ANNOTATION 'Token creation timestamp', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_extension_attributes_vault_payment_token_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID.', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_extension_attributes_vault_payment_token_entity_id string NOT NULL OPTIONS (ANNOTATION 'Entity ID.', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_extension_attributes_vault_payment_token_expires_at string NOT NULL OPTIONS (ANNOTATION 'Token expiration timestamp', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/expires_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_extension_attributes_vault_payment_token_gateway_token string NOT NULL OPTIONS (ANNOTATION 'Gateway token ID', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/gateway_token', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_extension_attributes_vault_payment_token_is_active boolean NOT NULL OPTIONS (ANNOTATION 'Is active.', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/is_active', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_extension_attributes_vault_payment_token_is_visible boolean NOT NULL OPTIONS (ANNOTATION 'Is visible.', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/is_visible', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_extension_attributes_vault_payment_token_payment_method_code string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/payment_method_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_extension_attributes_vault_payment_token_public_hash string NOT NULL OPTIONS (ANNOTATION 'Public hash', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/public_hash', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_extension_attributes_vault_payment_token_token_details string NOT NULL OPTIONS (ANNOTATION 'Token details', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/token_details', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_extension_attributes_vault_payment_token_type string NOT NULL OPTIONS (ANNOTATION 'Type', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_last_trans_id string NOT NULL OPTIONS (ANNOTATION 'Last transaction ID.', NAMEINSOURCE 'entity/payment/last_trans_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_method string NOT NULL OPTIONS (ANNOTATION 'Method.', NAMEINSOURCE 'entity/payment/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_parent_id string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/payment/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_po_number string NOT NULL OPTIONS (ANNOTATION 'PO number.', NAMEINSOURCE 'entity/payment/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_protection_eligibility string NOT NULL OPTIONS (ANNOTATION 'Protection eligibility.', NAMEINSOURCE 'entity/payment/protection_eligibility', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_quote_payment_id string NOT NULL OPTIONS (ANNOTATION 'Quote payment ID.', NAMEINSOURCE 'entity/payment/quote_payment_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping amount.', NAMEINSOURCE 'entity/payment/shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_shipping_captured string NOT NULL OPTIONS (ANNOTATION 'Shipping captured.', NAMEINSOURCE 'entity/payment/shipping_captured', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_shipping_refunded string NOT NULL OPTIONS (ANNOTATION 'Shipping refunded.', NAMEINSOURCE 'entity/payment/shipping_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_auth_expiration string NOT NULL OPTIONS (ANNOTATION 'Payment authorization expiration date.', NAMEINSOURCE 'entity/payment_auth_expiration', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_authorization_amount string NOT NULL OPTIONS (ANNOTATION 'Payment authorization amount.', NAMEINSOURCE 'entity/payment_authorization_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_protect_code string NOT NULL OPTIONS (ANNOTATION 'Protect code.', NAMEINSOURCE 'entity/protect_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_quote_address_id string NOT NULL OPTIONS (ANNOTATION 'Quote address ID.', NAMEINSOURCE 'entity/quote_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_quote_id string NOT NULL OPTIONS (ANNOTATION 'Quote ID.', NAMEINSOURCE 'entity/quote_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_relation_child_id string NOT NULL OPTIONS (ANNOTATION 'Relation child ID.', NAMEINSOURCE 'entity/relation_child_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_relation_child_real_id string NOT NULL OPTIONS (ANNOTATION 'Relation child real ID.', NAMEINSOURCE 'entity/relation_child_real_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_relation_parent_id string NOT NULL OPTIONS (ANNOTATION 'Relation parent ID.', NAMEINSOURCE 'entity/relation_parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_relation_parent_real_id string NOT NULL OPTIONS (ANNOTATION 'Relation parent real ID.', NAMEINSOURCE 'entity/relation_parent_real_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_remote_ip string NOT NULL OPTIONS (ANNOTATION 'Remote IP address.', NAMEINSOURCE 'entity/remote_ip', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping amount.', NAMEINSOURCE 'entity/shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_canceled string NOT NULL OPTIONS (ANNOTATION 'Shipping canceled amount.', NAMEINSOURCE 'entity/shipping_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_description string NOT NULL OPTIONS (ANNOTATION 'Shipping description.', NAMEINSOURCE 'entity/shipping_description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping discount amount.', NAMEINSOURCE 'entity/shipping_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping discount tax compensation amount.', NAMEINSOURCE 'entity/shipping_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Shipping including tax amount.', NAMEINSOURCE 'entity/shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_invoiced string NOT NULL OPTIONS (ANNOTATION 'Shipping invoiced amount.', NAMEINSOURCE 'entity/shipping_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_refunded string NOT NULL OPTIONS (ANNOTATION 'Shipping refunded amount.', NAMEINSOURCE 'entity/shipping_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping tax amount.', NAMEINSOURCE 'entity/shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_tax_refunded string NOT NULL OPTIONS (ANNOTATION 'Shipping tax refunded amount.', NAMEINSOURCE 'entity/shipping_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_state string NOT NULL OPTIONS (ANNOTATION 'State.', NAMEINSOURCE 'entity/state', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_status string NOT NULL OPTIONS (ANNOTATION 'Status.', NAMEINSOURCE 'entity/status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_status_histories_sales-data-order-status-history-interface_comment" string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_status_histories_sales-data-order-status-history-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_status_histories_sales-data-order-status-history-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Order status history ID.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_status_histories_sales-data-order-status-history-interface_entity_name" string NOT NULL OPTIONS (ANNOTATION 'Entity name.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/entity_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_status_histories_sales-data-order-status-history-interface_is_customer_notified" string NOT NULL OPTIONS (ANNOTATION 'Is-customer-notified flag value.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/is_customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_status_histories_sales-data-order-status-history-interface_is_visible_on_front" string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_status_histories_sales-data-order-status-history-interface_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/parent_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_status_histories_sales-data-order-status-history-interface_status" string NOT NULL OPTIONS (ANNOTATION 'Status.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_currency_code string NOT NULL OPTIONS (ANNOTATION 'Store currency code.', NAMEINSOURCE 'entity/store_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_id string NOT NULL OPTIONS (ANNOTATION 'Store ID.', NAMEINSOURCE 'entity/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_name string NOT NULL OPTIONS (ANNOTATION 'Store name.', NAMEINSOURCE 'entity/store_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_to_base_rate string NOT NULL OPTIONS (ANNOTATION 'Store-to-base rate.', NAMEINSOURCE 'entity/store_to_base_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_to_order_rate string NOT NULL OPTIONS (ANNOTATION 'Store-to-order rate.', NAMEINSOURCE 'entity/store_to_order_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal string NOT NULL OPTIONS (ANNOTATION 'Subtotal.', NAMEINSOURCE 'entity/subtotal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal_canceled string NOT NULL OPTIONS (ANNOTATION 'Subtotal canceled amount.', NAMEINSOURCE 'entity/subtotal_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Subtotal including tax amount.', NAMEINSOURCE 'entity/subtotal_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal_invoiced string NOT NULL OPTIONS (ANNOTATION 'Subtotal invoiced amount.', NAMEINSOURCE 'entity/subtotal_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal_refunded string NOT NULL OPTIONS (ANNOTATION 'Subtotal refunded amount.', NAMEINSOURCE 'entity/subtotal_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_tax_canceled string NOT NULL OPTIONS (ANNOTATION 'Tax canceled amount.', NAMEINSOURCE 'entity/tax_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_tax_invoiced string NOT NULL OPTIONS (ANNOTATION 'Tax invoiced amount.', NAMEINSOURCE 'entity/tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_tax_refunded string NOT NULL OPTIONS (ANNOTATION 'Tax refunded amount.', NAMEINSOURCE 'entity/tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_canceled string NOT NULL OPTIONS (ANNOTATION 'Total canceled.', NAMEINSOURCE 'entity/total_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_due string NOT NULL OPTIONS (ANNOTATION 'Total due.', NAMEINSOURCE 'entity/total_due', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_invoiced string NOT NULL OPTIONS (ANNOTATION 'Total invoiced amount.', NAMEINSOURCE 'entity/total_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_item_count string NOT NULL OPTIONS (ANNOTATION 'Total item count.', NAMEINSOURCE 'entity/total_item_count', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_offline_refunded string NOT NULL OPTIONS (ANNOTATION 'Total offline refunded amount.', NAMEINSOURCE 'entity/total_offline_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_online_refunded string NOT NULL OPTIONS (ANNOTATION 'Total online refunded amount.', NAMEINSOURCE 'entity/total_online_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_paid string NOT NULL OPTIONS (ANNOTATION 'Total paid.', NAMEINSOURCE 'entity/total_paid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_qty_ordered string NOT NULL OPTIONS (ANNOTATION 'Total quantity ordered.', NAMEINSOURCE 'entity/total_qty_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_refunded string NOT NULL OPTIONS (ANNOTATION 'Total amount refunded.', NAMEINSOURCE 'entity/total_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_weight string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_x_forwarded_for string NOT NULL OPTIONS (ANNOTATION 'X-Forwarded-For field value.', NAMEINSOURCE 'entity/x_forwarded_for', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (adjustment_negative string, adjustment_positive string, applied_rule_ids string, base_adjustment_negative string, base_adjustment_positive string, base_currency_code string, base_discount_amount string, base_discount_canceled string, base_discount_invoiced string, base_discount_refunded string, base_discount_tax_compensation_amount string, base_discount_tax_compensation_invoiced string, base_discount_tax_compensation_refunded string, base_grand_total string, base_shipping_amount string, base_shipping_canceled string, base_shipping_discount_amount string, base_shipping_discount_tax_compensation_amnt string, base_shipping_incl_tax string, base_shipping_invoiced string, base_shipping_refunded string, base_shipping_tax_amount string, base_shipping_tax_refunded string, base_subtotal string, base_subtotal_canceled string, base_subtotal_incl_tax string, base_subtotal_invoiced string, base_subtotal_refunded string, base_tax_amount string, base_tax_canceled string, base_tax_invoiced string, base_tax_refunded string, base_to_global_rate string, base_to_order_rate string, base_total_canceled string, base_total_due string, base_total_invoiced string, base_total_invoiced_cost string, base_total_offline_refunded string, base_total_online_refunded string, base_total_paid string, base_total_qty_ordered string, base_total_refunded string, billing_address_address_type string OPTIONS (NAMEINSOURCE 'billing_address/address_type'), billing_address_city string OPTIONS (NAMEINSOURCE 'billing_address/city'), billing_address_company string OPTIONS (NAMEINSOURCE 'billing_address/company'), billing_address_country_id string OPTIONS (NAMEINSOURCE 'billing_address/country_id'), billing_address_customer_address_id string OPTIONS (NAMEINSOURCE 'billing_address/customer_address_id'), billing_address_customer_id string OPTIONS (NAMEINSOURCE 'billing_address/customer_id'), billing_address_email string OPTIONS (NAMEINSOURCE 'billing_address/email'), billing_address_entity_id string OPTIONS (NAMEINSOURCE 'billing_address/entity_id'), billing_address_fax string OPTIONS (NAMEINSOURCE 'billing_address/fax'), billing_address_firstname string OPTIONS (NAMEINSOURCE 'billing_address/firstname'), billing_address_lastname string OPTIONS (NAMEINSOURCE 'billing_address/lastname'), billing_address_middlename string OPTIONS (NAMEINSOURCE 'billing_address/middlename'), billing_address_parent_id string OPTIONS (NAMEINSOURCE 'billing_address/parent_id'), billing_address_postcode string OPTIONS (NAMEINSOURCE 'billing_address/postcode'), billing_address_prefix string OPTIONS (NAMEINSOURCE 'billing_address/prefix'), billing_address_region string OPTIONS (NAMEINSOURCE 'billing_address/region'), billing_address_region_code string OPTIONS (NAMEINSOURCE 'billing_address/region_code'), billing_address_region_id string OPTIONS (NAMEINSOURCE 'billing_address/region_id'), billing_address_street string[] OPTIONS (NAMEINSOURCE 'billing_address/street'), billing_address_suffix string OPTIONS (NAMEINSOURCE 'billing_address/suffix'), billing_address_telephone string OPTIONS (NAMEINSOURCE 'billing_address/telephone'), billing_address_vat_id string OPTIONS (NAMEINSOURCE 'billing_address/vat_id'), billing_address_vat_is_valid string OPTIONS (NAMEINSOURCE 'billing_address/vat_is_valid'), billing_address_vat_request_date string OPTIONS (NAMEINSOURCE 'billing_address/vat_request_date'), billing_address_vat_request_id string OPTIONS (NAMEINSOURCE 'billing_address/vat_request_id'), billing_address_vat_request_success string OPTIONS (NAMEINSOURCE 'billing_address/vat_request_success'), billing_address_id string, can_ship_partially string, can_ship_partially_item string, coupon_code string, created_at string, customer_dob string, customer_email string, customer_firstname string, customer_gender string, customer_group_id string, customer_id string, customer_is_guest string, customer_lastname string, customer_middlename string, customer_note string, customer_note_notify string, customer_prefix string, customer_suffix string, customer_taxvat string, discount_amount string, discount_canceled string, discount_description string, discount_invoiced string, discount_refunded string, discount_tax_compensation_amount string, discount_tax_compensation_invoiced string, discount_tax_compensation_refunded string, edit_increment string, email_sent string, entity_id string, ext_customer_id string, ext_order_id string, "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/amount'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_base_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/base_amount'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/code'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/code'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/percent'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/title'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/percent'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/title'), extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_converting_from_quote boolean OPTIONS (NAMEINSOURCE 'extension_attributes/converting_from_quote'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_gift_message_customer_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/customer_id'), extension_attributes_gift_message_extension_attributes_entity_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/entity_id'), extension_attributes_gift_message_extension_attributes_entity_type string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/entity_type'), extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card boolean OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt boolean OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), extension_attributes_gift_message_extension_attributes_wrapping_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/wrapping_id'), extension_attributes_gift_message_gift_message_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/gift_message_id'), extension_attributes_gift_message_message string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/message'), extension_attributes_gift_message_recipient string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/recipient'), extension_attributes_gift_message_sender string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/sender'), extension_attributes_gw_add_card string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_add_card'), extension_attributes_gw_allow_gift_receipt string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_allow_gift_receipt'), extension_attributes_gw_base_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_base_price'), extension_attributes_gw_base_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_base_price_incl_tax'), extension_attributes_gw_base_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_base_tax_amount'), extension_attributes_gw_card_base_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_base_price'), extension_attributes_gw_card_base_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_base_price_incl_tax'), extension_attributes_gw_card_base_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_base_tax_amount'), extension_attributes_gw_card_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_price'), extension_attributes_gw_card_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_price_incl_tax'), extension_attributes_gw_card_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_tax_amount'), extension_attributes_gw_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_id'), extension_attributes_gw_items_base_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_base_price'), extension_attributes_gw_items_base_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_base_price_incl_tax'), extension_attributes_gw_items_base_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_base_tax_amount'), extension_attributes_gw_items_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_price'), extension_attributes_gw_items_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_price_incl_tax'), extension_attributes_gw_items_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_tax_amount'), extension_attributes_gw_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_price'), extension_attributes_gw_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_price_incl_tax'), extension_attributes_gw_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_tax_amount'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/amount'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_base_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/base_amount'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/code'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/code'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/percent'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/title'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/percent'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/title'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_associated_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/associated_item_id'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/item_id'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/additional_data'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/applied_rule_ids'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_cost'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_original_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_original_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_price_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_total'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_total_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_before_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_row_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_created_at" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/created_at'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_description" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/description'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_percent'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_event_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/event_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/ext_order_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/message'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_free_shipping" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/free_shipping'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/is_qty_decimal'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_is_virtual" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/is_virtual'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/locked_do_invoice'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_locked_do_ship" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/locked_do_ship'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_no_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/no_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_order_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/order_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_original_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/original_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_additional_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/additional_data'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/applied_rule_ids'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_cost" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_cost'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_original_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_original_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_total" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_created_at" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/created_at'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_description" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/description'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_percent'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_event_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/event_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/ext_order_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_free_shipping" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/free_shipping'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/is_qty_decimal'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_is_virtual" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/is_virtual'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_invoice'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_locked_do_ship" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_ship'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_no_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/no_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_order_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/order_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_original_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/original_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_parent_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/parent_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_price_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/price_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_backordered" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_backordered'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_ordered" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_ordered'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_returned" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_returned'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_shipped" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_shipped'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_quote_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/quote_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_total" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_total'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_weight" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_weight'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/sku'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_store_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/store_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_before_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_before_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_percent'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_updated_at" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/updated_at'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weight" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weight'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/price_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_backordered" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_backordered'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_ordered" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_ordered'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_returned'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_shipped" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_shipped'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_quote_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/quote_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_total'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_total_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_weight" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_weight'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/sku'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_store_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/store_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_before_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_before_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_percent'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_updated_at" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/updated_at'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied_row_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_row_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weight" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weight'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_address_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/address_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_city" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/city'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_company" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/company'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_country_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/country_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_customer_address_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/customer_address_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_customer_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/customer_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_entity_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/entity_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_fax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/fax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_firstname" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/firstname'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_lastname" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/lastname'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_middlename" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/middlename'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_parent_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/parent_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_postcode" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/postcode'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_prefix" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/prefix'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region_code'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_street" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/street'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_suffix" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/suffix'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_telephone" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/telephone'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_is_valid" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_is_valid'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_date" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_date'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_success" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_success'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_method" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/method'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_discount_tax_compensation_amnt" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_discount_tax_compensation_amnt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_stock_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/stock_id'), forced_shipment_with_invoice string, global_currency_code string, grand_total string, hold_before_state string, hold_before_status string, increment_id string, is_virtual string, "items_sales-data-order-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/additional_data'), "items_sales-data-order-item-interface_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/amount_refunded'), "items_sales-data-order-item-interface_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/applied_rule_ids'), "items_sales-data-order-item-interface_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_amount_refunded'), "items_sales-data-order-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_cost'), "items_sales-data-order-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_amount'), "items_sales-data-order-item-interface_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_invoiced'), "items_sales-data-order-item-interface_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_refunded'), "items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_base_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_original_price'), "items_sales-data-order-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_price'), "items_sales-data-order-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_price_incl_tax'), "items_sales-data-order-item-interface_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_row_invoiced'), "items_sales-data-order-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_row_total'), "items_sales-data-order-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_row_total_incl_tax'), "items_sales-data-order-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_amount'), "items_sales-data-order-item-interface_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_before_discount'), "items_sales-data-order-item-interface_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_invoiced'), "items_sales-data-order-item-interface_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_refunded'), "items_sales-data-order-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_applied_amount'), "items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt'), "items_sales-data-order-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_disposition'), "items_sales-data-order-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_row_disposition'), "items_sales-data-order-item-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/created_at'), "items_sales-data-order-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/description'), "items_sales-data-order-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_amount'), "items_sales-data-order-item-interface_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_invoiced'), "items_sales-data-order-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_percent'), "items_sales-data-order-item-interface_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_refunded'), "items_sales-data-order-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_amount'), "items_sales-data-order-item-interface_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_canceled'), "items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_event_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/event_id'), "items_sales-data-order-item-interface_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/ext_order_item_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/message'), "items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient'), "items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender'), "items_sales-data-order-item-interface_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/free_shipping'), "items_sales-data-order-item-interface_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_price'), "items_sales-data-order-item-interface_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_price_invoiced'), "items_sales-data-order-item-interface_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_price_refunded'), "items_sales-data-order-item-interface_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_tax_amount'), "items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced'), "items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded'), "items_sales-data-order-item-interface_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_id'), "items_sales-data-order-item-interface_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_price'), "items_sales-data-order-item-interface_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_price_invoiced'), "items_sales-data-order-item-interface_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_price_refunded'), "items_sales-data-order-item-interface_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_tax_amount'), "items_sales-data-order-item-interface_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_tax_amount_invoiced'), "items_sales-data-order-item-interface_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_tax_amount_refunded'), "items_sales-data-order-item-interface_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/is_qty_decimal'), "items_sales-data-order-item-interface_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/is_virtual'), "items_sales-data-order-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/item_id'), "items_sales-data-order-item-interface_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/locked_do_invoice'), "items_sales-data-order-item-interface_locked_do_ship" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/locked_do_ship'), "items_sales-data-order-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/name'), "items_sales-data-order-item-interface_no_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/no_discount'), "items_sales-data-order-item-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/order_id'), "items_sales-data-order-item-interface_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/original_price'), "items_sales-data-order-item-interface_parent_item_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/additional_data'), "items_sales-data-order-item-interface_parent_item_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/amount_refunded'), "items_sales-data-order-item-interface_parent_item_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/applied_rule_ids'), "items_sales-data-order-item-interface_parent_item_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_amount_refunded'), "items_sales-data-order-item-interface_parent_item_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_cost'), "items_sales-data-order-item-interface_parent_item_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_amount'), "items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced'), "items_sales-data-order-item-interface_parent_item_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_refunded'), "items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount'), "items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_parent_item_base_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_original_price'), "items_sales-data-order-item-interface_parent_item_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_price'), "items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax'), "items_sales-data-order-item-interface_parent_item_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_row_invoiced'), "items_sales-data-order-item-interface_parent_item_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_row_total'), "items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax'), "items_sales-data-order-item-interface_parent_item_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_amount'), "items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount'), "items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced'), "items_sales-data-order-item-interface_parent_item_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_refunded'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition'), "items_sales-data-order-item-interface_parent_item_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/created_at'), "items_sales-data-order-item-interface_parent_item_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/description'), "items_sales-data-order-item-interface_parent_item_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_amount'), "items_sales-data-order-item-interface_parent_item_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_invoiced'), "items_sales-data-order-item-interface_parent_item_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_percent'), "items_sales-data-order-item-interface_parent_item_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_refunded'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_parent_item_event_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/event_id'), "items_sales-data-order-item-interface_parent_item_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/ext_order_item_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender'), "items_sales-data-order-item-interface_parent_item_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/free_shipping'), "items_sales-data-order-item-interface_parent_item_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_price'), "items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded'), "items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount'), "items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded'), "items_sales-data-order-item-interface_parent_item_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_id'), "items_sales-data-order-item-interface_parent_item_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_price'), "items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_price_refunded'), "items_sales-data-order-item-interface_parent_item_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_tax_amount'), "items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded'), "items_sales-data-order-item-interface_parent_item_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/is_qty_decimal'), "items_sales-data-order-item-interface_parent_item_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/is_virtual'), "items_sales-data-order-item-interface_parent_item_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/item_id'), "items_sales-data-order-item-interface_parent_item_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/locked_do_invoice'), "items_sales-data-order-item-interface_parent_item_locked_do_ship" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/locked_do_ship'), "items_sales-data-order-item-interface_parent_item_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/name'), "items_sales-data-order-item-interface_parent_item_no_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/no_discount'), "items_sales-data-order-item-interface_parent_item_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/order_id'), "items_sales-data-order-item-interface_parent_item_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/original_price'), "items_sales-data-order-item-interface_parent_item_parent_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/parent_item_id'), "items_sales-data-order-item-interface_parent_item_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/price'), "items_sales-data-order-item-interface_parent_item_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/price_incl_tax'), "items_sales-data-order-item-interface_parent_item_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_sales-data-order-item-interface_parent_item_product_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_type'), "items_sales-data-order-item-interface_parent_item_qty_backordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_backordered'), "items_sales-data-order-item-interface_parent_item_qty_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_canceled'), "items_sales-data-order-item-interface_parent_item_qty_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_invoiced'), "items_sales-data-order-item-interface_parent_item_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_ordered'), "items_sales-data-order-item-interface_parent_item_qty_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_refunded'), "items_sales-data-order-item-interface_parent_item_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_returned'), "items_sales-data-order-item-interface_parent_item_qty_shipped" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_shipped'), "items_sales-data-order-item-interface_parent_item_quote_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/quote_item_id'), "items_sales-data-order-item-interface_parent_item_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_invoiced'), "items_sales-data-order-item-interface_parent_item_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_total'), "items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax'), "items_sales-data-order-item-interface_parent_item_row_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_weight'), "items_sales-data-order-item-interface_parent_item_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/sku'), "items_sales-data-order-item-interface_parent_item_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/store_id'), "items_sales-data-order-item-interface_parent_item_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_amount'), "items_sales-data-order-item-interface_parent_item_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_before_discount'), "items_sales-data-order-item-interface_parent_item_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_canceled'), "items_sales-data-order-item-interface_parent_item_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_invoiced'), "items_sales-data-order-item-interface_parent_item_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_percent'), "items_sales-data-order-item-interface_parent_item_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_refunded'), "items_sales-data-order-item-interface_parent_item_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/updated_at'), "items_sales-data-order-item-interface_parent_item_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_applied'), "items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount'), "items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount'), "items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition'), "items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition'), "items_sales-data-order-item-interface_parent_item_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weight'), "items_sales-data-order-item-interface_parent_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item_id'), "items_sales-data-order-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/price'), "items_sales-data-order-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/price_incl_tax'), "items_sales-data-order-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_sales-data-order-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_type'), "items_sales-data-order-item-interface_qty_backordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_backordered'), "items_sales-data-order-item-interface_qty_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_canceled'), "items_sales-data-order-item-interface_qty_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_invoiced'), "items_sales-data-order-item-interface_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_ordered'), "items_sales-data-order-item-interface_qty_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_refunded'), "items_sales-data-order-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_returned'), "items_sales-data-order-item-interface_qty_shipped" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_shipped'), "items_sales-data-order-item-interface_quote_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/quote_item_id'), "items_sales-data-order-item-interface_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_invoiced'), "items_sales-data-order-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_total'), "items_sales-data-order-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_total_incl_tax'), "items_sales-data-order-item-interface_row_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_weight'), "items_sales-data-order-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/sku'), "items_sales-data-order-item-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/store_id'), "items_sales-data-order-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_amount'), "items_sales-data-order-item-interface_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_before_discount'), "items_sales-data-order-item-interface_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_canceled'), "items_sales-data-order-item-interface_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_invoiced'), "items_sales-data-order-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_percent'), "items_sales-data-order-item-interface_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_refunded'), "items_sales-data-order-item-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/updated_at'), "items_sales-data-order-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_applied'), "items_sales-data-order-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_applied_amount'), "items_sales-data-order-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_applied_row_amount'), "items_sales-data-order-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_disposition'), "items_sales-data-order-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_row_disposition'), "items_sales-data-order-item-interface_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weight'), order_currency_code string, original_increment_id string, payment_account_status string OPTIONS (NAMEINSOURCE 'payment/account_status'), payment_additional_data string OPTIONS (NAMEINSOURCE 'payment/additional_data'), payment_additional_information string[] OPTIONS (NAMEINSOURCE 'payment/additional_information'), payment_address_status string OPTIONS (NAMEINSOURCE 'payment/address_status'), payment_amount_authorized string OPTIONS (NAMEINSOURCE 'payment/amount_authorized'), payment_amount_canceled string OPTIONS (NAMEINSOURCE 'payment/amount_canceled'), payment_amount_ordered string OPTIONS (NAMEINSOURCE 'payment/amount_ordered'), payment_amount_paid string OPTIONS (NAMEINSOURCE 'payment/amount_paid'), payment_amount_refunded string OPTIONS (NAMEINSOURCE 'payment/amount_refunded'), payment_anet_trans_method string OPTIONS (NAMEINSOURCE 'payment/anet_trans_method'), payment_base_amount_authorized string OPTIONS (NAMEINSOURCE 'payment/base_amount_authorized'), payment_base_amount_canceled string OPTIONS (NAMEINSOURCE 'payment/base_amount_canceled'), payment_base_amount_ordered string OPTIONS (NAMEINSOURCE 'payment/base_amount_ordered'), payment_base_amount_paid string OPTIONS (NAMEINSOURCE 'payment/base_amount_paid'), payment_base_amount_paid_online string OPTIONS (NAMEINSOURCE 'payment/base_amount_paid_online'), payment_base_amount_refunded string OPTIONS (NAMEINSOURCE 'payment/base_amount_refunded'), payment_base_amount_refunded_online string OPTIONS (NAMEINSOURCE 'payment/base_amount_refunded_online'), payment_base_shipping_amount string OPTIONS (NAMEINSOURCE 'payment/base_shipping_amount'), payment_base_shipping_captured string OPTIONS (NAMEINSOURCE 'payment/base_shipping_captured'), payment_base_shipping_refunded string OPTIONS (NAMEINSOURCE 'payment/base_shipping_refunded'), payment_cc_approval string OPTIONS (NAMEINSOURCE 'payment/cc_approval'), payment_cc_avs_status string OPTIONS (NAMEINSOURCE 'payment/cc_avs_status'), payment_cc_cid_status string OPTIONS (NAMEINSOURCE 'payment/cc_cid_status'), payment_cc_debug_request_body string OPTIONS (NAMEINSOURCE 'payment/cc_debug_request_body'), payment_cc_debug_response_body string OPTIONS (NAMEINSOURCE 'payment/cc_debug_response_body'), payment_cc_debug_response_serialized string OPTIONS (NAMEINSOURCE 'payment/cc_debug_response_serialized'), payment_cc_exp_month string OPTIONS (NAMEINSOURCE 'payment/cc_exp_month'), payment_cc_exp_year string OPTIONS (NAMEINSOURCE 'payment/cc_exp_year'), payment_cc_last4 string OPTIONS (NAMEINSOURCE 'payment/cc_last4'), payment_cc_number_enc string OPTIONS (NAMEINSOURCE 'payment/cc_number_enc'), payment_cc_owner string OPTIONS (NAMEINSOURCE 'payment/cc_owner'), payment_cc_secure_verify string OPTIONS (NAMEINSOURCE 'payment/cc_secure_verify'), payment_cc_ss_issue string OPTIONS (NAMEINSOURCE 'payment/cc_ss_issue'), payment_cc_ss_start_month string OPTIONS (NAMEINSOURCE 'payment/cc_ss_start_month'), payment_cc_ss_start_year string OPTIONS (NAMEINSOURCE 'payment/cc_ss_start_year'), payment_cc_status string OPTIONS (NAMEINSOURCE 'payment/cc_status'), payment_cc_status_description string OPTIONS (NAMEINSOURCE 'payment/cc_status_description'), payment_cc_trans_id string OPTIONS (NAMEINSOURCE 'payment/cc_trans_id'), payment_cc_type string OPTIONS (NAMEINSOURCE 'payment/cc_type'), payment_echeck_account_name string OPTIONS (NAMEINSOURCE 'payment/echeck_account_name'), payment_echeck_account_type string OPTIONS (NAMEINSOURCE 'payment/echeck_account_type'), payment_echeck_bank_name string OPTIONS (NAMEINSOURCE 'payment/echeck_bank_name'), payment_echeck_routing_number string OPTIONS (NAMEINSOURCE 'payment/echeck_routing_number'), payment_echeck_type string OPTIONS (NAMEINSOURCE 'payment/echeck_type'), payment_entity_id string OPTIONS (NAMEINSOURCE 'payment/entity_id'), payment_extension_attributes_vault_payment_token_created_at string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/created_at'), payment_extension_attributes_vault_payment_token_customer_id string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/customer_id'), payment_extension_attributes_vault_payment_token_entity_id string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/entity_id'), payment_extension_attributes_vault_payment_token_expires_at string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/expires_at'), payment_extension_attributes_vault_payment_token_gateway_token string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/gateway_token'), payment_extension_attributes_vault_payment_token_is_active boolean OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/is_active'), payment_extension_attributes_vault_payment_token_is_visible boolean OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/is_visible'), payment_extension_attributes_vault_payment_token_payment_method_code string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/payment_method_code'), payment_extension_attributes_vault_payment_token_public_hash string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/public_hash'), payment_extension_attributes_vault_payment_token_token_details string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/token_details'), payment_extension_attributes_vault_payment_token_type string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/type'), payment_last_trans_id string OPTIONS (NAMEINSOURCE 'payment/last_trans_id'), payment_method string OPTIONS (NAMEINSOURCE 'payment/method'), payment_parent_id string OPTIONS (NAMEINSOURCE 'payment/parent_id'), payment_po_number string OPTIONS (NAMEINSOURCE 'payment/po_number'), payment_protection_eligibility string OPTIONS (NAMEINSOURCE 'payment/protection_eligibility'), payment_quote_payment_id string OPTIONS (NAMEINSOURCE 'payment/quote_payment_id'), payment_shipping_amount string OPTIONS (NAMEINSOURCE 'payment/shipping_amount'), payment_shipping_captured string OPTIONS (NAMEINSOURCE 'payment/shipping_captured'), payment_shipping_refunded string OPTIONS (NAMEINSOURCE 'payment/shipping_refunded'), payment_auth_expiration string, payment_authorization_amount string, protect_code string, quote_address_id string, quote_id string, relation_child_id string, relation_child_real_id string, relation_parent_id string, relation_parent_real_id string, remote_ip string, shipping_amount string, shipping_canceled string, shipping_description string, shipping_discount_amount string, shipping_discount_tax_compensation_amount string, shipping_incl_tax string, shipping_invoiced string, shipping_refunded string, shipping_tax_amount string, shipping_tax_refunded string, state string, status string, "status_histories_sales-data-order-status-history-interface_comment" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/comment'), "status_histories_sales-data-order-status-history-interface_created_at" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/created_at'), "status_histories_sales-data-order-status-history-interface_entity_id" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/entity_id'), "status_histories_sales-data-order-status-history-interface_entity_name" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/entity_name'), "status_histories_sales-data-order-status-history-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/is_customer_notified'), "status_histories_sales-data-order-status-history-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/is_visible_on_front'), "status_histories_sales-data-order-status-history-interface_parent_id" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/parent_id'), "status_histories_sales-data-order-status-history-interface_status" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/status'), store_currency_code string, store_id string, store_name string, store_to_base_rate string, store_to_order_rate string, subtotal string, subtotal_canceled string, subtotal_incl_tax string, subtotal_invoiced string, subtotal_refunded string, tax_amount string, tax_canceled string, tax_invoiced string, tax_refunded string, total_canceled string, total_due string, total_invoiced string, total_item_count string, total_offline_refunded string, total_online_refunded string, total_paid string, total_qty_ordered string, total_refunded string, updated_at string, weight string, x_forwarded_for string)
OPTIONS (ANNOTATION 'Performs persist operations for a specified order.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/');

CREATE FOREIGN PROCEDURE salesOrderRepositoryV1SavePut(IN entity_adjustment_negative string NOT NULL OPTIONS (ANNOTATION 'Negative adjustment value.', NAMEINSOURCE 'entity/adjustment_negative', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_adjustment_positive string NOT NULL OPTIONS (ANNOTATION 'Positive adjustment value.', NAMEINSOURCE 'entity/adjustment_positive', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_applied_rule_ids string NOT NULL OPTIONS (ANNOTATION 'Applied rule IDs.', NAMEINSOURCE 'entity/applied_rule_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_adjustment_negative string NOT NULL OPTIONS (ANNOTATION 'Base negative adjustment value.', NAMEINSOURCE 'entity/base_adjustment_negative', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_adjustment_positive string NOT NULL OPTIONS (ANNOTATION 'Base positive adjustment value.', NAMEINSOURCE 'entity/base_adjustment_positive', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_currency_code string NOT NULL OPTIONS (ANNOTATION 'Base currency code.', NAMEINSOURCE 'entity/base_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Base discount amount.', NAMEINSOURCE 'entity/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_canceled string NOT NULL OPTIONS (ANNOTATION 'Base discount canceled.', NAMEINSOURCE 'entity/base_discount_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_invoiced string NOT NULL OPTIONS (ANNOTATION 'Base discount invoiced.', NAMEINSOURCE 'entity/base_discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_refunded string NOT NULL OPTIONS (ANNOTATION 'Base discount refunded.', NAMEINSOURCE 'entity/base_discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation amount.', NAMEINSOURCE 'entity/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_tax_compensation_invoiced string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation invoiced.', NAMEINSOURCE 'entity/base_discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_discount_tax_compensation_refunded string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation refunded.', NAMEINSOURCE 'entity/base_discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_grand_total string NOT NULL OPTIONS (ANNOTATION 'Base grand total.', NAMEINSOURCE 'entity/base_grand_total', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_base_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Base shipping amount.', NAMEINSOURCE 'entity/base_shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_canceled string NOT NULL OPTIONS (ANNOTATION 'Base shipping canceled.', NAMEINSOURCE 'entity/base_shipping_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Base shipping discount amount.', NAMEINSOURCE 'entity/base_shipping_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_discount_tax_compensation_amnt string NOT NULL OPTIONS (ANNOTATION 'Base shipping discount tax compensation amount.', NAMEINSOURCE 'entity/base_shipping_discount_tax_compensation_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Base shipping including tax.', NAMEINSOURCE 'entity/base_shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_invoiced string NOT NULL OPTIONS (ANNOTATION 'Base shipping invoiced.', NAMEINSOURCE 'entity/base_shipping_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_refunded string NOT NULL OPTIONS (ANNOTATION 'Base shipping refunded.', NAMEINSOURCE 'entity/base_shipping_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Base shipping tax amount.', NAMEINSOURCE 'entity/base_shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_shipping_tax_refunded string NOT NULL OPTIONS (ANNOTATION 'Base shipping tax refunded.', NAMEINSOURCE 'entity/base_shipping_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal string NOT NULL OPTIONS (ANNOTATION 'Base subtotal.', NAMEINSOURCE 'entity/base_subtotal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal_canceled string NOT NULL OPTIONS (ANNOTATION 'Base subtotal canceled.', NAMEINSOURCE 'entity/base_subtotal_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Base subtotal including tax.', NAMEINSOURCE 'entity/base_subtotal_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal_invoiced string NOT NULL OPTIONS (ANNOTATION 'Base subtotal invoiced.', NAMEINSOURCE 'entity/base_subtotal_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_subtotal_refunded string NOT NULL OPTIONS (ANNOTATION 'Base subtotal refunded.', NAMEINSOURCE 'entity/base_subtotal_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_tax_canceled string NOT NULL OPTIONS (ANNOTATION 'Base tax canceled.', NAMEINSOURCE 'entity/base_tax_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_tax_invoiced string NOT NULL OPTIONS (ANNOTATION 'Base tax invoiced.', NAMEINSOURCE 'entity/base_tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_tax_refunded string NOT NULL OPTIONS (ANNOTATION 'Base tax refunded.', NAMEINSOURCE 'entity/base_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_to_global_rate string NOT NULL OPTIONS (ANNOTATION 'Base-to-global rate.', NAMEINSOURCE 'entity/base_to_global_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_to_order_rate string NOT NULL OPTIONS (ANNOTATION 'Base-to-order rate.', NAMEINSOURCE 'entity/base_to_order_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_canceled string NOT NULL OPTIONS (ANNOTATION 'Base total canceled.', NAMEINSOURCE 'entity/base_total_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_due string NOT NULL OPTIONS (ANNOTATION 'Base total due.', NAMEINSOURCE 'entity/base_total_due', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_invoiced string NOT NULL OPTIONS (ANNOTATION 'Base total invoiced.', NAMEINSOURCE 'entity/base_total_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_invoiced_cost string NOT NULL OPTIONS (ANNOTATION 'Base total invoiced cost.', NAMEINSOURCE 'entity/base_total_invoiced_cost', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_offline_refunded string NOT NULL OPTIONS (ANNOTATION 'Base total offline refunded.', NAMEINSOURCE 'entity/base_total_offline_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_online_refunded string NOT NULL OPTIONS (ANNOTATION 'Base total online refunded.', NAMEINSOURCE 'entity/base_total_online_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_paid string NOT NULL OPTIONS (ANNOTATION 'Base total paid.', NAMEINSOURCE 'entity/base_total_paid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_qty_ordered string NOT NULL OPTIONS (ANNOTATION 'Base total quantity ordered.', NAMEINSOURCE 'entity/base_total_qty_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_base_total_refunded string NOT NULL OPTIONS (ANNOTATION 'Base total refunded.', NAMEINSOURCE 'entity/base_total_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_address_type string NOT NULL OPTIONS (ANNOTATION 'Address type.', NAMEINSOURCE 'entity/billing_address/address_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_city string NOT NULL OPTIONS (ANNOTATION 'City.', NAMEINSOURCE 'entity/billing_address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_company string NOT NULL OPTIONS (ANNOTATION 'Company.', NAMEINSOURCE 'entity/billing_address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_country_id string NOT NULL OPTIONS (ANNOTATION 'Country ID.', NAMEINSOURCE 'entity/billing_address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Country address ID.', NAMEINSOURCE 'entity/billing_address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID.', NAMEINSOURCE 'entity/billing_address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_email string NOT NULL OPTIONS (ANNOTATION 'Email address.', NAMEINSOURCE 'entity/billing_address/email', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_entity_id string NOT NULL OPTIONS (ANNOTATION 'Order address ID.', NAMEINSOURCE 'entity/billing_address/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number.', NAMEINSOURCE 'entity/billing_address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_firstname string NOT NULL OPTIONS (ANNOTATION 'First name.', NAMEINSOURCE 'entity/billing_address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name.', NAMEINSOURCE 'entity/billing_address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name.', NAMEINSOURCE 'entity/billing_address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_parent_id string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/billing_address/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_postcode string NOT NULL OPTIONS (ANNOTATION 'Postal code.', NAMEINSOURCE 'entity/billing_address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix.', NAMEINSOURCE 'entity/billing_address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_region string NOT NULL OPTIONS (ANNOTATION 'Region.', NAMEINSOURCE 'entity/billing_address/region', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code.', NAMEINSOURCE 'entity/billing_address/region_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_region_id string NOT NULL OPTIONS (ANNOTATION 'Region ID.', NAMEINSOURCE 'entity/billing_address/region_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/billing_address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix.', NAMEINSOURCE 'entity/billing_address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number.', NAMEINSOURCE 'entity/billing_address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_billing_address_vat_id string NOT NULL OPTIONS (ANNOTATION 'VAT ID.', NAMEINSOURCE 'entity/billing_address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_vat_is_valid string NOT NULL OPTIONS (ANNOTATION 'VAT-is-valid flag value.', NAMEINSOURCE 'entity/billing_address/vat_is_valid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_vat_request_date string NOT NULL OPTIONS (ANNOTATION 'VAT request date.', NAMEINSOURCE 'entity/billing_address/vat_request_date', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_vat_request_id string NOT NULL OPTIONS (ANNOTATION 'VAT request ID.', NAMEINSOURCE 'entity/billing_address/vat_request_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_vat_request_success string NOT NULL OPTIONS (ANNOTATION 'VAT-request-success flag value.', NAMEINSOURCE 'entity/billing_address/vat_request_success', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_billing_address_id string NOT NULL OPTIONS (ANNOTATION 'Billing address ID.', NAMEINSOURCE 'entity/billing_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_can_ship_partially string NOT NULL OPTIONS (ANNOTATION 'Can-ship-partially flag value.', NAMEINSOURCE 'entity/can_ship_partially', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_can_ship_partially_item string NOT NULL OPTIONS (ANNOTATION 'Can-ship-partially-item flag value.', NAMEINSOURCE 'entity/can_ship_partially_item', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_coupon_code string NOT NULL OPTIONS (ANNOTATION 'Coupon code.', NAMEINSOURCE 'entity/coupon_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_created_at string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_dob string NOT NULL OPTIONS (ANNOTATION 'Customer date-of-birth (DOB).', NAMEINSOURCE 'entity/customer_dob', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_email string NOT NULL OPTIONS (ANNOTATION 'Customer email address.', NAMEINSOURCE 'entity/customer_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_customer_firstname string NOT NULL OPTIONS (ANNOTATION 'Customer first name.', NAMEINSOURCE 'entity/customer_firstname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_gender string NOT NULL OPTIONS (ANNOTATION 'Customer gender.', NAMEINSOURCE 'entity/customer_gender', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_group_id string NOT NULL OPTIONS (ANNOTATION 'Customer group ID.', NAMEINSOURCE 'entity/customer_group_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID.', NAMEINSOURCE 'entity/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_is_guest string NOT NULL OPTIONS (ANNOTATION 'Customer-is-guest flag value.', NAMEINSOURCE 'entity/customer_is_guest', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_lastname string NOT NULL OPTIONS (ANNOTATION 'Customer last name.', NAMEINSOURCE 'entity/customer_lastname', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_middlename string NOT NULL OPTIONS (ANNOTATION 'Customer middle name.', NAMEINSOURCE 'entity/customer_middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_note string NOT NULL OPTIONS (ANNOTATION 'Customer note.', NAMEINSOURCE 'entity/customer_note', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_note_notify string NOT NULL OPTIONS (ANNOTATION 'Customer-note-notify flag value.', NAMEINSOURCE 'entity/customer_note_notify', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_prefix string NOT NULL OPTIONS (ANNOTATION 'Customer prefix.', NAMEINSOURCE 'entity/customer_prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_suffix string NOT NULL OPTIONS (ANNOTATION 'Customer suffix.', NAMEINSOURCE 'entity/customer_suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_taxvat string NOT NULL OPTIONS (ANNOTATION 'Customer value-added tax (VAT).', NAMEINSOURCE 'entity/customer_taxvat', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_canceled string NOT NULL OPTIONS (ANNOTATION 'Discount canceled.', NAMEINSOURCE 'entity/discount_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_description string NOT NULL OPTIONS (ANNOTATION 'Discount description.', NAMEINSOURCE 'entity/discount_description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_invoiced string NOT NULL OPTIONS (ANNOTATION 'Discount invoiced.', NAMEINSOURCE 'entity/discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_refunded string NOT NULL OPTIONS (ANNOTATION 'Discount refunded amount.', NAMEINSOURCE 'entity/discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_tax_compensation_invoiced string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation invoiced amount.', NAMEINSOURCE 'entity/discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_discount_tax_compensation_refunded string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation refunded amount.', NAMEINSOURCE 'entity/discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_edit_increment string NOT NULL OPTIONS (ANNOTATION 'Edit increment value.', NAMEINSOURCE 'entity/edit_increment', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_email_sent string NOT NULL OPTIONS (ANNOTATION 'Email-sent flag value.', NAMEINSOURCE 'entity/email_sent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_entity_id string NOT NULL OPTIONS (ANNOTATION 'Order ID.', NAMEINSOURCE 'entity/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_ext_customer_id string NOT NULL OPTIONS (ANNOTATION 'External customer ID.', NAMEINSOURCE 'entity/ext_customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_ext_order_id string NOT NULL OPTIONS (ANNOTATION 'External order ID.', NAMEINSOURCE 'entity/ext_order_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_base_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount in base currency', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/base_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_code" string NOT NULL OPTIONS (ANNOTATION 'Code', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_code" string NOT NULL OPTIONS (ANNOTATION 'Code', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax Percent', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax Percent', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'entity/extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_base_customer_balance_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/base_customer_balance_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_converting_from_quote boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/converting_from_quote', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_customer_balance_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/customer_balance_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'entity/extension_attributes/gift_message/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_extension_attributes_entity_id string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gift_message/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_extension_attributes_entity_type string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gift_message/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_extension_attributes_wrapping_id string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gift_message/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_gift_message_id string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'entity/extension_attributes/gift_message/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gift_message_message string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'entity/extension_attributes/gift_message/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_extension_attributes_gift_message_recipient string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'entity/extension_attributes/gift_message/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_extension_attributes_gift_message_sender string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'entity/extension_attributes/gift_message/sender', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_extension_attributes_gw_add_card string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_add_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_allow_gift_receipt string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_base_price string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_base_price_incl_tax string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_base_tax_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_card_base_price string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_card_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_card_base_price_incl_tax string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_card_base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_card_base_tax_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_card_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_card_price string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_card_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_card_price_incl_tax string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_card_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_card_tax_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_card_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_id string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_items_base_price string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_items_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_items_base_price_incl_tax string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_items_base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_items_base_tax_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_items_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_items_price string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_items_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_items_price_incl_tax string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_items_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_items_tax_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_items_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_price string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_price_incl_tax string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_extension_attributes_gw_tax_amount string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/gw_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_base_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount in base currency', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/base_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_code" string NOT NULL OPTIONS (ANNOTATION 'Code', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_code" string NOT NULL OPTIONS (ANNOTATION 'Code', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax Percent', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax Percent', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_associated_item_id" string NOT NULL OPTIONS (ANNOTATION 'Associated item id if this item is associated with another item, null otherwise', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/associated_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_item_id" string NOT NULL OPTIONS (ANNOTATION 'Item id if this item is a product', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_type" string NOT NULL OPTIONS (ANNOTATION 'Type (shipping, product, weee, gift wrapping, etc)', NAMEINSOURCE 'entity/extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_additional_data" string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_applied_rule_ids" string NOT NULL OPTIONS (ANNOTATION 'Applied rule IDs.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/applied_rule_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_cost" string NOT NULL OPTIONS (ANNOTATION 'Base cost.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_cost', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_original_price" string NOT NULL OPTIONS (ANNOTATION 'Base original price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_price" string NOT NULL OPTIONS (ANNOTATION 'Base price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base price including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base row invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_total" string NOT NULL OPTIONS (ANNOTATION 'Base row total.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base row total including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Base tax before discount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base tax invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base tax refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied row amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax row disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_percent" string NOT NULL OPTIONS (ANNOTATION 'Discount percent.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_canceled" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_event_id" string NOT NULL OPTIONS (ANNOTATION 'Event ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/event_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_ext_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'External order item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/ext_order_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_message" string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_free_shipping" string NOT NULL OPTIONS (ANNOTATION 'Free-shipping flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/free_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price" string NOT NULL OPTIONS (ANNOTATION 'GW base price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base price invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base price refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_id" string NOT NULL OPTIONS (ANNOTATION 'GW ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price" string NOT NULL OPTIONS (ANNOTATION 'GW price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW price invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW price refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_is_qty_decimal" string NOT NULL OPTIONS (ANNOTATION 'Is-quantity-decimal flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/is_qty_decimal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_is_virtual" string NOT NULL OPTIONS (ANNOTATION 'Is-virtual flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/is_virtual', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_item_id" string NOT NULL OPTIONS (ANNOTATION 'Item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_locked_do_invoice" string NOT NULL OPTIONS (ANNOTATION 'Locked DO invoice flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/locked_do_invoice', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_locked_do_ship" string NOT NULL OPTIONS (ANNOTATION 'Locked DO ship flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/locked_do_ship', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_name" string NOT NULL OPTIONS (ANNOTATION 'Name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_no_discount" string NOT NULL OPTIONS (ANNOTATION 'No-discount flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/no_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_order_id" string NOT NULL OPTIONS (ANNOTATION 'Order ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/order_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_original_price" string NOT NULL OPTIONS (ANNOTATION 'Original price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_additional_data" string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_applied_rule_ids" string NOT NULL OPTIONS (ANNOTATION 'Applied rule IDs.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/applied_rule_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_cost" string NOT NULL OPTIONS (ANNOTATION 'Base cost.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_cost', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_original_price" string NOT NULL OPTIONS (ANNOTATION 'Base original price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_price" string NOT NULL OPTIONS (ANNOTATION 'Base price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base price including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base row invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_total" string NOT NULL OPTIONS (ANNOTATION 'Base row total.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base row total including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Base tax before discount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base tax invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base tax refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied row amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax row disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_percent" string NOT NULL OPTIONS (ANNOTATION 'Discount percent.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_event_id" string NOT NULL OPTIONS (ANNOTATION 'Event ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/event_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_ext_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'External order item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/ext_order_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_free_shipping" string NOT NULL OPTIONS (ANNOTATION 'Free-shipping flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/free_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price" string NOT NULL OPTIONS (ANNOTATION 'GW base price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base price invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base price refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_id" string NOT NULL OPTIONS (ANNOTATION 'GW ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price" string NOT NULL OPTIONS (ANNOTATION 'GW price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW price invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW price refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_is_qty_decimal" string NOT NULL OPTIONS (ANNOTATION 'Is-quantity-decimal flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/is_qty_decimal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_is_virtual" string NOT NULL OPTIONS (ANNOTATION 'Is-virtual flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/is_virtual', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_item_id" string NOT NULL OPTIONS (ANNOTATION 'Item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_locked_do_invoice" string NOT NULL OPTIONS (ANNOTATION 'Locked DO invoice flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_invoice', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_locked_do_ship" string NOT NULL OPTIONS (ANNOTATION 'Locked DO ship flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_ship', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_name" string NOT NULL OPTIONS (ANNOTATION 'Name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_no_discount" string NOT NULL OPTIONS (ANNOTATION 'No-discount flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/no_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_order_id" string NOT NULL OPTIONS (ANNOTATION 'Order ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/order_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_original_price" string NOT NULL OPTIONS (ANNOTATION 'Original price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_parent_item_id" string NOT NULL OPTIONS (ANNOTATION 'Parent item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/parent_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_price" string NOT NULL OPTIONS (ANNOTATION 'Price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Price including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_id" string NOT NULL OPTIONS (ANNOTATION 'Product ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_type" string NOT NULL OPTIONS (ANNOTATION 'Product type.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_backordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity backordered.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_backordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_canceled" string NOT NULL OPTIONS (ANNOTATION 'Quantity canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Quantity invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_ordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity ordered.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_refunded" string NOT NULL OPTIONS (ANNOTATION 'Quantity refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_returned" string NOT NULL OPTIONS (ANNOTATION 'Quantity returned.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_returned', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_shipped" string NOT NULL OPTIONS (ANNOTATION 'Quantity shipped.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_shipped', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_quote_item_id" string NOT NULL OPTIONS (ANNOTATION 'Quote item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/quote_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Row invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_total" string NOT NULL OPTIONS (ANNOTATION 'Row total.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Row total including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_weight" string NOT NULL OPTIONS (ANNOTATION 'Row weight.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Tax before discount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_canceled" string NOT NULL OPTIONS (ANNOTATION 'Tax canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Tax invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax percent.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Tax refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_updated_at" string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied row amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax row disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weight" string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_id" string NOT NULL OPTIONS (ANNOTATION 'Parent item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Price including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_id" string NOT NULL OPTIONS (ANNOTATION 'Product ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_type" string NOT NULL OPTIONS (ANNOTATION 'Product type.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_backordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity backordered.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_backordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_canceled" string NOT NULL OPTIONS (ANNOTATION 'Quantity canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Quantity invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_ordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity ordered.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_refunded" string NOT NULL OPTIONS (ANNOTATION 'Quantity refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_returned" string NOT NULL OPTIONS (ANNOTATION 'Quantity returned.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_returned', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_shipped" string NOT NULL OPTIONS (ANNOTATION 'Quantity shipped.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_shipped', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_quote_item_id" string NOT NULL OPTIONS (ANNOTATION 'Quote item ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/quote_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Row invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_total" string NOT NULL OPTIONS (ANNOTATION 'Row total.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Row total including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_weight" string NOT NULL OPTIONS (ANNOTATION 'Row weight.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Tax before discount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_canceled" string NOT NULL OPTIONS (ANNOTATION 'Tax canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Tax invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax percent.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Tax refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_updated_at" string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied_row_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied row amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied_row_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax row disposition.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weight" string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_address_type" string NOT NULL OPTIONS (ANNOTATION 'Address type.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/address_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_city" string NOT NULL OPTIONS (ANNOTATION 'City.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_company" string NOT NULL OPTIONS (ANNOTATION 'Company.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_country_id" string NOT NULL OPTIONS (ANNOTATION 'Country ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_customer_address_id" string NOT NULL OPTIONS (ANNOTATION 'Country address ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_email" string NOT NULL OPTIONS (ANNOTATION 'Email address.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/email', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Order address ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_fax" string NOT NULL OPTIONS (ANNOTATION 'Fax number.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_firstname" string NOT NULL OPTIONS (ANNOTATION 'First name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_lastname" string NOT NULL OPTIONS (ANNOTATION 'Last name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_middlename" string NOT NULL OPTIONS (ANNOTATION 'Middle name.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_postcode" string NOT NULL OPTIONS (ANNOTATION 'Postal code.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_prefix" string NOT NULL OPTIONS (ANNOTATION 'Prefix.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region" string NOT NULL OPTIONS (ANNOTATION 'Region.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region_code" string NOT NULL OPTIONS (ANNOTATION 'Region code.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region_id" string NOT NULL OPTIONS (ANNOTATION 'Region ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_street" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_suffix" string NOT NULL OPTIONS (ANNOTATION 'Suffix.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_telephone" string NOT NULL OPTIONS (ANNOTATION 'Telephone number.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_id" string NOT NULL OPTIONS (ANNOTATION 'VAT ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_is_valid" string NOT NULL OPTIONS (ANNOTATION 'VAT-is-valid flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_is_valid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_date" string NOT NULL OPTIONS (ANNOTATION 'VAT request date.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_date', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_id" string NOT NULL OPTIONS (ANNOTATION 'VAT request ID.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_success" string NOT NULL OPTIONS (ANNOTATION 'VAT-request-success flag value.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_success', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_method" string NOT NULL OPTIONS (ANNOTATION 'Shipping method', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/method', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_amount" string NOT NULL OPTIONS (ANNOTATION 'Base shipping amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_canceled" string NOT NULL OPTIONS (ANNOTATION 'Base shipping canceled.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Base shipping discount amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_discount_tax_compensation_amnt" string NOT NULL OPTIONS (ANNOTATION 'Base shipping discount tax compensation amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_discount_tax_compensation_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base shipping including tax.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base shipping invoiced.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base shipping refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base shipping tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base shipping tax refunded.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_amount" string NOT NULL OPTIONS (ANNOTATION 'Shipping amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_canceled" string NOT NULL OPTIONS (ANNOTATION 'Shipping canceled amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Shipping discount amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Shipping discount tax compensation amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Shipping including tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Shipping invoiced amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_refunded" string NOT NULL OPTIONS (ANNOTATION 'Shipping refunded amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Shipping tax amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Shipping tax refunded amount.', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_stock_id" string NOT NULL OPTIONS (ANNOTATION 'Stock id', NAMEINSOURCE 'entity/extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/stock_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_forced_shipment_with_invoice string NOT NULL OPTIONS (ANNOTATION 'Forced-shipment-with-invoice flag value.', NAMEINSOURCE 'entity/forced_shipment_with_invoice', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_global_currency_code string NOT NULL OPTIONS (ANNOTATION 'Global currency code.', NAMEINSOURCE 'entity/global_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_grand_total string NOT NULL OPTIONS (ANNOTATION 'Grand total.', NAMEINSOURCE 'entity/grand_total', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_hold_before_state string NOT NULL OPTIONS (ANNOTATION 'Hold before state.', NAMEINSOURCE 'entity/hold_before_state', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_hold_before_status string NOT NULL OPTIONS (ANNOTATION 'Hold before status.', NAMEINSOURCE 'entity/hold_before_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_increment_id string NOT NULL OPTIONS (ANNOTATION 'Increment ID.', NAMEINSOURCE 'entity/increment_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_is_virtual string NOT NULL OPTIONS (ANNOTATION 'Is-virtual flag value.', NAMEINSOURCE 'entity/is_virtual', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_additional_data" string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_applied_rule_ids" string NOT NULL OPTIONS (ANNOTATION 'Applied rule IDs.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/applied_rule_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_cost" string NOT NULL OPTIONS (ANNOTATION 'Base cost.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_cost', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_original_price" string NOT NULL OPTIONS (ANNOTATION 'Base original price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_price" string NOT NULL OPTIONS (ANNOTATION 'Base price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base price including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base row invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_row_total" string NOT NULL OPTIONS (ANNOTATION 'Base row total.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base row total including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Base tax before discount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base tax invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base tax refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied row amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_base_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax row disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/base_weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_percent" string NOT NULL OPTIONS (ANNOTATION 'Discount percent.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_tax_compensation_canceled" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation canceled.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_tax_compensation_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_event_id" string NOT NULL OPTIONS (ANNOTATION 'Event ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/event_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_ext_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'External order item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/ext_order_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_message" string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_free_shipping" string NOT NULL OPTIONS (ANNOTATION 'Free-shipping flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/free_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_base_price" string NOT NULL OPTIONS (ANNOTATION 'GW base price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_base_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base price invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_base_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_base_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base price refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_base_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_id" string NOT NULL OPTIONS (ANNOTATION 'GW ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_price" string NOT NULL OPTIONS (ANNOTATION 'GW price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW price invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW price refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_gw_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/gw_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_is_qty_decimal" string NOT NULL OPTIONS (ANNOTATION 'Is-quantity-decimal flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/is_qty_decimal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_is_virtual" string NOT NULL OPTIONS (ANNOTATION 'Is-virtual flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/is_virtual', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_item_id" string NOT NULL OPTIONS (ANNOTATION 'Item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_locked_do_invoice" string NOT NULL OPTIONS (ANNOTATION 'Locked DO invoice flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/locked_do_invoice', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_locked_do_ship" string NOT NULL OPTIONS (ANNOTATION 'Locked DO ship flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/locked_do_ship', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_name" string NOT NULL OPTIONS (ANNOTATION 'Name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_no_discount" string NOT NULL OPTIONS (ANNOTATION 'No-discount flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/no_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_order_id" string NOT NULL OPTIONS (ANNOTATION 'Order ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/order_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_original_price" string NOT NULL OPTIONS (ANNOTATION 'Original price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_additional_data" string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_applied_rule_ids" string NOT NULL OPTIONS (ANNOTATION 'Applied rule IDs.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/applied_rule_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_cost" string NOT NULL OPTIONS (ANNOTATION 'Base cost.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_cost', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base discount tax compensation refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_original_price" string NOT NULL OPTIONS (ANNOTATION 'Base original price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_price" string NOT NULL OPTIONS (ANNOTATION 'Base price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base price including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base row invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_row_total" string NOT NULL OPTIONS (ANNOTATION 'Base row total.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Base row total including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Base tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Base tax before discount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Base tax invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Base tax refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax applied row amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'Base WEEE tax row disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_percent" string NOT NULL OPTIONS (ANNOTATION 'Discount percent.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation canceled.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string NOT NULL OPTIONS (ANNOTATION 'Discount tax compensation refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_event_id" string NOT NULL OPTIONS (ANNOTATION 'Event ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/event_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_ext_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'External order item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/ext_order_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string NOT NULL OPTIONS (ANNOTATION 'Customer ID. Otherwise, null.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string NOT NULL OPTIONS (ANNOTATION 'Gift message ID. Otherwise, null.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string NOT NULL OPTIONS (ANNOTATION 'Message text.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string NOT NULL OPTIONS (ANNOTATION 'Recipient name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string NOT NULL OPTIONS (ANNOTATION 'Sender name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_free_shipping" string NOT NULL OPTIONS (ANNOTATION 'Free-shipping flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/free_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_base_price" string NOT NULL OPTIONS (ANNOTATION 'GW base price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_base_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base price invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base price refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW base tax amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_id" string NOT NULL OPTIONS (ANNOTATION 'GW ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_price" string NOT NULL OPTIONS (ANNOTATION 'GW price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW price invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_price_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW price refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_price_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string NOT NULL OPTIONS (ANNOTATION 'GW tax amount refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_is_qty_decimal" string NOT NULL OPTIONS (ANNOTATION 'Is-quantity-decimal flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/is_qty_decimal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_is_virtual" string NOT NULL OPTIONS (ANNOTATION 'Is-virtual flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/is_virtual', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_item_id" string NOT NULL OPTIONS (ANNOTATION 'Item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_locked_do_invoice" string NOT NULL OPTIONS (ANNOTATION 'Locked DO invoice flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/locked_do_invoice', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_locked_do_ship" string NOT NULL OPTIONS (ANNOTATION 'Locked DO ship flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/locked_do_ship', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_name" string NOT NULL OPTIONS (ANNOTATION 'Name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_no_discount" string NOT NULL OPTIONS (ANNOTATION 'No-discount flag value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/no_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_order_id" string NOT NULL OPTIONS (ANNOTATION 'Order ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/order_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_original_price" string NOT NULL OPTIONS (ANNOTATION 'Original price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/original_price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_parent_item_id" string NOT NULL OPTIONS (ANNOTATION 'Parent item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/parent_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_price" string NOT NULL OPTIONS (ANNOTATION 'Price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Price including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_id" string NOT NULL OPTIONS (ANNOTATION 'Product ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_product_type" string NOT NULL OPTIONS (ANNOTATION 'Product type.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_backordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity backordered.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_backordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_canceled" string NOT NULL OPTIONS (ANNOTATION 'Quantity canceled.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Quantity invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_ordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity ordered.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_refunded" string NOT NULL OPTIONS (ANNOTATION 'Quantity refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_returned" string NOT NULL OPTIONS (ANNOTATION 'Quantity returned.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_returned', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_qty_shipped" string NOT NULL OPTIONS (ANNOTATION 'Quantity shipped.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/qty_shipped', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_quote_item_id" string NOT NULL OPTIONS (ANNOTATION 'Quote item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/quote_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Row invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_row_total" string NOT NULL OPTIONS (ANNOTATION 'Row total.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Row total including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_row_weight" string NOT NULL OPTIONS (ANNOTATION 'Row weight.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/row_weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_parent_item_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Tax before discount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_tax_canceled" string NOT NULL OPTIONS (ANNOTATION 'Tax canceled.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/tax_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Tax invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_tax_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax percent.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/tax_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Tax refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_updated_at" string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_weee_tax_applied" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied row amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax row disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_weight" string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_parent_item_id" string NOT NULL OPTIONS (ANNOTATION 'Parent item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/parent_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_price_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Price including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/price_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_id" string NOT NULL OPTIONS (ANNOTATION 'Product ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Bundle option id.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string NOT NULL OPTIONS (ANNOTATION 'Bundle option quantity.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option SKU', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Item id', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card open amount value.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string NOT NULL OPTIONS (ANNOTATION 'Gift card amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string NOT NULL OPTIONS (ANNOTATION 'Giftcard message.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient email.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card recipient name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender email.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string NOT NULL OPTIONS (ANNOTATION 'Gift card sender name.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_product_type" string NOT NULL OPTIONS (ANNOTATION 'Product type.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/product_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_backordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity backordered.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_backordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_canceled" string NOT NULL OPTIONS (ANNOTATION 'Quantity canceled.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Quantity invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_ordered" string NOT NULL OPTIONS (ANNOTATION 'Quantity ordered.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_refunded" string NOT NULL OPTIONS (ANNOTATION 'Quantity refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_returned" string NOT NULL OPTIONS (ANNOTATION 'Quantity returned.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_returned', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_qty_shipped" string NOT NULL OPTIONS (ANNOTATION 'Quantity shipped.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/qty_shipped', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_quote_item_id" string NOT NULL OPTIONS (ANNOTATION 'Quote item ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/quote_item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_row_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Row invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/row_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_row_total" string NOT NULL OPTIONS (ANNOTATION 'Row total.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_row_total_incl_tax" string NOT NULL OPTIONS (ANNOTATION 'Row total including tax.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/row_total_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_row_weight" string NOT NULL OPTIONS (ANNOTATION 'Row weight.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/row_weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-order-item-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store ID.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_tax_amount" string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_tax_before_discount" string NOT NULL OPTIONS (ANNOTATION 'Tax before discount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/tax_before_discount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_tax_canceled" string NOT NULL OPTIONS (ANNOTATION 'Tax canceled.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/tax_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_tax_invoiced" string NOT NULL OPTIONS (ANNOTATION 'Tax invoiced.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_tax_percent" string NOT NULL OPTIONS (ANNOTATION 'Tax percent.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/tax_percent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_tax_refunded" string NOT NULL OPTIONS (ANNOTATION 'Tax refunded.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_updated_at" string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_weee_tax_applied" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/weee_tax_applied', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_weee_tax_applied_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/weee_tax_applied_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_weee_tax_applied_row_amount" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax applied row amount.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/weee_tax_applied_row_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_weee_tax_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/weee_tax_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_weee_tax_row_disposition" string NOT NULL OPTIONS (ANNOTATION 'WEEE tax row disposition.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/weee_tax_row_disposition', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-order-item-interface_weight" string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/items[]/sales-data-order-item-interface/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_order_currency_code string NOT NULL OPTIONS (ANNOTATION 'Order currency code.', NAMEINSOURCE 'entity/order_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_original_increment_id string NOT NULL OPTIONS (ANNOTATION 'Original increment ID.', NAMEINSOURCE 'entity/original_increment_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_account_status string NOT NULL OPTIONS (ANNOTATION 'Account status.', NAMEINSOURCE 'entity/payment/account_status', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_additional_data string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/payment/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_additional_information string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/payment/additional_information', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_address_status string NOT NULL OPTIONS (ANNOTATION 'Address status.', NAMEINSOURCE 'entity/payment/address_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_amount_authorized string NOT NULL OPTIONS (ANNOTATION 'Amount authorized.', NAMEINSOURCE 'entity/payment/amount_authorized', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_amount_canceled string NOT NULL OPTIONS (ANNOTATION 'Amount canceled.', NAMEINSOURCE 'entity/payment/amount_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_amount_ordered string NOT NULL OPTIONS (ANNOTATION 'Amount ordered.', NAMEINSOURCE 'entity/payment/amount_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_amount_paid string NOT NULL OPTIONS (ANNOTATION 'Amount paid.', NAMEINSOURCE 'entity/payment/amount_paid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_amount_refunded string NOT NULL OPTIONS (ANNOTATION 'Amount refunded.', NAMEINSOURCE 'entity/payment/amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_anet_trans_method string NOT NULL OPTIONS (ANNOTATION 'Anet transaction method.', NAMEINSOURCE 'entity/payment/anet_trans_method', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_authorized string NOT NULL OPTIONS (ANNOTATION 'Base amount authorized.', NAMEINSOURCE 'entity/payment/base_amount_authorized', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_canceled string NOT NULL OPTIONS (ANNOTATION 'Base amount canceled.', NAMEINSOURCE 'entity/payment/base_amount_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_ordered string NOT NULL OPTIONS (ANNOTATION 'Base amount ordered.', NAMEINSOURCE 'entity/payment/base_amount_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_paid string NOT NULL OPTIONS (ANNOTATION 'Base amount paid.', NAMEINSOURCE 'entity/payment/base_amount_paid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_paid_online string NOT NULL OPTIONS (ANNOTATION 'Base amount paid online.', NAMEINSOURCE 'entity/payment/base_amount_paid_online', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_refunded string NOT NULL OPTIONS (ANNOTATION 'Base amount refunded.', NAMEINSOURCE 'entity/payment/base_amount_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_amount_refunded_online string NOT NULL OPTIONS (ANNOTATION 'Base amount refunded online.', NAMEINSOURCE 'entity/payment/base_amount_refunded_online', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Base shipping amount.', NAMEINSOURCE 'entity/payment/base_shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_shipping_captured string NOT NULL OPTIONS (ANNOTATION 'Base shipping captured amount.', NAMEINSOURCE 'entity/payment/base_shipping_captured', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_base_shipping_refunded string NOT NULL OPTIONS (ANNOTATION 'Base shipping refunded amount.', NAMEINSOURCE 'entity/payment/base_shipping_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_approval string NOT NULL OPTIONS (ANNOTATION 'Credit card approval.', NAMEINSOURCE 'entity/payment/cc_approval', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_avs_status string NOT NULL OPTIONS (ANNOTATION 'Credit card avs status.', NAMEINSOURCE 'entity/payment/cc_avs_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_cid_status string NOT NULL OPTIONS (ANNOTATION 'Credit card CID status.', NAMEINSOURCE 'entity/payment/cc_cid_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_debug_request_body string NOT NULL OPTIONS (ANNOTATION 'Credit card debug request body.', NAMEINSOURCE 'entity/payment/cc_debug_request_body', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_debug_response_body string NOT NULL OPTIONS (ANNOTATION 'Credit card debug response body.', NAMEINSOURCE 'entity/payment/cc_debug_response_body', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_debug_response_serialized string NOT NULL OPTIONS (ANNOTATION 'Credit card debug response serialized.', NAMEINSOURCE 'entity/payment/cc_debug_response_serialized', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_exp_month string NOT NULL OPTIONS (ANNOTATION 'Credit card expiration month.', NAMEINSOURCE 'entity/payment/cc_exp_month', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_exp_year string NOT NULL OPTIONS (ANNOTATION 'Credit card expiration year.', NAMEINSOURCE 'entity/payment/cc_exp_year', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_last4 string NOT NULL OPTIONS (ANNOTATION 'Last four digits of the credit card.', NAMEINSOURCE 'entity/payment/cc_last4', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_cc_number_enc string NOT NULL OPTIONS (ANNOTATION 'Encrypted credit card number.', NAMEINSOURCE 'entity/payment/cc_number_enc', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_owner string NOT NULL OPTIONS (ANNOTATION 'Credit card number.', NAMEINSOURCE 'entity/payment/cc_owner', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_secure_verify string NOT NULL OPTIONS (ANNOTATION 'Credit card secure verify.', NAMEINSOURCE 'entity/payment/cc_secure_verify', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_ss_issue string NOT NULL OPTIONS (ANNOTATION 'Credit card SS issue.', NAMEINSOURCE 'entity/payment/cc_ss_issue', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_ss_start_month string NOT NULL OPTIONS (ANNOTATION 'Credit card SS start month.', NAMEINSOURCE 'entity/payment/cc_ss_start_month', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_ss_start_year string NOT NULL OPTIONS (ANNOTATION 'Credit card SS start year.', NAMEINSOURCE 'entity/payment/cc_ss_start_year', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_status string NOT NULL OPTIONS (ANNOTATION 'Credit card status.', NAMEINSOURCE 'entity/payment/cc_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_status_description string NOT NULL OPTIONS (ANNOTATION 'Credit card status description.', NAMEINSOURCE 'entity/payment/cc_status_description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_trans_id string NOT NULL OPTIONS (ANNOTATION 'Credit card transaction ID.', NAMEINSOURCE 'entity/payment/cc_trans_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_cc_type string NOT NULL OPTIONS (ANNOTATION 'Credit card type.', NAMEINSOURCE 'entity/payment/cc_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_echeck_account_name string NOT NULL OPTIONS (ANNOTATION 'eCheck account name.', NAMEINSOURCE 'entity/payment/echeck_account_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_echeck_account_type string NOT NULL OPTIONS (ANNOTATION 'eCheck account type.', NAMEINSOURCE 'entity/payment/echeck_account_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_echeck_bank_name string NOT NULL OPTIONS (ANNOTATION 'eCheck bank name.', NAMEINSOURCE 'entity/payment/echeck_bank_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_echeck_routing_number string NOT NULL OPTIONS (ANNOTATION 'eCheck routing number.', NAMEINSOURCE 'entity/payment/echeck_routing_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_echeck_type string NOT NULL OPTIONS (ANNOTATION 'eCheck type.', NAMEINSOURCE 'entity/payment/echeck_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_entity_id string NOT NULL OPTIONS (ANNOTATION 'Entity ID.', NAMEINSOURCE 'entity/payment/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_extension_attributes_vault_payment_token_created_at string NOT NULL OPTIONS (ANNOTATION 'Token creation timestamp', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_extension_attributes_vault_payment_token_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID.', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_extension_attributes_vault_payment_token_entity_id string NOT NULL OPTIONS (ANNOTATION 'Entity ID.', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_extension_attributes_vault_payment_token_expires_at string NOT NULL OPTIONS (ANNOTATION 'Token expiration timestamp', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/expires_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_extension_attributes_vault_payment_token_gateway_token string NOT NULL OPTIONS (ANNOTATION 'Gateway token ID', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/gateway_token', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_extension_attributes_vault_payment_token_is_active boolean NOT NULL OPTIONS (ANNOTATION 'Is active.', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/is_active', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_extension_attributes_vault_payment_token_is_visible boolean NOT NULL OPTIONS (ANNOTATION 'Is visible.', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/is_visible', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_extension_attributes_vault_payment_token_payment_method_code string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/payment_method_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_extension_attributes_vault_payment_token_public_hash string NOT NULL OPTIONS (ANNOTATION 'Public hash', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/public_hash', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_extension_attributes_vault_payment_token_token_details string NOT NULL OPTIONS (ANNOTATION 'Token details', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/token_details', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_extension_attributes_vault_payment_token_type string NOT NULL OPTIONS (ANNOTATION 'Type', NAMEINSOURCE 'entity/payment/extension_attributes/vault_payment_token/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_last_trans_id string NOT NULL OPTIONS (ANNOTATION 'Last transaction ID.', NAMEINSOURCE 'entity/payment/last_trans_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_method string NOT NULL OPTIONS (ANNOTATION 'Method.', NAMEINSOURCE 'entity/payment/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_payment_parent_id string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/payment/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_po_number string NOT NULL OPTIONS (ANNOTATION 'PO number.', NAMEINSOURCE 'entity/payment/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_protection_eligibility string NOT NULL OPTIONS (ANNOTATION 'Protection eligibility.', NAMEINSOURCE 'entity/payment/protection_eligibility', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_quote_payment_id string NOT NULL OPTIONS (ANNOTATION 'Quote payment ID.', NAMEINSOURCE 'entity/payment/quote_payment_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping amount.', NAMEINSOURCE 'entity/payment/shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_shipping_captured string NOT NULL OPTIONS (ANNOTATION 'Shipping captured.', NAMEINSOURCE 'entity/payment/shipping_captured', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_shipping_refunded string NOT NULL OPTIONS (ANNOTATION 'Shipping refunded.', NAMEINSOURCE 'entity/payment/shipping_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_auth_expiration string NOT NULL OPTIONS (ANNOTATION 'Payment authorization expiration date.', NAMEINSOURCE 'entity/payment_auth_expiration', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_payment_authorization_amount string NOT NULL OPTIONS (ANNOTATION 'Payment authorization amount.', NAMEINSOURCE 'entity/payment_authorization_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_protect_code string NOT NULL OPTIONS (ANNOTATION 'Protect code.', NAMEINSOURCE 'entity/protect_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_quote_address_id string NOT NULL OPTIONS (ANNOTATION 'Quote address ID.', NAMEINSOURCE 'entity/quote_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_quote_id string NOT NULL OPTIONS (ANNOTATION 'Quote ID.', NAMEINSOURCE 'entity/quote_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_relation_child_id string NOT NULL OPTIONS (ANNOTATION 'Relation child ID.', NAMEINSOURCE 'entity/relation_child_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_relation_child_real_id string NOT NULL OPTIONS (ANNOTATION 'Relation child real ID.', NAMEINSOURCE 'entity/relation_child_real_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_relation_parent_id string NOT NULL OPTIONS (ANNOTATION 'Relation parent ID.', NAMEINSOURCE 'entity/relation_parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_relation_parent_real_id string NOT NULL OPTIONS (ANNOTATION 'Relation parent real ID.', NAMEINSOURCE 'entity/relation_parent_real_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_remote_ip string NOT NULL OPTIONS (ANNOTATION 'Remote IP address.', NAMEINSOURCE 'entity/remote_ip', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping amount.', NAMEINSOURCE 'entity/shipping_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_canceled string NOT NULL OPTIONS (ANNOTATION 'Shipping canceled amount.', NAMEINSOURCE 'entity/shipping_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_description string NOT NULL OPTIONS (ANNOTATION 'Shipping description.', NAMEINSOURCE 'entity/shipping_description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping discount amount.', NAMEINSOURCE 'entity/shipping_discount_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_discount_tax_compensation_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping discount tax compensation amount.', NAMEINSOURCE 'entity/shipping_discount_tax_compensation_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Shipping including tax amount.', NAMEINSOURCE 'entity/shipping_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_invoiced string NOT NULL OPTIONS (ANNOTATION 'Shipping invoiced amount.', NAMEINSOURCE 'entity/shipping_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_refunded string NOT NULL OPTIONS (ANNOTATION 'Shipping refunded amount.', NAMEINSOURCE 'entity/shipping_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Shipping tax amount.', NAMEINSOURCE 'entity/shipping_tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_tax_refunded string NOT NULL OPTIONS (ANNOTATION 'Shipping tax refunded amount.', NAMEINSOURCE 'entity/shipping_tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_state string NOT NULL OPTIONS (ANNOTATION 'State.', NAMEINSOURCE 'entity/state', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_status string NOT NULL OPTIONS (ANNOTATION 'Status.', NAMEINSOURCE 'entity/status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_status_histories_sales-data-order-status-history-interface_comment" string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_status_histories_sales-data-order-status-history-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_status_histories_sales-data-order-status-history-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Order status history ID.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_status_histories_sales-data-order-status-history-interface_entity_name" string NOT NULL OPTIONS (ANNOTATION 'Entity name.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/entity_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_status_histories_sales-data-order-status-history-interface_is_customer_notified" string NOT NULL OPTIONS (ANNOTATION 'Is-customer-notified flag value.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/is_customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_status_histories_sales-data-order-status-history-interface_is_visible_on_front" string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_status_histories_sales-data-order-status-history-interface_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/parent_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_status_histories_sales-data-order-status-history-interface_status" string NOT NULL OPTIONS (ANNOTATION 'Status.', NAMEINSOURCE 'entity/status_histories[]/sales-data-order-status-history-interface/status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_currency_code string NOT NULL OPTIONS (ANNOTATION 'Store currency code.', NAMEINSOURCE 'entity/store_currency_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_id string NOT NULL OPTIONS (ANNOTATION 'Store ID.', NAMEINSOURCE 'entity/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_name string NOT NULL OPTIONS (ANNOTATION 'Store name.', NAMEINSOURCE 'entity/store_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_to_base_rate string NOT NULL OPTIONS (ANNOTATION 'Store-to-base rate.', NAMEINSOURCE 'entity/store_to_base_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_to_order_rate string NOT NULL OPTIONS (ANNOTATION 'Store-to-order rate.', NAMEINSOURCE 'entity/store_to_order_rate', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal string NOT NULL OPTIONS (ANNOTATION 'Subtotal.', NAMEINSOURCE 'entity/subtotal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal_canceled string NOT NULL OPTIONS (ANNOTATION 'Subtotal canceled amount.', NAMEINSOURCE 'entity/subtotal_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal_incl_tax string NOT NULL OPTIONS (ANNOTATION 'Subtotal including tax amount.', NAMEINSOURCE 'entity/subtotal_incl_tax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal_invoiced string NOT NULL OPTIONS (ANNOTATION 'Subtotal invoiced amount.', NAMEINSOURCE 'entity/subtotal_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_subtotal_refunded string NOT NULL OPTIONS (ANNOTATION 'Subtotal refunded amount.', NAMEINSOURCE 'entity/subtotal_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_tax_amount string NOT NULL OPTIONS (ANNOTATION 'Tax amount.', NAMEINSOURCE 'entity/tax_amount', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_tax_canceled string NOT NULL OPTIONS (ANNOTATION 'Tax canceled amount.', NAMEINSOURCE 'entity/tax_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_tax_invoiced string NOT NULL OPTIONS (ANNOTATION 'Tax invoiced amount.', NAMEINSOURCE 'entity/tax_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_tax_refunded string NOT NULL OPTIONS (ANNOTATION 'Tax refunded amount.', NAMEINSOURCE 'entity/tax_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_canceled string NOT NULL OPTIONS (ANNOTATION 'Total canceled.', NAMEINSOURCE 'entity/total_canceled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_due string NOT NULL OPTIONS (ANNOTATION 'Total due.', NAMEINSOURCE 'entity/total_due', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_invoiced string NOT NULL OPTIONS (ANNOTATION 'Total invoiced amount.', NAMEINSOURCE 'entity/total_invoiced', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_item_count string NOT NULL OPTIONS (ANNOTATION 'Total item count.', NAMEINSOURCE 'entity/total_item_count', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_offline_refunded string NOT NULL OPTIONS (ANNOTATION 'Total offline refunded amount.', NAMEINSOURCE 'entity/total_offline_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_online_refunded string NOT NULL OPTIONS (ANNOTATION 'Total online refunded amount.', NAMEINSOURCE 'entity/total_online_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_paid string NOT NULL OPTIONS (ANNOTATION 'Total paid.', NAMEINSOURCE 'entity/total_paid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_qty_ordered string NOT NULL OPTIONS (ANNOTATION 'Total quantity ordered.', NAMEINSOURCE 'entity/total_qty_ordered', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_refunded string NOT NULL OPTIONS (ANNOTATION 'Total amount refunded.', NAMEINSOURCE 'entity/total_refunded', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_weight string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_x_forwarded_for string NOT NULL OPTIONS (ANNOTATION 'X-Forwarded-For field value.', NAMEINSOURCE 'entity/x_forwarded_for', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (adjustment_negative string, adjustment_positive string, applied_rule_ids string, base_adjustment_negative string, base_adjustment_positive string, base_currency_code string, base_discount_amount string, base_discount_canceled string, base_discount_invoiced string, base_discount_refunded string, base_discount_tax_compensation_amount string, base_discount_tax_compensation_invoiced string, base_discount_tax_compensation_refunded string, base_grand_total string, base_shipping_amount string, base_shipping_canceled string, base_shipping_discount_amount string, base_shipping_discount_tax_compensation_amnt string, base_shipping_incl_tax string, base_shipping_invoiced string, base_shipping_refunded string, base_shipping_tax_amount string, base_shipping_tax_refunded string, base_subtotal string, base_subtotal_canceled string, base_subtotal_incl_tax string, base_subtotal_invoiced string, base_subtotal_refunded string, base_tax_amount string, base_tax_canceled string, base_tax_invoiced string, base_tax_refunded string, base_to_global_rate string, base_to_order_rate string, base_total_canceled string, base_total_due string, base_total_invoiced string, base_total_invoiced_cost string, base_total_offline_refunded string, base_total_online_refunded string, base_total_paid string, base_total_qty_ordered string, base_total_refunded string, billing_address_address_type string OPTIONS (NAMEINSOURCE 'billing_address/address_type'), billing_address_city string OPTIONS (NAMEINSOURCE 'billing_address/city'), billing_address_company string OPTIONS (NAMEINSOURCE 'billing_address/company'), billing_address_country_id string OPTIONS (NAMEINSOURCE 'billing_address/country_id'), billing_address_customer_address_id string OPTIONS (NAMEINSOURCE 'billing_address/customer_address_id'), billing_address_customer_id string OPTIONS (NAMEINSOURCE 'billing_address/customer_id'), billing_address_email string OPTIONS (NAMEINSOURCE 'billing_address/email'), billing_address_entity_id string OPTIONS (NAMEINSOURCE 'billing_address/entity_id'), billing_address_fax string OPTIONS (NAMEINSOURCE 'billing_address/fax'), billing_address_firstname string OPTIONS (NAMEINSOURCE 'billing_address/firstname'), billing_address_lastname string OPTIONS (NAMEINSOURCE 'billing_address/lastname'), billing_address_middlename string OPTIONS (NAMEINSOURCE 'billing_address/middlename'), billing_address_parent_id string OPTIONS (NAMEINSOURCE 'billing_address/parent_id'), billing_address_postcode string OPTIONS (NAMEINSOURCE 'billing_address/postcode'), billing_address_prefix string OPTIONS (NAMEINSOURCE 'billing_address/prefix'), billing_address_region string OPTIONS (NAMEINSOURCE 'billing_address/region'), billing_address_region_code string OPTIONS (NAMEINSOURCE 'billing_address/region_code'), billing_address_region_id string OPTIONS (NAMEINSOURCE 'billing_address/region_id'), billing_address_street string[] OPTIONS (NAMEINSOURCE 'billing_address/street'), billing_address_suffix string OPTIONS (NAMEINSOURCE 'billing_address/suffix'), billing_address_telephone string OPTIONS (NAMEINSOURCE 'billing_address/telephone'), billing_address_vat_id string OPTIONS (NAMEINSOURCE 'billing_address/vat_id'), billing_address_vat_is_valid string OPTIONS (NAMEINSOURCE 'billing_address/vat_is_valid'), billing_address_vat_request_date string OPTIONS (NAMEINSOURCE 'billing_address/vat_request_date'), billing_address_vat_request_id string OPTIONS (NAMEINSOURCE 'billing_address/vat_request_id'), billing_address_vat_request_success string OPTIONS (NAMEINSOURCE 'billing_address/vat_request_success'), billing_address_id string, can_ship_partially string, can_ship_partially_item string, coupon_code string, created_at string, customer_dob string, customer_email string, customer_firstname string, customer_gender string, customer_group_id string, customer_id string, customer_is_guest string, customer_lastname string, customer_middlename string, customer_note string, customer_note_notify string, customer_prefix string, customer_suffix string, customer_taxvat string, discount_amount string, discount_canceled string, discount_description string, discount_invoiced string, discount_refunded string, discount_tax_compensation_amount string, discount_tax_compensation_invoiced string, discount_tax_compensation_refunded string, edit_increment string, email_sent string, entity_id string, ext_customer_id string, ext_order_id string, "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/amount'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_base_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/base_amount'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/code'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/code'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/percent'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/title'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/percent'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/title'), extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_converting_from_quote boolean OPTIONS (NAMEINSOURCE 'extension_attributes/converting_from_quote'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_gift_message_customer_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/customer_id'), extension_attributes_gift_message_extension_attributes_entity_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/entity_id'), extension_attributes_gift_message_extension_attributes_entity_type string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/entity_type'), extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card boolean OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt boolean OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), extension_attributes_gift_message_extension_attributes_wrapping_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/wrapping_id'), extension_attributes_gift_message_gift_message_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/gift_message_id'), extension_attributes_gift_message_message string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/message'), extension_attributes_gift_message_recipient string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/recipient'), extension_attributes_gift_message_sender string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/sender'), extension_attributes_gw_add_card string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_add_card'), extension_attributes_gw_allow_gift_receipt string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_allow_gift_receipt'), extension_attributes_gw_base_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_base_price'), extension_attributes_gw_base_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_base_price_incl_tax'), extension_attributes_gw_base_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_base_tax_amount'), extension_attributes_gw_card_base_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_base_price'), extension_attributes_gw_card_base_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_base_price_incl_tax'), extension_attributes_gw_card_base_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_base_tax_amount'), extension_attributes_gw_card_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_price'), extension_attributes_gw_card_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_price_incl_tax'), extension_attributes_gw_card_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_tax_amount'), extension_attributes_gw_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_id'), extension_attributes_gw_items_base_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_base_price'), extension_attributes_gw_items_base_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_base_price_incl_tax'), extension_attributes_gw_items_base_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_base_tax_amount'), extension_attributes_gw_items_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_price'), extension_attributes_gw_items_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_price_incl_tax'), extension_attributes_gw_items_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_tax_amount'), extension_attributes_gw_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_price'), extension_attributes_gw_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_price_incl_tax'), extension_attributes_gw_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_tax_amount'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/amount'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_base_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/base_amount'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/code'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/code'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/percent'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/title'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/percent'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/title'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_associated_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/associated_item_id'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/item_id'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/additional_data'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/applied_rule_ids'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_cost'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_original_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_original_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_price_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_total'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_total_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_before_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_row_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_created_at" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/created_at'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_description" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/description'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_percent'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_event_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/event_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/ext_order_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/message'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_free_shipping" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/free_shipping'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/is_qty_decimal'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_is_virtual" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/is_virtual'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/locked_do_invoice'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_locked_do_ship" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/locked_do_ship'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_no_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/no_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_order_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/order_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_original_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/original_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_additional_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/additional_data'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/applied_rule_ids'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_cost" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_cost'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_original_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_original_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_total" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_created_at" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/created_at'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_description" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/description'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_percent'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_event_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/event_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/ext_order_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_free_shipping" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/free_shipping'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/is_qty_decimal'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_is_virtual" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/is_virtual'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_invoice'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_locked_do_ship" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_ship'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_no_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/no_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_order_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/order_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_original_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/original_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_parent_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/parent_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_price_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/price_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_backordered" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_backordered'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_ordered" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_ordered'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_returned" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_returned'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_shipped" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_shipped'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_quote_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/quote_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_total" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_total'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_weight" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_weight'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/sku'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_store_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/store_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_before_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_before_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_percent'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_updated_at" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/updated_at'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weight" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weight'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/price_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_backordered" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_backordered'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_ordered" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_ordered'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_returned'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_shipped" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_shipped'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_quote_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/quote_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_total'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_total_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_weight" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_weight'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/sku'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_store_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/store_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_before_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_before_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_percent'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_updated_at" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/updated_at'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied_row_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_row_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weight" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weight'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_address_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/address_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_city" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/city'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_company" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/company'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_country_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/country_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_customer_address_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/customer_address_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_customer_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/customer_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_entity_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/entity_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_fax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/fax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_firstname" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/firstname'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_lastname" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/lastname'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_middlename" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/middlename'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_parent_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/parent_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_postcode" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/postcode'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_prefix" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/prefix'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region_code'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_street" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/street'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_suffix" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/suffix'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_telephone" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/telephone'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_is_valid" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_is_valid'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_date" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_date'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_success" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_success'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_method" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/method'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_discount_tax_compensation_amnt" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_discount_tax_compensation_amnt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_stock_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/stock_id'), forced_shipment_with_invoice string, global_currency_code string, grand_total string, hold_before_state string, hold_before_status string, increment_id string, is_virtual string, "items_sales-data-order-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/additional_data'), "items_sales-data-order-item-interface_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/amount_refunded'), "items_sales-data-order-item-interface_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/applied_rule_ids'), "items_sales-data-order-item-interface_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_amount_refunded'), "items_sales-data-order-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_cost'), "items_sales-data-order-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_amount'), "items_sales-data-order-item-interface_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_invoiced'), "items_sales-data-order-item-interface_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_refunded'), "items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_base_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_original_price'), "items_sales-data-order-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_price'), "items_sales-data-order-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_price_incl_tax'), "items_sales-data-order-item-interface_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_row_invoiced'), "items_sales-data-order-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_row_total'), "items_sales-data-order-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_row_total_incl_tax'), "items_sales-data-order-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_amount'), "items_sales-data-order-item-interface_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_before_discount'), "items_sales-data-order-item-interface_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_invoiced'), "items_sales-data-order-item-interface_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_refunded'), "items_sales-data-order-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_applied_amount'), "items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt'), "items_sales-data-order-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_disposition'), "items_sales-data-order-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_row_disposition'), "items_sales-data-order-item-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/created_at'), "items_sales-data-order-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/description'), "items_sales-data-order-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_amount'), "items_sales-data-order-item-interface_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_invoiced'), "items_sales-data-order-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_percent'), "items_sales-data-order-item-interface_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_refunded'), "items_sales-data-order-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_amount'), "items_sales-data-order-item-interface_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_canceled'), "items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_event_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/event_id'), "items_sales-data-order-item-interface_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/ext_order_item_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/message'), "items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient'), "items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender'), "items_sales-data-order-item-interface_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/free_shipping'), "items_sales-data-order-item-interface_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_price'), "items_sales-data-order-item-interface_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_price_invoiced'), "items_sales-data-order-item-interface_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_price_refunded'), "items_sales-data-order-item-interface_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_tax_amount'), "items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced'), "items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded'), "items_sales-data-order-item-interface_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_id'), "items_sales-data-order-item-interface_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_price'), "items_sales-data-order-item-interface_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_price_invoiced'), "items_sales-data-order-item-interface_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_price_refunded'), "items_sales-data-order-item-interface_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_tax_amount'), "items_sales-data-order-item-interface_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_tax_amount_invoiced'), "items_sales-data-order-item-interface_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_tax_amount_refunded'), "items_sales-data-order-item-interface_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/is_qty_decimal'), "items_sales-data-order-item-interface_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/is_virtual'), "items_sales-data-order-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/item_id'), "items_sales-data-order-item-interface_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/locked_do_invoice'), "items_sales-data-order-item-interface_locked_do_ship" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/locked_do_ship'), "items_sales-data-order-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/name'), "items_sales-data-order-item-interface_no_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/no_discount'), "items_sales-data-order-item-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/order_id'), "items_sales-data-order-item-interface_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/original_price'), "items_sales-data-order-item-interface_parent_item_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/additional_data'), "items_sales-data-order-item-interface_parent_item_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/amount_refunded'), "items_sales-data-order-item-interface_parent_item_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/applied_rule_ids'), "items_sales-data-order-item-interface_parent_item_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_amount_refunded'), "items_sales-data-order-item-interface_parent_item_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_cost'), "items_sales-data-order-item-interface_parent_item_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_amount'), "items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced'), "items_sales-data-order-item-interface_parent_item_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_refunded'), "items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount'), "items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_parent_item_base_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_original_price'), "items_sales-data-order-item-interface_parent_item_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_price'), "items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax'), "items_sales-data-order-item-interface_parent_item_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_row_invoiced'), "items_sales-data-order-item-interface_parent_item_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_row_total'), "items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax'), "items_sales-data-order-item-interface_parent_item_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_amount'), "items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount'), "items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced'), "items_sales-data-order-item-interface_parent_item_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_refunded'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition'), "items_sales-data-order-item-interface_parent_item_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/created_at'), "items_sales-data-order-item-interface_parent_item_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/description'), "items_sales-data-order-item-interface_parent_item_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_amount'), "items_sales-data-order-item-interface_parent_item_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_invoiced'), "items_sales-data-order-item-interface_parent_item_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_percent'), "items_sales-data-order-item-interface_parent_item_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_refunded'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_parent_item_event_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/event_id'), "items_sales-data-order-item-interface_parent_item_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/ext_order_item_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender'), "items_sales-data-order-item-interface_parent_item_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/free_shipping'), "items_sales-data-order-item-interface_parent_item_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_price'), "items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded'), "items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount'), "items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded'), "items_sales-data-order-item-interface_parent_item_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_id'), "items_sales-data-order-item-interface_parent_item_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_price'), "items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_price_refunded'), "items_sales-data-order-item-interface_parent_item_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_tax_amount'), "items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded'), "items_sales-data-order-item-interface_parent_item_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/is_qty_decimal'), "items_sales-data-order-item-interface_parent_item_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/is_virtual'), "items_sales-data-order-item-interface_parent_item_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/item_id'), "items_sales-data-order-item-interface_parent_item_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/locked_do_invoice'), "items_sales-data-order-item-interface_parent_item_locked_do_ship" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/locked_do_ship'), "items_sales-data-order-item-interface_parent_item_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/name'), "items_sales-data-order-item-interface_parent_item_no_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/no_discount'), "items_sales-data-order-item-interface_parent_item_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/order_id'), "items_sales-data-order-item-interface_parent_item_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/original_price'), "items_sales-data-order-item-interface_parent_item_parent_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/parent_item_id'), "items_sales-data-order-item-interface_parent_item_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/price'), "items_sales-data-order-item-interface_parent_item_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/price_incl_tax'), "items_sales-data-order-item-interface_parent_item_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_sales-data-order-item-interface_parent_item_product_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_type'), "items_sales-data-order-item-interface_parent_item_qty_backordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_backordered'), "items_sales-data-order-item-interface_parent_item_qty_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_canceled'), "items_sales-data-order-item-interface_parent_item_qty_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_invoiced'), "items_sales-data-order-item-interface_parent_item_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_ordered'), "items_sales-data-order-item-interface_parent_item_qty_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_refunded'), "items_sales-data-order-item-interface_parent_item_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_returned'), "items_sales-data-order-item-interface_parent_item_qty_shipped" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_shipped'), "items_sales-data-order-item-interface_parent_item_quote_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/quote_item_id'), "items_sales-data-order-item-interface_parent_item_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_invoiced'), "items_sales-data-order-item-interface_parent_item_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_total'), "items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax'), "items_sales-data-order-item-interface_parent_item_row_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_weight'), "items_sales-data-order-item-interface_parent_item_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/sku'), "items_sales-data-order-item-interface_parent_item_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/store_id'), "items_sales-data-order-item-interface_parent_item_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_amount'), "items_sales-data-order-item-interface_parent_item_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_before_discount'), "items_sales-data-order-item-interface_parent_item_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_canceled'), "items_sales-data-order-item-interface_parent_item_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_invoiced'), "items_sales-data-order-item-interface_parent_item_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_percent'), "items_sales-data-order-item-interface_parent_item_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_refunded'), "items_sales-data-order-item-interface_parent_item_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/updated_at'), "items_sales-data-order-item-interface_parent_item_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_applied'), "items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount'), "items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount'), "items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition'), "items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition'), "items_sales-data-order-item-interface_parent_item_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weight'), "items_sales-data-order-item-interface_parent_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item_id'), "items_sales-data-order-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/price'), "items_sales-data-order-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/price_incl_tax'), "items_sales-data-order-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_sales-data-order-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_type'), "items_sales-data-order-item-interface_qty_backordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_backordered'), "items_sales-data-order-item-interface_qty_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_canceled'), "items_sales-data-order-item-interface_qty_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_invoiced'), "items_sales-data-order-item-interface_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_ordered'), "items_sales-data-order-item-interface_qty_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_refunded'), "items_sales-data-order-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_returned'), "items_sales-data-order-item-interface_qty_shipped" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_shipped'), "items_sales-data-order-item-interface_quote_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/quote_item_id'), "items_sales-data-order-item-interface_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_invoiced'), "items_sales-data-order-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_total'), "items_sales-data-order-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_total_incl_tax'), "items_sales-data-order-item-interface_row_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_weight'), "items_sales-data-order-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/sku'), "items_sales-data-order-item-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/store_id'), "items_sales-data-order-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_amount'), "items_sales-data-order-item-interface_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_before_discount'), "items_sales-data-order-item-interface_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_canceled'), "items_sales-data-order-item-interface_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_invoiced'), "items_sales-data-order-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_percent'), "items_sales-data-order-item-interface_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_refunded'), "items_sales-data-order-item-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/updated_at'), "items_sales-data-order-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_applied'), "items_sales-data-order-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_applied_amount'), "items_sales-data-order-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_applied_row_amount'), "items_sales-data-order-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_disposition'), "items_sales-data-order-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_row_disposition'), "items_sales-data-order-item-interface_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weight'), order_currency_code string, original_increment_id string, payment_account_status string OPTIONS (NAMEINSOURCE 'payment/account_status'), payment_additional_data string OPTIONS (NAMEINSOURCE 'payment/additional_data'), payment_additional_information string[] OPTIONS (NAMEINSOURCE 'payment/additional_information'), payment_address_status string OPTIONS (NAMEINSOURCE 'payment/address_status'), payment_amount_authorized string OPTIONS (NAMEINSOURCE 'payment/amount_authorized'), payment_amount_canceled string OPTIONS (NAMEINSOURCE 'payment/amount_canceled'), payment_amount_ordered string OPTIONS (NAMEINSOURCE 'payment/amount_ordered'), payment_amount_paid string OPTIONS (NAMEINSOURCE 'payment/amount_paid'), payment_amount_refunded string OPTIONS (NAMEINSOURCE 'payment/amount_refunded'), payment_anet_trans_method string OPTIONS (NAMEINSOURCE 'payment/anet_trans_method'), payment_base_amount_authorized string OPTIONS (NAMEINSOURCE 'payment/base_amount_authorized'), payment_base_amount_canceled string OPTIONS (NAMEINSOURCE 'payment/base_amount_canceled'), payment_base_amount_ordered string OPTIONS (NAMEINSOURCE 'payment/base_amount_ordered'), payment_base_amount_paid string OPTIONS (NAMEINSOURCE 'payment/base_amount_paid'), payment_base_amount_paid_online string OPTIONS (NAMEINSOURCE 'payment/base_amount_paid_online'), payment_base_amount_refunded string OPTIONS (NAMEINSOURCE 'payment/base_amount_refunded'), payment_base_amount_refunded_online string OPTIONS (NAMEINSOURCE 'payment/base_amount_refunded_online'), payment_base_shipping_amount string OPTIONS (NAMEINSOURCE 'payment/base_shipping_amount'), payment_base_shipping_captured string OPTIONS (NAMEINSOURCE 'payment/base_shipping_captured'), payment_base_shipping_refunded string OPTIONS (NAMEINSOURCE 'payment/base_shipping_refunded'), payment_cc_approval string OPTIONS (NAMEINSOURCE 'payment/cc_approval'), payment_cc_avs_status string OPTIONS (NAMEINSOURCE 'payment/cc_avs_status'), payment_cc_cid_status string OPTIONS (NAMEINSOURCE 'payment/cc_cid_status'), payment_cc_debug_request_body string OPTIONS (NAMEINSOURCE 'payment/cc_debug_request_body'), payment_cc_debug_response_body string OPTIONS (NAMEINSOURCE 'payment/cc_debug_response_body'), payment_cc_debug_response_serialized string OPTIONS (NAMEINSOURCE 'payment/cc_debug_response_serialized'), payment_cc_exp_month string OPTIONS (NAMEINSOURCE 'payment/cc_exp_month'), payment_cc_exp_year string OPTIONS (NAMEINSOURCE 'payment/cc_exp_year'), payment_cc_last4 string OPTIONS (NAMEINSOURCE 'payment/cc_last4'), payment_cc_number_enc string OPTIONS (NAMEINSOURCE 'payment/cc_number_enc'), payment_cc_owner string OPTIONS (NAMEINSOURCE 'payment/cc_owner'), payment_cc_secure_verify string OPTIONS (NAMEINSOURCE 'payment/cc_secure_verify'), payment_cc_ss_issue string OPTIONS (NAMEINSOURCE 'payment/cc_ss_issue'), payment_cc_ss_start_month string OPTIONS (NAMEINSOURCE 'payment/cc_ss_start_month'), payment_cc_ss_start_year string OPTIONS (NAMEINSOURCE 'payment/cc_ss_start_year'), payment_cc_status string OPTIONS (NAMEINSOURCE 'payment/cc_status'), payment_cc_status_description string OPTIONS (NAMEINSOURCE 'payment/cc_status_description'), payment_cc_trans_id string OPTIONS (NAMEINSOURCE 'payment/cc_trans_id'), payment_cc_type string OPTIONS (NAMEINSOURCE 'payment/cc_type'), payment_echeck_account_name string OPTIONS (NAMEINSOURCE 'payment/echeck_account_name'), payment_echeck_account_type string OPTIONS (NAMEINSOURCE 'payment/echeck_account_type'), payment_echeck_bank_name string OPTIONS (NAMEINSOURCE 'payment/echeck_bank_name'), payment_echeck_routing_number string OPTIONS (NAMEINSOURCE 'payment/echeck_routing_number'), payment_echeck_type string OPTIONS (NAMEINSOURCE 'payment/echeck_type'), payment_entity_id string OPTIONS (NAMEINSOURCE 'payment/entity_id'), payment_extension_attributes_vault_payment_token_created_at string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/created_at'), payment_extension_attributes_vault_payment_token_customer_id string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/customer_id'), payment_extension_attributes_vault_payment_token_entity_id string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/entity_id'), payment_extension_attributes_vault_payment_token_expires_at string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/expires_at'), payment_extension_attributes_vault_payment_token_gateway_token string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/gateway_token'), payment_extension_attributes_vault_payment_token_is_active boolean OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/is_active'), payment_extension_attributes_vault_payment_token_is_visible boolean OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/is_visible'), payment_extension_attributes_vault_payment_token_payment_method_code string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/payment_method_code'), payment_extension_attributes_vault_payment_token_public_hash string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/public_hash'), payment_extension_attributes_vault_payment_token_token_details string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/token_details'), payment_extension_attributes_vault_payment_token_type string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/type'), payment_last_trans_id string OPTIONS (NAMEINSOURCE 'payment/last_trans_id'), payment_method string OPTIONS (NAMEINSOURCE 'payment/method'), payment_parent_id string OPTIONS (NAMEINSOURCE 'payment/parent_id'), payment_po_number string OPTIONS (NAMEINSOURCE 'payment/po_number'), payment_protection_eligibility string OPTIONS (NAMEINSOURCE 'payment/protection_eligibility'), payment_quote_payment_id string OPTIONS (NAMEINSOURCE 'payment/quote_payment_id'), payment_shipping_amount string OPTIONS (NAMEINSOURCE 'payment/shipping_amount'), payment_shipping_captured string OPTIONS (NAMEINSOURCE 'payment/shipping_captured'), payment_shipping_refunded string OPTIONS (NAMEINSOURCE 'payment/shipping_refunded'), payment_auth_expiration string, payment_authorization_amount string, protect_code string, quote_address_id string, quote_id string, relation_child_id string, relation_child_real_id string, relation_parent_id string, relation_parent_real_id string, remote_ip string, shipping_amount string, shipping_canceled string, shipping_description string, shipping_discount_amount string, shipping_discount_tax_compensation_amount string, shipping_incl_tax string, shipping_invoiced string, shipping_refunded string, shipping_tax_amount string, shipping_tax_refunded string, state string, status string, "status_histories_sales-data-order-status-history-interface_comment" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/comment'), "status_histories_sales-data-order-status-history-interface_created_at" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/created_at'), "status_histories_sales-data-order-status-history-interface_entity_id" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/entity_id'), "status_histories_sales-data-order-status-history-interface_entity_name" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/entity_name'), "status_histories_sales-data-order-status-history-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/is_customer_notified'), "status_histories_sales-data-order-status-history-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/is_visible_on_front'), "status_histories_sales-data-order-status-history-interface_parent_id" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/parent_id'), "status_histories_sales-data-order-status-history-interface_status" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/status'), store_currency_code string, store_id string, store_name string, store_to_base_rate string, store_to_order_rate string, subtotal string, subtotal_canceled string, subtotal_incl_tax string, subtotal_invoiced string, subtotal_refunded string, tax_amount string, tax_canceled string, tax_invoiced string, tax_refunded string, total_canceled string, total_due string, total_invoiced string, total_item_count string, total_offline_refunded string, total_online_refunded string, total_paid string, total_qty_ordered string, total_refunded string, updated_at string, weight string, x_forwarded_for string)
OPTIONS (ANNOTATION 'Performs persist operations for a specified order.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/create');

CREATE FOREIGN PROCEDURE salesOrderItemRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_sales-data-order-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/additional_data'), "items_sales-data-order-item-interface_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/amount_refunded'), "items_sales-data-order-item-interface_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/applied_rule_ids'), "items_sales-data-order-item-interface_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_amount_refunded'), "items_sales-data-order-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_cost'), "items_sales-data-order-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_amount'), "items_sales-data-order-item-interface_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_invoiced'), "items_sales-data-order-item-interface_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_refunded'), "items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_base_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_original_price'), "items_sales-data-order-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_price'), "items_sales-data-order-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_price_incl_tax'), "items_sales-data-order-item-interface_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_row_invoiced'), "items_sales-data-order-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_row_total'), "items_sales-data-order-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_row_total_incl_tax'), "items_sales-data-order-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_amount'), "items_sales-data-order-item-interface_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_before_discount'), "items_sales-data-order-item-interface_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_invoiced'), "items_sales-data-order-item-interface_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_refunded'), "items_sales-data-order-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_applied_amount'), "items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt'), "items_sales-data-order-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_disposition'), "items_sales-data-order-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_row_disposition'), "items_sales-data-order-item-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/created_at'), "items_sales-data-order-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/description'), "items_sales-data-order-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_amount'), "items_sales-data-order-item-interface_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_invoiced'), "items_sales-data-order-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_percent'), "items_sales-data-order-item-interface_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_refunded'), "items_sales-data-order-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_amount'), "items_sales-data-order-item-interface_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_canceled'), "items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_event_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/event_id'), "items_sales-data-order-item-interface_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/ext_order_item_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/message'), "items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient'), "items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender'), "items_sales-data-order-item-interface_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/free_shipping'), "items_sales-data-order-item-interface_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_price'), "items_sales-data-order-item-interface_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_price_invoiced'), "items_sales-data-order-item-interface_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_price_refunded'), "items_sales-data-order-item-interface_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_tax_amount'), "items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced'), "items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded'), "items_sales-data-order-item-interface_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_id'), "items_sales-data-order-item-interface_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_price'), "items_sales-data-order-item-interface_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_price_invoiced'), "items_sales-data-order-item-interface_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_price_refunded'), "items_sales-data-order-item-interface_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_tax_amount'), "items_sales-data-order-item-interface_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_tax_amount_invoiced'), "items_sales-data-order-item-interface_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_tax_amount_refunded'), "items_sales-data-order-item-interface_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/is_qty_decimal'), "items_sales-data-order-item-interface_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/is_virtual'), "items_sales-data-order-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/item_id'), "items_sales-data-order-item-interface_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/locked_do_invoice'), "items_sales-data-order-item-interface_locked_do_ship" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/locked_do_ship'), "items_sales-data-order-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/name'), "items_sales-data-order-item-interface_no_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/no_discount'), "items_sales-data-order-item-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/order_id'), "items_sales-data-order-item-interface_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/original_price'), "items_sales-data-order-item-interface_parent_item_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/additional_data'), "items_sales-data-order-item-interface_parent_item_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/amount_refunded'), "items_sales-data-order-item-interface_parent_item_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/applied_rule_ids'), "items_sales-data-order-item-interface_parent_item_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_amount_refunded'), "items_sales-data-order-item-interface_parent_item_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_cost'), "items_sales-data-order-item-interface_parent_item_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_amount'), "items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced'), "items_sales-data-order-item-interface_parent_item_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_refunded'), "items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount'), "items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_parent_item_base_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_original_price'), "items_sales-data-order-item-interface_parent_item_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_price'), "items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax'), "items_sales-data-order-item-interface_parent_item_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_row_invoiced'), "items_sales-data-order-item-interface_parent_item_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_row_total'), "items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax'), "items_sales-data-order-item-interface_parent_item_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_amount'), "items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount'), "items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced'), "items_sales-data-order-item-interface_parent_item_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_refunded'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition'), "items_sales-data-order-item-interface_parent_item_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/created_at'), "items_sales-data-order-item-interface_parent_item_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/description'), "items_sales-data-order-item-interface_parent_item_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_amount'), "items_sales-data-order-item-interface_parent_item_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_invoiced'), "items_sales-data-order-item-interface_parent_item_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_percent'), "items_sales-data-order-item-interface_parent_item_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_refunded'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_parent_item_event_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/event_id'), "items_sales-data-order-item-interface_parent_item_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/ext_order_item_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender'), "items_sales-data-order-item-interface_parent_item_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/free_shipping'), "items_sales-data-order-item-interface_parent_item_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_price'), "items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded'), "items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount'), "items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded'), "items_sales-data-order-item-interface_parent_item_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_id'), "items_sales-data-order-item-interface_parent_item_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_price'), "items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_price_refunded'), "items_sales-data-order-item-interface_parent_item_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_tax_amount'), "items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded'), "items_sales-data-order-item-interface_parent_item_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/is_qty_decimal'), "items_sales-data-order-item-interface_parent_item_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/is_virtual'), "items_sales-data-order-item-interface_parent_item_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/item_id'), "items_sales-data-order-item-interface_parent_item_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/locked_do_invoice'), "items_sales-data-order-item-interface_parent_item_locked_do_ship" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/locked_do_ship'), "items_sales-data-order-item-interface_parent_item_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/name'), "items_sales-data-order-item-interface_parent_item_no_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/no_discount'), "items_sales-data-order-item-interface_parent_item_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/order_id'), "items_sales-data-order-item-interface_parent_item_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/original_price'), "items_sales-data-order-item-interface_parent_item_parent_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/parent_item_id'), "items_sales-data-order-item-interface_parent_item_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/price'), "items_sales-data-order-item-interface_parent_item_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/price_incl_tax'), "items_sales-data-order-item-interface_parent_item_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_sales-data-order-item-interface_parent_item_product_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_type'), "items_sales-data-order-item-interface_parent_item_qty_backordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_backordered'), "items_sales-data-order-item-interface_parent_item_qty_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_canceled'), "items_sales-data-order-item-interface_parent_item_qty_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_invoiced'), "items_sales-data-order-item-interface_parent_item_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_ordered'), "items_sales-data-order-item-interface_parent_item_qty_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_refunded'), "items_sales-data-order-item-interface_parent_item_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_returned'), "items_sales-data-order-item-interface_parent_item_qty_shipped" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_shipped'), "items_sales-data-order-item-interface_parent_item_quote_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/quote_item_id'), "items_sales-data-order-item-interface_parent_item_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_invoiced'), "items_sales-data-order-item-interface_parent_item_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_total'), "items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax'), "items_sales-data-order-item-interface_parent_item_row_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_weight'), "items_sales-data-order-item-interface_parent_item_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/sku'), "items_sales-data-order-item-interface_parent_item_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/store_id'), "items_sales-data-order-item-interface_parent_item_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_amount'), "items_sales-data-order-item-interface_parent_item_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_before_discount'), "items_sales-data-order-item-interface_parent_item_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_canceled'), "items_sales-data-order-item-interface_parent_item_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_invoiced'), "items_sales-data-order-item-interface_parent_item_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_percent'), "items_sales-data-order-item-interface_parent_item_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_refunded'), "items_sales-data-order-item-interface_parent_item_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/updated_at'), "items_sales-data-order-item-interface_parent_item_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_applied'), "items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount'), "items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount'), "items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition'), "items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition'), "items_sales-data-order-item-interface_parent_item_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weight'), "items_sales-data-order-item-interface_parent_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item_id'), "items_sales-data-order-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/price'), "items_sales-data-order-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/price_incl_tax'), "items_sales-data-order-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_sales-data-order-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_type'), "items_sales-data-order-item-interface_qty_backordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_backordered'), "items_sales-data-order-item-interface_qty_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_canceled'), "items_sales-data-order-item-interface_qty_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_invoiced'), "items_sales-data-order-item-interface_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_ordered'), "items_sales-data-order-item-interface_qty_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_refunded'), "items_sales-data-order-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_returned'), "items_sales-data-order-item-interface_qty_shipped" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_shipped'), "items_sales-data-order-item-interface_quote_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/quote_item_id'), "items_sales-data-order-item-interface_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_invoiced'), "items_sales-data-order-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_total'), "items_sales-data-order-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_total_incl_tax'), "items_sales-data-order-item-interface_row_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_weight'), "items_sales-data-order-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/sku'), "items_sales-data-order-item-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/store_id'), "items_sales-data-order-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_amount'), "items_sales-data-order-item-interface_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_before_discount'), "items_sales-data-order-item-interface_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_canceled'), "items_sales-data-order-item-interface_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_invoiced'), "items_sales-data-order-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_percent'), "items_sales-data-order-item-interface_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_refunded'), "items_sales-data-order-item-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/updated_at'), "items_sales-data-order-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_applied'), "items_sales-data-order-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_applied_amount'), "items_sales-data-order-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_applied_row_amount'), "items_sales-data-order-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_disposition'), "items_sales-data-order-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_row_disposition'), "items_sales-data-order-item-interface_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weight'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Lists order items that match specified search criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#OrderItemRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/items');

CREATE FOREIGN PROCEDURE salesOrderItemRepositoryV1GetGet(IN id string NOT NULL OPTIONS (ANNOTATION 'The order item ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (additional_data string, amount_refunded string, applied_rule_ids string, base_amount_refunded string, base_cost string, base_discount_amount string, base_discount_invoiced string, base_discount_refunded string, base_discount_tax_compensation_amount string, base_discount_tax_compensation_invoiced string, base_discount_tax_compensation_refunded string, base_original_price string, base_price string, base_price_incl_tax string, base_row_invoiced string, base_row_total string, base_row_total_incl_tax string, base_tax_amount string, base_tax_before_discount string, base_tax_invoiced string, base_tax_refunded string, base_weee_tax_applied_amount string, base_weee_tax_applied_row_amnt string, base_weee_tax_disposition string, base_weee_tax_row_disposition string, created_at string, description string, discount_amount string, discount_invoiced string, discount_percent string, discount_refunded string, discount_tax_compensation_amount string, discount_tax_compensation_canceled string, discount_tax_compensation_invoiced string, discount_tax_compensation_refunded string, event_id string, ext_order_item_id string, extension_attributes_gift_message_customer_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/customer_id'), extension_attributes_gift_message_extension_attributes_entity_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/entity_id'), extension_attributes_gift_message_extension_attributes_entity_type string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/entity_type'), extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card boolean OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt boolean OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), extension_attributes_gift_message_extension_attributes_wrapping_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/wrapping_id'), extension_attributes_gift_message_gift_message_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/gift_message_id'), extension_attributes_gift_message_message string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/message'), extension_attributes_gift_message_recipient string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/recipient'), extension_attributes_gift_message_sender string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/sender'), free_shipping string, gw_base_price string, gw_base_price_invoiced string, gw_base_price_refunded string, gw_base_tax_amount string, gw_base_tax_amount_invoiced string, gw_base_tax_amount_refunded string, gw_id string, gw_price string, gw_price_invoiced string, gw_price_refunded string, gw_tax_amount string, gw_tax_amount_invoiced string, gw_tax_amount_refunded string, is_qty_decimal string, is_virtual string, item_id string, locked_do_invoice string, locked_do_ship string, name string, no_discount string, order_id string, original_price string, parent_item_additional_data string OPTIONS (NAMEINSOURCE 'parent_item/additional_data'), parent_item_amount_refunded string OPTIONS (NAMEINSOURCE 'parent_item/amount_refunded'), parent_item_applied_rule_ids string OPTIONS (NAMEINSOURCE 'parent_item/applied_rule_ids'), parent_item_base_amount_refunded string OPTIONS (NAMEINSOURCE 'parent_item/base_amount_refunded'), parent_item_base_cost string OPTIONS (NAMEINSOURCE 'parent_item/base_cost'), parent_item_base_discount_amount string OPTIONS (NAMEINSOURCE 'parent_item/base_discount_amount'), parent_item_base_discount_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/base_discount_invoiced'), parent_item_base_discount_refunded string OPTIONS (NAMEINSOURCE 'parent_item/base_discount_refunded'), parent_item_base_discount_tax_compensation_amount string OPTIONS (NAMEINSOURCE 'parent_item/base_discount_tax_compensation_amount'), parent_item_base_discount_tax_compensation_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/base_discount_tax_compensation_invoiced'), parent_item_base_discount_tax_compensation_refunded string OPTIONS (NAMEINSOURCE 'parent_item/base_discount_tax_compensation_refunded'), parent_item_base_original_price string OPTIONS (NAMEINSOURCE 'parent_item/base_original_price'), parent_item_base_price string OPTIONS (NAMEINSOURCE 'parent_item/base_price'), parent_item_base_price_incl_tax string OPTIONS (NAMEINSOURCE 'parent_item/base_price_incl_tax'), parent_item_base_row_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/base_row_invoiced'), parent_item_base_row_total string OPTIONS (NAMEINSOURCE 'parent_item/base_row_total'), parent_item_base_row_total_incl_tax string OPTIONS (NAMEINSOURCE 'parent_item/base_row_total_incl_tax'), parent_item_base_tax_amount string OPTIONS (NAMEINSOURCE 'parent_item/base_tax_amount'), parent_item_base_tax_before_discount string OPTIONS (NAMEINSOURCE 'parent_item/base_tax_before_discount'), parent_item_base_tax_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/base_tax_invoiced'), parent_item_base_tax_refunded string OPTIONS (NAMEINSOURCE 'parent_item/base_tax_refunded'), parent_item_base_weee_tax_applied_amount string OPTIONS (NAMEINSOURCE 'parent_item/base_weee_tax_applied_amount'), parent_item_base_weee_tax_applied_row_amnt string OPTIONS (NAMEINSOURCE 'parent_item/base_weee_tax_applied_row_amnt'), parent_item_base_weee_tax_disposition string OPTIONS (NAMEINSOURCE 'parent_item/base_weee_tax_disposition'), parent_item_base_weee_tax_row_disposition string OPTIONS (NAMEINSOURCE 'parent_item/base_weee_tax_row_disposition'), parent_item_created_at string OPTIONS (NAMEINSOURCE 'parent_item/created_at'), parent_item_description string OPTIONS (NAMEINSOURCE 'parent_item/description'), parent_item_discount_amount string OPTIONS (NAMEINSOURCE 'parent_item/discount_amount'), parent_item_discount_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/discount_invoiced'), parent_item_discount_percent string OPTIONS (NAMEINSOURCE 'parent_item/discount_percent'), parent_item_discount_refunded string OPTIONS (NAMEINSOURCE 'parent_item/discount_refunded'), parent_item_discount_tax_compensation_amount string OPTIONS (NAMEINSOURCE 'parent_item/discount_tax_compensation_amount'), parent_item_discount_tax_compensation_canceled string OPTIONS (NAMEINSOURCE 'parent_item/discount_tax_compensation_canceled'), parent_item_discount_tax_compensation_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/discount_tax_compensation_invoiced'), parent_item_discount_tax_compensation_refunded string OPTIONS (NAMEINSOURCE 'parent_item/discount_tax_compensation_refunded'), parent_item_event_id string OPTIONS (NAMEINSOURCE 'parent_item/event_id'), parent_item_ext_order_item_id string OPTIONS (NAMEINSOURCE 'parent_item/ext_order_item_id'), parent_item_extension_attributes_gift_message_customer_id string OPTIONS (NAMEINSOURCE 'parent_item/extension_attributes/gift_message/customer_id'), parent_item_extension_attributes_gift_message_extension_attributes_entity_id string OPTIONS (NAMEINSOURCE 'parent_item/extension_attributes/gift_message/extension_attributes/entity_id'), parent_item_extension_attributes_gift_message_extension_attributes_entity_type string OPTIONS (NAMEINSOURCE 'parent_item/extension_attributes/gift_message/extension_attributes/entity_type'), parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card boolean OPTIONS (NAMEINSOURCE 'parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt boolean OPTIONS (NAMEINSOURCE 'parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id string OPTIONS (NAMEINSOURCE 'parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id'), parent_item_extension_attributes_gift_message_gift_message_id string OPTIONS (NAMEINSOURCE 'parent_item/extension_attributes/gift_message/gift_message_id'), parent_item_extension_attributes_gift_message_message string OPTIONS (NAMEINSOURCE 'parent_item/extension_attributes/gift_message/message'), parent_item_extension_attributes_gift_message_recipient string OPTIONS (NAMEINSOURCE 'parent_item/extension_attributes/gift_message/recipient'), parent_item_extension_attributes_gift_message_sender string OPTIONS (NAMEINSOURCE 'parent_item/extension_attributes/gift_message/sender'), parent_item_free_shipping string OPTIONS (NAMEINSOURCE 'parent_item/free_shipping'), parent_item_gw_base_price string OPTIONS (NAMEINSOURCE 'parent_item/gw_base_price'), parent_item_gw_base_price_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/gw_base_price_invoiced'), parent_item_gw_base_price_refunded string OPTIONS (NAMEINSOURCE 'parent_item/gw_base_price_refunded'), parent_item_gw_base_tax_amount string OPTIONS (NAMEINSOURCE 'parent_item/gw_base_tax_amount'), parent_item_gw_base_tax_amount_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/gw_base_tax_amount_invoiced'), parent_item_gw_base_tax_amount_refunded string OPTIONS (NAMEINSOURCE 'parent_item/gw_base_tax_amount_refunded'), parent_item_gw_id string OPTIONS (NAMEINSOURCE 'parent_item/gw_id'), parent_item_gw_price string OPTIONS (NAMEINSOURCE 'parent_item/gw_price'), parent_item_gw_price_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/gw_price_invoiced'), parent_item_gw_price_refunded string OPTIONS (NAMEINSOURCE 'parent_item/gw_price_refunded'), parent_item_gw_tax_amount string OPTIONS (NAMEINSOURCE 'parent_item/gw_tax_amount'), parent_item_gw_tax_amount_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/gw_tax_amount_invoiced'), parent_item_gw_tax_amount_refunded string OPTIONS (NAMEINSOURCE 'parent_item/gw_tax_amount_refunded'), parent_item_is_qty_decimal string OPTIONS (NAMEINSOURCE 'parent_item/is_qty_decimal'), parent_item_is_virtual string OPTIONS (NAMEINSOURCE 'parent_item/is_virtual'), parent_item_item_id string OPTIONS (NAMEINSOURCE 'parent_item/item_id'), parent_item_locked_do_invoice string OPTIONS (NAMEINSOURCE 'parent_item/locked_do_invoice'), parent_item_locked_do_ship string OPTIONS (NAMEINSOURCE 'parent_item/locked_do_ship'), parent_item_name string OPTIONS (NAMEINSOURCE 'parent_item/name'), parent_item_no_discount string OPTIONS (NAMEINSOURCE 'parent_item/no_discount'), parent_item_order_id string OPTIONS (NAMEINSOURCE 'parent_item/order_id'), parent_item_original_price string OPTIONS (NAMEINSOURCE 'parent_item/original_price'), parent_item_parent_item_id string OPTIONS (NAMEINSOURCE 'parent_item/parent_item_id'), parent_item_price string OPTIONS (NAMEINSOURCE 'parent_item/price'), parent_item_price_incl_tax string OPTIONS (NAMEINSOURCE 'parent_item/price_incl_tax'), parent_item_product_id string OPTIONS (NAMEINSOURCE 'parent_item/product_id'), "parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), parent_item_product_option_extension_attributes_downloadable_option_downloadable_links string[] OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/downloadable_option/downloadable_links'), parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message'), parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string OPTIONS (NAMEINSOURCE 'parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), parent_item_product_type string OPTIONS (NAMEINSOURCE 'parent_item/product_type'), parent_item_qty_backordered string OPTIONS (NAMEINSOURCE 'parent_item/qty_backordered'), parent_item_qty_canceled string OPTIONS (NAMEINSOURCE 'parent_item/qty_canceled'), parent_item_qty_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/qty_invoiced'), parent_item_qty_ordered string OPTIONS (NAMEINSOURCE 'parent_item/qty_ordered'), parent_item_qty_refunded string OPTIONS (NAMEINSOURCE 'parent_item/qty_refunded'), parent_item_qty_returned string OPTIONS (NAMEINSOURCE 'parent_item/qty_returned'), parent_item_qty_shipped string OPTIONS (NAMEINSOURCE 'parent_item/qty_shipped'), parent_item_quote_item_id string OPTIONS (NAMEINSOURCE 'parent_item/quote_item_id'), parent_item_row_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/row_invoiced'), parent_item_row_total string OPTIONS (NAMEINSOURCE 'parent_item/row_total'), parent_item_row_total_incl_tax string OPTIONS (NAMEINSOURCE 'parent_item/row_total_incl_tax'), parent_item_row_weight string OPTIONS (NAMEINSOURCE 'parent_item/row_weight'), parent_item_sku string OPTIONS (NAMEINSOURCE 'parent_item/sku'), parent_item_store_id string OPTIONS (NAMEINSOURCE 'parent_item/store_id'), parent_item_tax_amount string OPTIONS (NAMEINSOURCE 'parent_item/tax_amount'), parent_item_tax_before_discount string OPTIONS (NAMEINSOURCE 'parent_item/tax_before_discount'), parent_item_tax_canceled string OPTIONS (NAMEINSOURCE 'parent_item/tax_canceled'), parent_item_tax_invoiced string OPTIONS (NAMEINSOURCE 'parent_item/tax_invoiced'), parent_item_tax_percent string OPTIONS (NAMEINSOURCE 'parent_item/tax_percent'), parent_item_tax_refunded string OPTIONS (NAMEINSOURCE 'parent_item/tax_refunded'), parent_item_updated_at string OPTIONS (NAMEINSOURCE 'parent_item/updated_at'), parent_item_weee_tax_applied string OPTIONS (NAMEINSOURCE 'parent_item/weee_tax_applied'), parent_item_weee_tax_applied_amount string OPTIONS (NAMEINSOURCE 'parent_item/weee_tax_applied_amount'), parent_item_weee_tax_applied_row_amount string OPTIONS (NAMEINSOURCE 'parent_item/weee_tax_applied_row_amount'), parent_item_weee_tax_disposition string OPTIONS (NAMEINSOURCE 'parent_item/weee_tax_disposition'), parent_item_weee_tax_row_disposition string OPTIONS (NAMEINSOURCE 'parent_item/weee_tax_row_disposition'), parent_item_weight string OPTIONS (NAMEINSOURCE 'parent_item/weight'), parent_item_id string, price string, price_incl_tax string, product_id string, "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), product_option_extension_attributes_downloadable_option_downloadable_links string[] OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/downloadable_option/downloadable_links'), product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_amount string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_amount'), product_option_extension_attributes_giftcard_item_option_giftcard_message string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_message'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_email string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), product_option_extension_attributes_giftcard_item_option_giftcard_sender_name string OPTIONS (NAMEINSOURCE 'product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), product_type string, qty_backordered string, qty_canceled string, qty_invoiced string, qty_ordered string, qty_refunded string, qty_returned string, qty_shipped string, quote_item_id string, row_invoiced string, row_total string, row_total_incl_tax string, row_weight string, sku string, store_id string, tax_amount string, tax_before_discount string, tax_canceled string, tax_invoiced string, tax_percent string, tax_refunded string, updated_at string, weee_tax_applied string, weee_tax_applied_amount string, weee_tax_applied_row_amount string, weee_tax_disposition string, weee_tax_row_disposition string, weight string)
OPTIONS (ANNOTATION 'Loads a specified order item.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/items/{id}');

CREATE FOREIGN PROCEDURE salesOrderRepositoryV1GetGet(IN id string NOT NULL OPTIONS (ANNOTATION 'The order ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (adjustment_negative string, adjustment_positive string, applied_rule_ids string, base_adjustment_negative string, base_adjustment_positive string, base_currency_code string, base_discount_amount string, base_discount_canceled string, base_discount_invoiced string, base_discount_refunded string, base_discount_tax_compensation_amount string, base_discount_tax_compensation_invoiced string, base_discount_tax_compensation_refunded string, base_grand_total string, base_shipping_amount string, base_shipping_canceled string, base_shipping_discount_amount string, base_shipping_discount_tax_compensation_amnt string, base_shipping_incl_tax string, base_shipping_invoiced string, base_shipping_refunded string, base_shipping_tax_amount string, base_shipping_tax_refunded string, base_subtotal string, base_subtotal_canceled string, base_subtotal_incl_tax string, base_subtotal_invoiced string, base_subtotal_refunded string, base_tax_amount string, base_tax_canceled string, base_tax_invoiced string, base_tax_refunded string, base_to_global_rate string, base_to_order_rate string, base_total_canceled string, base_total_due string, base_total_invoiced string, base_total_invoiced_cost string, base_total_offline_refunded string, base_total_online_refunded string, base_total_paid string, base_total_qty_ordered string, base_total_refunded string, billing_address_address_type string OPTIONS (NAMEINSOURCE 'billing_address/address_type'), billing_address_city string OPTIONS (NAMEINSOURCE 'billing_address/city'), billing_address_company string OPTIONS (NAMEINSOURCE 'billing_address/company'), billing_address_country_id string OPTIONS (NAMEINSOURCE 'billing_address/country_id'), billing_address_customer_address_id string OPTIONS (NAMEINSOURCE 'billing_address/customer_address_id'), billing_address_customer_id string OPTIONS (NAMEINSOURCE 'billing_address/customer_id'), billing_address_email string OPTIONS (NAMEINSOURCE 'billing_address/email'), billing_address_entity_id string OPTIONS (NAMEINSOURCE 'billing_address/entity_id'), billing_address_fax string OPTIONS (NAMEINSOURCE 'billing_address/fax'), billing_address_firstname string OPTIONS (NAMEINSOURCE 'billing_address/firstname'), billing_address_lastname string OPTIONS (NAMEINSOURCE 'billing_address/lastname'), billing_address_middlename string OPTIONS (NAMEINSOURCE 'billing_address/middlename'), billing_address_parent_id string OPTIONS (NAMEINSOURCE 'billing_address/parent_id'), billing_address_postcode string OPTIONS (NAMEINSOURCE 'billing_address/postcode'), billing_address_prefix string OPTIONS (NAMEINSOURCE 'billing_address/prefix'), billing_address_region string OPTIONS (NAMEINSOURCE 'billing_address/region'), billing_address_region_code string OPTIONS (NAMEINSOURCE 'billing_address/region_code'), billing_address_region_id string OPTIONS (NAMEINSOURCE 'billing_address/region_id'), billing_address_street string[] OPTIONS (NAMEINSOURCE 'billing_address/street'), billing_address_suffix string OPTIONS (NAMEINSOURCE 'billing_address/suffix'), billing_address_telephone string OPTIONS (NAMEINSOURCE 'billing_address/telephone'), billing_address_vat_id string OPTIONS (NAMEINSOURCE 'billing_address/vat_id'), billing_address_vat_is_valid string OPTIONS (NAMEINSOURCE 'billing_address/vat_is_valid'), billing_address_vat_request_date string OPTIONS (NAMEINSOURCE 'billing_address/vat_request_date'), billing_address_vat_request_id string OPTIONS (NAMEINSOURCE 'billing_address/vat_request_id'), billing_address_vat_request_success string OPTIONS (NAMEINSOURCE 'billing_address/vat_request_success'), billing_address_id string, can_ship_partially string, can_ship_partially_item string, coupon_code string, created_at string, customer_dob string, customer_email string, customer_firstname string, customer_gender string, customer_group_id string, customer_id string, customer_is_guest string, customer_lastname string, customer_middlename string, customer_note string, customer_note_notify string, customer_prefix string, customer_suffix string, customer_taxvat string, discount_amount string, discount_canceled string, discount_description string, discount_invoiced string, discount_refunded string, discount_tax_compensation_amount string, discount_tax_compensation_invoiced string, discount_tax_compensation_refunded string, edit_increment string, email_sent string, entity_id string, ext_customer_id string, ext_order_id string, "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/amount'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_base_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/base_amount'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/code'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/code'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/percent'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/title'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/percent'), "extension_attributes_applied_taxes_tax-data-order-tax-details-applied-tax-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/title'), extension_attributes_base_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/base_customer_balance_amount'), extension_attributes_converting_from_quote boolean OPTIONS (NAMEINSOURCE 'extension_attributes/converting_from_quote'), extension_attributes_customer_balance_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/customer_balance_amount'), extension_attributes_gift_message_customer_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/customer_id'), extension_attributes_gift_message_extension_attributes_entity_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/entity_id'), extension_attributes_gift_message_extension_attributes_entity_type string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/entity_type'), extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card boolean OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt boolean OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), extension_attributes_gift_message_extension_attributes_wrapping_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/extension_attributes/wrapping_id'), extension_attributes_gift_message_gift_message_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/gift_message_id'), extension_attributes_gift_message_message string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/message'), extension_attributes_gift_message_recipient string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/recipient'), extension_attributes_gift_message_sender string OPTIONS (NAMEINSOURCE 'extension_attributes/gift_message/sender'), extension_attributes_gw_add_card string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_add_card'), extension_attributes_gw_allow_gift_receipt string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_allow_gift_receipt'), extension_attributes_gw_base_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_base_price'), extension_attributes_gw_base_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_base_price_incl_tax'), extension_attributes_gw_base_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_base_tax_amount'), extension_attributes_gw_card_base_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_base_price'), extension_attributes_gw_card_base_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_base_price_incl_tax'), extension_attributes_gw_card_base_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_base_tax_amount'), extension_attributes_gw_card_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_price'), extension_attributes_gw_card_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_price_incl_tax'), extension_attributes_gw_card_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_card_tax_amount'), extension_attributes_gw_id string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_id'), extension_attributes_gw_items_base_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_base_price'), extension_attributes_gw_items_base_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_base_price_incl_tax'), extension_attributes_gw_items_base_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_base_tax_amount'), extension_attributes_gw_items_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_price'), extension_attributes_gw_items_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_price_incl_tax'), extension_attributes_gw_items_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_items_tax_amount'), extension_attributes_gw_price string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_price'), extension_attributes_gw_price_incl_tax string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_price_incl_tax'), extension_attributes_gw_tax_amount string OPTIONS (NAMEINSOURCE 'extension_attributes/gw_tax_amount'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/amount'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_base_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/base_amount'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/code'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/code'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/percent'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_extension_attributes_rates_tax-data-applied-tax-rate-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/extension_attributes/rates[]/tax-data-applied-tax-rate-interface/title'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/percent'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_applied_taxes_tax-data-order-tax-details-applied-tax-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/applied_taxes[]/tax-data-order-tax-details-applied-tax-interface/title'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_associated_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/associated_item_id'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/item_id'), "extension_attributes_item_applied_taxes_tax-data-order-tax-details-item-interface_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/item_applied_taxes[]/tax-data-order-tax-details-item-interface/type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/additional_data'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/applied_rule_ids'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_cost'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_original_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_original_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_price_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_total'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_row_total_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_before_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/base_weee_tax_row_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_created_at" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/created_at'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_description" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/description'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_percent'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/discount_tax_compensation_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_event_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/event_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/ext_order_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/message'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_free_shipping" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/free_shipping'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_price_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_price_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/gw_tax_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/is_qty_decimal'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_is_virtual" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/is_virtual'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/locked_do_invoice'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_locked_do_ship" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/locked_do_ship'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_no_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/no_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_order_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/order_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_original_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/original_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_additional_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/additional_data'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/applied_rule_ids'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_cost" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_cost'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_original_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_original_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_total" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_created_at" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/created_at'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_description" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/description'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_percent'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_event_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/event_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/ext_order_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_free_shipping" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/free_shipping'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_price_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/is_qty_decimal'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_is_virtual" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/is_virtual'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_invoice'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_locked_do_ship" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/locked_do_ship'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_no_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/no_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_order_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/order_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_original_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/original_price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_parent_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/parent_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_price_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/price_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_product_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/product_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_backordered" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_backordered'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_ordered" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_ordered'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_returned" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_returned'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_qty_shipped" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/qty_shipped'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_quote_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/quote_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_total" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_total'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_row_weight" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/row_weight'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/sku'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_store_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/store_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_before_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_before_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_percent'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_updated_at" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/updated_at'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_weight" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item/weight'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_parent_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/parent_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/price'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/price_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/product_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_backordered" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_backordered'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_ordered" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_ordered'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_returned'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_qty_shipped" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/qty_shipped'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_quote_item_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/quote_item_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_total'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_total_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_row_weight" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/row_weight'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/sku'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_store_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/store_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_before_discount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_before_discount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_percent'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_updated_at" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/updated_at'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_applied_row_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weee_tax_row_disposition'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_items_sales-data-order-item-interface_weight" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/items[]/sales-data-order-item-interface/weight'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_address_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/address_type'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_city" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/city'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_company" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/company'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_country_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/country_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_customer_address_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/customer_address_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_customer_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/customer_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_email" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/email'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_entity_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/entity_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_fax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/fax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_firstname" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/firstname'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_lastname" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/lastname'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_middlename" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/middlename'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_parent_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/parent_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_postcode" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/postcode'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_prefix" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/prefix'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region_code" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region_code'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_region_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/region_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_street" string[] OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/street'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_suffix" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/suffix'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_telephone" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/telephone'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_is_valid" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_is_valid'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_date" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_date'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_id'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_address_vat_request_success" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/address/vat_request_success'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_method" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/method'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_discount_tax_compensation_amnt" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_discount_tax_compensation_amnt'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_base_shipping_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/base_shipping_tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_canceled" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_canceled'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_discount_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_discount_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_discount_tax_compensation_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_incl_tax" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_incl_tax'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_invoiced" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_invoiced'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_tax_amount" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_tax_amount'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_shipping_total_shipping_tax_refunded" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/shipping/total/shipping_tax_refunded'), "extension_attributes_shipping_assignments_sales-data-shipping-assignment-interface_stock_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/shipping_assignments[]/sales-data-shipping-assignment-interface/stock_id'), forced_shipment_with_invoice string, global_currency_code string, grand_total string, hold_before_state string, hold_before_status string, increment_id string, is_virtual string, "items_sales-data-order-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/additional_data'), "items_sales-data-order-item-interface_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/amount_refunded'), "items_sales-data-order-item-interface_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/applied_rule_ids'), "items_sales-data-order-item-interface_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_amount_refunded'), "items_sales-data-order-item-interface_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_cost'), "items_sales-data-order-item-interface_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_amount'), "items_sales-data-order-item-interface_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_invoiced'), "items_sales-data-order-item-interface_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_refunded'), "items_sales-data-order-item-interface_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_tax_compensation_amount'), "items_sales-data-order-item-interface_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_base_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_original_price'), "items_sales-data-order-item-interface_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_price'), "items_sales-data-order-item-interface_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_price_incl_tax'), "items_sales-data-order-item-interface_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_row_invoiced'), "items_sales-data-order-item-interface_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_row_total'), "items_sales-data-order-item-interface_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_row_total_incl_tax'), "items_sales-data-order-item-interface_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_amount'), "items_sales-data-order-item-interface_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_before_discount'), "items_sales-data-order-item-interface_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_invoiced'), "items_sales-data-order-item-interface_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_tax_refunded'), "items_sales-data-order-item-interface_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_applied_amount'), "items_sales-data-order-item-interface_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_applied_row_amnt'), "items_sales-data-order-item-interface_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_disposition'), "items_sales-data-order-item-interface_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/base_weee_tax_row_disposition'), "items_sales-data-order-item-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/created_at'), "items_sales-data-order-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/description'), "items_sales-data-order-item-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_amount'), "items_sales-data-order-item-interface_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_invoiced'), "items_sales-data-order-item-interface_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_percent'), "items_sales-data-order-item-interface_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_refunded'), "items_sales-data-order-item-interface_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_amount'), "items_sales-data-order-item-interface_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_canceled'), "items_sales-data-order-item-interface_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_event_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/event_id'), "items_sales-data-order-item-interface_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/ext_order_item_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/customer_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-item-interface_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-item-interface_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/message'), "items_sales-data-order-item-interface_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/recipient'), "items_sales-data-order-item-interface_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/extension_attributes/gift_message/sender'), "items_sales-data-order-item-interface_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/free_shipping'), "items_sales-data-order-item-interface_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_price'), "items_sales-data-order-item-interface_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_price_invoiced'), "items_sales-data-order-item-interface_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_price_refunded'), "items_sales-data-order-item-interface_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_tax_amount'), "items_sales-data-order-item-interface_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_tax_amount_invoiced'), "items_sales-data-order-item-interface_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_base_tax_amount_refunded'), "items_sales-data-order-item-interface_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_id'), "items_sales-data-order-item-interface_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_price'), "items_sales-data-order-item-interface_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_price_invoiced'), "items_sales-data-order-item-interface_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_price_refunded'), "items_sales-data-order-item-interface_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_tax_amount'), "items_sales-data-order-item-interface_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_tax_amount_invoiced'), "items_sales-data-order-item-interface_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/gw_tax_amount_refunded'), "items_sales-data-order-item-interface_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/is_qty_decimal'), "items_sales-data-order-item-interface_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/is_virtual'), "items_sales-data-order-item-interface_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/item_id'), "items_sales-data-order-item-interface_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/locked_do_invoice'), "items_sales-data-order-item-interface_locked_do_ship" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/locked_do_ship'), "items_sales-data-order-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/name'), "items_sales-data-order-item-interface_no_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/no_discount'), "items_sales-data-order-item-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/order_id'), "items_sales-data-order-item-interface_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/original_price'), "items_sales-data-order-item-interface_parent_item_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/additional_data'), "items_sales-data-order-item-interface_parent_item_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/amount_refunded'), "items_sales-data-order-item-interface_parent_item_applied_rule_ids" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/applied_rule_ids'), "items_sales-data-order-item-interface_parent_item_base_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_amount_refunded'), "items_sales-data-order-item-interface_parent_item_base_cost" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_cost'), "items_sales-data-order-item-interface_parent_item_base_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_amount'), "items_sales-data-order-item-interface_parent_item_base_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_invoiced'), "items_sales-data-order-item-interface_parent_item_base_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_refunded'), "items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_amount'), "items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_parent_item_base_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_parent_item_base_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_original_price'), "items_sales-data-order-item-interface_parent_item_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_price'), "items_sales-data-order-item-interface_parent_item_base_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_price_incl_tax'), "items_sales-data-order-item-interface_parent_item_base_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_row_invoiced'), "items_sales-data-order-item-interface_parent_item_base_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_row_total'), "items_sales-data-order-item-interface_parent_item_base_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_row_total_incl_tax'), "items_sales-data-order-item-interface_parent_item_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_amount'), "items_sales-data-order-item-interface_parent_item_base_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_before_discount'), "items_sales-data-order-item-interface_parent_item_base_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_invoiced'), "items_sales-data-order-item-interface_parent_item_base_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_tax_refunded'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_amount'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_applied_row_amnt" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_applied_row_amnt'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_disposition'), "items_sales-data-order-item-interface_parent_item_base_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/base_weee_tax_row_disposition'), "items_sales-data-order-item-interface_parent_item_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/created_at'), "items_sales-data-order-item-interface_parent_item_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/description'), "items_sales-data-order-item-interface_parent_item_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_amount'), "items_sales-data-order-item-interface_parent_item_discount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_invoiced'), "items_sales-data-order-item-interface_parent_item_discount_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_percent'), "items_sales-data-order-item-interface_parent_item_discount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_refunded'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_amount'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_canceled'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_invoiced'), "items_sales-data-order-item-interface_parent_item_discount_tax_compensation_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/discount_tax_compensation_refunded'), "items_sales-data-order-item-interface_parent_item_event_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/event_id'), "items_sales-data-order-item-interface_parent_item_ext_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/ext_order_item_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/customer_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_entity_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/entity_type'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_add_printed_card" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_add_printed_card'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_allow_gift_receipt" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_allow_gift_receipt'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_extension_attributes_wrapping_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/extension_attributes/wrapping_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_gift_message_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/gift_message_id'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/message'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_recipient" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/recipient'), "items_sales-data-order-item-interface_parent_item_extension_attributes_gift_message_sender" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/extension_attributes/gift_message/sender'), "items_sales-data-order-item-interface_parent_item_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/free_shipping'), "items_sales-data-order-item-interface_parent_item_gw_base_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_price'), "items_sales-data-order-item-interface_parent_item_gw_base_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_price_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_base_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_price_refunded'), "items_sales-data-order-item-interface_parent_item_gw_base_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount'), "items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_base_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_base_tax_amount_refunded'), "items_sales-data-order-item-interface_parent_item_gw_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_id'), "items_sales-data-order-item-interface_parent_item_gw_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_price'), "items_sales-data-order-item-interface_parent_item_gw_price_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_price_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_price_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_price_refunded'), "items_sales-data-order-item-interface_parent_item_gw_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_tax_amount'), "items_sales-data-order-item-interface_parent_item_gw_tax_amount_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_invoiced'), "items_sales-data-order-item-interface_parent_item_gw_tax_amount_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/gw_tax_amount_refunded'), "items_sales-data-order-item-interface_parent_item_is_qty_decimal" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/is_qty_decimal'), "items_sales-data-order-item-interface_parent_item_is_virtual" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/is_virtual'), "items_sales-data-order-item-interface_parent_item_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/item_id'), "items_sales-data-order-item-interface_parent_item_locked_do_invoice" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/locked_do_invoice'), "items_sales-data-order-item-interface_parent_item_locked_do_ship" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/locked_do_ship'), "items_sales-data-order-item-interface_parent_item_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/name'), "items_sales-data-order-item-interface_parent_item_no_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/no_discount'), "items_sales-data-order-item-interface_parent_item_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/order_id'), "items_sales-data-order-item-interface_parent_item_original_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/original_price'), "items_sales-data-order-item-interface_parent_item_parent_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/parent_item_id'), "items_sales-data-order-item-interface_parent_item_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/price'), "items_sales-data-order-item-interface_parent_item_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/price_incl_tax'), "items_sales-data-order-item-interface_parent_item_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_sales-data-order-item-interface_parent_item_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_sales-data-order-item-interface_parent_item_product_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/product_type'), "items_sales-data-order-item-interface_parent_item_qty_backordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_backordered'), "items_sales-data-order-item-interface_parent_item_qty_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_canceled'), "items_sales-data-order-item-interface_parent_item_qty_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_invoiced'), "items_sales-data-order-item-interface_parent_item_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_ordered'), "items_sales-data-order-item-interface_parent_item_qty_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_refunded'), "items_sales-data-order-item-interface_parent_item_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_returned'), "items_sales-data-order-item-interface_parent_item_qty_shipped" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/qty_shipped'), "items_sales-data-order-item-interface_parent_item_quote_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/quote_item_id'), "items_sales-data-order-item-interface_parent_item_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_invoiced'), "items_sales-data-order-item-interface_parent_item_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_total'), "items_sales-data-order-item-interface_parent_item_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_total_incl_tax'), "items_sales-data-order-item-interface_parent_item_row_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/row_weight'), "items_sales-data-order-item-interface_parent_item_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/sku'), "items_sales-data-order-item-interface_parent_item_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/store_id'), "items_sales-data-order-item-interface_parent_item_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_amount'), "items_sales-data-order-item-interface_parent_item_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_before_discount'), "items_sales-data-order-item-interface_parent_item_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_canceled'), "items_sales-data-order-item-interface_parent_item_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_invoiced'), "items_sales-data-order-item-interface_parent_item_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_percent'), "items_sales-data-order-item-interface_parent_item_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/tax_refunded'), "items_sales-data-order-item-interface_parent_item_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/updated_at'), "items_sales-data-order-item-interface_parent_item_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_applied'), "items_sales-data-order-item-interface_parent_item_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_amount'), "items_sales-data-order-item-interface_parent_item_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_applied_row_amount'), "items_sales-data-order-item-interface_parent_item_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_disposition'), "items_sales-data-order-item-interface_parent_item_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weee_tax_row_disposition'), "items_sales-data-order-item-interface_parent_item_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item/weight'), "items_sales-data-order-item-interface_parent_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/parent_item_id'), "items_sales-data-order-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/price'), "items_sales-data-order-item-interface_price_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/price_incl_tax'), "items_sales-data-order-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_qty'), "items_sales-data-order-item-interface_product_option_extension_attributes_bundle_options_bundle-data-bundle-option-interface_option_selections" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/bundle_options[]/bundle-data-bundle-option-interface/option_selections'), "items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_configurable_item_options_configurable-product-data-configurable-item-option-value-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/configurable_item_options[]/configurable-product-data-configurable-item-option-value-interface/option_value'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/base64_encoded_data'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/name'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_extension_attributes_file_info_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/extension_attributes/file_info/type'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_id'), "items_sales-data-order-item-interface_product_option_extension_attributes_custom_options_catalog-data-custom-option-interface_option_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/custom_options[]/catalog-data-custom-option-interface/option_value'), "items_sales-data-order-item-interface_product_option_extension_attributes_downloadable_option_downloadable_links" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/downloadable_option/downloadable_links'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_custom_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/custom_giftcard_amount'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_amount'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_message" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_message'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_email'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_recipient_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_recipient_name'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_email" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_email'), "items_sales-data-order-item-interface_product_option_extension_attributes_giftcard_item_option_giftcard_sender_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_option/extension_attributes/giftcard_item_option/giftcard_sender_name'), "items_sales-data-order-item-interface_product_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/product_type'), "items_sales-data-order-item-interface_qty_backordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_backordered'), "items_sales-data-order-item-interface_qty_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_canceled'), "items_sales-data-order-item-interface_qty_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_invoiced'), "items_sales-data-order-item-interface_qty_ordered" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_ordered'), "items_sales-data-order-item-interface_qty_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_refunded'), "items_sales-data-order-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_returned'), "items_sales-data-order-item-interface_qty_shipped" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/qty_shipped'), "items_sales-data-order-item-interface_quote_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/quote_item_id'), "items_sales-data-order-item-interface_row_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_invoiced'), "items_sales-data-order-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_total'), "items_sales-data-order-item-interface_row_total_incl_tax" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_total_incl_tax'), "items_sales-data-order-item-interface_row_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/row_weight'), "items_sales-data-order-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/sku'), "items_sales-data-order-item-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/store_id'), "items_sales-data-order-item-interface_tax_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_amount'), "items_sales-data-order-item-interface_tax_before_discount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_before_discount'), "items_sales-data-order-item-interface_tax_canceled" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_canceled'), "items_sales-data-order-item-interface_tax_invoiced" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_invoiced'), "items_sales-data-order-item-interface_tax_percent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_percent'), "items_sales-data-order-item-interface_tax_refunded" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/tax_refunded'), "items_sales-data-order-item-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/updated_at'), "items_sales-data-order-item-interface_weee_tax_applied" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_applied'), "items_sales-data-order-item-interface_weee_tax_applied_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_applied_amount'), "items_sales-data-order-item-interface_weee_tax_applied_row_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_applied_row_amount'), "items_sales-data-order-item-interface_weee_tax_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_disposition'), "items_sales-data-order-item-interface_weee_tax_row_disposition" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weee_tax_row_disposition'), "items_sales-data-order-item-interface_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-item-interface/weight'), order_currency_code string, original_increment_id string, payment_account_status string OPTIONS (NAMEINSOURCE 'payment/account_status'), payment_additional_data string OPTIONS (NAMEINSOURCE 'payment/additional_data'), payment_additional_information string[] OPTIONS (NAMEINSOURCE 'payment/additional_information'), payment_address_status string OPTIONS (NAMEINSOURCE 'payment/address_status'), payment_amount_authorized string OPTIONS (NAMEINSOURCE 'payment/amount_authorized'), payment_amount_canceled string OPTIONS (NAMEINSOURCE 'payment/amount_canceled'), payment_amount_ordered string OPTIONS (NAMEINSOURCE 'payment/amount_ordered'), payment_amount_paid string OPTIONS (NAMEINSOURCE 'payment/amount_paid'), payment_amount_refunded string OPTIONS (NAMEINSOURCE 'payment/amount_refunded'), payment_anet_trans_method string OPTIONS (NAMEINSOURCE 'payment/anet_trans_method'), payment_base_amount_authorized string OPTIONS (NAMEINSOURCE 'payment/base_amount_authorized'), payment_base_amount_canceled string OPTIONS (NAMEINSOURCE 'payment/base_amount_canceled'), payment_base_amount_ordered string OPTIONS (NAMEINSOURCE 'payment/base_amount_ordered'), payment_base_amount_paid string OPTIONS (NAMEINSOURCE 'payment/base_amount_paid'), payment_base_amount_paid_online string OPTIONS (NAMEINSOURCE 'payment/base_amount_paid_online'), payment_base_amount_refunded string OPTIONS (NAMEINSOURCE 'payment/base_amount_refunded'), payment_base_amount_refunded_online string OPTIONS (NAMEINSOURCE 'payment/base_amount_refunded_online'), payment_base_shipping_amount string OPTIONS (NAMEINSOURCE 'payment/base_shipping_amount'), payment_base_shipping_captured string OPTIONS (NAMEINSOURCE 'payment/base_shipping_captured'), payment_base_shipping_refunded string OPTIONS (NAMEINSOURCE 'payment/base_shipping_refunded'), payment_cc_approval string OPTIONS (NAMEINSOURCE 'payment/cc_approval'), payment_cc_avs_status string OPTIONS (NAMEINSOURCE 'payment/cc_avs_status'), payment_cc_cid_status string OPTIONS (NAMEINSOURCE 'payment/cc_cid_status'), payment_cc_debug_request_body string OPTIONS (NAMEINSOURCE 'payment/cc_debug_request_body'), payment_cc_debug_response_body string OPTIONS (NAMEINSOURCE 'payment/cc_debug_response_body'), payment_cc_debug_response_serialized string OPTIONS (NAMEINSOURCE 'payment/cc_debug_response_serialized'), payment_cc_exp_month string OPTIONS (NAMEINSOURCE 'payment/cc_exp_month'), payment_cc_exp_year string OPTIONS (NAMEINSOURCE 'payment/cc_exp_year'), payment_cc_last4 string OPTIONS (NAMEINSOURCE 'payment/cc_last4'), payment_cc_number_enc string OPTIONS (NAMEINSOURCE 'payment/cc_number_enc'), payment_cc_owner string OPTIONS (NAMEINSOURCE 'payment/cc_owner'), payment_cc_secure_verify string OPTIONS (NAMEINSOURCE 'payment/cc_secure_verify'), payment_cc_ss_issue string OPTIONS (NAMEINSOURCE 'payment/cc_ss_issue'), payment_cc_ss_start_month string OPTIONS (NAMEINSOURCE 'payment/cc_ss_start_month'), payment_cc_ss_start_year string OPTIONS (NAMEINSOURCE 'payment/cc_ss_start_year'), payment_cc_status string OPTIONS (NAMEINSOURCE 'payment/cc_status'), payment_cc_status_description string OPTIONS (NAMEINSOURCE 'payment/cc_status_description'), payment_cc_trans_id string OPTIONS (NAMEINSOURCE 'payment/cc_trans_id'), payment_cc_type string OPTIONS (NAMEINSOURCE 'payment/cc_type'), payment_echeck_account_name string OPTIONS (NAMEINSOURCE 'payment/echeck_account_name'), payment_echeck_account_type string OPTIONS (NAMEINSOURCE 'payment/echeck_account_type'), payment_echeck_bank_name string OPTIONS (NAMEINSOURCE 'payment/echeck_bank_name'), payment_echeck_routing_number string OPTIONS (NAMEINSOURCE 'payment/echeck_routing_number'), payment_echeck_type string OPTIONS (NAMEINSOURCE 'payment/echeck_type'), payment_entity_id string OPTIONS (NAMEINSOURCE 'payment/entity_id'), payment_extension_attributes_vault_payment_token_created_at string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/created_at'), payment_extension_attributes_vault_payment_token_customer_id string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/customer_id'), payment_extension_attributes_vault_payment_token_entity_id string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/entity_id'), payment_extension_attributes_vault_payment_token_expires_at string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/expires_at'), payment_extension_attributes_vault_payment_token_gateway_token string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/gateway_token'), payment_extension_attributes_vault_payment_token_is_active boolean OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/is_active'), payment_extension_attributes_vault_payment_token_is_visible boolean OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/is_visible'), payment_extension_attributes_vault_payment_token_payment_method_code string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/payment_method_code'), payment_extension_attributes_vault_payment_token_public_hash string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/public_hash'), payment_extension_attributes_vault_payment_token_token_details string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/token_details'), payment_extension_attributes_vault_payment_token_type string OPTIONS (NAMEINSOURCE 'payment/extension_attributes/vault_payment_token/type'), payment_last_trans_id string OPTIONS (NAMEINSOURCE 'payment/last_trans_id'), payment_method string OPTIONS (NAMEINSOURCE 'payment/method'), payment_parent_id string OPTIONS (NAMEINSOURCE 'payment/parent_id'), payment_po_number string OPTIONS (NAMEINSOURCE 'payment/po_number'), payment_protection_eligibility string OPTIONS (NAMEINSOURCE 'payment/protection_eligibility'), payment_quote_payment_id string OPTIONS (NAMEINSOURCE 'payment/quote_payment_id'), payment_shipping_amount string OPTIONS (NAMEINSOURCE 'payment/shipping_amount'), payment_shipping_captured string OPTIONS (NAMEINSOURCE 'payment/shipping_captured'), payment_shipping_refunded string OPTIONS (NAMEINSOURCE 'payment/shipping_refunded'), payment_auth_expiration string, payment_authorization_amount string, protect_code string, quote_address_id string, quote_id string, relation_child_id string, relation_child_real_id string, relation_parent_id string, relation_parent_real_id string, remote_ip string, shipping_amount string, shipping_canceled string, shipping_description string, shipping_discount_amount string, shipping_discount_tax_compensation_amount string, shipping_incl_tax string, shipping_invoiced string, shipping_refunded string, shipping_tax_amount string, shipping_tax_refunded string, state string, status string, "status_histories_sales-data-order-status-history-interface_comment" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/comment'), "status_histories_sales-data-order-status-history-interface_created_at" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/created_at'), "status_histories_sales-data-order-status-history-interface_entity_id" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/entity_id'), "status_histories_sales-data-order-status-history-interface_entity_name" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/entity_name'), "status_histories_sales-data-order-status-history-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/is_customer_notified'), "status_histories_sales-data-order-status-history-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/is_visible_on_front'), "status_histories_sales-data-order-status-history-interface_parent_id" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/parent_id'), "status_histories_sales-data-order-status-history-interface_status" string OPTIONS (NAMEINSOURCE 'status_histories[]/sales-data-order-status-history-interface/status'), store_currency_code string, store_id string, store_name string, store_to_base_rate string, store_to_order_rate string, subtotal string, subtotal_canceled string, subtotal_incl_tax string, subtotal_invoiced string, subtotal_refunded string, tax_amount string, tax_canceled string, tax_invoiced string, tax_refunded string, total_canceled string, total_due string, total_invoiced string, total_item_count string, total_offline_refunded string, total_online_refunded string, total_paid string, total_qty_ordered string, total_refunded string, updated_at string, weight string, x_forwarded_for string)
OPTIONS (ANNOTATION 'Loads a specified order.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/{id}');

CREATE FOREIGN PROCEDURE salesOrderManagementV1CancelPost(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The order ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Cancels a specified order.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/{id}/cancel');

CREATE FOREIGN PROCEDURE salesOrderManagementV1GetCommentsListGet(IN id string NOT NULL OPTIONS (ANNOTATION 'The order ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE ("items_sales-data-order-status-history-interface_comment" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-status-history-interface/comment'), "items_sales-data-order-status-history-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-status-history-interface/created_at'), "items_sales-data-order-status-history-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-status-history-interface/entity_id'), "items_sales-data-order-status-history-interface_entity_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-status-history-interface/entity_name'), "items_sales-data-order-status-history-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-status-history-interface/is_customer_notified'), "items_sales-data-order-status-history-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-status-history-interface/is_visible_on_front'), "items_sales-data-order-status-history-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-status-history-interface/parent_id'), "items_sales-data-order-status-history-interface_status" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-order-status-history-interface/status'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Lists comments for a specified order.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/{id}/comments');

CREATE FOREIGN PROCEDURE salesOrderManagementV1AddCommentPost(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The order ID.', "teiid_rest:PARAMETER_TYPE" 'path'), IN statusHistory_comment string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'statusHistory/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN statusHistory_created_at string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'statusHistory/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN statusHistory_entity_id string NOT NULL OPTIONS (ANNOTATION 'Order status history ID.', NAMEINSOURCE 'statusHistory/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN statusHistory_entity_name string NOT NULL OPTIONS (ANNOTATION 'Entity name.', NAMEINSOURCE 'statusHistory/entity_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN statusHistory_is_customer_notified string NOT NULL OPTIONS (ANNOTATION 'Is-customer-notified flag value.', NAMEINSOURCE 'statusHistory/is_customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN statusHistory_is_visible_on_front string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'statusHistory/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN statusHistory_parent_id string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'statusHistory/parent_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN statusHistory_status string NOT NULL OPTIONS (ANNOTATION 'Status.', NAMEINSOURCE 'statusHistory/status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Adds a comment to a specified order.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/{id}/comments');

CREATE FOREIGN PROCEDURE salesOrderManagementV1NotifyPost(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The order ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Emails a user a specified order.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/{id}/emails');

CREATE FOREIGN PROCEDURE salesOrderManagementV1HoldPost(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The order ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Holds a specified order.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/{id}/hold');

CREATE FOREIGN PROCEDURE salesOrderManagementV1GetStatusGet(OUT "return" string RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The order ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Gets the status for a specified order.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/{id}/statuses');

CREATE FOREIGN PROCEDURE salesOrderManagementV1UnHoldPost(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The order ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Releases a specified order from hold status.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/{id}/unhold');

CREATE FOREIGN PROCEDURE salesOrderAddressRepositoryV1SavePut(IN parent_id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN entity_address_type string NOT NULL OPTIONS (ANNOTATION 'Address type.', NAMEINSOURCE 'entity/address_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_city string NOT NULL OPTIONS (ANNOTATION 'City.', NAMEINSOURCE 'entity/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_company string NOT NULL OPTIONS (ANNOTATION 'Company.', NAMEINSOURCE 'entity/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_country_id string NOT NULL OPTIONS (ANNOTATION 'Country ID.', NAMEINSOURCE 'entity/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Country address ID.', NAMEINSOURCE 'entity/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID.', NAMEINSOURCE 'entity/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_email string NOT NULL OPTIONS (ANNOTATION 'Email address.', NAMEINSOURCE 'entity/email', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_entity_id string NOT NULL OPTIONS (ANNOTATION 'Order address ID.', NAMEINSOURCE 'entity/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number.', NAMEINSOURCE 'entity/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_firstname string NOT NULL OPTIONS (ANNOTATION 'First name.', NAMEINSOURCE 'entity/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name.', NAMEINSOURCE 'entity/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name.', NAMEINSOURCE 'entity/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_parent_id string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_postcode string NOT NULL OPTIONS (ANNOTATION 'Postal code.', NAMEINSOURCE 'entity/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix.', NAMEINSOURCE 'entity/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_region string NOT NULL OPTIONS (ANNOTATION 'Region.', NAMEINSOURCE 'entity/region', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code.', NAMEINSOURCE 'entity/region_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_region_id string NOT NULL OPTIONS (ANNOTATION 'Region ID.', NAMEINSOURCE 'entity/region_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'entity/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix.', NAMEINSOURCE 'entity/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number.', NAMEINSOURCE 'entity/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_vat_id string NOT NULL OPTIONS (ANNOTATION 'VAT ID.', NAMEINSOURCE 'entity/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_vat_is_valid string NOT NULL OPTIONS (ANNOTATION 'VAT-is-valid flag value.', NAMEINSOURCE 'entity/vat_is_valid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_vat_request_date string NOT NULL OPTIONS (ANNOTATION 'VAT request date.', NAMEINSOURCE 'entity/vat_request_date', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_vat_request_id string NOT NULL OPTIONS (ANNOTATION 'VAT request ID.', NAMEINSOURCE 'entity/vat_request_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_vat_request_success string NOT NULL OPTIONS (ANNOTATION 'VAT-request-success flag value.', NAMEINSOURCE 'entity/vat_request_success', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (address_type string, city string, company string, country_id string, customer_address_id string, customer_id string, email string, entity_id string, fax string, firstname string, lastname string, middlename string, parent_id string, postcode string, prefix string, region string, region_code string, region_id string, street string[], suffix string, telephone string, vat_id string, vat_is_valid string, vat_request_date string, vat_request_id string, vat_request_success string)
OPTIONS (ANNOTATION 'Performs persist operations for a specified order address.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/orders/{parent_id}');

CREATE FOREIGN PROCEDURE catalogProductRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_catalog-data-product-interface_attribute_set_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/attribute_set_id'), "items_catalog-data-product-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/created_at'), "items_catalog-data-product-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_catalog-data-product-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/custom_attributes[]/framework-attribute-interface/value'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/option_id'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_position" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/position'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_can_change_quantity" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/can_change_quantity'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/id'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/is_default'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/option_id'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_position" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/position'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price_type'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/qty'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/sku'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_required" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/required'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/sku'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_title" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/title'), "items_catalog-data-product-interface_extension_attributes_bundle_product_options_bundle-data-option-interface_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/bundle_product_options[]/bundle-data-option-interface/type'), "items_catalog-data-product-interface_extension_attributes_configurable_product_links" string[] OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/configurable_product_links'), "items_catalog-data-product-interface_extension_attributes_configurable_product_options_configurable-product-data-option-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/attribute_id'), "items_catalog-data-product-interface_extension_attributes_configurable_product_options_configurable-product-data-option-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/id'), "items_catalog-data-product-interface_extension_attributes_configurable_product_options_configurable-product-data-option-interface_is_use_default" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/is_use_default'), "items_catalog-data-product-interface_extension_attributes_configurable_product_options_configurable-product-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/label'), "items_catalog-data-product-interface_extension_attributes_configurable_product_options_configurable-product-data-option-interface_position" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/position'), "items_catalog-data-product-interface_extension_attributes_configurable_product_options_configurable-product-data-option-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/product_id'), "items_catalog-data-product-interface_extension_attributes_configurable_product_options_configurable-product-data-option-interface_values_configurable-product-data-option-value-interface_value_index" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/values[]/configurable-product-data-option-value-interface/value_index'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/id'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_is_shareable" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/is_shareable'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_file_data" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/file_data'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_name" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/name'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_type'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_url" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_url'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_number_of_downloads" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/number_of_downloads'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/price'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_file_data" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/file_data'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_name" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/name'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_type'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_url" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_url'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sort_order" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sort_order'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_links_downloadable-data-link-interface_title" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/title'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/id'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_file_data" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/file_data'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_name" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/name'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_type'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_url" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_url'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sort_order" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sort_order'), "items_catalog-data-product-interface_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_title" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/title'), "items_catalog-data-product-interface_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/attribute_id'), "items_catalog-data-product-interface_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/value'), "items_catalog-data-product-interface_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_id'), "items_catalog-data-product-interface_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_value" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_value'), "items_catalog-data-product-interface_extension_attributes_stock_item_backorders" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/backorders'), "items_catalog-data-product-interface_extension_attributes_stock_item_enable_qty_increments" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/enable_qty_increments'), "items_catalog-data-product-interface_extension_attributes_stock_item_is_decimal_divided" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/is_decimal_divided'), "items_catalog-data-product-interface_extension_attributes_stock_item_is_in_stock" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/is_in_stock'), "items_catalog-data-product-interface_extension_attributes_stock_item_is_qty_decimal" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/is_qty_decimal'), "items_catalog-data-product-interface_extension_attributes_stock_item_item_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/item_id'), "items_catalog-data-product-interface_extension_attributes_stock_item_low_stock_date" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/low_stock_date'), "items_catalog-data-product-interface_extension_attributes_stock_item_manage_stock" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/manage_stock'), "items_catalog-data-product-interface_extension_attributes_stock_item_max_sale_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/max_sale_qty'), "items_catalog-data-product-interface_extension_attributes_stock_item_min_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/min_qty'), "items_catalog-data-product-interface_extension_attributes_stock_item_min_sale_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/min_sale_qty'), "items_catalog-data-product-interface_extension_attributes_stock_item_notify_stock_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/notify_stock_qty'), "items_catalog-data-product-interface_extension_attributes_stock_item_product_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/product_id'), "items_catalog-data-product-interface_extension_attributes_stock_item_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/qty'), "items_catalog-data-product-interface_extension_attributes_stock_item_qty_increments" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/qty_increments'), "items_catalog-data-product-interface_extension_attributes_stock_item_show_default_notification_message" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/show_default_notification_message'), "items_catalog-data-product-interface_extension_attributes_stock_item_stock_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/stock_id'), "items_catalog-data-product-interface_extension_attributes_stock_item_stock_status_changed_auto" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/stock_status_changed_auto'), "items_catalog-data-product-interface_extension_attributes_stock_item_use_config_backorders" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/use_config_backorders'), "items_catalog-data-product-interface_extension_attributes_stock_item_use_config_enable_qty_inc" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/use_config_enable_qty_inc'), "items_catalog-data-product-interface_extension_attributes_stock_item_use_config_manage_stock" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/use_config_manage_stock'), "items_catalog-data-product-interface_extension_attributes_stock_item_use_config_max_sale_qty" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/use_config_max_sale_qty'), "items_catalog-data-product-interface_extension_attributes_stock_item_use_config_min_qty" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/use_config_min_qty'), "items_catalog-data-product-interface_extension_attributes_stock_item_use_config_min_sale_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/use_config_min_sale_qty'), "items_catalog-data-product-interface_extension_attributes_stock_item_use_config_notify_stock_qty" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/use_config_notify_stock_qty'), "items_catalog-data-product-interface_extension_attributes_stock_item_use_config_qty_increments" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/extension_attributes/stock_item/use_config_qty_increments'), "items_catalog-data-product-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/id'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/base64_encoded_data'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_name" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/name'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/type'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_disabled" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/disabled'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_media_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/media_type'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_description" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_description'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_metadata" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_metadata'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_provider" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_provider'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_title" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_title'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_url" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_url'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_file" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/file'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/id'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_label" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/label'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_media_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/media_type'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_position" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/position'), "items_catalog-data-product-interface_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_types" string[] OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/types'), "items_catalog-data-product-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/name'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_file_extension" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/file_extension'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_image_size_x" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/image_size_x'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_image_size_y" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/image_size_y'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_is_require" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/is_require'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_max_characters" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/max_characters'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/option_id'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/price'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_price_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/price_type'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_product_sku" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/product_sku'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/sku'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/sort_order'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_title" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/title'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/type'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_option_type_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/option_type_id'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price_type'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sku'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sort_order" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sort_order'), "items_catalog-data-product-interface_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_title" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/title'), "items_catalog-data-product-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/price'), "items_catalog-data-product-interface_product_links_catalog-data-product-link-interface_extension_attributes_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/product_links[]/catalog-data-product-link-interface/extension_attributes/qty'), "items_catalog-data-product-interface_product_links_catalog-data-product-link-interface_link_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/product_links[]/catalog-data-product-link-interface/link_type'), "items_catalog-data-product-interface_product_links_catalog-data-product-link-interface_linked_product_sku" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/product_links[]/catalog-data-product-link-interface/linked_product_sku'), "items_catalog-data-product-interface_product_links_catalog-data-product-link-interface_linked_product_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/product_links[]/catalog-data-product-link-interface/linked_product_type'), "items_catalog-data-product-interface_product_links_catalog-data-product-link-interface_position" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/product_links[]/catalog-data-product-link-interface/position'), "items_catalog-data-product-interface_product_links_catalog-data-product-link-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/product_links[]/catalog-data-product-link-interface/sku'), "items_catalog-data-product-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/sku'), "items_catalog-data-product-interface_status" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/status'), "items_catalog-data-product-interface_tier_prices_catalog-data-product-tier-price-interface_customer_group_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/tier_prices[]/catalog-data-product-tier-price-interface/customer_group_id'), "items_catalog-data-product-interface_tier_prices_catalog-data-product-tier-price-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/tier_prices[]/catalog-data-product-tier-price-interface/qty'), "items_catalog-data-product-interface_tier_prices_catalog-data-product-tier-price-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/tier_prices[]/catalog-data-product-tier-price-interface/value'), "items_catalog-data-product-interface_type_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/type_id'), "items_catalog-data-product-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/updated_at'), "items_catalog-data-product-interface_visibility" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/visibility'), "items_catalog-data-product-interface_weight" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-interface/weight'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Get product list', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products');

CREATE FOREIGN PROCEDURE catalogProductRepositoryV1SavePost(IN product_attribute_set_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set id', NAMEINSOURCE 'product/attribute_set_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_created_at string NOT NULL OPTIONS (ANNOTATION 'Created date', NAMEINSOURCE 'product/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'product/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'product/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Option position', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_can_change_quantity" string NOT NULL OPTIONS (ANNOTATION 'Whether quantity could be changed', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/can_change_quantity', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_id" string NOT NULL OPTIONS (ANNOTATION 'The identifier', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_is_default" boolean NOT NULL OPTIONS (ANNOTATION 'Is default', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/is_default', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Position', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Qty', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Linked product sku', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_required" boolean NOT NULL OPTIONS (ANNOTATION 'Is required option', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/required', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Product sku', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_type" string NOT NULL OPTIONS (ANNOTATION 'Input type', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_extension_attributes_configurable_product_links string[] NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_attribute_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/attribute_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_is_use_default" boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/is_use_default', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_label" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_position" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_product_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_values_configurable-product-data-option-value-interface_value_index" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/values[]/configurable-product-data-option-value-interface/value_index', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_id" string NOT NULL OPTIONS (ANNOTATION 'Sample(or link) id', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_is_shareable" string NOT NULL OPTIONS (ANNOTATION 'Shareable status', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/is_shareable', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file" string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_file_data" string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_name" string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_type" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_url" string NOT NULL OPTIONS (ANNOTATION 'Link url or null when type is ''file''', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_number_of_downloads" string NOT NULL OPTIONS (ANNOTATION 'Of downloads per user', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/number_of_downloads', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file" string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_file_data" string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_name" string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_type" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_url" string NOT NULL OPTIONS (ANNOTATION 'file URL', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sort_order" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_title" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_id" string NOT NULL OPTIONS (ANNOTATION 'Sample(or link) id', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file" string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_file_data" string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_name" string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_type" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_url" string NOT NULL OPTIONS (ANNOTATION 'file URL', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Order index for sample', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_attribute_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/attribute_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_value" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_value" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_backorders string NOT NULL OPTIONS (ANNOTATION 'Backorders status', NAMEINSOURCE 'product/extension_attributes/stock_item/backorders', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_enable_qty_increments boolean NOT NULL OPTIONS (ANNOTATION 'Whether Quantity Increments is enabled', NAMEINSOURCE 'product/extension_attributes/stock_item/enable_qty_increments', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_is_decimal_divided boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/is_decimal_divided', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_is_in_stock boolean NOT NULL OPTIONS (ANNOTATION 'Stock Availability', NAMEINSOURCE 'product/extension_attributes/stock_item/is_in_stock', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_is_qty_decimal boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/is_qty_decimal', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_item_id string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_extension_attributes_stock_item_low_stock_date string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/low_stock_date', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_manage_stock boolean NOT NULL OPTIONS (ANNOTATION 'Can Manage Stock', NAMEINSOURCE 'product/extension_attributes/stock_item/manage_stock', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_max_sale_qty string NOT NULL OPTIONS (ANNOTATION 'Maximum Qty Allowed in Shopping Cart data wrapper', NAMEINSOURCE 'product/extension_attributes/stock_item/max_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_min_qty string NOT NULL OPTIONS (ANNOTATION 'Minimal quantity available for item status in stock', NAMEINSOURCE 'product/extension_attributes/stock_item/min_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_min_sale_qty string NOT NULL OPTIONS (ANNOTATION 'Minimum Qty Allowed in Shopping Cart or NULL when there is no limitation', NAMEINSOURCE 'product/extension_attributes/stock_item/min_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_notify_stock_qty string NOT NULL OPTIONS (ANNOTATION 'Notify for Quantity Below data wrapper', NAMEINSOURCE 'product/extension_attributes/stock_item/notify_stock_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_product_id string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_extension_attributes_stock_item_qty string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_qty_increments string NOT NULL OPTIONS (ANNOTATION 'Quantity Increments data wrapper', NAMEINSOURCE 'product/extension_attributes/stock_item/qty_increments', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_show_default_notification_message boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/show_default_notification_message', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_stock_id string NOT NULL OPTIONS (ANNOTATION 'Stock identifier', NAMEINSOURCE 'product/extension_attributes/stock_item/stock_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_extension_attributes_stock_item_stock_status_changed_auto string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/stock_status_changed_auto', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_backorders boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_backorders', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_enable_qty_inc boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_enable_qty_inc', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_manage_stock boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_manage_stock', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_max_sale_qty boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_max_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_min_qty boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_min_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_min_sale_qty string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_min_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_notify_stock_qty boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_notify_stock_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_qty_increments boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_qty_increments', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'product/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_disabled" boolean NOT NULL OPTIONS (ANNOTATION 'If gallery entry is hidden from product page', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/disabled', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_media_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/media_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_description" string NOT NULL OPTIONS (ANNOTATION 'Video Description', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_description', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_metadata" string NOT NULL OPTIONS (ANNOTATION 'Metadata', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_metadata', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_provider" string NOT NULL OPTIONS (ANNOTATION 'Provider', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_provider', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_url" string NOT NULL OPTIONS (ANNOTATION 'Video URL', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_url', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_file" string NOT NULL OPTIONS (ANNOTATION 'File path', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_id" string NOT NULL OPTIONS (ANNOTATION 'Gallery entry ID', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_label" string NOT NULL OPTIONS (ANNOTATION 'Gallery entry alternative text', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/label', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_media_type" string NOT NULL OPTIONS (ANNOTATION 'Media type', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/media_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Gallery entry position (sort order)', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/position', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_types" string[] NOT NULL OPTIONS (NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/types', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_name string NOT NULL OPTIONS (ANNOTATION 'Name', NAMEINSOURCE 'product/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_file_extension" string NOT NULL OPTIONS (NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/file_extension', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_image_size_x" string NOT NULL OPTIONS (NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/image_size_x', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_image_size_y" string NOT NULL OPTIONS (NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/image_size_y', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_is_require" boolean NOT NULL OPTIONS (ANNOTATION 'Is require', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/is_require', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_max_characters" string NOT NULL OPTIONS (NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/max_characters', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_product_sku" string NOT NULL OPTIONS (ANNOTATION 'Product SKU', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/product_sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_type" string NOT NULL OPTIONS (ANNOTATION 'Option type', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_option_type_id" string NOT NULL OPTIONS (ANNOTATION 'Option type id', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/option_type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_price string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_product_links_catalog-data-product-link-interface_extension_attributes_qty" string NOT NULL OPTIONS (NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/extension_attributes/qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_product_links_catalog-data-product-link-interface_link_type" string NOT NULL OPTIONS (ANNOTATION 'Link type', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/link_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_product_links_catalog-data-product-link-interface_linked_product_sku" string NOT NULL OPTIONS (ANNOTATION 'Linked product sku', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/linked_product_sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_product_links_catalog-data-product-link-interface_linked_product_type" string NOT NULL OPTIONS (ANNOTATION 'Linked product type (simple, virtual, etc)', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/linked_product_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_product_links_catalog-data-product-link-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Linked item position', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/position', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_product_links_catalog-data-product-link-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_sku string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'product/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_status string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'product/status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_tier_prices_catalog-data-product-tier-price-interface_customer_group_id" string NOT NULL OPTIONS (ANNOTATION 'Customer group id', NAMEINSOURCE 'product/tier_prices[]/catalog-data-product-tier-price-interface/customer_group_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_tier_prices_catalog-data-product-tier-price-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Tier qty', NAMEINSOURCE 'product/tier_prices[]/catalog-data-product-tier-price-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_tier_prices_catalog-data-product-tier-price-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Price value', NAMEINSOURCE 'product/tier_prices[]/catalog-data-product-tier-price-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_type_id string NOT NULL OPTIONS (ANNOTATION 'Type id', NAMEINSOURCE 'product/type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated date', NAMEINSOURCE 'product/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_visibility string NOT NULL OPTIONS (ANNOTATION 'Visibility', NAMEINSOURCE 'product/visibility', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_weight string NOT NULL OPTIONS (ANNOTATION 'Weight', NAMEINSOURCE 'product/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN saveOptions boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (attribute_set_id string, created_at string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), "extension_attributes_bundle_product_options_bundle-data-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/option_id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/position'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_can_change_quantity" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/can_change_quantity'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/is_default'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/option_id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/position'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price_type'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/qty'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/sku'), "extension_attributes_bundle_product_options_bundle-data-option-interface_required" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/required'), "extension_attributes_bundle_product_options_bundle-data-option-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/sku'), "extension_attributes_bundle_product_options_bundle-data-option-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/title'), "extension_attributes_bundle_product_options_bundle-data-option-interface_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/type'), extension_attributes_configurable_product_links string[] OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_links'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/attribute_id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_is_use_default" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/is_use_default'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/label'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/position'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_product_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/product_id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_values_configurable-product-data-option-value-interface_value_index" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/values[]/configurable-product-data-option-value-interface/value_index'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/id'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_is_shareable" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/is_shareable'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/file_data'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/name'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_type'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_url'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_number_of_downloads" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/number_of_downloads'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/price'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/file_data'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/name'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_type'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_url'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sort_order" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sort_order'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/title'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/id'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/file_data'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/name'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_type'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_url'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sort_order" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sort_order'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/title'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/attribute_id'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/value'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_id'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_value'), extension_attributes_stock_item_backorders string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/backorders'), extension_attributes_stock_item_enable_qty_increments boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/enable_qty_increments'), extension_attributes_stock_item_is_decimal_divided boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_decimal_divided'), extension_attributes_stock_item_is_in_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_in_stock'), extension_attributes_stock_item_is_qty_decimal boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_qty_decimal'), extension_attributes_stock_item_item_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/item_id'), extension_attributes_stock_item_low_stock_date string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/low_stock_date'), extension_attributes_stock_item_manage_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/manage_stock'), extension_attributes_stock_item_max_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/max_sale_qty'), extension_attributes_stock_item_min_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/min_qty'), extension_attributes_stock_item_min_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/min_sale_qty'), extension_attributes_stock_item_notify_stock_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/notify_stock_qty'), extension_attributes_stock_item_product_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/product_id'), extension_attributes_stock_item_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/qty'), extension_attributes_stock_item_qty_increments string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/qty_increments'), extension_attributes_stock_item_show_default_notification_message boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/show_default_notification_message'), extension_attributes_stock_item_stock_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/stock_id'), extension_attributes_stock_item_stock_status_changed_auto string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/stock_status_changed_auto'), extension_attributes_stock_item_use_config_backorders boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_backorders'), extension_attributes_stock_item_use_config_enable_qty_inc boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_enable_qty_inc'), extension_attributes_stock_item_use_config_manage_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_manage_stock'), extension_attributes_stock_item_use_config_max_sale_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_max_sale_qty'), extension_attributes_stock_item_use_config_min_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_min_qty'), extension_attributes_stock_item_use_config_min_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_min_sale_qty'), extension_attributes_stock_item_use_config_notify_stock_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_notify_stock_qty'), extension_attributes_stock_item_use_config_qty_increments boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_qty_increments'), id string, "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/base64_encoded_data'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_name" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/name'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_disabled" boolean OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/disabled'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_media_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/media_type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_description" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_description'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_metadata" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_metadata'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_provider" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_provider'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_title" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_title'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_url" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_url'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_file" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/file'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_id" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/id'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_label" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/label'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_media_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/media_type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_position" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/position'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_types" string[] OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/types'), name string, "options_catalog-data-product-custom-option-interface_file_extension" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/file_extension'), "options_catalog-data-product-custom-option-interface_image_size_x" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/image_size_x'), "options_catalog-data-product-custom-option-interface_image_size_y" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/image_size_y'), "options_catalog-data-product-custom-option-interface_is_require" boolean OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/is_require'), "options_catalog-data-product-custom-option-interface_max_characters" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/max_characters'), "options_catalog-data-product-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/option_id'), "options_catalog-data-product-custom-option-interface_price" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/price'), "options_catalog-data-product-custom-option-interface_price_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/price_type'), "options_catalog-data-product-custom-option-interface_product_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/product_sku'), "options_catalog-data-product-custom-option-interface_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/sku'), "options_catalog-data-product-custom-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/sort_order'), "options_catalog-data-product-custom-option-interface_title" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/title'), "options_catalog-data-product-custom-option-interface_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/type'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_option_type_id" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/option_type_id'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price_type'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sku'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sort_order'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_title" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/title'), price string, "product_links_catalog-data-product-link-interface_extension_attributes_qty" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/extension_attributes/qty'), "product_links_catalog-data-product-link-interface_link_type" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/link_type'), "product_links_catalog-data-product-link-interface_linked_product_sku" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/linked_product_sku'), "product_links_catalog-data-product-link-interface_linked_product_type" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/linked_product_type'), "product_links_catalog-data-product-link-interface_position" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/position'), "product_links_catalog-data-product-link-interface_sku" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/sku'), sku string, status string, "tier_prices_catalog-data-product-tier-price-interface_customer_group_id" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/customer_group_id'), "tier_prices_catalog-data-product-tier-price-interface_qty" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/qty'), "tier_prices_catalog-data-product-tier-price-interface_value" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/value'), type_id string, updated_at string, visibility string, weight string)
OPTIONS (ANNOTATION 'Create product', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products');

CREATE FOREIGN PROCEDURE catalogAttributeSetManagementV1CreatePost(IN attributeSet_attribute_set_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set ID', NAMEINSOURCE 'attributeSet/attribute_set_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attributeSet_attribute_set_name string NOT NULL OPTIONS (ANNOTATION 'Attribute set name', NAMEINSOURCE 'attributeSet/attribute_set_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN attributeSet_entity_type_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set entity type id', NAMEINSOURCE 'attributeSet/entity_type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attributeSet_sort_order string NOT NULL OPTIONS (ANNOTATION 'Attribute set sort order index', NAMEINSOURCE 'attributeSet/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN skeletonId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (attribute_set_id string, attribute_set_name string, entity_type_id string, sort_order string)
OPTIONS (ANNOTATION 'Create attribute set from data', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attribute-sets');

CREATE FOREIGN PROCEDURE catalogProductAttributeManagementV1AssignPost(OUT "return" string RESULT, IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN attributeGroupId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN attributeSetId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN sortOrder string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Assign attribute to attribute set', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attribute-sets/attributes');

CREATE FOREIGN PROCEDURE catalogProductAttributeGroupRepositoryV1SavePost(IN group_attribute_group_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'group/attribute_group_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN group_attribute_group_name string NOT NULL OPTIONS (ANNOTATION 'Name', NAMEINSOURCE 'group/attribute_group_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN group_attribute_set_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set id', NAMEINSOURCE 'group/attribute_set_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN group_extension_attributes_attribute_group_code string NOT NULL OPTIONS (NAMEINSOURCE 'group/extension_attributes/attribute_group_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN group_extension_attributes_sort_order string NOT NULL OPTIONS (NAMEINSOURCE 'group/extension_attributes/sort_order', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (attribute_group_id string, attribute_group_name string, attribute_set_id string, extension_attributes_attribute_group_code string OPTIONS (NAMEINSOURCE 'extension_attributes/attribute_group_code'), extension_attributes_sort_order string OPTIONS (NAMEINSOURCE 'extension_attributes/sort_order'))
OPTIONS (ANNOTATION 'Save attribute group', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attribute-sets/groups');

CREATE FOREIGN PROCEDURE catalogProductAttributeGroupRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_eav-data-attribute-group-interface_attribute_group_id" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-group-interface/attribute_group_id'), "items_eav-data-attribute-group-interface_attribute_group_name" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-group-interface/attribute_group_name'), "items_eav-data-attribute-group-interface_attribute_set_id" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-group-interface/attribute_set_id'), "items_eav-data-attribute-group-interface_extension_attributes_attribute_group_code" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-group-interface/extension_attributes/attribute_group_code'), "items_eav-data-attribute-group-interface_extension_attributes_sort_order" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-group-interface/extension_attributes/sort_order'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Retrieve list of attribute groups', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attribute-sets/groups/list');

CREATE FOREIGN PROCEDURE catalogProductAttributeGroupRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN groupId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove attribute group by id', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attribute-sets/groups/{groupId}');

CREATE FOREIGN PROCEDURE catalogAttributeSetRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_eav-data-attribute-set-interface_attribute_set_id" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-set-interface/attribute_set_id'), "items_eav-data-attribute-set-interface_attribute_set_name" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-set-interface/attribute_set_name'), "items_eav-data-attribute-set-interface_entity_type_id" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-set-interface/entity_type_id'), "items_eav-data-attribute-set-interface_sort_order" string OPTIONS (NAMEINSOURCE 'items[]/eav-data-attribute-set-interface/sort_order'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Retrieve list of Attribute Sets', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attribute-sets/sets/list');

CREATE FOREIGN PROCEDURE catalogAttributeSetRepositoryV1GetGet(IN attributeSetId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (attribute_set_id string, attribute_set_name string, entity_type_id string, sort_order string)
OPTIONS (ANNOTATION 'Retrieve attribute set information based on given ID', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attribute-sets/{attributeSetId}');

CREATE FOREIGN PROCEDURE catalogAttributeSetRepositoryV1SavePut(IN attributeSetId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN attributeSet_attribute_set_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set ID', NAMEINSOURCE 'attributeSet/attribute_set_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attributeSet_attribute_set_name string NOT NULL OPTIONS (ANNOTATION 'Attribute set name', NAMEINSOURCE 'attributeSet/attribute_set_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN attributeSet_entity_type_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set entity type id', NAMEINSOURCE 'attributeSet/entity_type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attributeSet_sort_order string NOT NULL OPTIONS (ANNOTATION 'Attribute set sort order index', NAMEINSOURCE 'attributeSet/sort_order', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (attribute_set_id string, attribute_set_name string, entity_type_id string, sort_order string)
OPTIONS (ANNOTATION 'Save attribute set data', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attribute-sets/{attributeSetId}');

CREATE FOREIGN PROCEDURE catalogAttributeSetRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN attributeSetId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove attribute set by given ID', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attribute-sets/{attributeSetId}');

CREATE FOREIGN PROCEDURE catalogProductAttributeManagementV1GetAttributesGet(IN attributeSetId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (apply_to string[], attribute_code string, attribute_id string, backend_model string, backend_type string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_frontend_label string, default_value string, entity_type_id string, frontend_class string, frontend_input string, "frontend_labels_eav-data-attribute-frontend-label-interface_label" string OPTIONS (NAMEINSOURCE 'frontend_labels[]/eav-data-attribute-frontend-label-interface/label'), "frontend_labels_eav-data-attribute-frontend-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'frontend_labels[]/eav-data-attribute-frontend-label-interface/store_id'), is_comparable string, is_filterable boolean, is_filterable_in_grid boolean, is_filterable_in_search boolean, is_html_allowed_on_front boolean, is_required boolean, is_searchable string, is_unique string, is_used_for_promo_rules string, is_used_in_grid boolean, is_user_defined boolean, is_visible boolean, is_visible_in_advanced_search string, is_visible_in_grid boolean, is_visible_on_front string, is_wysiwyg_enabled boolean, note string, "options_eav-data-attribute-option-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/is_default'), "options_eav-data-attribute-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/label'), "options_eav-data-attribute-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/sort_order'), "options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/label'), "options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/store_id'), "options_eav-data-attribute-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/value'), position string, scope string, source_model string, used_for_sort_by boolean, used_in_product_listing string, "validation_rules_eav-data-attribute-validation-rule-interface_key" string OPTIONS (NAMEINSOURCE 'validation_rules[]/eav-data-attribute-validation-rule-interface/key'), "validation_rules_eav-data-attribute-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/eav-data-attribute-validation-rule-interface/value'))
OPTIONS (ANNOTATION 'Retrieve related attributes based on given attribute set ID', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attribute-sets/{attributeSetId}/attributes');

CREATE FOREIGN PROCEDURE catalogProductAttributeManagementV1UnassignDelete(OUT "return" boolean RESULT, IN attributeSetId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove attribute from attribute set', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attribute-sets/{attributeSetId}/attributes/{attributeCode}');

CREATE FOREIGN PROCEDURE catalogProductAttributeGroupRepositoryV1SavePut(IN attributeSetId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN group_attribute_group_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'group/attribute_group_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN group_attribute_group_name string NOT NULL OPTIONS (ANNOTATION 'Name', NAMEINSOURCE 'group/attribute_group_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN group_attribute_set_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set id', NAMEINSOURCE 'group/attribute_set_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN group_extension_attributes_attribute_group_code string NOT NULL OPTIONS (NAMEINSOURCE 'group/extension_attributes/attribute_group_code', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN group_extension_attributes_sort_order string NOT NULL OPTIONS (NAMEINSOURCE 'group/extension_attributes/sort_order', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (attribute_group_id string, attribute_group_name string, attribute_set_id string, extension_attributes_attribute_group_code string OPTIONS (NAMEINSOURCE 'extension_attributes/attribute_group_code'), extension_attributes_sort_order string OPTIONS (NAMEINSOURCE 'extension_attributes/sort_order'))
OPTIONS (ANNOTATION 'Save attribute group', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attribute-sets/{attributeSetId}/groups');

CREATE FOREIGN PROCEDURE catalogProductAttributeRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_catalog-data-product-attribute-interface_apply_to" string[] OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/apply_to'), "items_catalog-data-product-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/attribute_code'), "items_catalog-data-product-attribute-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/attribute_id'), "items_catalog-data-product-attribute-interface_backend_model" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/backend_model'), "items_catalog-data-product-attribute-interface_backend_type" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/backend_type'), "items_catalog-data-product-attribute-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_catalog-data-product-attribute-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/custom_attributes[]/framework-attribute-interface/value'), "items_catalog-data-product-attribute-interface_default_frontend_label" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/default_frontend_label'), "items_catalog-data-product-attribute-interface_default_value" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/default_value'), "items_catalog-data-product-attribute-interface_entity_type_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/entity_type_id'), "items_catalog-data-product-attribute-interface_frontend_class" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/frontend_class'), "items_catalog-data-product-attribute-interface_frontend_input" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/frontend_input'), "items_catalog-data-product-attribute-interface_frontend_labels_eav-data-attribute-frontend-label-interface_label" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/frontend_labels[]/eav-data-attribute-frontend-label-interface/label'), "items_catalog-data-product-attribute-interface_frontend_labels_eav-data-attribute-frontend-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/frontend_labels[]/eav-data-attribute-frontend-label-interface/store_id'), "items_catalog-data-product-attribute-interface_is_comparable" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_comparable'), "items_catalog-data-product-attribute-interface_is_filterable" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_filterable'), "items_catalog-data-product-attribute-interface_is_filterable_in_grid" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_filterable_in_grid'), "items_catalog-data-product-attribute-interface_is_filterable_in_search" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_filterable_in_search'), "items_catalog-data-product-attribute-interface_is_html_allowed_on_front" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_html_allowed_on_front'), "items_catalog-data-product-attribute-interface_is_required" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_required'), "items_catalog-data-product-attribute-interface_is_searchable" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_searchable'), "items_catalog-data-product-attribute-interface_is_unique" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_unique'), "items_catalog-data-product-attribute-interface_is_used_for_promo_rules" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_used_for_promo_rules'), "items_catalog-data-product-attribute-interface_is_used_in_grid" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_used_in_grid'), "items_catalog-data-product-attribute-interface_is_user_defined" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_user_defined'), "items_catalog-data-product-attribute-interface_is_visible" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_visible'), "items_catalog-data-product-attribute-interface_is_visible_in_advanced_search" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_visible_in_advanced_search'), "items_catalog-data-product-attribute-interface_is_visible_in_grid" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_visible_in_grid'), "items_catalog-data-product-attribute-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_visible_on_front'), "items_catalog-data-product-attribute-interface_is_wysiwyg_enabled" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/is_wysiwyg_enabled'), "items_catalog-data-product-attribute-interface_note" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/note'), "items_catalog-data-product-attribute-interface_options_eav-data-attribute-option-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/options[]/eav-data-attribute-option-interface/is_default'), "items_catalog-data-product-attribute-interface_options_eav-data-attribute-option-interface_label" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/options[]/eav-data-attribute-option-interface/label'), "items_catalog-data-product-attribute-interface_options_eav-data-attribute-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/options[]/eav-data-attribute-option-interface/sort_order'), "items_catalog-data-product-attribute-interface_options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_label" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/label'), "items_catalog-data-product-attribute-interface_options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/store_id'), "items_catalog-data-product-attribute-interface_options_eav-data-attribute-option-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/options[]/eav-data-attribute-option-interface/value'), "items_catalog-data-product-attribute-interface_position" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/position'), "items_catalog-data-product-attribute-interface_scope" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/scope'), "items_catalog-data-product-attribute-interface_source_model" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/source_model'), "items_catalog-data-product-attribute-interface_used_for_sort_by" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/used_for_sort_by'), "items_catalog-data-product-attribute-interface_used_in_product_listing" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/used_in_product_listing'), "items_catalog-data-product-attribute-interface_validation_rules_eav-data-attribute-validation-rule-interface_key" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/validation_rules[]/eav-data-attribute-validation-rule-interface/key'), "items_catalog-data-product-attribute-interface_validation_rules_eav-data-attribute-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-attribute-interface/validation_rules[]/eav-data-attribute-validation-rule-interface/value'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Retrieve all attributes for entity type', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attributes');

CREATE FOREIGN PROCEDURE catalogProductAttributeRepositoryV1SavePost(IN attribute_apply_to string[] NOT NULL OPTIONS (NAMEINSOURCE 'attribute/apply_to', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_attribute_code string NOT NULL OPTIONS (ANNOTATION 'Code of the attribute.', NAMEINSOURCE 'attribute/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN attribute_attribute_id string NOT NULL OPTIONS (ANNOTATION 'Id of the attribute.', NAMEINSOURCE 'attribute/attribute_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_backend_model string NOT NULL OPTIONS (ANNOTATION 'Backend model', NAMEINSOURCE 'attribute/backend_model', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_backend_type string NOT NULL OPTIONS (ANNOTATION 'Backend type.', NAMEINSOURCE 'attribute/backend_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'attribute/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "attribute_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'attribute/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN attribute_default_frontend_label string NOT NULL OPTIONS (ANNOTATION 'Frontend label for default store', NAMEINSOURCE 'attribute/default_frontend_label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_default_value string NOT NULL OPTIONS (ANNOTATION 'Default value for the element.', NAMEINSOURCE 'attribute/default_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_entity_type_id string NOT NULL OPTIONS (ANNOTATION 'Entity type id', NAMEINSOURCE 'attribute/entity_type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_frontend_class string NOT NULL OPTIONS (ANNOTATION 'Frontend class of attribute', NAMEINSOURCE 'attribute/frontend_class', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_frontend_input string NOT NULL OPTIONS (ANNOTATION 'HTML for input element.', NAMEINSOURCE 'attribute/frontend_input', "teiid_rest:PARAMETER_TYPE" 'body'), IN "attribute_frontend_labels_eav-data-attribute-frontend-label-interface_label" string NOT NULL OPTIONS (ANNOTATION 'Option label', NAMEINSOURCE 'attribute/frontend_labels[]/eav-data-attribute-frontend-label-interface/label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_frontend_labels_eav-data-attribute-frontend-label-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store id', NAMEINSOURCE 'attribute/frontend_labels[]/eav-data-attribute-frontend-label-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_comparable string NOT NULL OPTIONS (ANNOTATION 'The attribute can be compared on the frontend', NAMEINSOURCE 'attribute/is_comparable', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_filterable boolean NOT NULL OPTIONS (ANNOTATION 'It used in layered navigation', NAMEINSOURCE 'attribute/is_filterable', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_filterable_in_grid boolean NOT NULL OPTIONS (ANNOTATION 'It is filterable in catalog product grid', NAMEINSOURCE 'attribute/is_filterable_in_grid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_filterable_in_search boolean NOT NULL OPTIONS (ANNOTATION 'It is used in search results layered navigation', NAMEINSOURCE 'attribute/is_filterable_in_search', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_html_allowed_on_front boolean NOT NULL OPTIONS (ANNOTATION 'The HTML tags are allowed on the frontend', NAMEINSOURCE 'attribute/is_html_allowed_on_front', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_required boolean NOT NULL OPTIONS (ANNOTATION 'Attribute is required.', NAMEINSOURCE 'attribute/is_required', "teiid_rest:PARAMETER_TYPE" 'body'), IN attribute_is_searchable string NOT NULL OPTIONS (ANNOTATION 'The attribute can be used in Quick Search', NAMEINSOURCE 'attribute/is_searchable', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_unique string NOT NULL OPTIONS (ANNOTATION 'This is a unique attribute', NAMEINSOURCE 'attribute/is_unique', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_used_for_promo_rules string NOT NULL OPTIONS (ANNOTATION 'The attribute can be used for promo rules', NAMEINSOURCE 'attribute/is_used_for_promo_rules', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_used_in_grid boolean NOT NULL OPTIONS (ANNOTATION 'It is used in catalog product grid', NAMEINSOURCE 'attribute/is_used_in_grid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_user_defined boolean NOT NULL OPTIONS (ANNOTATION 'Current attribute has been defined by a user.', NAMEINSOURCE 'attribute/is_user_defined', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_visible boolean NOT NULL OPTIONS (ANNOTATION 'Attribute is visible on frontend.', NAMEINSOURCE 'attribute/is_visible', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_visible_in_advanced_search string NOT NULL OPTIONS (ANNOTATION 'The attribute can be used in Advanced Search', NAMEINSOURCE 'attribute/is_visible_in_advanced_search', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_visible_in_grid boolean NOT NULL OPTIONS (ANNOTATION 'It is visible in catalog product grid', NAMEINSOURCE 'attribute/is_visible_in_grid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_visible_on_front string NOT NULL OPTIONS (ANNOTATION 'The attribute is visible on the frontend', NAMEINSOURCE 'attribute/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_wysiwyg_enabled boolean NOT NULL OPTIONS (ANNOTATION 'WYSIWYG flag', NAMEINSOURCE 'attribute/is_wysiwyg_enabled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_note string NOT NULL OPTIONS (ANNOTATION 'The note attribute for the element.', NAMEINSOURCE 'attribute/note', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_options_eav-data-attribute-option-interface_is_default" boolean NOT NULL OPTIONS (ANNOTATION 'Default', NAMEINSOURCE 'attribute/options[]/eav-data-attribute-option-interface/is_default', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_options_eav-data-attribute-option-interface_label" string NOT NULL OPTIONS (ANNOTATION 'Option label', NAMEINSOURCE 'attribute/options[]/eav-data-attribute-option-interface/label', "teiid_rest:PARAMETER_TYPE" 'body'), IN "attribute_options_eav-data-attribute-option-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Option order', NAMEINSOURCE 'attribute/options[]/eav-data-attribute-option-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_label" string NOT NULL OPTIONS (ANNOTATION 'Option label', NAMEINSOURCE 'attribute/options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store id', NAMEINSOURCE 'attribute/options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_options_eav-data-attribute-option-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'attribute/options[]/eav-data-attribute-option-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN attribute_position string NOT NULL OPTIONS (ANNOTATION 'Position', NAMEINSOURCE 'attribute/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_scope string NOT NULL OPTIONS (ANNOTATION 'Attribute scope', NAMEINSOURCE 'attribute/scope', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_source_model string NOT NULL OPTIONS (ANNOTATION 'Source model', NAMEINSOURCE 'attribute/source_model', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_used_for_sort_by boolean NOT NULL OPTIONS (ANNOTATION 'It is used for sorting in product listing', NAMEINSOURCE 'attribute/used_for_sort_by', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_used_in_product_listing string NOT NULL OPTIONS (ANNOTATION 'The attribute can be used in product listing', NAMEINSOURCE 'attribute/used_in_product_listing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_validation_rules_eav-data-attribute-validation-rule-interface_key" string NOT NULL OPTIONS (ANNOTATION 'Object key', NAMEINSOURCE 'attribute/validation_rules[]/eav-data-attribute-validation-rule-interface/key', "teiid_rest:PARAMETER_TYPE" 'body'), IN "attribute_validation_rules_eav-data-attribute-validation-rule-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Object value', NAMEINSOURCE 'attribute/validation_rules[]/eav-data-attribute-validation-rule-interface/value', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (apply_to string[], attribute_code string, attribute_id string, backend_model string, backend_type string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_frontend_label string, default_value string, entity_type_id string, frontend_class string, frontend_input string, "frontend_labels_eav-data-attribute-frontend-label-interface_label" string OPTIONS (NAMEINSOURCE 'frontend_labels[]/eav-data-attribute-frontend-label-interface/label'), "frontend_labels_eav-data-attribute-frontend-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'frontend_labels[]/eav-data-attribute-frontend-label-interface/store_id'), is_comparable string, is_filterable boolean, is_filterable_in_grid boolean, is_filterable_in_search boolean, is_html_allowed_on_front boolean, is_required boolean, is_searchable string, is_unique string, is_used_for_promo_rules string, is_used_in_grid boolean, is_user_defined boolean, is_visible boolean, is_visible_in_advanced_search string, is_visible_in_grid boolean, is_visible_on_front string, is_wysiwyg_enabled boolean, note string, "options_eav-data-attribute-option-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/is_default'), "options_eav-data-attribute-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/label'), "options_eav-data-attribute-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/sort_order'), "options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/label'), "options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/store_id'), "options_eav-data-attribute-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/value'), position string, scope string, source_model string, used_for_sort_by boolean, used_in_product_listing string, "validation_rules_eav-data-attribute-validation-rule-interface_key" string OPTIONS (NAMEINSOURCE 'validation_rules[]/eav-data-attribute-validation-rule-interface/key'), "validation_rules_eav-data-attribute-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/eav-data-attribute-validation-rule-interface/value'))
OPTIONS (ANNOTATION 'Save attribute data', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attributes');

CREATE FOREIGN PROCEDURE catalogProductAttributeTypesListV1GetItemsGet() RETURNS TABLE (label string, "value" string)
OPTIONS (ANNOTATION 'Retrieve list of product attribute types', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attributes/types');

CREATE FOREIGN PROCEDURE catalogProductAttributeRepositoryV1GetGet(IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (apply_to string[], attribute_code string, attribute_id string, backend_model string, backend_type string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_frontend_label string, default_value string, entity_type_id string, frontend_class string, frontend_input string, "frontend_labels_eav-data-attribute-frontend-label-interface_label" string OPTIONS (NAMEINSOURCE 'frontend_labels[]/eav-data-attribute-frontend-label-interface/label'), "frontend_labels_eav-data-attribute-frontend-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'frontend_labels[]/eav-data-attribute-frontend-label-interface/store_id'), is_comparable string, is_filterable boolean, is_filterable_in_grid boolean, is_filterable_in_search boolean, is_html_allowed_on_front boolean, is_required boolean, is_searchable string, is_unique string, is_used_for_promo_rules string, is_used_in_grid boolean, is_user_defined boolean, is_visible boolean, is_visible_in_advanced_search string, is_visible_in_grid boolean, is_visible_on_front string, is_wysiwyg_enabled boolean, note string, "options_eav-data-attribute-option-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/is_default'), "options_eav-data-attribute-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/label'), "options_eav-data-attribute-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/sort_order'), "options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/label'), "options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/store_id'), "options_eav-data-attribute-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/value'), position string, scope string, source_model string, used_for_sort_by boolean, used_in_product_listing string, "validation_rules_eav-data-attribute-validation-rule-interface_key" string OPTIONS (NAMEINSOURCE 'validation_rules[]/eav-data-attribute-validation-rule-interface/key'), "validation_rules_eav-data-attribute-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/eav-data-attribute-validation-rule-interface/value'))
OPTIONS (ANNOTATION 'Retrieve specific attribute', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attributes/{attributeCode}');

CREATE FOREIGN PROCEDURE catalogProductAttributeRepositoryV1SavePut(IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN attribute_apply_to string[] NOT NULL OPTIONS (NAMEINSOURCE 'attribute/apply_to', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_attribute_code string NOT NULL OPTIONS (ANNOTATION 'Code of the attribute.', NAMEINSOURCE 'attribute/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN attribute_attribute_id string NOT NULL OPTIONS (ANNOTATION 'Id of the attribute.', NAMEINSOURCE 'attribute/attribute_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_backend_model string NOT NULL OPTIONS (ANNOTATION 'Backend model', NAMEINSOURCE 'attribute/backend_model', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_backend_type string NOT NULL OPTIONS (ANNOTATION 'Backend type.', NAMEINSOURCE 'attribute/backend_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'attribute/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "attribute_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'attribute/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN attribute_default_frontend_label string NOT NULL OPTIONS (ANNOTATION 'Frontend label for default store', NAMEINSOURCE 'attribute/default_frontend_label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_default_value string NOT NULL OPTIONS (ANNOTATION 'Default value for the element.', NAMEINSOURCE 'attribute/default_value', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_entity_type_id string NOT NULL OPTIONS (ANNOTATION 'Entity type id', NAMEINSOURCE 'attribute/entity_type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_frontend_class string NOT NULL OPTIONS (ANNOTATION 'Frontend class of attribute', NAMEINSOURCE 'attribute/frontend_class', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_frontend_input string NOT NULL OPTIONS (ANNOTATION 'HTML for input element.', NAMEINSOURCE 'attribute/frontend_input', "teiid_rest:PARAMETER_TYPE" 'body'), IN "attribute_frontend_labels_eav-data-attribute-frontend-label-interface_label" string NOT NULL OPTIONS (ANNOTATION 'Option label', NAMEINSOURCE 'attribute/frontend_labels[]/eav-data-attribute-frontend-label-interface/label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_frontend_labels_eav-data-attribute-frontend-label-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store id', NAMEINSOURCE 'attribute/frontend_labels[]/eav-data-attribute-frontend-label-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_comparable string NOT NULL OPTIONS (ANNOTATION 'The attribute can be compared on the frontend', NAMEINSOURCE 'attribute/is_comparable', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_filterable boolean NOT NULL OPTIONS (ANNOTATION 'It used in layered navigation', NAMEINSOURCE 'attribute/is_filterable', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_filterable_in_grid boolean NOT NULL OPTIONS (ANNOTATION 'It is filterable in catalog product grid', NAMEINSOURCE 'attribute/is_filterable_in_grid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_filterable_in_search boolean NOT NULL OPTIONS (ANNOTATION 'It is used in search results layered navigation', NAMEINSOURCE 'attribute/is_filterable_in_search', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_html_allowed_on_front boolean NOT NULL OPTIONS (ANNOTATION 'The HTML tags are allowed on the frontend', NAMEINSOURCE 'attribute/is_html_allowed_on_front', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_required boolean NOT NULL OPTIONS (ANNOTATION 'Attribute is required.', NAMEINSOURCE 'attribute/is_required', "teiid_rest:PARAMETER_TYPE" 'body'), IN attribute_is_searchable string NOT NULL OPTIONS (ANNOTATION 'The attribute can be used in Quick Search', NAMEINSOURCE 'attribute/is_searchable', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_unique string NOT NULL OPTIONS (ANNOTATION 'This is a unique attribute', NAMEINSOURCE 'attribute/is_unique', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_used_for_promo_rules string NOT NULL OPTIONS (ANNOTATION 'The attribute can be used for promo rules', NAMEINSOURCE 'attribute/is_used_for_promo_rules', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_used_in_grid boolean NOT NULL OPTIONS (ANNOTATION 'It is used in catalog product grid', NAMEINSOURCE 'attribute/is_used_in_grid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_user_defined boolean NOT NULL OPTIONS (ANNOTATION 'Current attribute has been defined by a user.', NAMEINSOURCE 'attribute/is_user_defined', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_visible boolean NOT NULL OPTIONS (ANNOTATION 'Attribute is visible on frontend.', NAMEINSOURCE 'attribute/is_visible', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_visible_in_advanced_search string NOT NULL OPTIONS (ANNOTATION 'The attribute can be used in Advanced Search', NAMEINSOURCE 'attribute/is_visible_in_advanced_search', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_visible_in_grid boolean NOT NULL OPTIONS (ANNOTATION 'It is visible in catalog product grid', NAMEINSOURCE 'attribute/is_visible_in_grid', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_visible_on_front string NOT NULL OPTIONS (ANNOTATION 'The attribute is visible on the frontend', NAMEINSOURCE 'attribute/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_is_wysiwyg_enabled boolean NOT NULL OPTIONS (ANNOTATION 'WYSIWYG flag', NAMEINSOURCE 'attribute/is_wysiwyg_enabled', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_note string NOT NULL OPTIONS (ANNOTATION 'The note attribute for the element.', NAMEINSOURCE 'attribute/note', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_options_eav-data-attribute-option-interface_is_default" boolean NOT NULL OPTIONS (ANNOTATION 'Default', NAMEINSOURCE 'attribute/options[]/eav-data-attribute-option-interface/is_default', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_options_eav-data-attribute-option-interface_label" string NOT NULL OPTIONS (ANNOTATION 'Option label', NAMEINSOURCE 'attribute/options[]/eav-data-attribute-option-interface/label', "teiid_rest:PARAMETER_TYPE" 'body'), IN "attribute_options_eav-data-attribute-option-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Option order', NAMEINSOURCE 'attribute/options[]/eav-data-attribute-option-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_label" string NOT NULL OPTIONS (ANNOTATION 'Option label', NAMEINSOURCE 'attribute/options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store id', NAMEINSOURCE 'attribute/options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_options_eav-data-attribute-option-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'attribute/options[]/eav-data-attribute-option-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN attribute_position string NOT NULL OPTIONS (ANNOTATION 'Position', NAMEINSOURCE 'attribute/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_scope string NOT NULL OPTIONS (ANNOTATION 'Attribute scope', NAMEINSOURCE 'attribute/scope', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_source_model string NOT NULL OPTIONS (ANNOTATION 'Source model', NAMEINSOURCE 'attribute/source_model', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_used_for_sort_by boolean NOT NULL OPTIONS (ANNOTATION 'It is used for sorting in product listing', NAMEINSOURCE 'attribute/used_for_sort_by', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN attribute_used_in_product_listing string NOT NULL OPTIONS (ANNOTATION 'The attribute can be used in product listing', NAMEINSOURCE 'attribute/used_in_product_listing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "attribute_validation_rules_eav-data-attribute-validation-rule-interface_key" string NOT NULL OPTIONS (ANNOTATION 'Object key', NAMEINSOURCE 'attribute/validation_rules[]/eav-data-attribute-validation-rule-interface/key', "teiid_rest:PARAMETER_TYPE" 'body'), IN "attribute_validation_rules_eav-data-attribute-validation-rule-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Object value', NAMEINSOURCE 'attribute/validation_rules[]/eav-data-attribute-validation-rule-interface/value', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (apply_to string[], attribute_code string, attribute_id string, backend_model string, backend_type string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_frontend_label string, default_value string, entity_type_id string, frontend_class string, frontend_input string, "frontend_labels_eav-data-attribute-frontend-label-interface_label" string OPTIONS (NAMEINSOURCE 'frontend_labels[]/eav-data-attribute-frontend-label-interface/label'), "frontend_labels_eav-data-attribute-frontend-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'frontend_labels[]/eav-data-attribute-frontend-label-interface/store_id'), is_comparable string, is_filterable boolean, is_filterable_in_grid boolean, is_filterable_in_search boolean, is_html_allowed_on_front boolean, is_required boolean, is_searchable string, is_unique string, is_used_for_promo_rules string, is_used_in_grid boolean, is_user_defined boolean, is_visible boolean, is_visible_in_advanced_search string, is_visible_in_grid boolean, is_visible_on_front string, is_wysiwyg_enabled boolean, note string, "options_eav-data-attribute-option-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/is_default'), "options_eav-data-attribute-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/label'), "options_eav-data-attribute-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/sort_order'), "options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/label'), "options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/store_id'), "options_eav-data-attribute-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/value'), position string, scope string, source_model string, used_for_sort_by boolean, used_in_product_listing string, "validation_rules_eav-data-attribute-validation-rule-interface_key" string OPTIONS (NAMEINSOURCE 'validation_rules[]/eav-data-attribute-validation-rule-interface/key'), "validation_rules_eav-data-attribute-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/eav-data-attribute-validation-rule-interface/value'))
OPTIONS (ANNOTATION 'Save attribute data', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attributes/{attributeCode}');

CREATE FOREIGN PROCEDURE catalogProductAttributeRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete Attribute by id', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attributes/{attributeCode}');

CREATE FOREIGN PROCEDURE catalogProductAttributeOptionManagementV1GetItemsGet(IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (is_default boolean, label string, sort_order string, "store_labels_eav-data-attribute-option-label-interface_label" string OPTIONS (NAMEINSOURCE 'store_labels[]/eav-data-attribute-option-label-interface/label'), "store_labels_eav-data-attribute-option-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'store_labels[]/eav-data-attribute-option-label-interface/store_id'), "value" string)
OPTIONS (ANNOTATION 'Retrieve list of attribute options', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attributes/{attributeCode}/options');

CREATE FOREIGN PROCEDURE catalogProductAttributeOptionManagementV1AddPost(OUT "return" boolean RESULT, IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN option_is_default boolean NOT NULL OPTIONS (ANNOTATION 'Default', NAMEINSOURCE 'option/is_default', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_label string NOT NULL OPTIONS (ANNOTATION 'Option label', NAMEINSOURCE 'option/label', "teiid_rest:PARAMETER_TYPE" 'body'), IN option_sort_order string NOT NULL OPTIONS (ANNOTATION 'Option order', NAMEINSOURCE 'option/sort_order', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_store_labels_eav-data-attribute-option-label-interface_label" string NOT NULL OPTIONS (ANNOTATION 'Option label', NAMEINSOURCE 'option/store_labels[]/eav-data-attribute-option-label-interface/label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_store_labels_eav-data-attribute-option-label-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store id', NAMEINSOURCE 'option/store_labels[]/eav-data-attribute-option-label-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_value string NOT NULL OPTIONS (ANNOTATION 'Option value', NAMEINSOURCE 'option/value', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Add option to attribute', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attributes/{attributeCode}/options');

CREATE FOREIGN PROCEDURE catalogProductAttributeOptionManagementV1DeleteDelete(OUT "return" boolean RESULT, IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN optionId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete option from attribute', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/attributes/{attributeCode}/options/{optionId}');

CREATE FOREIGN PROCEDURE downloadableSampleRepositoryV1DeleteDelete(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete downloadable sample', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/downloadable-links/samples/{id}');

CREATE FOREIGN PROCEDURE downloadableLinkRepositoryV1DeleteDelete(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete downloadable link', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/downloadable-links/{id}');

CREATE FOREIGN PROCEDURE catalogProductLinkTypeListV1GetItemsGet() RETURNS TABLE (code string, name string)
OPTIONS (ANNOTATION 'Retrieve information about available product link types', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/links/types');

CREATE FOREIGN PROCEDURE catalogProductLinkTypeListV1GetItemAttributesGet(IN type string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, type string)
OPTIONS (ANNOTATION 'Provide a list of the product link type attributes', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/links/{type}/attributes');

CREATE FOREIGN PROCEDURE catalogProductMediaAttributeManagementV1GetListGet(IN attributeSetName string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (apply_to string[], attribute_code string, attribute_id string, backend_model string, backend_type string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), default_frontend_label string, default_value string, entity_type_id string, frontend_class string, frontend_input string, "frontend_labels_eav-data-attribute-frontend-label-interface_label" string OPTIONS (NAMEINSOURCE 'frontend_labels[]/eav-data-attribute-frontend-label-interface/label'), "frontend_labels_eav-data-attribute-frontend-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'frontend_labels[]/eav-data-attribute-frontend-label-interface/store_id'), is_comparable string, is_filterable boolean, is_filterable_in_grid boolean, is_filterable_in_search boolean, is_html_allowed_on_front boolean, is_required boolean, is_searchable string, is_unique string, is_used_for_promo_rules string, is_used_in_grid boolean, is_user_defined boolean, is_visible boolean, is_visible_in_advanced_search string, is_visible_in_grid boolean, is_visible_on_front string, is_wysiwyg_enabled boolean, note string, "options_eav-data-attribute-option-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/is_default'), "options_eav-data-attribute-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/label'), "options_eav-data-attribute-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/sort_order'), "options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/label'), "options_eav-data-attribute-option-interface_store_labels_eav-data-attribute-option-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/store_labels[]/eav-data-attribute-option-label-interface/store_id'), "options_eav-data-attribute-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/eav-data-attribute-option-interface/value'), position string, scope string, source_model string, used_for_sort_by boolean, used_in_product_listing string, "validation_rules_eav-data-attribute-validation-rule-interface_key" string OPTIONS (NAMEINSOURCE 'validation_rules[]/eav-data-attribute-validation-rule-interface/key'), "validation_rules_eav-data-attribute-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/eav-data-attribute-validation-rule-interface/value'))
OPTIONS (ANNOTATION 'Retrieve the list of media attributes (fronted input type is media_image) assigned to the given attribute set.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/media/types/{attributeSetName}');

CREATE FOREIGN PROCEDURE catalogProductCustomOptionRepositoryV1SavePost(IN option_file_extension string NOT NULL OPTIONS (NAMEINSOURCE 'option/file_extension', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_image_size_x string NOT NULL OPTIONS (NAMEINSOURCE 'option/image_size_x', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_image_size_y string NOT NULL OPTIONS (NAMEINSOURCE 'option/image_size_y', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_is_require boolean NOT NULL OPTIONS (ANNOTATION 'Is require', NAMEINSOURCE 'option/is_require', "teiid_rest:PARAMETER_TYPE" 'body'), IN option_max_characters string NOT NULL OPTIONS (NAMEINSOURCE 'option/max_characters', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_option_id string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'option/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_price string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'option/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_price_type string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'option/price_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_product_sku string NOT NULL OPTIONS (ANNOTATION 'Product SKU', NAMEINSOURCE 'option/product_sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN option_sku string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'option/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_sort_order string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'option/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN option_title string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'option/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN option_type string NOT NULL OPTIONS (ANNOTATION 'Option type', NAMEINSOURCE 'option/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_values_catalog-data-product-custom-option-values-interface_option_type_id" string NOT NULL OPTIONS (ANNOTATION 'Option type id', NAMEINSOURCE 'option/values[]/catalog-data-product-custom-option-values-interface/option_type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_values_catalog-data-product-custom-option-values-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'option/values[]/catalog-data-product-custom-option-values-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_values_catalog-data-product-custom-option-values-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'option/values[]/catalog-data-product-custom-option-values-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_values_catalog-data-product-custom-option-values-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'option/values[]/catalog-data-product-custom-option-values-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_values_catalog-data-product-custom-option-values-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'option/values[]/catalog-data-product-custom-option-values-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_values_catalog-data-product-custom-option-values-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'option/values[]/catalog-data-product-custom-option-values-interface/title', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (file_extension string, image_size_x string, image_size_y string, is_require boolean, max_characters string, option_id string, price string, price_type string, product_sku string, sku string, sort_order string, title string, type string, "values_catalog-data-product-custom-option-values-interface_option_type_id" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/option_type_id'), "values_catalog-data-product-custom-option-values-interface_price" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/price'), "values_catalog-data-product-custom-option-values-interface_price_type" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/price_type'), "values_catalog-data-product-custom-option-values-interface_sku" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/sku'), "values_catalog-data-product-custom-option-values-interface_sort_order" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/sort_order'), "values_catalog-data-product-custom-option-values-interface_title" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/title'))
OPTIONS (ANNOTATION 'Save Custom Option', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/options');

CREATE FOREIGN PROCEDURE catalogProductCustomOptionTypeListV1GetItemsGet() RETURNS TABLE (code string, "group" string, label string)
OPTIONS (ANNOTATION 'Get custom option types', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/options/types');

CREATE FOREIGN PROCEDURE catalogProductCustomOptionRepositoryV1SavePut(IN optionId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN option_file_extension string NOT NULL OPTIONS (NAMEINSOURCE 'option/file_extension', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_image_size_x string NOT NULL OPTIONS (NAMEINSOURCE 'option/image_size_x', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_image_size_y string NOT NULL OPTIONS (NAMEINSOURCE 'option/image_size_y', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_is_require boolean NOT NULL OPTIONS (ANNOTATION 'Is require', NAMEINSOURCE 'option/is_require', "teiid_rest:PARAMETER_TYPE" 'body'), IN option_max_characters string NOT NULL OPTIONS (NAMEINSOURCE 'option/max_characters', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_option_id string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'option/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_price string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'option/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_price_type string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'option/price_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_product_sku string NOT NULL OPTIONS (ANNOTATION 'Product SKU', NAMEINSOURCE 'option/product_sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN option_sku string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'option/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN option_sort_order string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'option/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN option_title string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'option/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN option_type string NOT NULL OPTIONS (ANNOTATION 'Option type', NAMEINSOURCE 'option/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_values_catalog-data-product-custom-option-values-interface_option_type_id" string NOT NULL OPTIONS (ANNOTATION 'Option type id', NAMEINSOURCE 'option/values[]/catalog-data-product-custom-option-values-interface/option_type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_values_catalog-data-product-custom-option-values-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'option/values[]/catalog-data-product-custom-option-values-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_values_catalog-data-product-custom-option-values-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'option/values[]/catalog-data-product-custom-option-values-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_values_catalog-data-product-custom-option-values-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'option/values[]/catalog-data-product-custom-option-values-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "option_values_catalog-data-product-custom-option-values-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'option/values[]/catalog-data-product-custom-option-values-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "option_values_catalog-data-product-custom-option-values-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'option/values[]/catalog-data-product-custom-option-values-interface/title', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (file_extension string, image_size_x string, image_size_y string, is_require boolean, max_characters string, option_id string, price string, price_type string, product_sku string, sku string, sort_order string, title string, type string, "values_catalog-data-product-custom-option-values-interface_option_type_id" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/option_type_id'), "values_catalog-data-product-custom-option-values-interface_price" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/price'), "values_catalog-data-product-custom-option-values-interface_price_type" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/price_type'), "values_catalog-data-product-custom-option-values-interface_sku" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/sku'), "values_catalog-data-product-custom-option-values-interface_sort_order" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/sort_order'), "values_catalog-data-product-custom-option-values-interface_title" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/title'))
OPTIONS (ANNOTATION 'Save Custom Option', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/options/{optionId}');

CREATE FOREIGN PROCEDURE catalogProductTypeListV1GetProductTypesGet() RETURNS TABLE (label string, name string)
OPTIONS (ANNOTATION 'Retrieve available product types', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/types');

CREATE FOREIGN PROCEDURE catalogInventoryStockRegistryV1UpdateStockItemBySkuPut(OUT "return" string RESULT, IN productSku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN itemId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN stockItem_backorders string NOT NULL OPTIONS (ANNOTATION 'Backorders status', NAMEINSOURCE 'stockItem/backorders', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_enable_qty_increments boolean NOT NULL OPTIONS (ANNOTATION 'Whether Quantity Increments is enabled', NAMEINSOURCE 'stockItem/enable_qty_increments', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_is_decimal_divided boolean NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/is_decimal_divided', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_is_in_stock boolean NOT NULL OPTIONS (ANNOTATION 'Stock Availability', NAMEINSOURCE 'stockItem/is_in_stock', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_is_qty_decimal boolean NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/is_qty_decimal', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_item_id string NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN stockItem_low_stock_date string NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/low_stock_date', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_manage_stock boolean NOT NULL OPTIONS (ANNOTATION 'Can Manage Stock', NAMEINSOURCE 'stockItem/manage_stock', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_max_sale_qty string NOT NULL OPTIONS (ANNOTATION 'Maximum Qty Allowed in Shopping Cart data wrapper', NAMEINSOURCE 'stockItem/max_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_min_qty string NOT NULL OPTIONS (ANNOTATION 'Minimal quantity available for item status in stock', NAMEINSOURCE 'stockItem/min_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_min_sale_qty string NOT NULL OPTIONS (ANNOTATION 'Minimum Qty Allowed in Shopping Cart or NULL when there is no limitation', NAMEINSOURCE 'stockItem/min_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_notify_stock_qty string NOT NULL OPTIONS (ANNOTATION 'Notify for Quantity Below data wrapper', NAMEINSOURCE 'stockItem/notify_stock_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_product_id string NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN stockItem_qty string NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_qty_increments string NOT NULL OPTIONS (ANNOTATION 'Quantity Increments data wrapper', NAMEINSOURCE 'stockItem/qty_increments', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_show_default_notification_message boolean NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/show_default_notification_message', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_stock_id string NOT NULL OPTIONS (ANNOTATION 'Stock identifier', NAMEINSOURCE 'stockItem/stock_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN stockItem_stock_status_changed_auto string NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/stock_status_changed_auto', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_use_config_backorders boolean NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/use_config_backorders', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_use_config_enable_qty_inc boolean NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/use_config_enable_qty_inc', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_use_config_manage_stock boolean NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/use_config_manage_stock', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_use_config_max_sale_qty boolean NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/use_config_max_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_use_config_min_qty boolean NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/use_config_min_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_use_config_min_sale_qty string NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/use_config_min_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_use_config_notify_stock_qty boolean NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/use_config_notify_stock_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN stockItem_use_config_qty_increments boolean NOT NULL OPTIONS (NAMEINSOURCE 'stockItem/use_config_qty_increments', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS ("teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{productSku}/stockItems/{itemId}');

CREATE FOREIGN PROCEDURE catalogProductRepositoryV1GetGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN editMode boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN storeId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN forceReload boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (attribute_set_id string, created_at string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), "extension_attributes_bundle_product_options_bundle-data-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/option_id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/position'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_can_change_quantity" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/can_change_quantity'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/is_default'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/option_id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/position'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price_type'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/qty'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/sku'), "extension_attributes_bundle_product_options_bundle-data-option-interface_required" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/required'), "extension_attributes_bundle_product_options_bundle-data-option-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/sku'), "extension_attributes_bundle_product_options_bundle-data-option-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/title'), "extension_attributes_bundle_product_options_bundle-data-option-interface_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/type'), extension_attributes_configurable_product_links string[] OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_links'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/attribute_id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_is_use_default" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/is_use_default'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/label'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/position'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_product_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/product_id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_values_configurable-product-data-option-value-interface_value_index" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/values[]/configurable-product-data-option-value-interface/value_index'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/id'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_is_shareable" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/is_shareable'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/file_data'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/name'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_type'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_url'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_number_of_downloads" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/number_of_downloads'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/price'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/file_data'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/name'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_type'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_url'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sort_order" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sort_order'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/title'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/id'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/file_data'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/name'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_type'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_url'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sort_order" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sort_order'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/title'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/attribute_id'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/value'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_id'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_value'), extension_attributes_stock_item_backorders string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/backorders'), extension_attributes_stock_item_enable_qty_increments boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/enable_qty_increments'), extension_attributes_stock_item_is_decimal_divided boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_decimal_divided'), extension_attributes_stock_item_is_in_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_in_stock'), extension_attributes_stock_item_is_qty_decimal boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_qty_decimal'), extension_attributes_stock_item_item_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/item_id'), extension_attributes_stock_item_low_stock_date string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/low_stock_date'), extension_attributes_stock_item_manage_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/manage_stock'), extension_attributes_stock_item_max_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/max_sale_qty'), extension_attributes_stock_item_min_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/min_qty'), extension_attributes_stock_item_min_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/min_sale_qty'), extension_attributes_stock_item_notify_stock_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/notify_stock_qty'), extension_attributes_stock_item_product_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/product_id'), extension_attributes_stock_item_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/qty'), extension_attributes_stock_item_qty_increments string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/qty_increments'), extension_attributes_stock_item_show_default_notification_message boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/show_default_notification_message'), extension_attributes_stock_item_stock_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/stock_id'), extension_attributes_stock_item_stock_status_changed_auto string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/stock_status_changed_auto'), extension_attributes_stock_item_use_config_backorders boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_backorders'), extension_attributes_stock_item_use_config_enable_qty_inc boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_enable_qty_inc'), extension_attributes_stock_item_use_config_manage_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_manage_stock'), extension_attributes_stock_item_use_config_max_sale_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_max_sale_qty'), extension_attributes_stock_item_use_config_min_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_min_qty'), extension_attributes_stock_item_use_config_min_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_min_sale_qty'), extension_attributes_stock_item_use_config_notify_stock_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_notify_stock_qty'), extension_attributes_stock_item_use_config_qty_increments boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_qty_increments'), id string, "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/base64_encoded_data'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_name" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/name'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_disabled" boolean OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/disabled'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_media_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/media_type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_description" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_description'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_metadata" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_metadata'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_provider" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_provider'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_title" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_title'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_url" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_url'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_file" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/file'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_id" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/id'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_label" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/label'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_media_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/media_type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_position" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/position'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_types" string[] OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/types'), name string, "options_catalog-data-product-custom-option-interface_file_extension" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/file_extension'), "options_catalog-data-product-custom-option-interface_image_size_x" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/image_size_x'), "options_catalog-data-product-custom-option-interface_image_size_y" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/image_size_y'), "options_catalog-data-product-custom-option-interface_is_require" boolean OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/is_require'), "options_catalog-data-product-custom-option-interface_max_characters" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/max_characters'), "options_catalog-data-product-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/option_id'), "options_catalog-data-product-custom-option-interface_price" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/price'), "options_catalog-data-product-custom-option-interface_price_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/price_type'), "options_catalog-data-product-custom-option-interface_product_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/product_sku'), "options_catalog-data-product-custom-option-interface_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/sku'), "options_catalog-data-product-custom-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/sort_order'), "options_catalog-data-product-custom-option-interface_title" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/title'), "options_catalog-data-product-custom-option-interface_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/type'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_option_type_id" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/option_type_id'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price_type'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sku'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sort_order'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_title" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/title'), price string, "product_links_catalog-data-product-link-interface_extension_attributes_qty" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/extension_attributes/qty'), "product_links_catalog-data-product-link-interface_link_type" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/link_type'), "product_links_catalog-data-product-link-interface_linked_product_sku" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/linked_product_sku'), "product_links_catalog-data-product-link-interface_linked_product_type" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/linked_product_type'), "product_links_catalog-data-product-link-interface_position" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/position'), "product_links_catalog-data-product-link-interface_sku" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/sku'), sku string, status string, "tier_prices_catalog-data-product-tier-price-interface_customer_group_id" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/customer_group_id'), "tier_prices_catalog-data-product-tier-price-interface_qty" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/qty'), "tier_prices_catalog-data-product-tier-price-interface_value" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/value'), type_id string, updated_at string, visibility string, weight string)
OPTIONS (ANNOTATION 'Get info about product by product SKU', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}');

CREATE FOREIGN PROCEDURE catalogProductRepositoryV1SavePut(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN product_attribute_set_id string NOT NULL OPTIONS (ANNOTATION 'Attribute set id', NAMEINSOURCE 'product/attribute_set_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_created_at string NOT NULL OPTIONS (ANNOTATION 'Created date', NAMEINSOURCE 'product/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'product/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'product/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Option position', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_can_change_quantity" string NOT NULL OPTIONS (ANNOTATION 'Whether quantity could be changed', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/can_change_quantity', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_id" string NOT NULL OPTIONS (ANNOTATION 'The identifier', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_is_default" boolean NOT NULL OPTIONS (ANNOTATION 'Is default', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/is_default', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Position', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Qty', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Linked product sku', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_required" boolean NOT NULL OPTIONS (ANNOTATION 'Is required option', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/required', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Product sku', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_bundle_product_options_bundle-data-option-interface_type" string NOT NULL OPTIONS (ANNOTATION 'Input type', NAMEINSOURCE 'product/extension_attributes/bundle_product_options[]/bundle-data-option-interface/type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_extension_attributes_configurable_product_links string[] NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_links', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_attribute_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/attribute_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_is_use_default" boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/is_use_default', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_label" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_position" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/position', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_product_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_configurable_product_options_configurable-product-data-option-interface_values_configurable-product-data-option-value-interface_value_index" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/values[]/configurable-product-data-option-value-interface/value_index', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_id" string NOT NULL OPTIONS (ANNOTATION 'Sample(or link) id', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_is_shareable" string NOT NULL OPTIONS (ANNOTATION 'Shareable status', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/is_shareable', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file" string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_file_data" string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_name" string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_type" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_url" string NOT NULL OPTIONS (ANNOTATION 'Link url or null when type is ''file''', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_number_of_downloads" string NOT NULL OPTIONS (ANNOTATION 'Of downloads per user', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/number_of_downloads', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file" string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_file_data" string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_name" string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_type" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_url" string NOT NULL OPTIONS (ANNOTATION 'file URL', NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_sort_order" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_links_downloadable-data-link-interface_title" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_id" string NOT NULL OPTIONS (ANNOTATION 'Sample(or link) id', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file" string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_file_data" string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_name" string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_type" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_url" string NOT NULL OPTIONS (ANNOTATION 'file URL', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Order index for sample', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'product/extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_attribute_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/attribute_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_value" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_id" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_value" string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_value', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_backorders string NOT NULL OPTIONS (ANNOTATION 'Backorders status', NAMEINSOURCE 'product/extension_attributes/stock_item/backorders', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_enable_qty_increments boolean NOT NULL OPTIONS (ANNOTATION 'Whether Quantity Increments is enabled', NAMEINSOURCE 'product/extension_attributes/stock_item/enable_qty_increments', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_is_decimal_divided boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/is_decimal_divided', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_is_in_stock boolean NOT NULL OPTIONS (ANNOTATION 'Stock Availability', NAMEINSOURCE 'product/extension_attributes/stock_item/is_in_stock', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_is_qty_decimal boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/is_qty_decimal', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_item_id string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/item_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_extension_attributes_stock_item_low_stock_date string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/low_stock_date', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_manage_stock boolean NOT NULL OPTIONS (ANNOTATION 'Can Manage Stock', NAMEINSOURCE 'product/extension_attributes/stock_item/manage_stock', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_max_sale_qty string NOT NULL OPTIONS (ANNOTATION 'Maximum Qty Allowed in Shopping Cart data wrapper', NAMEINSOURCE 'product/extension_attributes/stock_item/max_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_min_qty string NOT NULL OPTIONS (ANNOTATION 'Minimal quantity available for item status in stock', NAMEINSOURCE 'product/extension_attributes/stock_item/min_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_min_sale_qty string NOT NULL OPTIONS (ANNOTATION 'Minimum Qty Allowed in Shopping Cart or NULL when there is no limitation', NAMEINSOURCE 'product/extension_attributes/stock_item/min_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_notify_stock_qty string NOT NULL OPTIONS (ANNOTATION 'Notify for Quantity Below data wrapper', NAMEINSOURCE 'product/extension_attributes/stock_item/notify_stock_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_product_id string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_extension_attributes_stock_item_qty string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_qty_increments string NOT NULL OPTIONS (ANNOTATION 'Quantity Increments data wrapper', NAMEINSOURCE 'product/extension_attributes/stock_item/qty_increments', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_show_default_notification_message boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/show_default_notification_message', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_stock_id string NOT NULL OPTIONS (ANNOTATION 'Stock identifier', NAMEINSOURCE 'product/extension_attributes/stock_item/stock_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_extension_attributes_stock_item_stock_status_changed_auto string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/stock_status_changed_auto', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_backorders boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_backorders', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_enable_qty_inc boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_enable_qty_inc', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_manage_stock boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_manage_stock', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_max_sale_qty boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_max_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_min_qty boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_min_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_min_sale_qty string NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_min_sale_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_notify_stock_qty boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_notify_stock_qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_extension_attributes_stock_item_use_config_qty_increments boolean NOT NULL OPTIONS (NAMEINSOURCE 'product/extension_attributes/stock_item/use_config_qty_increments', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'product/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_base64_encoded_data" string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_name" string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_disabled" boolean NOT NULL OPTIONS (ANNOTATION 'If gallery entry is hidden from product page', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/disabled', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_media_type" string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/media_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_description" string NOT NULL OPTIONS (ANNOTATION 'Video Description', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_description', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_metadata" string NOT NULL OPTIONS (ANNOTATION 'Metadata', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_metadata', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_provider" string NOT NULL OPTIONS (ANNOTATION 'Provider', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_provider', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_title" string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_url" string NOT NULL OPTIONS (ANNOTATION 'Video URL', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_url', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_file" string NOT NULL OPTIONS (ANNOTATION 'File path', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_id" string NOT NULL OPTIONS (ANNOTATION 'Gallery entry ID', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_label" string NOT NULL OPTIONS (ANNOTATION 'Gallery entry alternative text', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/label', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_media_type" string NOT NULL OPTIONS (ANNOTATION 'Media type', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/media_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Gallery entry position (sort order)', NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/position', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_types" string[] NOT NULL OPTIONS (NAMEINSOURCE 'product/media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/types', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_name string NOT NULL OPTIONS (ANNOTATION 'Name', NAMEINSOURCE 'product/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_file_extension" string NOT NULL OPTIONS (NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/file_extension', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_image_size_x" string NOT NULL OPTIONS (NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/image_size_x', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_image_size_y" string NOT NULL OPTIONS (NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/image_size_y', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_is_require" boolean NOT NULL OPTIONS (ANNOTATION 'Is require', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/is_require', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_max_characters" string NOT NULL OPTIONS (NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/max_characters', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_option_id" string NOT NULL OPTIONS (ANNOTATION 'Option id', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/option_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_product_sku" string NOT NULL OPTIONS (ANNOTATION 'Product SKU', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/product_sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_type" string NOT NULL OPTIONS (ANNOTATION 'Option type', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_option_type_id" string NOT NULL OPTIONS (ANNOTATION 'Option type id', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/option_type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price_type" string NOT NULL OPTIONS (ANNOTATION 'Price type', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sort_order" string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Option title', NAMEINSOURCE 'product/options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_price string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'product/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_product_links_catalog-data-product-link-interface_extension_attributes_qty" string NOT NULL OPTIONS (NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/extension_attributes/qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_product_links_catalog-data-product-link-interface_link_type" string NOT NULL OPTIONS (ANNOTATION 'Link type', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/link_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_product_links_catalog-data-product-link-interface_linked_product_sku" string NOT NULL OPTIONS (ANNOTATION 'Linked product sku', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/linked_product_sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_product_links_catalog-data-product-link-interface_linked_product_type" string NOT NULL OPTIONS (ANNOTATION 'Linked product type (simple, virtual, etc)', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/linked_product_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_product_links_catalog-data-product-link-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Linked item position', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/position', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_product_links_catalog-data-product-link-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU', NAMEINSOURCE 'product/product_links[]/catalog-data-product-link-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_sku string NOT NULL OPTIONS (ANNOTATION 'Sku', NAMEINSOURCE 'product/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_status string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'product/status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "product_tier_prices_catalog-data-product-tier-price-interface_customer_group_id" string NOT NULL OPTIONS (ANNOTATION 'Customer group id', NAMEINSOURCE 'product/tier_prices[]/catalog-data-product-tier-price-interface/customer_group_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_tier_prices_catalog-data-product-tier-price-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Tier qty', NAMEINSOURCE 'product/tier_prices[]/catalog-data-product-tier-price-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "product_tier_prices_catalog-data-product-tier-price-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Price value', NAMEINSOURCE 'product/tier_prices[]/catalog-data-product-tier-price-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN product_type_id string NOT NULL OPTIONS (ANNOTATION 'Type id', NAMEINSOURCE 'product/type_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated date', NAMEINSOURCE 'product/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_visibility string NOT NULL OPTIONS (ANNOTATION 'Visibility', NAMEINSOURCE 'product/visibility', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN product_weight string NOT NULL OPTIONS (ANNOTATION 'Weight', NAMEINSOURCE 'product/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN saveOptions boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (attribute_set_id string, created_at string, "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), "extension_attributes_bundle_product_options_bundle-data-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/option_id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/position'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_can_change_quantity" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/can_change_quantity'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_is_default" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/is_default'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_option_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/option_id'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/position'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_price_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/price_type'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_qty" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/qty'), "extension_attributes_bundle_product_options_bundle-data-option-interface_product_links_bundle-data-link-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/product_links[]/bundle-data-link-interface/sku'), "extension_attributes_bundle_product_options_bundle-data-option-interface_required" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/required'), "extension_attributes_bundle_product_options_bundle-data-option-interface_sku" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/sku'), "extension_attributes_bundle_product_options_bundle-data-option-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/title'), "extension_attributes_bundle_product_options_bundle-data-option-interface_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/bundle_product_options[]/bundle-data-option-interface/type'), extension_attributes_configurable_product_links string[] OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_links'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/attribute_id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_is_use_default" boolean OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/is_use_default'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/label'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_position" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/position'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_product_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/product_id'), "extension_attributes_configurable_product_options_configurable-product-data-option-interface_values_configurable-product-data-option-value-interface_value_index" string OPTIONS (NAMEINSOURCE 'extension_attributes/configurable_product_options[]/configurable-product-data-option-interface/values[]/configurable-product-data-option-value-interface/value_index'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/id'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_is_shareable" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/is_shareable'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/file_data'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_file_content/name'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_type'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_link_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/link_url'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_number_of_downloads" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/number_of_downloads'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_price" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/price'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/file_data'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_file_content/name'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_type'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sample_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sample_url'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_sort_order" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/sort_order'), "extension_attributes_downloadable_product_links_downloadable-data-link-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_links[]/downloadable-data-link-interface/title'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/id'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_file_data" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/file_data'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_file_content_name" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_file_content/name'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_type" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_type'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sample_url" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sample_url'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_sort_order" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/sort_order'), "extension_attributes_downloadable_product_samples_downloadable-data-sample-interface_title" string OPTIONS (NAMEINSOURCE 'extension_attributes/downloadable_product_samples[]/downloadable-data-sample-interface/title'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_attribute_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/attribute_id'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/value'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_id" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_id'), "extension_attributes_giftcard_amounts_gift-card-data-giftcard-amount-interface_website_value" string OPTIONS (NAMEINSOURCE 'extension_attributes/giftcard_amounts[]/gift-card-data-giftcard-amount-interface/website_value'), extension_attributes_stock_item_backorders string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/backorders'), extension_attributes_stock_item_enable_qty_increments boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/enable_qty_increments'), extension_attributes_stock_item_is_decimal_divided boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_decimal_divided'), extension_attributes_stock_item_is_in_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_in_stock'), extension_attributes_stock_item_is_qty_decimal boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/is_qty_decimal'), extension_attributes_stock_item_item_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/item_id'), extension_attributes_stock_item_low_stock_date string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/low_stock_date'), extension_attributes_stock_item_manage_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/manage_stock'), extension_attributes_stock_item_max_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/max_sale_qty'), extension_attributes_stock_item_min_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/min_qty'), extension_attributes_stock_item_min_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/min_sale_qty'), extension_attributes_stock_item_notify_stock_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/notify_stock_qty'), extension_attributes_stock_item_product_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/product_id'), extension_attributes_stock_item_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/qty'), extension_attributes_stock_item_qty_increments string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/qty_increments'), extension_attributes_stock_item_show_default_notification_message boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/show_default_notification_message'), extension_attributes_stock_item_stock_id string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/stock_id'), extension_attributes_stock_item_stock_status_changed_auto string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/stock_status_changed_auto'), extension_attributes_stock_item_use_config_backorders boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_backorders'), extension_attributes_stock_item_use_config_enable_qty_inc boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_enable_qty_inc'), extension_attributes_stock_item_use_config_manage_stock boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_manage_stock'), extension_attributes_stock_item_use_config_max_sale_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_max_sale_qty'), extension_attributes_stock_item_use_config_min_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_min_qty'), extension_attributes_stock_item_use_config_min_sale_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_min_sale_qty'), extension_attributes_stock_item_use_config_notify_stock_qty boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_notify_stock_qty'), extension_attributes_stock_item_use_config_qty_increments boolean OPTIONS (NAMEINSOURCE 'extension_attributes/stock_item/use_config_qty_increments'), id string, "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_base64_encoded_data" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/base64_encoded_data'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_name" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/name'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_content_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/content/type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_disabled" boolean OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/disabled'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_media_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/media_type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_description" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_description'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_metadata" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_metadata'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_provider" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_provider'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_title" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_title'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_extension_attributes_video_content_video_url" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/extension_attributes/video_content/video_url'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_file" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/file'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_id" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/id'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_label" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/label'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_media_type" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/media_type'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_position" string OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/position'), "media_gallery_entries_catalog-data-product-attribute-media-gallery-entry-interface_types" string[] OPTIONS (NAMEINSOURCE 'media_gallery_entries[]/catalog-data-product-attribute-media-gallery-entry-interface/types'), name string, "options_catalog-data-product-custom-option-interface_file_extension" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/file_extension'), "options_catalog-data-product-custom-option-interface_image_size_x" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/image_size_x'), "options_catalog-data-product-custom-option-interface_image_size_y" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/image_size_y'), "options_catalog-data-product-custom-option-interface_is_require" boolean OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/is_require'), "options_catalog-data-product-custom-option-interface_max_characters" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/max_characters'), "options_catalog-data-product-custom-option-interface_option_id" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/option_id'), "options_catalog-data-product-custom-option-interface_price" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/price'), "options_catalog-data-product-custom-option-interface_price_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/price_type'), "options_catalog-data-product-custom-option-interface_product_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/product_sku'), "options_catalog-data-product-custom-option-interface_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/sku'), "options_catalog-data-product-custom-option-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/sort_order'), "options_catalog-data-product-custom-option-interface_title" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/title'), "options_catalog-data-product-custom-option-interface_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/type'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_option_type_id" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/option_type_id'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_price_type" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/price_type'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sku" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sku'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_sort_order" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/sort_order'), "options_catalog-data-product-custom-option-interface_values_catalog-data-product-custom-option-values-interface_title" string OPTIONS (NAMEINSOURCE 'options[]/catalog-data-product-custom-option-interface/values[]/catalog-data-product-custom-option-values-interface/title'), price string, "product_links_catalog-data-product-link-interface_extension_attributes_qty" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/extension_attributes/qty'), "product_links_catalog-data-product-link-interface_link_type" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/link_type'), "product_links_catalog-data-product-link-interface_linked_product_sku" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/linked_product_sku'), "product_links_catalog-data-product-link-interface_linked_product_type" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/linked_product_type'), "product_links_catalog-data-product-link-interface_position" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/position'), "product_links_catalog-data-product-link-interface_sku" string OPTIONS (NAMEINSOURCE 'product_links[]/catalog-data-product-link-interface/sku'), sku string, status string, "tier_prices_catalog-data-product-tier-price-interface_customer_group_id" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/customer_group_id'), "tier_prices_catalog-data-product-tier-price-interface_qty" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/qty'), "tier_prices_catalog-data-product-tier-price-interface_value" string OPTIONS (NAMEINSOURCE 'tier_prices[]/catalog-data-product-tier-price-interface/value'), type_id string, updated_at string, visibility string, weight string)
OPTIONS (ANNOTATION 'Create product', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}');

CREATE FOREIGN PROCEDURE catalogProductRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS ("teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}');

CREATE FOREIGN PROCEDURE downloadableLinkRepositoryV1GetListGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (id string, is_shareable string, link_file string, link_file_content_file_data string OPTIONS (NAMEINSOURCE 'link_file_content/file_data'), link_file_content_name string OPTIONS (NAMEINSOURCE 'link_file_content/name'), link_type string, link_url string, number_of_downloads string, price string, sample_file string, sample_file_content_file_data string OPTIONS (NAMEINSOURCE 'sample_file_content/file_data'), sample_file_content_name string OPTIONS (NAMEINSOURCE 'sample_file_content/name'), sample_type string, sample_url string, sort_order string, title string)
OPTIONS (ANNOTATION 'List of links with associated samples', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/downloadable-links');

CREATE FOREIGN PROCEDURE downloadableLinkRepositoryV1SavePost(OUT "return" string RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN isGlobalScopeContent boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_id string NOT NULL OPTIONS (ANNOTATION 'Sample(or link) id', NAMEINSOURCE 'link/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_is_shareable string NOT NULL OPTIONS (ANNOTATION 'Shareable status', NAMEINSOURCE 'link/is_shareable', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_link_file string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'link/link_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_link_file_content_file_data string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'link/link_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_link_file_content_name string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'link/link_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_link_type string NOT NULL OPTIONS (NAMEINSOURCE 'link/link_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_link_url string NOT NULL OPTIONS (ANNOTATION 'Link url or null when type is ''file''', NAMEINSOURCE 'link/link_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_number_of_downloads string NOT NULL OPTIONS (ANNOTATION 'Of downloads per user', NAMEINSOURCE 'link/number_of_downloads', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_price string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'link/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_sample_file string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'link/sample_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_sample_file_content_file_data string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'link/sample_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_sample_file_content_name string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'link/sample_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_sample_type string NOT NULL OPTIONS (NAMEINSOURCE 'link/sample_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_sample_url string NOT NULL OPTIONS (ANNOTATION 'file URL', NAMEINSOURCE 'link/sample_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_sort_order string NOT NULL OPTIONS (NAMEINSOURCE 'link/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_title string NOT NULL OPTIONS (NAMEINSOURCE 'link/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Update downloadable link of the given product (link type and its resources cannot be changed)', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/downloadable-links');

CREATE FOREIGN PROCEDURE downloadableSampleRepositoryV1GetListGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (id string, sample_file string, sample_file_content_file_data string OPTIONS (NAMEINSOURCE 'sample_file_content/file_data'), sample_file_content_name string OPTIONS (NAMEINSOURCE 'sample_file_content/name'), sample_type string, sample_url string, sort_order string, title string)
OPTIONS (ANNOTATION 'List of samples for downloadable product', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/downloadable-links/samples');

CREATE FOREIGN PROCEDURE downloadableSampleRepositoryV1SavePost(OUT "return" string RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN isGlobalScopeContent boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN sample_id string NOT NULL OPTIONS (ANNOTATION 'Sample(or link) id', NAMEINSOURCE 'sample/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN sample_sample_file string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'sample/sample_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN sample_sample_file_content_file_data string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'sample/sample_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN sample_sample_file_content_name string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'sample/sample_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN sample_sample_type string NOT NULL OPTIONS (NAMEINSOURCE 'sample/sample_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN sample_sample_url string NOT NULL OPTIONS (ANNOTATION 'file URL', NAMEINSOURCE 'sample/sample_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN sample_sort_order string NOT NULL OPTIONS (ANNOTATION 'Order index for sample', NAMEINSOURCE 'sample/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN sample_title string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'sample/title', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Update downloadable sample of the given product', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/downloadable-links/samples');

CREATE FOREIGN PROCEDURE downloadableSampleRepositoryV1SavePut(OUT "return" string RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN isGlobalScopeContent boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN sample_id string NOT NULL OPTIONS (ANNOTATION 'Sample(or link) id', NAMEINSOURCE 'sample/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN sample_sample_file string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'sample/sample_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN sample_sample_file_content_file_data string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'sample/sample_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN sample_sample_file_content_name string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'sample/sample_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN sample_sample_type string NOT NULL OPTIONS (NAMEINSOURCE 'sample/sample_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN sample_sample_url string NOT NULL OPTIONS (ANNOTATION 'file URL', NAMEINSOURCE 'sample/sample_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN sample_sort_order string NOT NULL OPTIONS (ANNOTATION 'Order index for sample', NAMEINSOURCE 'sample/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN sample_title string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'sample/title', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Update downloadable sample of the given product', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/downloadable-links/samples/{id}');

CREATE FOREIGN PROCEDURE downloadableLinkRepositoryV1SavePut(OUT "return" string RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN isGlobalScopeContent boolean NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_id string NOT NULL OPTIONS (ANNOTATION 'Sample(or link) id', NAMEINSOURCE 'link/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_is_shareable string NOT NULL OPTIONS (ANNOTATION 'Shareable status', NAMEINSOURCE 'link/is_shareable', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_link_file string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'link/link_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_link_file_content_file_data string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'link/link_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_link_file_content_name string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'link/link_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_link_type string NOT NULL OPTIONS (NAMEINSOURCE 'link/link_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_link_url string NOT NULL OPTIONS (ANNOTATION 'Link url or null when type is ''file''', NAMEINSOURCE 'link/link_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_number_of_downloads string NOT NULL OPTIONS (ANNOTATION 'Of downloads per user', NAMEINSOURCE 'link/number_of_downloads', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_price string NOT NULL OPTIONS (ANNOTATION 'Price', NAMEINSOURCE 'link/price', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_sample_file string NOT NULL OPTIONS (ANNOTATION 'relative file path', NAMEINSOURCE 'link/sample_file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_sample_file_content_file_data string NOT NULL OPTIONS (ANNOTATION 'Data (base64 encoded content)', NAMEINSOURCE 'link/sample_file_content/file_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_sample_file_content_name string NOT NULL OPTIONS (ANNOTATION 'File name', NAMEINSOURCE 'link/sample_file_content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_sample_type string NOT NULL OPTIONS (NAMEINSOURCE 'link/sample_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_sample_url string NOT NULL OPTIONS (ANNOTATION 'file URL', NAMEINSOURCE 'link/sample_url', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN link_sort_order string NOT NULL OPTIONS (NAMEINSOURCE 'link/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN link_title string NOT NULL OPTIONS (NAMEINSOURCE 'link/title', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Update downloadable link of the given product (link type and its resources cannot be changed)', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/downloadable-links/{id}');

CREATE FOREIGN PROCEDURE catalogProductTierPriceManagementV1GetListGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN customerGroupId string NOT NULL OPTIONS (ANNOTATION '''all'' can be used to specify ''ALL GROUPS''', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (customer_group_id string, qty string, "value" string)
OPTIONS (ANNOTATION 'Get tier price of product', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/group-prices/{customerGroupId}/tiers');

CREATE FOREIGN PROCEDURE catalogProductTierPriceManagementV1RemoveDelete(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN customerGroupId string NOT NULL OPTIONS (ANNOTATION '''all'' can be used to specify ''ALL GROUPS''', "teiid_rest:PARAMETER_TYPE" 'path'), IN qty string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove tier price from product', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/group-prices/{customerGroupId}/tiers/{qty}');

CREATE FOREIGN PROCEDURE catalogProductTierPriceManagementV1AddPost(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN customerGroupId string NOT NULL OPTIONS (ANNOTATION '''all'' can be used to specify ''ALL GROUPS''', "teiid_rest:PARAMETER_TYPE" 'path'), IN price string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN qty string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Create tier price for product', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/group-prices/{customerGroupId}/tiers/{qty}/price/{price}');

CREATE FOREIGN PROCEDURE catalogProductLinkRepositoryV1SavePut(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN entity_extension_attributes_qty string NOT NULL OPTIONS (NAMEINSOURCE 'entity/extension_attributes/qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_link_type string NOT NULL OPTIONS (ANNOTATION 'Link type', NAMEINSOURCE 'entity/link_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_linked_product_sku string NOT NULL OPTIONS (ANNOTATION 'Linked product sku', NAMEINSOURCE 'entity/linked_product_sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_linked_product_type string NOT NULL OPTIONS (ANNOTATION 'Linked product type (simple, virtual, etc)', NAMEINSOURCE 'entity/linked_product_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_position string NOT NULL OPTIONS (ANNOTATION 'Linked item position', NAMEINSOURCE 'entity/position', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_sku string NOT NULL OPTIONS (ANNOTATION 'SKU', NAMEINSOURCE 'entity/sku', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Save product link', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/links');

CREATE FOREIGN PROCEDURE catalogProductLinkManagementV1SetProductLinksPost(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN "items_catalog-data-product-link-interface_extension_attributes_qty" string NOT NULL OPTIONS (NAMEINSOURCE 'items[]/catalog-data-product-link-interface/extension_attributes/qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "items_catalog-data-product-link-interface_link_type" string NOT NULL OPTIONS (ANNOTATION 'Link type', NAMEINSOURCE 'items[]/catalog-data-product-link-interface/link_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "items_catalog-data-product-link-interface_linked_product_sku" string NOT NULL OPTIONS (ANNOTATION 'Linked product sku', NAMEINSOURCE 'items[]/catalog-data-product-link-interface/linked_product_sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN "items_catalog-data-product-link-interface_linked_product_type" string NOT NULL OPTIONS (ANNOTATION 'Linked product type (simple, virtual, etc)', NAMEINSOURCE 'items[]/catalog-data-product-link-interface/linked_product_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "items_catalog-data-product-link-interface_position" string NOT NULL OPTIONS (ANNOTATION 'Linked item position', NAMEINSOURCE 'items[]/catalog-data-product-link-interface/position', "teiid_rest:PARAMETER_TYPE" 'body'), IN "items_catalog-data-product-link-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU', NAMEINSOURCE 'items[]/catalog-data-product-link-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Assign a product link to another product', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/links');

CREATE FOREIGN PROCEDURE catalogProductLinkManagementV1GetLinkedItemsByTypeGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN type string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (extension_attributes_qty string OPTIONS (NAMEINSOURCE 'extension_attributes/qty'), link_type string, linked_product_sku string, linked_product_type string, position string, sku string)
OPTIONS (ANNOTATION 'Provide the list of links for a specific product', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/links/{type}');

CREATE FOREIGN PROCEDURE catalogProductLinkRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN type string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN linkedProductSku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS ("teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/links/{type}/{linkedProductSku}');

CREATE FOREIGN PROCEDURE catalogProductAttributeMediaGalleryManagementV1GetListGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (content_base64_encoded_data string OPTIONS (NAMEINSOURCE 'content/base64_encoded_data'), content_name string OPTIONS (NAMEINSOURCE 'content/name'), content_type string OPTIONS (NAMEINSOURCE 'content/type'), disabled boolean, extension_attributes_video_content_media_type string OPTIONS (NAMEINSOURCE 'extension_attributes/video_content/media_type'), extension_attributes_video_content_video_description string OPTIONS (NAMEINSOURCE 'extension_attributes/video_content/video_description'), extension_attributes_video_content_video_metadata string OPTIONS (NAMEINSOURCE 'extension_attributes/video_content/video_metadata'), extension_attributes_video_content_video_provider string OPTIONS (NAMEINSOURCE 'extension_attributes/video_content/video_provider'), extension_attributes_video_content_video_title string OPTIONS (NAMEINSOURCE 'extension_attributes/video_content/video_title'), extension_attributes_video_content_video_url string OPTIONS (NAMEINSOURCE 'extension_attributes/video_content/video_url'), file string, id string, label string, media_type string, position string, types string[])
OPTIONS (ANNOTATION 'Retrieve the list of gallery entries associated with given product', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/media');

CREATE FOREIGN PROCEDURE catalogProductAttributeMediaGalleryManagementV1CreatePost(OUT "return" string RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN entry_content_base64_encoded_data string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'entry/content/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_content_name string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'entry/content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_content_type string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'entry/content/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_disabled boolean NOT NULL OPTIONS (ANNOTATION 'If gallery entry is hidden from product page', NAMEINSOURCE 'entry/disabled', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_extension_attributes_video_content_media_type string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'entry/extension_attributes/video_content/media_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_extension_attributes_video_content_video_description string NOT NULL OPTIONS (ANNOTATION 'Video Description', NAMEINSOURCE 'entry/extension_attributes/video_content/video_description', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_extension_attributes_video_content_video_metadata string NOT NULL OPTIONS (ANNOTATION 'Metadata', NAMEINSOURCE 'entry/extension_attributes/video_content/video_metadata', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_extension_attributes_video_content_video_provider string NOT NULL OPTIONS (ANNOTATION 'Provider', NAMEINSOURCE 'entry/extension_attributes/video_content/video_provider', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_extension_attributes_video_content_video_title string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'entry/extension_attributes/video_content/video_title', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_extension_attributes_video_content_video_url string NOT NULL OPTIONS (ANNOTATION 'Video URL', NAMEINSOURCE 'entry/extension_attributes/video_content/video_url', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_file string NOT NULL OPTIONS (ANNOTATION 'File path', NAMEINSOURCE 'entry/file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entry_id string NOT NULL OPTIONS (ANNOTATION 'Gallery entry ID', NAMEINSOURCE 'entry/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entry_label string NOT NULL OPTIONS (ANNOTATION 'Gallery entry alternative text', NAMEINSOURCE 'entry/label', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_media_type string NOT NULL OPTIONS (ANNOTATION 'Media type', NAMEINSOURCE 'entry/media_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_position string NOT NULL OPTIONS (ANNOTATION 'Gallery entry position (sort order)', NAMEINSOURCE 'entry/position', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_types string[] NOT NULL OPTIONS (NAMEINSOURCE 'entry/types', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Create new gallery entry', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/media');

CREATE FOREIGN PROCEDURE catalogProductAttributeMediaGalleryManagementV1GetGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN entryId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (content_base64_encoded_data string OPTIONS (NAMEINSOURCE 'content/base64_encoded_data'), content_name string OPTIONS (NAMEINSOURCE 'content/name'), content_type string OPTIONS (NAMEINSOURCE 'content/type'), disabled boolean, extension_attributes_video_content_media_type string OPTIONS (NAMEINSOURCE 'extension_attributes/video_content/media_type'), extension_attributes_video_content_video_description string OPTIONS (NAMEINSOURCE 'extension_attributes/video_content/video_description'), extension_attributes_video_content_video_metadata string OPTIONS (NAMEINSOURCE 'extension_attributes/video_content/video_metadata'), extension_attributes_video_content_video_provider string OPTIONS (NAMEINSOURCE 'extension_attributes/video_content/video_provider'), extension_attributes_video_content_video_title string OPTIONS (NAMEINSOURCE 'extension_attributes/video_content/video_title'), extension_attributes_video_content_video_url string OPTIONS (NAMEINSOURCE 'extension_attributes/video_content/video_url'), file string, id string, label string, media_type string, position string, types string[])
OPTIONS (ANNOTATION 'Return information about gallery entry', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/media/{entryId}');

CREATE FOREIGN PROCEDURE catalogProductAttributeMediaGalleryManagementV1UpdatePut(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN entryId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN entry_content_base64_encoded_data string NOT NULL OPTIONS (ANNOTATION 'Media data (base64 encoded content)', NAMEINSOURCE 'entry/content/base64_encoded_data', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_content_name string NOT NULL OPTIONS (ANNOTATION 'Image name', NAMEINSOURCE 'entry/content/name', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_content_type string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'entry/content/type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_disabled boolean NOT NULL OPTIONS (ANNOTATION 'If gallery entry is hidden from product page', NAMEINSOURCE 'entry/disabled', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_extension_attributes_video_content_media_type string NOT NULL OPTIONS (ANNOTATION 'MIME type', NAMEINSOURCE 'entry/extension_attributes/video_content/media_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_extension_attributes_video_content_video_description string NOT NULL OPTIONS (ANNOTATION 'Video Description', NAMEINSOURCE 'entry/extension_attributes/video_content/video_description', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_extension_attributes_video_content_video_metadata string NOT NULL OPTIONS (ANNOTATION 'Metadata', NAMEINSOURCE 'entry/extension_attributes/video_content/video_metadata', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_extension_attributes_video_content_video_provider string NOT NULL OPTIONS (ANNOTATION 'Provider', NAMEINSOURCE 'entry/extension_attributes/video_content/video_provider', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_extension_attributes_video_content_video_title string NOT NULL OPTIONS (ANNOTATION 'Title', NAMEINSOURCE 'entry/extension_attributes/video_content/video_title', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_extension_attributes_video_content_video_url string NOT NULL OPTIONS (ANNOTATION 'Video URL', NAMEINSOURCE 'entry/extension_attributes/video_content/video_url', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_file string NOT NULL OPTIONS (ANNOTATION 'File path', NAMEINSOURCE 'entry/file', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entry_id string NOT NULL OPTIONS (ANNOTATION 'Gallery entry ID', NAMEINSOURCE 'entry/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entry_label string NOT NULL OPTIONS (ANNOTATION 'Gallery entry alternative text', NAMEINSOURCE 'entry/label', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_media_type string NOT NULL OPTIONS (ANNOTATION 'Media type', NAMEINSOURCE 'entry/media_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_position string NOT NULL OPTIONS (ANNOTATION 'Gallery entry position (sort order)', NAMEINSOURCE 'entry/position', "teiid_rest:PARAMETER_TYPE" 'body'), IN entry_types string[] NOT NULL OPTIONS (NAMEINSOURCE 'entry/types', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Update gallery entry', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/media/{entryId}');

CREATE FOREIGN PROCEDURE catalogProductAttributeMediaGalleryManagementV1RemoveDelete(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN entryId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove gallery entry', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/media/{entryId}');

CREATE FOREIGN PROCEDURE catalogProductCustomOptionRepositoryV1GetListGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (file_extension string, image_size_x string, image_size_y string, is_require boolean, max_characters string, option_id string, price string, price_type string, product_sku string, sku string, sort_order string, title string, type string, "values_catalog-data-product-custom-option-values-interface_option_type_id" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/option_type_id'), "values_catalog-data-product-custom-option-values-interface_price" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/price'), "values_catalog-data-product-custom-option-values-interface_price_type" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/price_type'), "values_catalog-data-product-custom-option-values-interface_sku" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/sku'), "values_catalog-data-product-custom-option-values-interface_sort_order" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/sort_order'), "values_catalog-data-product-custom-option-values-interface_title" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/title'))
OPTIONS (ANNOTATION 'Get the list of custom options for a specific product', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/options');

CREATE FOREIGN PROCEDURE catalogProductCustomOptionRepositoryV1GetGet(IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN optionId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (file_extension string, image_size_x string, image_size_y string, is_require boolean, max_characters string, option_id string, price string, price_type string, product_sku string, sku string, sort_order string, title string, type string, "values_catalog-data-product-custom-option-values-interface_option_type_id" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/option_type_id'), "values_catalog-data-product-custom-option-values-interface_price" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/price'), "values_catalog-data-product-custom-option-values-interface_price_type" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/price_type'), "values_catalog-data-product-custom-option-values-interface_sku" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/sku'), "values_catalog-data-product-custom-option-values-interface_sort_order" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/sort_order'), "values_catalog-data-product-custom-option-values-interface_title" string OPTIONS (NAMEINSOURCE 'values[]/catalog-data-product-custom-option-values-interface/title'))
OPTIONS (ANNOTATION 'Get custom option for a specific product', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/options/{optionId}');

CREATE FOREIGN PROCEDURE catalogProductCustomOptionRepositoryV1DeleteByIdentifierDelete(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN optionId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS ("teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/options/{optionId}');

CREATE FOREIGN PROCEDURE catalogProductWebsiteLinkRepositoryV1SavePut(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN productWebsiteLink_sku string NOT NULL OPTIONS (NAMEINSOURCE 'productWebsiteLink/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN productWebsiteLink_website_id string NOT NULL OPTIONS (ANNOTATION 'Website ids', NAMEINSOURCE 'productWebsiteLink/website_id', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Assign a product to the website', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/websites');

CREATE FOREIGN PROCEDURE catalogProductWebsiteLinkRepositoryV1SavePost(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN productWebsiteLink_sku string NOT NULL OPTIONS (NAMEINSOURCE 'productWebsiteLink/sku', "teiid_rest:PARAMETER_TYPE" 'body'), IN productWebsiteLink_website_id string NOT NULL OPTIONS (ANNOTATION 'Website ids', NAMEINSOURCE 'productWebsiteLink/website_id', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Assign a product to the website', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/websites');

CREATE FOREIGN PROCEDURE catalogProductWebsiteLinkRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN sku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN websiteId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove the website assignment from the product by product sku', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/products/{sku}/websites/{websiteId}');

CREATE FOREIGN PROCEDURE rmaRmaManagementV1SearchGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_rma-data-rma-interface_comments_rma-data-comment-interface_admin" boolean OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/comments[]/rma-data-comment-interface/admin'), "items_rma-data-rma-interface_comments_rma-data-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/comments[]/rma-data-comment-interface/comment'), "items_rma-data-rma-interface_comments_rma-data-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/comments[]/rma-data-comment-interface/created_at'), "items_rma-data-rma-interface_comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_rma-data-rma-interface_comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/value'), "items_rma-data-rma-interface_comments_rma-data-comment-interface_customer_notified" boolean OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/comments[]/rma-data-comment-interface/customer_notified'), "items_rma-data-rma-interface_comments_rma-data-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/comments[]/rma-data-comment-interface/entity_id'), "items_rma-data-rma-interface_comments_rma-data-comment-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/comments[]/rma-data-comment-interface/rma_entity_id'), "items_rma-data-rma-interface_comments_rma-data-comment-interface_status" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/comments[]/rma-data-comment-interface/status'), "items_rma-data-rma-interface_comments_rma-data-comment-interface_visible_on_front" boolean OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/comments[]/rma-data-comment-interface/visible_on_front'), "items_rma-data-rma-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_rma-data-rma-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/custom_attributes[]/framework-attribute-interface/value'), "items_rma-data-rma-interface_customer_custom_email" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/customer_custom_email'), "items_rma-data-rma-interface_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/customer_id'), "items_rma-data-rma-interface_date_requested" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/date_requested'), "items_rma-data-rma-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/entity_id'), "items_rma-data-rma-interface_increment_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/increment_id'), "items_rma-data-rma-interface_items_rma-data-item-interface_condition" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/items[]/rma-data-item-interface/condition'), "items_rma-data-rma-interface_items_rma-data-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/items[]/rma-data-item-interface/entity_id'), "items_rma-data-rma-interface_items_rma-data-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/items[]/rma-data-item-interface/order_item_id'), "items_rma-data-rma-interface_items_rma-data-item-interface_qty_approved" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/items[]/rma-data-item-interface/qty_approved'), "items_rma-data-rma-interface_items_rma-data-item-interface_qty_authorized" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/items[]/rma-data-item-interface/qty_authorized'), "items_rma-data-rma-interface_items_rma-data-item-interface_qty_requested" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/items[]/rma-data-item-interface/qty_requested'), "items_rma-data-rma-interface_items_rma-data-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/items[]/rma-data-item-interface/qty_returned'), "items_rma-data-rma-interface_items_rma-data-item-interface_reason" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/items[]/rma-data-item-interface/reason'), "items_rma-data-rma-interface_items_rma-data-item-interface_resolution" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/items[]/rma-data-item-interface/resolution'), "items_rma-data-rma-interface_items_rma-data-item-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/items[]/rma-data-item-interface/rma_entity_id'), "items_rma-data-rma-interface_items_rma-data-item-interface_status" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/items[]/rma-data-item-interface/status'), "items_rma-data-rma-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/order_id'), "items_rma-data-rma-interface_order_increment_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/order_increment_id'), "items_rma-data-rma-interface_status" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/status'), "items_rma-data-rma-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/store_id'), "items_rma-data-rma-interface_tracks_rma-data-track-interface_carrier_code" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/tracks[]/rma-data-track-interface/carrier_code'), "items_rma-data-rma-interface_tracks_rma-data-track-interface_carrier_title" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/tracks[]/rma-data-track-interface/carrier_title'), "items_rma-data-rma-interface_tracks_rma-data-track-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/tracks[]/rma-data-track-interface/entity_id'), "items_rma-data-rma-interface_tracks_rma-data-track-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/tracks[]/rma-data-track-interface/rma_entity_id'), "items_rma-data-rma-interface_tracks_rma-data-track-interface_track_number" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-rma-interface/tracks[]/rma-data-track-interface/track_number'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Return list of rma data objects based on search criteria', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returns');

CREATE FOREIGN PROCEDURE rmaRmaManagementV1SaveRmaPost(IN "rmaDataObject_comments_rma-data-comment-interface_admin" boolean NOT NULL OPTIONS (ANNOTATION 'Is_admin', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/admin', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_comment" string NOT NULL OPTIONS (ANNOTATION 'Comment', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created_at', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_customer_notified" boolean NOT NULL OPTIONS (ANNOTATION 'Is_customer_notified', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Entity_id', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_rma_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Rma Id', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/rma_entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_status" string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/status', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_visible_on_front" boolean NOT NULL OPTIONS (ANNOTATION 'Is_visible_on_front', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'rmaDataObject/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'rmaDataObject/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_customer_custom_email string NOT NULL OPTIONS (ANNOTATION 'Customer_custom_email', NAMEINSOURCE 'rmaDataObject/customer_custom_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer_id', NAMEINSOURCE 'rmaDataObject/customer_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_date_requested string NOT NULL OPTIONS (ANNOTATION 'Date_requested', NAMEINSOURCE 'rmaDataObject/date_requested', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_entity_id string NOT NULL OPTIONS (ANNOTATION 'Entity_id', NAMEINSOURCE 'rmaDataObject/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_increment_id string NOT NULL OPTIONS (ANNOTATION 'Entity_id', NAMEINSOURCE 'rmaDataObject/increment_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_condition" string NOT NULL OPTIONS (ANNOTATION 'Condition', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/condition', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'Order_item_id', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/order_item_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_qty_approved" string NOT NULL OPTIONS (ANNOTATION 'Qty_approved', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/qty_approved', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_qty_authorized" string NOT NULL OPTIONS (ANNOTATION 'Qty_authorized', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/qty_authorized', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_qty_requested" string NOT NULL OPTIONS (ANNOTATION 'Qty_requested', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/qty_requested', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_qty_returned" string NOT NULL OPTIONS (ANNOTATION 'Qty_returned', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/qty_returned', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_reason" string NOT NULL OPTIONS (ANNOTATION 'Reason', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/reason', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_resolution" string NOT NULL OPTIONS (ANNOTATION 'Resolution', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/resolution', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_rma_entity_id" string NOT NULL OPTIONS (ANNOTATION 'RMA id', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/rma_entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_status" string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/status', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_order_id string NOT NULL OPTIONS (ANNOTATION 'Order_id', NAMEINSOURCE 'rmaDataObject/order_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_order_increment_id string NOT NULL OPTIONS (ANNOTATION 'Order_increment_id', NAMEINSOURCE 'rmaDataObject/order_increment_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_status string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'rmaDataObject/status', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_store_id string NOT NULL OPTIONS (ANNOTATION 'Store_id', NAMEINSOURCE 'rmaDataObject/store_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_carrier_code" string NOT NULL OPTIONS (ANNOTATION 'Carrier code', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/carrier_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_carrier_title" string NOT NULL OPTIONS (ANNOTATION 'Carrier title', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/carrier_title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Entity id', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_rma_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Rma entity id', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/rma_entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_track_number" string NOT NULL OPTIONS (ANNOTATION 'Track number', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/track_number', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE ("comments_rma-data-comment-interface_admin" boolean OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/admin'), "comments_rma-data-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/comment'), "comments_rma-data-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/created_at'), "comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/value'), "comments_rma-data-comment-interface_customer_notified" boolean OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/customer_notified'), "comments_rma-data-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/entity_id'), "comments_rma-data-comment-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/rma_entity_id'), "comments_rma-data-comment-interface_status" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/status'), "comments_rma-data-comment-interface_visible_on_front" boolean OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/visible_on_front'), "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), customer_custom_email string, customer_id string, date_requested string, entity_id string, increment_id string, "items_rma-data-item-interface_condition" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/condition'), "items_rma-data-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/entity_id'), "items_rma-data-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/order_item_id'), "items_rma-data-item-interface_qty_approved" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/qty_approved'), "items_rma-data-item-interface_qty_authorized" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/qty_authorized'), "items_rma-data-item-interface_qty_requested" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/qty_requested'), "items_rma-data-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/qty_returned'), "items_rma-data-item-interface_reason" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/reason'), "items_rma-data-item-interface_resolution" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/resolution'), "items_rma-data-item-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/rma_entity_id'), "items_rma-data-item-interface_status" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/status'), order_id string, order_increment_id string, status string, store_id string, "tracks_rma-data-track-interface_carrier_code" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/carrier_code'), "tracks_rma-data-track-interface_carrier_title" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/carrier_title'), "tracks_rma-data-track-interface_entity_id" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/entity_id'), "tracks_rma-data-track-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/rma_entity_id'), "tracks_rma-data-track-interface_track_number" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/track_number'))
OPTIONS (ANNOTATION 'Save RMA', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returns');

CREATE FOREIGN PROCEDURE rmaRmaRepositoryV1GetGet(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE ("comments_rma-data-comment-interface_admin" boolean OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/admin'), "comments_rma-data-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/comment'), "comments_rma-data-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/created_at'), "comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/value'), "comments_rma-data-comment-interface_customer_notified" boolean OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/customer_notified'), "comments_rma-data-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/entity_id'), "comments_rma-data-comment-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/rma_entity_id'), "comments_rma-data-comment-interface_status" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/status'), "comments_rma-data-comment-interface_visible_on_front" boolean OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/visible_on_front'), "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), customer_custom_email string, customer_id string, date_requested string, entity_id string, increment_id string, "items_rma-data-item-interface_condition" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/condition'), "items_rma-data-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/entity_id'), "items_rma-data-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/order_item_id'), "items_rma-data-item-interface_qty_approved" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/qty_approved'), "items_rma-data-item-interface_qty_authorized" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/qty_authorized'), "items_rma-data-item-interface_qty_requested" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/qty_requested'), "items_rma-data-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/qty_returned'), "items_rma-data-item-interface_reason" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/reason'), "items_rma-data-item-interface_resolution" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/resolution'), "items_rma-data-item-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/rma_entity_id'), "items_rma-data-item-interface_status" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/status'), order_id string, order_increment_id string, status string, store_id string, "tracks_rma-data-track-interface_carrier_code" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/carrier_code'), "tracks_rma-data-track-interface_carrier_title" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/carrier_title'), "tracks_rma-data-track-interface_entity_id" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/entity_id'), "tracks_rma-data-track-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/rma_entity_id'), "tracks_rma-data-track-interface_track_number" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/track_number'))
OPTIONS (ANNOTATION 'Return data object for specified RMA id', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returns/{id}');

CREATE FOREIGN PROCEDURE rmaRmaManagementV1SaveRmaPut(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN "rmaDataObject_comments_rma-data-comment-interface_admin" boolean NOT NULL OPTIONS (ANNOTATION 'Is_admin', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/admin', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_comment" string NOT NULL OPTIONS (ANNOTATION 'Comment', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created_at', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_customer_notified" boolean NOT NULL OPTIONS (ANNOTATION 'Is_customer_notified', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Entity_id', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_rma_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Rma Id', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/rma_entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_status" string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/status', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_visible_on_front" boolean NOT NULL OPTIONS (ANNOTATION 'Is_visible_on_front', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'rmaDataObject/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'rmaDataObject/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_customer_custom_email string NOT NULL OPTIONS (ANNOTATION 'Customer_custom_email', NAMEINSOURCE 'rmaDataObject/customer_custom_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer_id', NAMEINSOURCE 'rmaDataObject/customer_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_date_requested string NOT NULL OPTIONS (ANNOTATION 'Date_requested', NAMEINSOURCE 'rmaDataObject/date_requested', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_entity_id string NOT NULL OPTIONS (ANNOTATION 'Entity_id', NAMEINSOURCE 'rmaDataObject/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_increment_id string NOT NULL OPTIONS (ANNOTATION 'Entity_id', NAMEINSOURCE 'rmaDataObject/increment_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_condition" string NOT NULL OPTIONS (ANNOTATION 'Condition', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/condition', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'Order_item_id', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/order_item_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_qty_approved" string NOT NULL OPTIONS (ANNOTATION 'Qty_approved', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/qty_approved', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_qty_authorized" string NOT NULL OPTIONS (ANNOTATION 'Qty_authorized', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/qty_authorized', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_qty_requested" string NOT NULL OPTIONS (ANNOTATION 'Qty_requested', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/qty_requested', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_qty_returned" string NOT NULL OPTIONS (ANNOTATION 'Qty_returned', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/qty_returned', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_reason" string NOT NULL OPTIONS (ANNOTATION 'Reason', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/reason', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_resolution" string NOT NULL OPTIONS (ANNOTATION 'Resolution', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/resolution', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_rma_entity_id" string NOT NULL OPTIONS (ANNOTATION 'RMA id', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/rma_entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_status" string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/status', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_order_id string NOT NULL OPTIONS (ANNOTATION 'Order_id', NAMEINSOURCE 'rmaDataObject/order_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_order_increment_id string NOT NULL OPTIONS (ANNOTATION 'Order_increment_id', NAMEINSOURCE 'rmaDataObject/order_increment_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_status string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'rmaDataObject/status', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_store_id string NOT NULL OPTIONS (ANNOTATION 'Store_id', NAMEINSOURCE 'rmaDataObject/store_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_carrier_code" string NOT NULL OPTIONS (ANNOTATION 'Carrier code', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/carrier_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_carrier_title" string NOT NULL OPTIONS (ANNOTATION 'Carrier title', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/carrier_title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Entity id', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_rma_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Rma entity id', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/rma_entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_track_number" string NOT NULL OPTIONS (ANNOTATION 'Track number', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/track_number', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE ("comments_rma-data-comment-interface_admin" boolean OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/admin'), "comments_rma-data-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/comment'), "comments_rma-data-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/created_at'), "comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/value'), "comments_rma-data-comment-interface_customer_notified" boolean OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/customer_notified'), "comments_rma-data-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/entity_id'), "comments_rma-data-comment-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/rma_entity_id'), "comments_rma-data-comment-interface_status" string OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/status'), "comments_rma-data-comment-interface_visible_on_front" boolean OPTIONS (NAMEINSOURCE 'comments[]/rma-data-comment-interface/visible_on_front'), "custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/attribute_code'), "custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'custom_attributes[]/framework-attribute-interface/value'), customer_custom_email string, customer_id string, date_requested string, entity_id string, increment_id string, "items_rma-data-item-interface_condition" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/condition'), "items_rma-data-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/entity_id'), "items_rma-data-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/order_item_id'), "items_rma-data-item-interface_qty_approved" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/qty_approved'), "items_rma-data-item-interface_qty_authorized" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/qty_authorized'), "items_rma-data-item-interface_qty_requested" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/qty_requested'), "items_rma-data-item-interface_qty_returned" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/qty_returned'), "items_rma-data-item-interface_reason" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/reason'), "items_rma-data-item-interface_resolution" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/resolution'), "items_rma-data-item-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/rma_entity_id'), "items_rma-data-item-interface_status" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-item-interface/status'), order_id string, order_increment_id string, status string, store_id string, "tracks_rma-data-track-interface_carrier_code" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/carrier_code'), "tracks_rma-data-track-interface_carrier_title" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/carrier_title'), "tracks_rma-data-track-interface_entity_id" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/entity_id'), "tracks_rma-data-track-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/rma_entity_id'), "tracks_rma-data-track-interface_track_number" string OPTIONS (NAMEINSOURCE 'tracks[]/rma-data-track-interface/track_number'))
OPTIONS (ANNOTATION 'Save RMA', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returns/{id}');

CREATE FOREIGN PROCEDURE rmaRmaRepositoryV1DeleteDelete(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN "rmaDataObject_comments_rma-data-comment-interface_admin" boolean NOT NULL OPTIONS (ANNOTATION 'Is_admin', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/admin', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_comment" string NOT NULL OPTIONS (ANNOTATION 'Comment', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created_at', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_customer_notified" boolean NOT NULL OPTIONS (ANNOTATION 'Is_customer_notified', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Entity_id', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_rma_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Rma Id', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/rma_entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_status" string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/status', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_comments_rma-data-comment-interface_visible_on_front" boolean NOT NULL OPTIONS (ANNOTATION 'Is_visible_on_front', NAMEINSOURCE 'rmaDataObject/comments[]/rma-data-comment-interface/visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'rmaDataObject/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'rmaDataObject/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_customer_custom_email string NOT NULL OPTIONS (ANNOTATION 'Customer_custom_email', NAMEINSOURCE 'rmaDataObject/customer_custom_email', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer_id', NAMEINSOURCE 'rmaDataObject/customer_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_date_requested string NOT NULL OPTIONS (ANNOTATION 'Date_requested', NAMEINSOURCE 'rmaDataObject/date_requested', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_entity_id string NOT NULL OPTIONS (ANNOTATION 'Entity_id', NAMEINSOURCE 'rmaDataObject/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_increment_id string NOT NULL OPTIONS (ANNOTATION 'Entity_id', NAMEINSOURCE 'rmaDataObject/increment_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_condition" string NOT NULL OPTIONS (ANNOTATION 'Condition', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/condition', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'Order_item_id', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/order_item_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_qty_approved" string NOT NULL OPTIONS (ANNOTATION 'Qty_approved', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/qty_approved', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_qty_authorized" string NOT NULL OPTIONS (ANNOTATION 'Qty_authorized', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/qty_authorized', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_qty_requested" string NOT NULL OPTIONS (ANNOTATION 'Qty_requested', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/qty_requested', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_qty_returned" string NOT NULL OPTIONS (ANNOTATION 'Qty_returned', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/qty_returned', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_reason" string NOT NULL OPTIONS (ANNOTATION 'Reason', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/reason', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_resolution" string NOT NULL OPTIONS (ANNOTATION 'Resolution', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/resolution', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_rma_entity_id" string NOT NULL OPTIONS (ANNOTATION 'RMA id', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/rma_entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_items_rma-data-item-interface_status" string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'rmaDataObject/items[]/rma-data-item-interface/status', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_order_id string NOT NULL OPTIONS (ANNOTATION 'Order_id', NAMEINSOURCE 'rmaDataObject/order_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_order_increment_id string NOT NULL OPTIONS (ANNOTATION 'Order_increment_id', NAMEINSOURCE 'rmaDataObject/order_increment_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_status string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'rmaDataObject/status', "teiid_rest:PARAMETER_TYPE" 'body'), IN rmaDataObject_store_id string NOT NULL OPTIONS (ANNOTATION 'Store_id', NAMEINSOURCE 'rmaDataObject/store_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_carrier_code" string NOT NULL OPTIONS (ANNOTATION 'Carrier code', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/carrier_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_carrier_title" string NOT NULL OPTIONS (ANNOTATION 'Carrier title', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/carrier_title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Entity id', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_rma_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Rma entity id', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/rma_entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rmaDataObject_tracks_rma-data-track-interface_track_number" string NOT NULL OPTIONS (ANNOTATION 'Track number', NAMEINSOURCE 'rmaDataObject/tracks[]/rma-data-track-interface/track_number', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete RMA', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returns/{id}');

CREATE FOREIGN PROCEDURE rmaCommentManagementV1CommentsListGet(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE ("items_rma-data-comment-interface_admin" boolean OPTIONS (NAMEINSOURCE 'items[]/rma-data-comment-interface/admin'), "items_rma-data-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-comment-interface/comment'), "items_rma-data-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-comment-interface/created_at'), "items_rma-data-comment-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_rma-data-comment-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-comment-interface/custom_attributes[]/framework-attribute-interface/value'), "items_rma-data-comment-interface_customer_notified" boolean OPTIONS (NAMEINSOURCE 'items[]/rma-data-comment-interface/customer_notified'), "items_rma-data-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-comment-interface/entity_id'), "items_rma-data-comment-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-comment-interface/rma_entity_id'), "items_rma-data-comment-interface_status" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-comment-interface/status'), "items_rma-data-comment-interface_visible_on_front" boolean OPTIONS (NAMEINSOURCE 'items[]/rma-data-comment-interface/visible_on_front'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Comments list', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returns/{id}/comments');

CREATE FOREIGN PROCEDURE rmaCommentManagementV1AddCommentPost(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN data_admin boolean NOT NULL OPTIONS (ANNOTATION 'Is_admin', NAMEINSOURCE 'data/admin', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_comment string NOT NULL OPTIONS (ANNOTATION 'Comment', NAMEINSOURCE 'data/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_created_at string NOT NULL OPTIONS (ANNOTATION 'Created_at', NAMEINSOURCE 'data/created_at', "teiid_rest:PARAMETER_TYPE" 'body'), IN "data_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'data/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "data_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'data/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_customer_notified boolean NOT NULL OPTIONS (ANNOTATION 'Is_customer_notified', NAMEINSOURCE 'data/customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_entity_id string NOT NULL OPTIONS (ANNOTATION 'Entity_id', NAMEINSOURCE 'data/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_rma_entity_id string NOT NULL OPTIONS (ANNOTATION 'Rma Id', NAMEINSOURCE 'data/rma_entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_status string NOT NULL OPTIONS (ANNOTATION 'Status', NAMEINSOURCE 'data/status', "teiid_rest:PARAMETER_TYPE" 'body'), IN data_visible_on_front boolean NOT NULL OPTIONS (ANNOTATION 'Is_visible_on_front', NAMEINSOURCE 'data/visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Add comment', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returns/{id}/comments');

CREATE FOREIGN PROCEDURE rmaTrackManagementV1GetShippingLabelPdfGet(OUT "return" string RESULT, IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Get shipping label int the PDF format', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returns/{id}/labels');

CREATE FOREIGN PROCEDURE rmaTrackManagementV1GetTracksGet(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE ("items_rma-data-track-interface_carrier_code" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-track-interface/carrier_code'), "items_rma-data-track-interface_carrier_title" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-track-interface/carrier_title'), "items_rma-data-track-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-track-interface/entity_id'), "items_rma-data-track-interface_rma_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-track-interface/rma_entity_id'), "items_rma-data-track-interface_track_number" string OPTIONS (NAMEINSOURCE 'items[]/rma-data-track-interface/track_number'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Get track list', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returns/{id}/tracking-numbers');

CREATE FOREIGN PROCEDURE rmaTrackManagementV1AddTrackPost(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN track_carrier_code string NOT NULL OPTIONS (ANNOTATION 'Carrier code', NAMEINSOURCE 'track/carrier_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN track_carrier_title string NOT NULL OPTIONS (ANNOTATION 'Carrier title', NAMEINSOURCE 'track/carrier_title', "teiid_rest:PARAMETER_TYPE" 'body'), IN track_entity_id string NOT NULL OPTIONS (ANNOTATION 'Entity id', NAMEINSOURCE 'track/entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN track_rma_entity_id string NOT NULL OPTIONS (ANNOTATION 'Rma entity id', NAMEINSOURCE 'track/rma_entity_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN track_track_number string NOT NULL OPTIONS (ANNOTATION 'Track number', NAMEINSOURCE 'track/track_number', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Add track', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returns/{id}/tracking-numbers');

CREATE FOREIGN PROCEDURE rmaTrackManagementV1RemoveTrackByIdDelete(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN trackId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Remove track by id', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returns/{id}/tracking-numbers/{trackId}');

CREATE FOREIGN PROCEDURE rmaRmaAttributesManagementV1GetAllAttributesMetadataGet() RETURNS TABLE (attribute_code string, backend_type string, data_model string, frontend_class string, frontend_input string, frontend_label string, input_filter string, is_filterable_in_grid boolean, is_searchable_in_grid boolean, is_used_in_grid boolean, is_visible_in_grid boolean, multiline_count string, note string, "options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/value'), "options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/value'), required boolean, sort_order string, store_label string, "system" boolean, user_defined boolean, "validation_rules_customer-data-validation-rule-interface_name" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/name'), "validation_rules_customer-data-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/value'), visible boolean)
OPTIONS (ANNOTATION 'Get all attribute metadata.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returnsAttributeMetadata');

CREATE FOREIGN PROCEDURE rmaRmaAttributesManagementV1GetCustomAttributesMetadataGet(IN dataObjectClassName string NOT NULL OPTIONS (ANNOTATION 'Data object class name', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (attribute_code string)
OPTIONS (ANNOTATION 'Get custom attribute metadata for the given Data object''s attribute set', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returnsAttributeMetadata/custom');

CREATE FOREIGN PROCEDURE rmaRmaAttributesManagementV1GetAttributesGet(IN formCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (attribute_code string, backend_type string, data_model string, frontend_class string, frontend_input string, frontend_label string, input_filter string, is_filterable_in_grid boolean, is_searchable_in_grid boolean, is_used_in_grid boolean, is_visible_in_grid boolean, multiline_count string, note string, "options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/value'), "options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/value'), required boolean, sort_order string, store_label string, "system" boolean, user_defined boolean, "validation_rules_customer-data-validation-rule-interface_name" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/name'), "validation_rules_customer-data-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/value'), visible boolean)
OPTIONS (ANNOTATION 'Retrieve all attributes filtered by form code', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returnsAttributeMetadata/form/{formCode}');

CREATE FOREIGN PROCEDURE rmaRmaAttributesManagementV1GetAttributeMetadataGet(IN attributeCode string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (attribute_code string, backend_type string, data_model string, frontend_class string, frontend_input string, frontend_label string, input_filter string, is_filterable_in_grid boolean, is_searchable_in_grid boolean, is_used_in_grid boolean, is_visible_in_grid boolean, multiline_count string, note string, "options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_label" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/label'), "options_customer-data-option-interface_options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/options[]/customer-data-option-interface/value'), "options_customer-data-option-interface_value" string OPTIONS (NAMEINSOURCE 'options[]/customer-data-option-interface/value'), required boolean, sort_order string, store_label string, "system" boolean, user_defined boolean, "validation_rules_customer-data-validation-rule-interface_name" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/name'), "validation_rules_customer-data-validation-rule-interface_value" string OPTIONS (NAMEINSOURCE 'validation_rules[]/customer-data-validation-rule-interface/value'), visible boolean)
OPTIONS (ANNOTATION 'Retrieve attribute metadata.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/returnsAttributeMetadata/{attributeCode}');

CREATE FOREIGN PROCEDURE rewardRewardManagementV1SetPost(OUT "return" boolean RESULT) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Set reward points to quote', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/reward/mine/use-reward');

CREATE FOREIGN PROCEDURE salesRuleRuleRepositoryV1SavePost(IN rule_action_condition_aggregator_type string NOT NULL OPTIONS (ANNOTATION 'The aggregator type', NAMEINSOURCE 'rule/action_condition/aggregator_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_action_condition_attribute_name string NOT NULL OPTIONS (ANNOTATION 'The attribute name of the condition', NAMEINSOURCE 'rule/action_condition/attribute_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_action_condition_condition_type string NOT NULL OPTIONS (ANNOTATION 'Condition type', NAMEINSOURCE 'rule/action_condition/condition_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_action_condition_conditions_sales-rule-data-condition-interface_aggregator_type" string NOT NULL OPTIONS (ANNOTATION 'The aggregator type', NAMEINSOURCE 'rule/action_condition/conditions[]/sales-rule-data-condition-interface/aggregator_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "rule_action_condition_conditions_sales-rule-data-condition-interface_attribute_name" string NOT NULL OPTIONS (ANNOTATION 'The attribute name of the condition', NAMEINSOURCE 'rule/action_condition/conditions[]/sales-rule-data-condition-interface/attribute_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "rule_action_condition_conditions_sales-rule-data-condition-interface_condition_type" string NOT NULL OPTIONS (ANNOTATION 'Condition type', NAMEINSOURCE 'rule/action_condition/conditions[]/sales-rule-data-condition-interface/condition_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_action_condition_conditions_sales-rule-data-condition-interface_operator" string NOT NULL OPTIONS (ANNOTATION 'The operator of the condition', NAMEINSOURCE 'rule/action_condition/conditions[]/sales-rule-data-condition-interface/operator', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_action_condition_conditions_sales-rule-data-condition-interface_value" string NOT NULL OPTIONS (ANNOTATION 'The value of the condition', NAMEINSOURCE 'rule/action_condition/conditions[]/sales-rule-data-condition-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_action_condition_operator string NOT NULL OPTIONS (ANNOTATION 'The operator of the condition', NAMEINSOURCE 'rule/action_condition/operator', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_action_condition_value string NOT NULL OPTIONS (ANNOTATION 'The value of the condition', NAMEINSOURCE 'rule/action_condition/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_apply_to_shipping boolean NOT NULL OPTIONS (ANNOTATION 'The rule applies to shipping', NAMEINSOURCE 'rule/apply_to_shipping', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_condition_aggregator_type string NOT NULL OPTIONS (ANNOTATION 'The aggregator type', NAMEINSOURCE 'rule/condition/aggregator_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_condition_attribute_name string NOT NULL OPTIONS (ANNOTATION 'The attribute name of the condition', NAMEINSOURCE 'rule/condition/attribute_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_condition_condition_type string NOT NULL OPTIONS (ANNOTATION 'Condition type', NAMEINSOURCE 'rule/condition/condition_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_condition_conditions_sales-rule-data-condition-interface_aggregator_type" string NOT NULL OPTIONS (ANNOTATION 'The aggregator type', NAMEINSOURCE 'rule/condition/conditions[]/sales-rule-data-condition-interface/aggregator_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "rule_condition_conditions_sales-rule-data-condition-interface_attribute_name" string NOT NULL OPTIONS (ANNOTATION 'The attribute name of the condition', NAMEINSOURCE 'rule/condition/conditions[]/sales-rule-data-condition-interface/attribute_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "rule_condition_conditions_sales-rule-data-condition-interface_condition_type" string NOT NULL OPTIONS (ANNOTATION 'Condition type', NAMEINSOURCE 'rule/condition/conditions[]/sales-rule-data-condition-interface/condition_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_condition_conditions_sales-rule-data-condition-interface_operator" string NOT NULL OPTIONS (ANNOTATION 'The operator of the condition', NAMEINSOURCE 'rule/condition/conditions[]/sales-rule-data-condition-interface/operator', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_condition_conditions_sales-rule-data-condition-interface_value" string NOT NULL OPTIONS (ANNOTATION 'The value of the condition', NAMEINSOURCE 'rule/condition/conditions[]/sales-rule-data-condition-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_condition_operator string NOT NULL OPTIONS (ANNOTATION 'The operator of the condition', NAMEINSOURCE 'rule/condition/operator', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_condition_value string NOT NULL OPTIONS (ANNOTATION 'The value of the condition', NAMEINSOURCE 'rule/condition/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_coupon_type string NOT NULL OPTIONS (ANNOTATION 'Coupon type', NAMEINSOURCE 'rule/coupon_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_customer_group_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'rule/customer_group_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_description string NOT NULL OPTIONS (ANNOTATION 'Description', NAMEINSOURCE 'rule/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Discount amount', NAMEINSOURCE 'rule/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_discount_qty string NOT NULL OPTIONS (ANNOTATION 'Maximum qty discount is applied', NAMEINSOURCE 'rule/discount_qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_discount_step string NOT NULL OPTIONS (ANNOTATION 'Discount step', NAMEINSOURCE 'rule/discount_step', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_extension_attributes_reward_points_delta string NOT NULL OPTIONS (NAMEINSOURCE 'rule/extension_attributes/reward_points_delta', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_from_date string NOT NULL OPTIONS (ANNOTATION 'The start date when the coupon is active', NAMEINSOURCE 'rule/from_date', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_is_active boolean NOT NULL OPTIONS (ANNOTATION 'The coupon is active', NAMEINSOURCE 'rule/is_active', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_is_advanced boolean NOT NULL OPTIONS (ANNOTATION 'Is this field needed', NAMEINSOURCE 'rule/is_advanced', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_is_rss boolean NOT NULL OPTIONS (ANNOTATION 'Whether the rule is in RSS', NAMEINSOURCE 'rule/is_rss', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_name string NOT NULL OPTIONS (ANNOTATION 'Rule name', NAMEINSOURCE 'rule/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_product_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'rule/product_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_rule_id string NOT NULL OPTIONS (ANNOTATION 'Rule id', NAMEINSOURCE 'rule/rule_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_simple_action string NOT NULL OPTIONS (ANNOTATION 'Simple action of the rule', NAMEINSOURCE 'rule/simple_action', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_simple_free_shipping string NOT NULL OPTIONS (ANNOTATION 'To grant free shipping', NAMEINSOURCE 'rule/simple_free_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_sort_order string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'rule/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_stop_rules_processing boolean NOT NULL OPTIONS (ANNOTATION 'To stop rule processing', NAMEINSOURCE 'rule/stop_rules_processing', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_store_labels_sales-rule-data-rule-label-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'StoreId', NAMEINSOURCE 'rule/store_labels[]/sales-rule-data-rule-label-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_store_labels_sales-rule-data-rule-label-interface_store_label" string NOT NULL OPTIONS (ANNOTATION 'The label for the store', NAMEINSOURCE 'rule/store_labels[]/sales-rule-data-rule-label-interface/store_label', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_times_used string NOT NULL OPTIONS (ANNOTATION 'How many times the rule has been used', NAMEINSOURCE 'rule/times_used', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_to_date string NOT NULL OPTIONS (ANNOTATION 'The end date when the coupon is active', NAMEINSOURCE 'rule/to_date', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_use_auto_generation boolean NOT NULL OPTIONS (ANNOTATION 'To auto generate coupon', NAMEINSOURCE 'rule/use_auto_generation', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_uses_per_coupon string NOT NULL OPTIONS (ANNOTATION 'Limit of uses per coupon', NAMEINSOURCE 'rule/uses_per_coupon', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_uses_per_customer string NOT NULL OPTIONS (ANNOTATION 'Number of uses per customer', NAMEINSOURCE 'rule/uses_per_customer', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_website_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'rule/website_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (action_condition_aggregator_type string OPTIONS (NAMEINSOURCE 'action_condition/aggregator_type'), action_condition_attribute_name string OPTIONS (NAMEINSOURCE 'action_condition/attribute_name'), action_condition_condition_type string OPTIONS (NAMEINSOURCE 'action_condition/condition_type'), "action_condition_conditions_sales-rule-data-condition-interface_aggregator_type" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/aggregator_type'), "action_condition_conditions_sales-rule-data-condition-interface_attribute_name" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/attribute_name'), "action_condition_conditions_sales-rule-data-condition-interface_condition_type" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/condition_type'), "action_condition_conditions_sales-rule-data-condition-interface_operator" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/operator'), "action_condition_conditions_sales-rule-data-condition-interface_value" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/value'), action_condition_operator string OPTIONS (NAMEINSOURCE 'action_condition/operator'), action_condition_value string OPTIONS (NAMEINSOURCE 'action_condition/value'), apply_to_shipping boolean, condition_aggregator_type string OPTIONS (NAMEINSOURCE 'condition/aggregator_type'), condition_attribute_name string OPTIONS (NAMEINSOURCE 'condition/attribute_name'), condition_condition_type string OPTIONS (NAMEINSOURCE 'condition/condition_type'), "condition_conditions_sales-rule-data-condition-interface_aggregator_type" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/aggregator_type'), "condition_conditions_sales-rule-data-condition-interface_attribute_name" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/attribute_name'), "condition_conditions_sales-rule-data-condition-interface_condition_type" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/condition_type'), "condition_conditions_sales-rule-data-condition-interface_operator" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/operator'), "condition_conditions_sales-rule-data-condition-interface_value" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/value'), condition_operator string OPTIONS (NAMEINSOURCE 'condition/operator'), condition_value string OPTIONS (NAMEINSOURCE 'condition/value'), coupon_type string, customer_group_ids string[], description string, discount_amount string, discount_qty string, discount_step string, extension_attributes_reward_points_delta string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_points_delta'), from_date string, is_active boolean, is_advanced boolean, is_rss boolean, name string, product_ids string[], rule_id string, simple_action string, simple_free_shipping string, sort_order string, stop_rules_processing boolean, "store_labels_sales-rule-data-rule-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'store_labels[]/sales-rule-data-rule-label-interface/store_id'), "store_labels_sales-rule-data-rule-label-interface_store_label" string OPTIONS (NAMEINSOURCE 'store_labels[]/sales-rule-data-rule-label-interface/store_label'), times_used string, to_date string, use_auto_generation boolean, uses_per_coupon string, uses_per_customer string, website_ids string[])
OPTIONS (ANNOTATION 'Save sales rule.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/salesRules');

CREATE FOREIGN PROCEDURE salesRuleRuleRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_sales-rule-data-rule-interface_action_condition_aggregator_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/action_condition/aggregator_type'), "items_sales-rule-data-rule-interface_action_condition_attribute_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/action_condition/attribute_name'), "items_sales-rule-data-rule-interface_action_condition_condition_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/action_condition/condition_type'), "items_sales-rule-data-rule-interface_action_condition_conditions_sales-rule-data-condition-interface_aggregator_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/action_condition/conditions[]/sales-rule-data-condition-interface/aggregator_type'), "items_sales-rule-data-rule-interface_action_condition_conditions_sales-rule-data-condition-interface_attribute_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/action_condition/conditions[]/sales-rule-data-condition-interface/attribute_name'), "items_sales-rule-data-rule-interface_action_condition_conditions_sales-rule-data-condition-interface_condition_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/action_condition/conditions[]/sales-rule-data-condition-interface/condition_type'), "items_sales-rule-data-rule-interface_action_condition_conditions_sales-rule-data-condition-interface_operator" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/action_condition/conditions[]/sales-rule-data-condition-interface/operator'), "items_sales-rule-data-rule-interface_action_condition_conditions_sales-rule-data-condition-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/action_condition/conditions[]/sales-rule-data-condition-interface/value'), "items_sales-rule-data-rule-interface_action_condition_operator" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/action_condition/operator'), "items_sales-rule-data-rule-interface_action_condition_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/action_condition/value'), "items_sales-rule-data-rule-interface_apply_to_shipping" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/apply_to_shipping'), "items_sales-rule-data-rule-interface_condition_aggregator_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/condition/aggregator_type'), "items_sales-rule-data-rule-interface_condition_attribute_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/condition/attribute_name'), "items_sales-rule-data-rule-interface_condition_condition_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/condition/condition_type'), "items_sales-rule-data-rule-interface_condition_conditions_sales-rule-data-condition-interface_aggregator_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/condition/conditions[]/sales-rule-data-condition-interface/aggregator_type'), "items_sales-rule-data-rule-interface_condition_conditions_sales-rule-data-condition-interface_attribute_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/condition/conditions[]/sales-rule-data-condition-interface/attribute_name'), "items_sales-rule-data-rule-interface_condition_conditions_sales-rule-data-condition-interface_condition_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/condition/conditions[]/sales-rule-data-condition-interface/condition_type'), "items_sales-rule-data-rule-interface_condition_conditions_sales-rule-data-condition-interface_operator" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/condition/conditions[]/sales-rule-data-condition-interface/operator'), "items_sales-rule-data-rule-interface_condition_conditions_sales-rule-data-condition-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/condition/conditions[]/sales-rule-data-condition-interface/value'), "items_sales-rule-data-rule-interface_condition_operator" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/condition/operator'), "items_sales-rule-data-rule-interface_condition_value" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/condition/value'), "items_sales-rule-data-rule-interface_coupon_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/coupon_type'), "items_sales-rule-data-rule-interface_customer_group_ids" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/customer_group_ids'), "items_sales-rule-data-rule-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/description'), "items_sales-rule-data-rule-interface_discount_amount" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/discount_amount'), "items_sales-rule-data-rule-interface_discount_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/discount_qty'), "items_sales-rule-data-rule-interface_discount_step" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/discount_step'), "items_sales-rule-data-rule-interface_extension_attributes_reward_points_delta" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/extension_attributes/reward_points_delta'), "items_sales-rule-data-rule-interface_from_date" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/from_date'), "items_sales-rule-data-rule-interface_is_active" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/is_active'), "items_sales-rule-data-rule-interface_is_advanced" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/is_advanced'), "items_sales-rule-data-rule-interface_is_rss" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/is_rss'), "items_sales-rule-data-rule-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/name'), "items_sales-rule-data-rule-interface_product_ids" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/product_ids'), "items_sales-rule-data-rule-interface_rule_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/rule_id'), "items_sales-rule-data-rule-interface_simple_action" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/simple_action'), "items_sales-rule-data-rule-interface_simple_free_shipping" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/simple_free_shipping'), "items_sales-rule-data-rule-interface_sort_order" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/sort_order'), "items_sales-rule-data-rule-interface_stop_rules_processing" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/stop_rules_processing'), "items_sales-rule-data-rule-interface_store_labels_sales-rule-data-rule-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/store_labels[]/sales-rule-data-rule-label-interface/store_id'), "items_sales-rule-data-rule-interface_store_labels_sales-rule-data-rule-label-interface_store_label" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/store_labels[]/sales-rule-data-rule-label-interface/store_label'), "items_sales-rule-data-rule-interface_times_used" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/times_used'), "items_sales-rule-data-rule-interface_to_date" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/to_date'), "items_sales-rule-data-rule-interface_use_auto_generation" boolean OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/use_auto_generation'), "items_sales-rule-data-rule-interface_uses_per_coupon" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/uses_per_coupon'), "items_sales-rule-data-rule-interface_uses_per_customer" string OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/uses_per_customer'), "items_sales-rule-data-rule-interface_website_ids" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-rule-data-rule-interface/website_ids'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Retrieve sales rules that match te specified criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#RuleRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/salesRules/search');

CREATE FOREIGN PROCEDURE salesRuleRuleRepositoryV1GetByIdGet(IN ruleId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (action_condition_aggregator_type string OPTIONS (NAMEINSOURCE 'action_condition/aggregator_type'), action_condition_attribute_name string OPTIONS (NAMEINSOURCE 'action_condition/attribute_name'), action_condition_condition_type string OPTIONS (NAMEINSOURCE 'action_condition/condition_type'), "action_condition_conditions_sales-rule-data-condition-interface_aggregator_type" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/aggregator_type'), "action_condition_conditions_sales-rule-data-condition-interface_attribute_name" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/attribute_name'), "action_condition_conditions_sales-rule-data-condition-interface_condition_type" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/condition_type'), "action_condition_conditions_sales-rule-data-condition-interface_operator" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/operator'), "action_condition_conditions_sales-rule-data-condition-interface_value" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/value'), action_condition_operator string OPTIONS (NAMEINSOURCE 'action_condition/operator'), action_condition_value string OPTIONS (NAMEINSOURCE 'action_condition/value'), apply_to_shipping boolean, condition_aggregator_type string OPTIONS (NAMEINSOURCE 'condition/aggregator_type'), condition_attribute_name string OPTIONS (NAMEINSOURCE 'condition/attribute_name'), condition_condition_type string OPTIONS (NAMEINSOURCE 'condition/condition_type'), "condition_conditions_sales-rule-data-condition-interface_aggregator_type" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/aggregator_type'), "condition_conditions_sales-rule-data-condition-interface_attribute_name" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/attribute_name'), "condition_conditions_sales-rule-data-condition-interface_condition_type" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/condition_type'), "condition_conditions_sales-rule-data-condition-interface_operator" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/operator'), "condition_conditions_sales-rule-data-condition-interface_value" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/value'), condition_operator string OPTIONS (NAMEINSOURCE 'condition/operator'), condition_value string OPTIONS (NAMEINSOURCE 'condition/value'), coupon_type string, customer_group_ids string[], description string, discount_amount string, discount_qty string, discount_step string, extension_attributes_reward_points_delta string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_points_delta'), from_date string, is_active boolean, is_advanced boolean, is_rss boolean, name string, product_ids string[], rule_id string, simple_action string, simple_free_shipping string, sort_order string, stop_rules_processing boolean, "store_labels_sales-rule-data-rule-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'store_labels[]/sales-rule-data-rule-label-interface/store_id'), "store_labels_sales-rule-data-rule-label-interface_store_label" string OPTIONS (NAMEINSOURCE 'store_labels[]/sales-rule-data-rule-label-interface/store_label'), times_used string, to_date string, use_auto_generation boolean, uses_per_coupon string, uses_per_customer string, website_ids string[])
OPTIONS (ANNOTATION 'Get rule by ID.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/salesRules/{ruleId}');

CREATE FOREIGN PROCEDURE salesRuleRuleRepositoryV1SavePut(IN ruleId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN rule_action_condition_aggregator_type string NOT NULL OPTIONS (ANNOTATION 'The aggregator type', NAMEINSOURCE 'rule/action_condition/aggregator_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_action_condition_attribute_name string NOT NULL OPTIONS (ANNOTATION 'The attribute name of the condition', NAMEINSOURCE 'rule/action_condition/attribute_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_action_condition_condition_type string NOT NULL OPTIONS (ANNOTATION 'Condition type', NAMEINSOURCE 'rule/action_condition/condition_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_action_condition_conditions_sales-rule-data-condition-interface_aggregator_type" string NOT NULL OPTIONS (ANNOTATION 'The aggregator type', NAMEINSOURCE 'rule/action_condition/conditions[]/sales-rule-data-condition-interface/aggregator_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "rule_action_condition_conditions_sales-rule-data-condition-interface_attribute_name" string NOT NULL OPTIONS (ANNOTATION 'The attribute name of the condition', NAMEINSOURCE 'rule/action_condition/conditions[]/sales-rule-data-condition-interface/attribute_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "rule_action_condition_conditions_sales-rule-data-condition-interface_condition_type" string NOT NULL OPTIONS (ANNOTATION 'Condition type', NAMEINSOURCE 'rule/action_condition/conditions[]/sales-rule-data-condition-interface/condition_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_action_condition_conditions_sales-rule-data-condition-interface_operator" string NOT NULL OPTIONS (ANNOTATION 'The operator of the condition', NAMEINSOURCE 'rule/action_condition/conditions[]/sales-rule-data-condition-interface/operator', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_action_condition_conditions_sales-rule-data-condition-interface_value" string NOT NULL OPTIONS (ANNOTATION 'The value of the condition', NAMEINSOURCE 'rule/action_condition/conditions[]/sales-rule-data-condition-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_action_condition_operator string NOT NULL OPTIONS (ANNOTATION 'The operator of the condition', NAMEINSOURCE 'rule/action_condition/operator', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_action_condition_value string NOT NULL OPTIONS (ANNOTATION 'The value of the condition', NAMEINSOURCE 'rule/action_condition/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_apply_to_shipping boolean NOT NULL OPTIONS (ANNOTATION 'The rule applies to shipping', NAMEINSOURCE 'rule/apply_to_shipping', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_condition_aggregator_type string NOT NULL OPTIONS (ANNOTATION 'The aggregator type', NAMEINSOURCE 'rule/condition/aggregator_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_condition_attribute_name string NOT NULL OPTIONS (ANNOTATION 'The attribute name of the condition', NAMEINSOURCE 'rule/condition/attribute_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_condition_condition_type string NOT NULL OPTIONS (ANNOTATION 'Condition type', NAMEINSOURCE 'rule/condition/condition_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_condition_conditions_sales-rule-data-condition-interface_aggregator_type" string NOT NULL OPTIONS (ANNOTATION 'The aggregator type', NAMEINSOURCE 'rule/condition/conditions[]/sales-rule-data-condition-interface/aggregator_type', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "rule_condition_conditions_sales-rule-data-condition-interface_attribute_name" string NOT NULL OPTIONS (ANNOTATION 'The attribute name of the condition', NAMEINSOURCE 'rule/condition/conditions[]/sales-rule-data-condition-interface/attribute_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "rule_condition_conditions_sales-rule-data-condition-interface_condition_type" string NOT NULL OPTIONS (ANNOTATION 'Condition type', NAMEINSOURCE 'rule/condition/conditions[]/sales-rule-data-condition-interface/condition_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_condition_conditions_sales-rule-data-condition-interface_operator" string NOT NULL OPTIONS (ANNOTATION 'The operator of the condition', NAMEINSOURCE 'rule/condition/conditions[]/sales-rule-data-condition-interface/operator', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_condition_conditions_sales-rule-data-condition-interface_value" string NOT NULL OPTIONS (ANNOTATION 'The value of the condition', NAMEINSOURCE 'rule/condition/conditions[]/sales-rule-data-condition-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_condition_operator string NOT NULL OPTIONS (ANNOTATION 'The operator of the condition', NAMEINSOURCE 'rule/condition/operator', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_condition_value string NOT NULL OPTIONS (ANNOTATION 'The value of the condition', NAMEINSOURCE 'rule/condition/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_coupon_type string NOT NULL OPTIONS (ANNOTATION 'Coupon type', NAMEINSOURCE 'rule/coupon_type', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_customer_group_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'rule/customer_group_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_description string NOT NULL OPTIONS (ANNOTATION 'Description', NAMEINSOURCE 'rule/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_discount_amount string NOT NULL OPTIONS (ANNOTATION 'Discount amount', NAMEINSOURCE 'rule/discount_amount', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_discount_qty string NOT NULL OPTIONS (ANNOTATION 'Maximum qty discount is applied', NAMEINSOURCE 'rule/discount_qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_discount_step string NOT NULL OPTIONS (ANNOTATION 'Discount step', NAMEINSOURCE 'rule/discount_step', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_extension_attributes_reward_points_delta string NOT NULL OPTIONS (NAMEINSOURCE 'rule/extension_attributes/reward_points_delta', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_from_date string NOT NULL OPTIONS (ANNOTATION 'The start date when the coupon is active', NAMEINSOURCE 'rule/from_date', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_is_active boolean NOT NULL OPTIONS (ANNOTATION 'The coupon is active', NAMEINSOURCE 'rule/is_active', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_is_advanced boolean NOT NULL OPTIONS (ANNOTATION 'Is this field needed', NAMEINSOURCE 'rule/is_advanced', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_is_rss boolean NOT NULL OPTIONS (ANNOTATION 'Whether the rule is in RSS', NAMEINSOURCE 'rule/is_rss', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_name string NOT NULL OPTIONS (ANNOTATION 'Rule name', NAMEINSOURCE 'rule/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_product_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'rule/product_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_rule_id string NOT NULL OPTIONS (ANNOTATION 'Rule id', NAMEINSOURCE 'rule/rule_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_simple_action string NOT NULL OPTIONS (ANNOTATION 'Simple action of the rule', NAMEINSOURCE 'rule/simple_action', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_simple_free_shipping string NOT NULL OPTIONS (ANNOTATION 'To grant free shipping', NAMEINSOURCE 'rule/simple_free_shipping', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_sort_order string NOT NULL OPTIONS (ANNOTATION 'Sort order', NAMEINSOURCE 'rule/sort_order', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_stop_rules_processing boolean NOT NULL OPTIONS (ANNOTATION 'To stop rule processing', NAMEINSOURCE 'rule/stop_rules_processing', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_store_labels_sales-rule-data-rule-label-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'StoreId', NAMEINSOURCE 'rule/store_labels[]/sales-rule-data-rule-label-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "rule_store_labels_sales-rule-data-rule-label-interface_store_label" string NOT NULL OPTIONS (ANNOTATION 'The label for the store', NAMEINSOURCE 'rule/store_labels[]/sales-rule-data-rule-label-interface/store_label', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_times_used string NOT NULL OPTIONS (ANNOTATION 'How many times the rule has been used', NAMEINSOURCE 'rule/times_used', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_to_date string NOT NULL OPTIONS (ANNOTATION 'The end date when the coupon is active', NAMEINSOURCE 'rule/to_date', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_use_auto_generation boolean NOT NULL OPTIONS (ANNOTATION 'To auto generate coupon', NAMEINSOURCE 'rule/use_auto_generation', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_uses_per_coupon string NOT NULL OPTIONS (ANNOTATION 'Limit of uses per coupon', NAMEINSOURCE 'rule/uses_per_coupon', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_uses_per_customer string NOT NULL OPTIONS (ANNOTATION 'Number of uses per customer', NAMEINSOURCE 'rule/uses_per_customer', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_website_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'rule/website_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (action_condition_aggregator_type string OPTIONS (NAMEINSOURCE 'action_condition/aggregator_type'), action_condition_attribute_name string OPTIONS (NAMEINSOURCE 'action_condition/attribute_name'), action_condition_condition_type string OPTIONS (NAMEINSOURCE 'action_condition/condition_type'), "action_condition_conditions_sales-rule-data-condition-interface_aggregator_type" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/aggregator_type'), "action_condition_conditions_sales-rule-data-condition-interface_attribute_name" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/attribute_name'), "action_condition_conditions_sales-rule-data-condition-interface_condition_type" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/condition_type'), "action_condition_conditions_sales-rule-data-condition-interface_operator" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/operator'), "action_condition_conditions_sales-rule-data-condition-interface_value" string OPTIONS (NAMEINSOURCE 'action_condition/conditions[]/sales-rule-data-condition-interface/value'), action_condition_operator string OPTIONS (NAMEINSOURCE 'action_condition/operator'), action_condition_value string OPTIONS (NAMEINSOURCE 'action_condition/value'), apply_to_shipping boolean, condition_aggregator_type string OPTIONS (NAMEINSOURCE 'condition/aggregator_type'), condition_attribute_name string OPTIONS (NAMEINSOURCE 'condition/attribute_name'), condition_condition_type string OPTIONS (NAMEINSOURCE 'condition/condition_type'), "condition_conditions_sales-rule-data-condition-interface_aggregator_type" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/aggregator_type'), "condition_conditions_sales-rule-data-condition-interface_attribute_name" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/attribute_name'), "condition_conditions_sales-rule-data-condition-interface_condition_type" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/condition_type'), "condition_conditions_sales-rule-data-condition-interface_operator" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/operator'), "condition_conditions_sales-rule-data-condition-interface_value" string OPTIONS (NAMEINSOURCE 'condition/conditions[]/sales-rule-data-condition-interface/value'), condition_operator string OPTIONS (NAMEINSOURCE 'condition/operator'), condition_value string OPTIONS (NAMEINSOURCE 'condition/value'), coupon_type string, customer_group_ids string[], description string, discount_amount string, discount_qty string, discount_step string, extension_attributes_reward_points_delta string OPTIONS (NAMEINSOURCE 'extension_attributes/reward_points_delta'), from_date string, is_active boolean, is_advanced boolean, is_rss boolean, name string, product_ids string[], rule_id string, simple_action string, simple_free_shipping string, sort_order string, stop_rules_processing boolean, "store_labels_sales-rule-data-rule-label-interface_store_id" string OPTIONS (NAMEINSOURCE 'store_labels[]/sales-rule-data-rule-label-interface/store_id'), "store_labels_sales-rule-data-rule-label-interface_store_label" string OPTIONS (NAMEINSOURCE 'store_labels[]/sales-rule-data-rule-label-interface/store_label'), times_used string, to_date string, use_auto_generation boolean, uses_per_coupon string, uses_per_customer string, website_ids string[])
OPTIONS (ANNOTATION 'Save sales rule.', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/salesRules/{ruleId}');

CREATE FOREIGN PROCEDURE salesRuleRuleRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN ruleId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete rule by ID.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/salesRules/{ruleId}');

CREATE FOREIGN PROCEDURE searchV1SearchGet(IN "searchCriteria[requestName]" string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (aggregations_bucket_names string[] OPTIONS (NAMEINSOURCE 'aggregations/bucket_names'), "aggregations_buckets_framework-search-bucket-interface_name" string OPTIONS (NAMEINSOURCE 'aggregations/buckets[]/framework-search-bucket-interface/name'), "aggregations_buckets_framework-search-bucket-interface_values_framework-search-aggregation-value-interface_metrics" string[] OPTIONS (NAMEINSOURCE 'aggregations/buckets[]/framework-search-bucket-interface/values[]/framework-search-aggregation-value-interface/metrics'), "aggregations_buckets_framework-search-bucket-interface_values_framework-search-aggregation-value-interface_value" string OPTIONS (NAMEINSOURCE 'aggregations/buckets[]/framework-search-bucket-interface/values[]/framework-search-aggregation-value-interface/value'), "items_framework-search-document-interface_custom_attributes_framework-attribute-interface_attribute_code" string OPTIONS (NAMEINSOURCE 'items[]/framework-search-document-interface/custom_attributes[]/framework-attribute-interface/attribute_code'), "items_framework-search-document-interface_custom_attributes_framework-attribute-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/framework-search-document-interface/custom_attributes[]/framework-attribute-interface/value'), "items_framework-search-document-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/framework-search-document-interface/id'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), search_criteria_request_name string OPTIONS (NAMEINSOURCE 'search_criteria/request_name'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Make Full Text Search and return found Documents', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/search');

CREATE FOREIGN PROCEDURE salesShipmentRepositoryV1SavePost(IN entity_billing_address_id string NOT NULL OPTIONS (ANNOTATION 'Billing address ID.', NAMEINSOURCE 'entity/billing_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_comments_sales-data-shipment-comment-interface_comment" string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'entity/comments[]/sales-data-shipment-comment-interface/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_comments_sales-data-shipment-comment-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/comments[]/sales-data-shipment-comment-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_comments_sales-data-shipment-comment-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Invoice ID.', NAMEINSOURCE 'entity/comments[]/sales-data-shipment-comment-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_comments_sales-data-shipment-comment-interface_is_customer_notified" string NOT NULL OPTIONS (ANNOTATION 'Is-customer-notified flag value.', NAMEINSOURCE 'entity/comments[]/sales-data-shipment-comment-interface/is_customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_comments_sales-data-shipment-comment-interface_is_visible_on_front" string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'entity/comments[]/sales-data-shipment-comment-interface/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_comments_sales-data-shipment-comment-interface_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/comments[]/sales-data-shipment-comment-interface/parent_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_created_at string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer ID.', NAMEINSOURCE 'entity/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_email_sent string NOT NULL OPTIONS (ANNOTATION 'Email-sent flag value.', NAMEINSOURCE 'entity/email_sent', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_entity_id string NOT NULL OPTIONS (ANNOTATION 'Shipment ID.', NAMEINSOURCE 'entity/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_increment_id string NOT NULL OPTIONS (ANNOTATION 'Increment ID.', NAMEINSOURCE 'entity/increment_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-shipment-item-interface_additional_data" string NOT NULL OPTIONS (ANNOTATION 'Additional data.', NAMEINSOURCE 'entity/items[]/sales-data-shipment-item-interface/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-shipment-item-interface_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/items[]/sales-data-shipment-item-interface/description', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-shipment-item-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Shipment item ID.', NAMEINSOURCE 'entity/items[]/sales-data-shipment-item-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-shipment-item-interface_name" string NOT NULL OPTIONS (ANNOTATION 'Name.', NAMEINSOURCE 'entity/items[]/sales-data-shipment-item-interface/name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-shipment-item-interface_order_item_id" string NOT NULL OPTIONS (ANNOTATION 'Order item ID.', NAMEINSOURCE 'entity/items[]/sales-data-shipment-item-interface/order_item_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-shipment-item-interface_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/items[]/sales-data-shipment-item-interface/parent_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-shipment-item-interface_price" string NOT NULL OPTIONS (ANNOTATION 'Price.', NAMEINSOURCE 'entity/items[]/sales-data-shipment-item-interface/price', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-shipment-item-interface_product_id" string NOT NULL OPTIONS (ANNOTATION 'Product ID.', NAMEINSOURCE 'entity/items[]/sales-data-shipment-item-interface/product_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-shipment-item-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Quantity.', NAMEINSOURCE 'entity/items[]/sales-data-shipment-item-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_items_sales-data-shipment-item-interface_row_total" string NOT NULL OPTIONS (ANNOTATION 'Row total.', NAMEINSOURCE 'entity/items[]/sales-data-shipment-item-interface/row_total', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-shipment-item-interface_sku" string NOT NULL OPTIONS (ANNOTATION 'SKU.', NAMEINSOURCE 'entity/items[]/sales-data-shipment-item-interface/sku', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_items_sales-data-shipment-item-interface_weight" string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/items[]/sales-data-shipment-item-interface/weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_order_id string NOT NULL OPTIONS (ANNOTATION 'Order ID.', NAMEINSOURCE 'entity/order_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_shipment_status string NOT NULL OPTIONS (ANNOTATION 'Shipment status.', NAMEINSOURCE 'entity/shipment_status', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_address_id string NOT NULL OPTIONS (ANNOTATION 'Shipping address ID.', NAMEINSOURCE 'entity/shipping_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_shipping_label string NOT NULL OPTIONS (ANNOTATION 'Shipping label.', NAMEINSOURCE 'entity/shipping_label', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_store_id string NOT NULL OPTIONS (ANNOTATION 'Store ID.', NAMEINSOURCE 'entity/store_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_qty string NOT NULL OPTIONS (ANNOTATION 'Total quantity.', NAMEINSOURCE 'entity/total_qty', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_total_weight string NOT NULL OPTIONS (ANNOTATION 'Total weight.', NAMEINSOURCE 'entity/total_weight', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_tracks_sales-data-shipment-track-interface_carrier_code" string NOT NULL OPTIONS (ANNOTATION 'Carrier code.', NAMEINSOURCE 'entity/tracks[]/sales-data-shipment-track-interface/carrier_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_tracks_sales-data-shipment-track-interface_created_at" string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/tracks[]/sales-data-shipment-track-interface/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_tracks_sales-data-shipment-track-interface_description" string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/tracks[]/sales-data-shipment-track-interface/description', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_tracks_sales-data-shipment-track-interface_entity_id" string NOT NULL OPTIONS (ANNOTATION 'Shipment package ID.', NAMEINSOURCE 'entity/tracks[]/sales-data-shipment-track-interface/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_tracks_sales-data-shipment-track-interface_order_id" string NOT NULL OPTIONS (ANNOTATION 'The order_id for the shipment package.', NAMEINSOURCE 'entity/tracks[]/sales-data-shipment-track-interface/order_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_tracks_sales-data-shipment-track-interface_parent_id" string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/tracks[]/sales-data-shipment-track-interface/parent_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_tracks_sales-data-shipment-track-interface_qty" string NOT NULL OPTIONS (ANNOTATION 'Quantity.', NAMEINSOURCE 'entity/tracks[]/sales-data-shipment-track-interface/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_tracks_sales-data-shipment-track-interface_title" string NOT NULL OPTIONS (ANNOTATION 'Title.', NAMEINSOURCE 'entity/tracks[]/sales-data-shipment-track-interface/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_tracks_sales-data-shipment-track-interface_track_number" string NOT NULL OPTIONS (ANNOTATION 'Track number.', NAMEINSOURCE 'entity/tracks[]/sales-data-shipment-track-interface/track_number', "teiid_rest:PARAMETER_TYPE" 'body'), IN "entity_tracks_sales-data-shipment-track-interface_updated_at" string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/tracks[]/sales-data-shipment-track-interface/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "entity_tracks_sales-data-shipment-track-interface_weight" string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/tracks[]/sales-data-shipment-track-interface/weight', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (billing_address_id string, "comments_sales-data-shipment-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-shipment-comment-interface/comment'), "comments_sales-data-shipment-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-shipment-comment-interface/created_at'), "comments_sales-data-shipment-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-shipment-comment-interface/entity_id'), "comments_sales-data-shipment-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-shipment-comment-interface/is_customer_notified'), "comments_sales-data-shipment-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-shipment-comment-interface/is_visible_on_front'), "comments_sales-data-shipment-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-shipment-comment-interface/parent_id'), created_at string, customer_id string, email_sent string, entity_id string, increment_id string, "items_sales-data-shipment-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/additional_data'), "items_sales-data-shipment-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/description'), "items_sales-data-shipment-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/entity_id'), "items_sales-data-shipment-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/name'), "items_sales-data-shipment-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/order_item_id'), "items_sales-data-shipment-item-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/parent_id'), "items_sales-data-shipment-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/price'), "items_sales-data-shipment-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/product_id'), "items_sales-data-shipment-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/qty'), "items_sales-data-shipment-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/row_total'), "items_sales-data-shipment-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/sku'), "items_sales-data-shipment-item-interface_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/weight'), order_id string, shipment_status string, shipping_address_id string, shipping_label string, store_id string, total_qty string, total_weight string, "tracks_sales-data-shipment-track-interface_carrier_code" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/carrier_code'), "tracks_sales-data-shipment-track-interface_created_at" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/created_at'), "tracks_sales-data-shipment-track-interface_description" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/description'), "tracks_sales-data-shipment-track-interface_entity_id" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/entity_id'), "tracks_sales-data-shipment-track-interface_order_id" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/order_id'), "tracks_sales-data-shipment-track-interface_parent_id" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/parent_id'), "tracks_sales-data-shipment-track-interface_qty" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/qty'), "tracks_sales-data-shipment-track-interface_title" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/title'), "tracks_sales-data-shipment-track-interface_track_number" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/track_number'), "tracks_sales-data-shipment-track-interface_updated_at" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/updated_at'), "tracks_sales-data-shipment-track-interface_weight" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/weight'), updated_at string)
OPTIONS (ANNOTATION 'Performs persist operations for a specified shipment.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/shipment/');

CREATE FOREIGN PROCEDURE salesShipmentTrackRepositoryV1SavePost(IN entity_carrier_code string NOT NULL OPTIONS (ANNOTATION 'Carrier code.', NAMEINSOURCE 'entity/carrier_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_created_at string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_description string NOT NULL OPTIONS (ANNOTATION 'Description.', NAMEINSOURCE 'entity/description', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_entity_id string NOT NULL OPTIONS (ANNOTATION 'Shipment package ID.', NAMEINSOURCE 'entity/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_order_id string NOT NULL OPTIONS (ANNOTATION 'The order_id for the shipment package.', NAMEINSOURCE 'entity/order_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_parent_id string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/parent_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_qty string NOT NULL OPTIONS (ANNOTATION 'Quantity.', NAMEINSOURCE 'entity/qty', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_title string NOT NULL OPTIONS (ANNOTATION 'Title.', NAMEINSOURCE 'entity/title', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_track_number string NOT NULL OPTIONS (ANNOTATION 'Track number.', NAMEINSOURCE 'entity/track_number', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_updated_at string NOT NULL OPTIONS (ANNOTATION 'Updated-at timestamp.', NAMEINSOURCE 'entity/updated_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_weight string NOT NULL OPTIONS (ANNOTATION 'Weight.', NAMEINSOURCE 'entity/weight', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (carrier_code string, created_at string, description string, entity_id string, order_id string, parent_id string, qty string, title string, track_number string, updated_at string, weight string)
OPTIONS (ANNOTATION 'Performs persist operations for a specified shipment track.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/shipment/track');

CREATE FOREIGN PROCEDURE salesShipmentTrackRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The shipment track ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Deletes a specified shipment track by ID.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/shipment/track/{id}');

CREATE FOREIGN PROCEDURE salesShipmentRepositoryV1GetGet(IN id string NOT NULL OPTIONS (ANNOTATION 'The shipment ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (billing_address_id string, "comments_sales-data-shipment-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-shipment-comment-interface/comment'), "comments_sales-data-shipment-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-shipment-comment-interface/created_at'), "comments_sales-data-shipment-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-shipment-comment-interface/entity_id'), "comments_sales-data-shipment-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-shipment-comment-interface/is_customer_notified'), "comments_sales-data-shipment-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-shipment-comment-interface/is_visible_on_front'), "comments_sales-data-shipment-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'comments[]/sales-data-shipment-comment-interface/parent_id'), created_at string, customer_id string, email_sent string, entity_id string, increment_id string, "items_sales-data-shipment-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/additional_data'), "items_sales-data-shipment-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/description'), "items_sales-data-shipment-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/entity_id'), "items_sales-data-shipment-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/name'), "items_sales-data-shipment-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/order_item_id'), "items_sales-data-shipment-item-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/parent_id'), "items_sales-data-shipment-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/price'), "items_sales-data-shipment-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/product_id'), "items_sales-data-shipment-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/qty'), "items_sales-data-shipment-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/row_total'), "items_sales-data-shipment-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/sku'), "items_sales-data-shipment-item-interface_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-item-interface/weight'), order_id string, shipment_status string, shipping_address_id string, shipping_label string, store_id string, total_qty string, total_weight string, "tracks_sales-data-shipment-track-interface_carrier_code" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/carrier_code'), "tracks_sales-data-shipment-track-interface_created_at" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/created_at'), "tracks_sales-data-shipment-track-interface_description" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/description'), "tracks_sales-data-shipment-track-interface_entity_id" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/entity_id'), "tracks_sales-data-shipment-track-interface_order_id" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/order_id'), "tracks_sales-data-shipment-track-interface_parent_id" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/parent_id'), "tracks_sales-data-shipment-track-interface_qty" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/qty'), "tracks_sales-data-shipment-track-interface_title" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/title'), "tracks_sales-data-shipment-track-interface_track_number" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/track_number'), "tracks_sales-data-shipment-track-interface_updated_at" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/updated_at'), "tracks_sales-data-shipment-track-interface_weight" string OPTIONS (NAMEINSOURCE 'tracks[]/sales-data-shipment-track-interface/weight'), updated_at string)
OPTIONS (ANNOTATION 'Loads a specified shipment.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/shipment/{id}');

CREATE FOREIGN PROCEDURE salesShipmentManagementV1GetCommentsListGet(IN id string NOT NULL OPTIONS (ANNOTATION 'The shipment ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE ("items_sales-data-shipment-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-comment-interface/comment'), "items_sales-data-shipment-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-comment-interface/created_at'), "items_sales-data-shipment-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-comment-interface/entity_id'), "items_sales-data-shipment-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-comment-interface/is_customer_notified'), "items_sales-data-shipment-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-comment-interface/is_visible_on_front'), "items_sales-data-shipment-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-comment-interface/parent_id'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Lists comments for a specified shipment.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/shipment/{id}/comments');

CREATE FOREIGN PROCEDURE salesShipmentCommentRepositoryV1SavePost(IN id string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN entity_comment string NOT NULL OPTIONS (ANNOTATION 'Comment.', NAMEINSOURCE 'entity/comment', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_created_at string NOT NULL OPTIONS (ANNOTATION 'Created-at timestamp.', NAMEINSOURCE 'entity/created_at', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_entity_id string NOT NULL OPTIONS (ANNOTATION 'Invoice ID.', NAMEINSOURCE 'entity/entity_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN entity_is_customer_notified string NOT NULL OPTIONS (ANNOTATION 'Is-customer-notified flag value.', NAMEINSOURCE 'entity/is_customer_notified', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_is_visible_on_front string NOT NULL OPTIONS (ANNOTATION 'Is-visible-on-storefront flag value.', NAMEINSOURCE 'entity/is_visible_on_front', "teiid_rest:PARAMETER_TYPE" 'body'), IN entity_parent_id string NOT NULL OPTIONS (ANNOTATION 'Parent ID.', NAMEINSOURCE 'entity/parent_id', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (comment string, created_at string, entity_id string, is_customer_notified string, is_visible_on_front string, parent_id string)
OPTIONS (ANNOTATION 'Performs persist operations for a specified shipment comment.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/shipment/{id}/comments');

CREATE FOREIGN PROCEDURE salesShipmentManagementV1NotifyPost(OUT "return" boolean RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The shipment ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Emails user a specified shipment.', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/shipment/{id}/emails');

CREATE FOREIGN PROCEDURE salesShipmentManagementV1GetLabelGet(OUT "return" string RESULT, IN id string NOT NULL OPTIONS (ANNOTATION 'The shipment label ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Gets a specified shipment label.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/shipment/{id}/label');

CREATE FOREIGN PROCEDURE salesShipmentRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_sales-data-shipment-interface_billing_address_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/billing_address_id'), "items_sales-data-shipment-interface_comments_sales-data-shipment-comment-interface_comment" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/comments[]/sales-data-shipment-comment-interface/comment'), "items_sales-data-shipment-interface_comments_sales-data-shipment-comment-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/comments[]/sales-data-shipment-comment-interface/created_at'), "items_sales-data-shipment-interface_comments_sales-data-shipment-comment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/comments[]/sales-data-shipment-comment-interface/entity_id'), "items_sales-data-shipment-interface_comments_sales-data-shipment-comment-interface_is_customer_notified" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/comments[]/sales-data-shipment-comment-interface/is_customer_notified'), "items_sales-data-shipment-interface_comments_sales-data-shipment-comment-interface_is_visible_on_front" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/comments[]/sales-data-shipment-comment-interface/is_visible_on_front'), "items_sales-data-shipment-interface_comments_sales-data-shipment-comment-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/comments[]/sales-data-shipment-comment-interface/parent_id'), "items_sales-data-shipment-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/created_at'), "items_sales-data-shipment-interface_customer_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/customer_id'), "items_sales-data-shipment-interface_email_sent" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/email_sent'), "items_sales-data-shipment-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/entity_id'), "items_sales-data-shipment-interface_increment_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/increment_id'), "items_sales-data-shipment-interface_items_sales-data-shipment-item-interface_additional_data" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/items[]/sales-data-shipment-item-interface/additional_data'), "items_sales-data-shipment-interface_items_sales-data-shipment-item-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/items[]/sales-data-shipment-item-interface/description'), "items_sales-data-shipment-interface_items_sales-data-shipment-item-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/items[]/sales-data-shipment-item-interface/entity_id'), "items_sales-data-shipment-interface_items_sales-data-shipment-item-interface_name" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/items[]/sales-data-shipment-item-interface/name'), "items_sales-data-shipment-interface_items_sales-data-shipment-item-interface_order_item_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/items[]/sales-data-shipment-item-interface/order_item_id'), "items_sales-data-shipment-interface_items_sales-data-shipment-item-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/items[]/sales-data-shipment-item-interface/parent_id'), "items_sales-data-shipment-interface_items_sales-data-shipment-item-interface_price" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/items[]/sales-data-shipment-item-interface/price'), "items_sales-data-shipment-interface_items_sales-data-shipment-item-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/items[]/sales-data-shipment-item-interface/product_id'), "items_sales-data-shipment-interface_items_sales-data-shipment-item-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/items[]/sales-data-shipment-item-interface/qty'), "items_sales-data-shipment-interface_items_sales-data-shipment-item-interface_row_total" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/items[]/sales-data-shipment-item-interface/row_total'), "items_sales-data-shipment-interface_items_sales-data-shipment-item-interface_sku" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/items[]/sales-data-shipment-item-interface/sku'), "items_sales-data-shipment-interface_items_sales-data-shipment-item-interface_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/items[]/sales-data-shipment-item-interface/weight'), "items_sales-data-shipment-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/order_id'), "items_sales-data-shipment-interface_shipment_status" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/shipment_status'), "items_sales-data-shipment-interface_shipping_address_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/shipping_address_id'), "items_sales-data-shipment-interface_shipping_label" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/shipping_label'), "items_sales-data-shipment-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/store_id'), "items_sales-data-shipment-interface_total_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/total_qty'), "items_sales-data-shipment-interface_total_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/total_weight'), "items_sales-data-shipment-interface_tracks_sales-data-shipment-track-interface_carrier_code" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/tracks[]/sales-data-shipment-track-interface/carrier_code'), "items_sales-data-shipment-interface_tracks_sales-data-shipment-track-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/tracks[]/sales-data-shipment-track-interface/created_at'), "items_sales-data-shipment-interface_tracks_sales-data-shipment-track-interface_description" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/tracks[]/sales-data-shipment-track-interface/description'), "items_sales-data-shipment-interface_tracks_sales-data-shipment-track-interface_entity_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/tracks[]/sales-data-shipment-track-interface/entity_id'), "items_sales-data-shipment-interface_tracks_sales-data-shipment-track-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/tracks[]/sales-data-shipment-track-interface/order_id'), "items_sales-data-shipment-interface_tracks_sales-data-shipment-track-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/tracks[]/sales-data-shipment-track-interface/parent_id'), "items_sales-data-shipment-interface_tracks_sales-data-shipment-track-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/tracks[]/sales-data-shipment-track-interface/qty'), "items_sales-data-shipment-interface_tracks_sales-data-shipment-track-interface_title" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/tracks[]/sales-data-shipment-track-interface/title'), "items_sales-data-shipment-interface_tracks_sales-data-shipment-track-interface_track_number" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/tracks[]/sales-data-shipment-track-interface/track_number'), "items_sales-data-shipment-interface_tracks_sales-data-shipment-track-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/tracks[]/sales-data-shipment-track-interface/updated_at'), "items_sales-data-shipment-interface_tracks_sales-data-shipment-track-interface_weight" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/tracks[]/sales-data-shipment-track-interface/weight'), "items_sales-data-shipment-interface_updated_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-shipment-interface/updated_at'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Lists shipments that match specified search criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#ShipmentRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/shipments');

CREATE FOREIGN PROCEDURE catalogInventoryStockRegistryV1GetLowStockItemsGet(IN scopeId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query'), IN qty string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query'), IN currentPage string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN pageSize string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_catalog-inventory-data-stock-status-interface_product_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/product_id'), "items_catalog-inventory-data-stock-status-interface_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/qty'), "items_catalog-inventory-data-stock-status-interface_stock_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_id'), "items_catalog-inventory-data-stock-status-interface_stock_item_backorders" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/backorders'), "items_catalog-inventory-data-stock-status-interface_stock_item_enable_qty_increments" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/enable_qty_increments'), "items_catalog-inventory-data-stock-status-interface_stock_item_is_decimal_divided" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/is_decimal_divided'), "items_catalog-inventory-data-stock-status-interface_stock_item_is_in_stock" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/is_in_stock'), "items_catalog-inventory-data-stock-status-interface_stock_item_is_qty_decimal" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/is_qty_decimal'), "items_catalog-inventory-data-stock-status-interface_stock_item_item_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/item_id'), "items_catalog-inventory-data-stock-status-interface_stock_item_low_stock_date" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/low_stock_date'), "items_catalog-inventory-data-stock-status-interface_stock_item_manage_stock" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/manage_stock'), "items_catalog-inventory-data-stock-status-interface_stock_item_max_sale_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/max_sale_qty'), "items_catalog-inventory-data-stock-status-interface_stock_item_min_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/min_qty'), "items_catalog-inventory-data-stock-status-interface_stock_item_min_sale_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/min_sale_qty'), "items_catalog-inventory-data-stock-status-interface_stock_item_notify_stock_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/notify_stock_qty'), "items_catalog-inventory-data-stock-status-interface_stock_item_product_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/product_id'), "items_catalog-inventory-data-stock-status-interface_stock_item_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/qty'), "items_catalog-inventory-data-stock-status-interface_stock_item_qty_increments" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/qty_increments'), "items_catalog-inventory-data-stock-status-interface_stock_item_show_default_notification_message" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/show_default_notification_message'), "items_catalog-inventory-data-stock-status-interface_stock_item_stock_id" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/stock_id'), "items_catalog-inventory-data-stock-status-interface_stock_item_stock_status_changed_auto" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/stock_status_changed_auto'), "items_catalog-inventory-data-stock-status-interface_stock_item_use_config_backorders" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/use_config_backorders'), "items_catalog-inventory-data-stock-status-interface_stock_item_use_config_enable_qty_inc" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/use_config_enable_qty_inc'), "items_catalog-inventory-data-stock-status-interface_stock_item_use_config_manage_stock" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/use_config_manage_stock'), "items_catalog-inventory-data-stock-status-interface_stock_item_use_config_max_sale_qty" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/use_config_max_sale_qty'), "items_catalog-inventory-data-stock-status-interface_stock_item_use_config_min_qty" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/use_config_min_qty'), "items_catalog-inventory-data-stock-status-interface_stock_item_use_config_min_sale_qty" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/use_config_min_sale_qty'), "items_catalog-inventory-data-stock-status-interface_stock_item_use_config_notify_stock_qty" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/use_config_notify_stock_qty'), "items_catalog-inventory-data-stock-status-interface_stock_item_use_config_qty_increments" boolean OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_item/use_config_qty_increments'), "items_catalog-inventory-data-stock-status-interface_stock_status" string OPTIONS (NAMEINSOURCE 'items[]/catalog-inventory-data-stock-status-interface/stock_status'), "search_criteria_criteria_list_framework-criteria-interface_filters" string[] OPTIONS (NAMEINSOURCE 'search_criteria/criteria_list[]/framework-criteria-interface/filters'), "search_criteria_criteria_list_framework-criteria-interface_limit" string[] OPTIONS (NAMEINSOURCE 'search_criteria/criteria_list[]/framework-criteria-interface/limit'), "search_criteria_criteria_list_framework-criteria-interface_mapper_interface_name" string OPTIONS (NAMEINSOURCE 'search_criteria/criteria_list[]/framework-criteria-interface/mapper_interface_name'), "search_criteria_criteria_list_framework-criteria-interface_orders" string[] OPTIONS (NAMEINSOURCE 'search_criteria/criteria_list[]/framework-criteria-interface/orders'), search_criteria_filters string[] OPTIONS (NAMEINSOURCE 'search_criteria/filters'), search_criteria_limit string[] OPTIONS (NAMEINSOURCE 'search_criteria/limit'), search_criteria_mapper_interface_name string OPTIONS (NAMEINSOURCE 'search_criteria/mapper_interface_name'), search_criteria_orders string[] OPTIONS (NAMEINSOURCE 'search_criteria/orders'), total_count string)
OPTIONS (ANNOTATION 'Retrieves a list of SKU''s with low inventory qty', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/stockItems/lowStock/');

CREATE FOREIGN PROCEDURE catalogInventoryStockRegistryV1GetStockItemBySkuGet(IN productSku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN scopeId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (backorders string, enable_qty_increments boolean, is_decimal_divided boolean, is_in_stock boolean, is_qty_decimal boolean, item_id string, low_stock_date string, manage_stock boolean, max_sale_qty string, min_qty string, min_sale_qty string, notify_stock_qty string, product_id string, qty string, qty_increments string, show_default_notification_message boolean, stock_id string, stock_status_changed_auto string, use_config_backorders boolean, use_config_enable_qty_inc boolean, use_config_manage_stock boolean, use_config_max_sale_qty boolean, use_config_min_qty boolean, use_config_min_sale_qty string, use_config_notify_stock_qty boolean, use_config_qty_increments boolean)
OPTIONS ("teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/stockItems/{productSku}');

CREATE FOREIGN PROCEDURE catalogInventoryStockRegistryV1GetStockStatusBySkuGet(IN productSku string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN scopeId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (product_id string, qty string, stock_id string, stock_item_backorders string OPTIONS (NAMEINSOURCE 'stock_item/backorders'), stock_item_enable_qty_increments boolean OPTIONS (NAMEINSOURCE 'stock_item/enable_qty_increments'), stock_item_is_decimal_divided boolean OPTIONS (NAMEINSOURCE 'stock_item/is_decimal_divided'), stock_item_is_in_stock boolean OPTIONS (NAMEINSOURCE 'stock_item/is_in_stock'), stock_item_is_qty_decimal boolean OPTIONS (NAMEINSOURCE 'stock_item/is_qty_decimal'), stock_item_item_id string OPTIONS (NAMEINSOURCE 'stock_item/item_id'), stock_item_low_stock_date string OPTIONS (NAMEINSOURCE 'stock_item/low_stock_date'), stock_item_manage_stock boolean OPTIONS (NAMEINSOURCE 'stock_item/manage_stock'), stock_item_max_sale_qty string OPTIONS (NAMEINSOURCE 'stock_item/max_sale_qty'), stock_item_min_qty string OPTIONS (NAMEINSOURCE 'stock_item/min_qty'), stock_item_min_sale_qty string OPTIONS (NAMEINSOURCE 'stock_item/min_sale_qty'), stock_item_notify_stock_qty string OPTIONS (NAMEINSOURCE 'stock_item/notify_stock_qty'), stock_item_product_id string OPTIONS (NAMEINSOURCE 'stock_item/product_id'), stock_item_qty string OPTIONS (NAMEINSOURCE 'stock_item/qty'), stock_item_qty_increments string OPTIONS (NAMEINSOURCE 'stock_item/qty_increments'), stock_item_show_default_notification_message boolean OPTIONS (NAMEINSOURCE 'stock_item/show_default_notification_message'), stock_item_stock_id string OPTIONS (NAMEINSOURCE 'stock_item/stock_id'), stock_item_stock_status_changed_auto string OPTIONS (NAMEINSOURCE 'stock_item/stock_status_changed_auto'), stock_item_use_config_backorders boolean OPTIONS (NAMEINSOURCE 'stock_item/use_config_backorders'), stock_item_use_config_enable_qty_inc boolean OPTIONS (NAMEINSOURCE 'stock_item/use_config_enable_qty_inc'), stock_item_use_config_manage_stock boolean OPTIONS (NAMEINSOURCE 'stock_item/use_config_manage_stock'), stock_item_use_config_max_sale_qty boolean OPTIONS (NAMEINSOURCE 'stock_item/use_config_max_sale_qty'), stock_item_use_config_min_qty boolean OPTIONS (NAMEINSOURCE 'stock_item/use_config_min_qty'), stock_item_use_config_min_sale_qty string OPTIONS (NAMEINSOURCE 'stock_item/use_config_min_sale_qty'), stock_item_use_config_notify_stock_qty boolean OPTIONS (NAMEINSOURCE 'stock_item/use_config_notify_stock_qty'), stock_item_use_config_qty_increments boolean OPTIONS (NAMEINSOURCE 'stock_item/use_config_qty_increments'), stock_status string)
OPTIONS ("teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/stockStatuses/{productSku}');

CREATE FOREIGN PROCEDURE storeStoreConfigManagerV1GetStoreConfigsGet(IN storeCodes string[] NOT NULL OPTIONS ("teiid_rest:COLLECION_FORMAT" 'multi', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (base_currency_code string, base_link_url string, base_media_url string, base_static_url string, base_url string, code string, default_display_currency_code string, id string, locale string, secure_base_link_url string, secure_base_media_url string, secure_base_static_url string, secure_base_url string, timezone string, website_id string, weight_unit string)
OPTIONS ("teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/store/storeConfigs');

CREATE FOREIGN PROCEDURE storeGroupRepositoryV1GetListGet() RETURNS TABLE (default_store_id string, id string, name string, root_category_id string, website_id string)
OPTIONS (ANNOTATION 'Retrieve list of all groups', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/store/storeGroups');

CREATE FOREIGN PROCEDURE storeStoreRepositoryV1GetListGet() RETURNS TABLE (code string, id string, name string, store_group_id string, website_id string)
OPTIONS (ANNOTATION 'Retrieve list of all stores', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/store/storeViews');

CREATE FOREIGN PROCEDURE storeWebsiteRepositoryV1GetListGet() RETURNS TABLE (code string, default_group_id string, id string, name string)
OPTIONS (ANNOTATION 'Retrieve list of all websites', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/store/websites');

CREATE FOREIGN PROCEDURE taxTaxClassRepositoryV1SavePost(OUT "return" string RESULT, IN taxClass_class_id string NOT NULL OPTIONS (ANNOTATION 'Tax class ID.', NAMEINSOURCE 'taxClass/class_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN taxClass_class_name string NOT NULL OPTIONS (ANNOTATION 'Tax class name.', NAMEINSOURCE 'taxClass/class_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN taxClass_class_type string NOT NULL OPTIONS (ANNOTATION 'Tax class type.', NAMEINSOURCE 'taxClass/class_type', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Create a Tax Class', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxClasses');

CREATE FOREIGN PROCEDURE taxTaxClassRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_tax-data-tax-class-interface_class_id" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-class-interface/class_id'), "items_tax-data-tax-class-interface_class_name" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-class-interface/class_name'), "items_tax-data-tax-class-interface_class_type" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-class-interface/class_type'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Retrieve tax classes which match a specific criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#TaxClassRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxClasses/search');

CREATE FOREIGN PROCEDURE taxTaxClassRepositoryV1SavePut(OUT "return" string RESULT, IN classId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN taxClass_class_id string NOT NULL OPTIONS (ANNOTATION 'Tax class ID.', NAMEINSOURCE 'taxClass/class_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN taxClass_class_name string NOT NULL OPTIONS (ANNOTATION 'Tax class name.', NAMEINSOURCE 'taxClass/class_name', "teiid_rest:PARAMETER_TYPE" 'body'), IN taxClass_class_type string NOT NULL OPTIONS (ANNOTATION 'Tax class type.', NAMEINSOURCE 'taxClass/class_type', "teiid_rest:PARAMETER_TYPE" 'body')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Create a Tax Class', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxClasses/{classId}');

CREATE FOREIGN PROCEDURE taxTaxClassRepositoryV1GetGet(IN taxClassId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (class_id string, class_name string, class_type string)
OPTIONS (ANNOTATION 'Get a tax class with the given tax class id.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxClasses/{taxClassId}');

CREATE FOREIGN PROCEDURE taxTaxClassRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN taxClassId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete a tax class with the given tax class id.', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxClasses/{taxClassId}');

CREATE FOREIGN PROCEDURE taxTaxRateRepositoryV1SavePut(IN taxRate_code string NOT NULL OPTIONS (ANNOTATION 'Tax rate code', NAMEINSOURCE 'taxRate/code', "teiid_rest:PARAMETER_TYPE" 'body'), IN taxRate_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'taxRate/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN taxRate_rate string NOT NULL OPTIONS (ANNOTATION 'Tax rate in percentage', NAMEINSOURCE 'taxRate/rate', "teiid_rest:PARAMETER_TYPE" 'body'), IN taxRate_region_name string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'taxRate/region_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN taxRate_tax_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'taxRate/tax_country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN taxRate_tax_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'taxRate/tax_postcode', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN taxRate_tax_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'taxRate/tax_region_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "taxRate_titles_tax-data-tax-rate-title-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store id', NAMEINSOURCE 'taxRate/titles[]/tax-data-tax-rate-title-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "taxRate_titles_tax-data-tax-rate-title-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Title value', NAMEINSOURCE 'taxRate/titles[]/tax-data-tax-rate-title-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN taxRate_zip_from string NOT NULL OPTIONS (ANNOTATION 'Zip range from', NAMEINSOURCE 'taxRate/zip_from', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN taxRate_zip_is_range string NOT NULL OPTIONS (ANNOTATION 'Zip is range', NAMEINSOURCE 'taxRate/zip_is_range', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN taxRate_zip_to string NOT NULL OPTIONS (ANNOTATION 'Zip range to', NAMEINSOURCE 'taxRate/zip_to', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, id string, rate string, region_name string, tax_country_id string, tax_postcode string, tax_region_id string, "titles_tax-data-tax-rate-title-interface_store_id" string OPTIONS (NAMEINSOURCE 'titles[]/tax-data-tax-rate-title-interface/store_id'), "titles_tax-data-tax-rate-title-interface_value" string OPTIONS (NAMEINSOURCE 'titles[]/tax-data-tax-rate-title-interface/value'), zip_from string, zip_is_range string, zip_to string)
OPTIONS (ANNOTATION 'Create or update tax rate', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxRates');

CREATE FOREIGN PROCEDURE taxTaxRateRepositoryV1SavePost(IN taxRate_code string NOT NULL OPTIONS (ANNOTATION 'Tax rate code', NAMEINSOURCE 'taxRate/code', "teiid_rest:PARAMETER_TYPE" 'body'), IN taxRate_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'taxRate/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN taxRate_rate string NOT NULL OPTIONS (ANNOTATION 'Tax rate in percentage', NAMEINSOURCE 'taxRate/rate', "teiid_rest:PARAMETER_TYPE" 'body'), IN taxRate_region_name string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'taxRate/region_name', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN taxRate_tax_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'taxRate/tax_country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN taxRate_tax_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'taxRate/tax_postcode', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN taxRate_tax_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'taxRate/tax_region_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN "taxRate_titles_tax-data-tax-rate-title-interface_store_id" string NOT NULL OPTIONS (ANNOTATION 'Store id', NAMEINSOURCE 'taxRate/titles[]/tax-data-tax-rate-title-interface/store_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "taxRate_titles_tax-data-tax-rate-title-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Title value', NAMEINSOURCE 'taxRate/titles[]/tax-data-tax-rate-title-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN taxRate_zip_from string NOT NULL OPTIONS (ANNOTATION 'Zip range from', NAMEINSOURCE 'taxRate/zip_from', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN taxRate_zip_is_range string NOT NULL OPTIONS (ANNOTATION 'Zip is range', NAMEINSOURCE 'taxRate/zip_is_range', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN taxRate_zip_to string NOT NULL OPTIONS (ANNOTATION 'Zip range to', NAMEINSOURCE 'taxRate/zip_to', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, id string, rate string, region_name string, tax_country_id string, tax_postcode string, tax_region_id string, "titles_tax-data-tax-rate-title-interface_store_id" string OPTIONS (NAMEINSOURCE 'titles[]/tax-data-tax-rate-title-interface/store_id'), "titles_tax-data-tax-rate-title-interface_value" string OPTIONS (NAMEINSOURCE 'titles[]/tax-data-tax-rate-title-interface/value'), zip_from string, zip_is_range string, zip_to string)
OPTIONS (ANNOTATION 'Create or update tax rate', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxRates');

CREATE FOREIGN PROCEDURE taxTaxRateRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_tax-data-tax-rate-interface_code" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rate-interface/code'), "items_tax-data-tax-rate-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rate-interface/id'), "items_tax-data-tax-rate-interface_rate" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rate-interface/rate'), "items_tax-data-tax-rate-interface_region_name" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rate-interface/region_name'), "items_tax-data-tax-rate-interface_tax_country_id" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rate-interface/tax_country_id'), "items_tax-data-tax-rate-interface_tax_postcode" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rate-interface/tax_postcode'), "items_tax-data-tax-rate-interface_tax_region_id" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rate-interface/tax_region_id'), "items_tax-data-tax-rate-interface_titles_tax-data-tax-rate-title-interface_store_id" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rate-interface/titles[]/tax-data-tax-rate-title-interface/store_id'), "items_tax-data-tax-rate-interface_titles_tax-data-tax-rate-title-interface_value" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rate-interface/titles[]/tax-data-tax-rate-title-interface/value'), "items_tax-data-tax-rate-interface_zip_from" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rate-interface/zip_from'), "items_tax-data-tax-rate-interface_zip_is_range" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rate-interface/zip_is_range'), "items_tax-data-tax-rate-interface_zip_to" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rate-interface/zip_to'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Search TaxRates This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#TaxRateRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxRates/search');

CREATE FOREIGN PROCEDURE taxTaxRateRepositoryV1GetGet(IN rateId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, id string, rate string, region_name string, tax_country_id string, tax_postcode string, tax_region_id string, "titles_tax-data-tax-rate-title-interface_store_id" string OPTIONS (NAMEINSOURCE 'titles[]/tax-data-tax-rate-title-interface/store_id'), "titles_tax-data-tax-rate-title-interface_value" string OPTIONS (NAMEINSOURCE 'titles[]/tax-data-tax-rate-title-interface/value'), zip_from string, zip_is_range string, zip_to string)
OPTIONS (ANNOTATION 'Get tax rate', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxRates/{rateId}');

CREATE FOREIGN PROCEDURE taxTaxRateRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN rateId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete tax rate', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxRates/{rateId}');

CREATE FOREIGN PROCEDURE taxTaxRuleRepositoryV1SavePut(IN rule_calculate_subtotal boolean NOT NULL OPTIONS (ANNOTATION 'Calculate subtotal.', NAMEINSOURCE 'rule/calculate_subtotal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_code string NOT NULL OPTIONS (ANNOTATION 'Tax rule code', NAMEINSOURCE 'rule/code', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_customer_tax_class_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'rule/customer_tax_class_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'rule/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_position string NOT NULL OPTIONS (ANNOTATION 'Sort order.', NAMEINSOURCE 'rule/position', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_priority string NOT NULL OPTIONS (ANNOTATION 'Priority', NAMEINSOURCE 'rule/priority', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_product_tax_class_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'rule/product_tax_class_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_tax_rate_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'rule/tax_rate_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (calculate_subtotal boolean, code string, customer_tax_class_ids string[], id string, position string, priority string, product_tax_class_ids string[], tax_rate_ids string[])
OPTIONS (ANNOTATION 'Save TaxRule', "teiid_rest:METHOD" 'PUT', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxRules');

CREATE FOREIGN PROCEDURE taxTaxRuleRepositoryV1SavePost(IN rule_calculate_subtotal boolean NOT NULL OPTIONS (ANNOTATION 'Calculate subtotal.', NAMEINSOURCE 'rule/calculate_subtotal', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_code string NOT NULL OPTIONS (ANNOTATION 'Tax rule code', NAMEINSOURCE 'rule/code', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_customer_tax_class_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'rule/customer_tax_class_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'rule/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_position string NOT NULL OPTIONS (ANNOTATION 'Sort order.', NAMEINSOURCE 'rule/position', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_priority string NOT NULL OPTIONS (ANNOTATION 'Priority', NAMEINSOURCE 'rule/priority', "teiid_rest:PARAMETER_TYPE" 'body'), IN rule_product_tax_class_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'rule/product_tax_class_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN rule_tax_rate_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'rule/tax_rate_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (calculate_subtotal boolean, code string, customer_tax_class_ids string[], id string, position string, priority string, product_tax_class_ids string[], tax_rate_ids string[])
OPTIONS (ANNOTATION 'Save TaxRule', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxRules');

CREATE FOREIGN PROCEDURE taxTaxRuleRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_tax-data-tax-rule-interface_calculate_subtotal" boolean OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rule-interface/calculate_subtotal'), "items_tax-data-tax-rule-interface_code" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rule-interface/code'), "items_tax-data-tax-rule-interface_customer_tax_class_ids" string[] OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rule-interface/customer_tax_class_ids'), "items_tax-data-tax-rule-interface_id" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rule-interface/id'), "items_tax-data-tax-rule-interface_position" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rule-interface/position'), "items_tax-data-tax-rule-interface_priority" string OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rule-interface/priority'), "items_tax-data-tax-rule-interface_product_tax_class_ids" string[] OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rule-interface/product_tax_class_ids'), "items_tax-data-tax-rule-interface_tax_rate_ids" string[] OPTIONS (NAMEINSOURCE 'items[]/tax-data-tax-rule-interface/tax_rate_ids'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Search TaxRules This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#TaxRuleRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxRules/search');

CREATE FOREIGN PROCEDURE taxTaxRuleRepositoryV1GetGet(IN ruleId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (calculate_subtotal boolean, code string, customer_tax_class_ids string[], id string, position string, priority string, product_tax_class_ids string[], tax_rate_ids string[])
OPTIONS (ANNOTATION 'Get TaxRule', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxRules/{ruleId}');

CREATE FOREIGN PROCEDURE taxTaxRuleRepositoryV1DeleteByIdDelete(OUT "return" boolean RESULT, IN ruleId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Delete TaxRule', "teiid_rest:METHOD" 'DELETE', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/taxRules/{ruleId}');

CREATE FOREIGN PROCEDURE salesTransactionRepositoryV1GetListGet(IN "searchCriteria[filterGroups][][filters][][field]" string NOT NULL OPTIONS (ANNOTATION 'Field', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][value]" string NOT NULL OPTIONS (ANNOTATION 'Value', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[filterGroups][][filters][][conditionType]" string NOT NULL OPTIONS (ANNOTATION 'Condition type', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][field]" string NOT NULL OPTIONS (ANNOTATION 'Sorting field.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[sortOrders][][direction]" string NOT NULL OPTIONS (ANNOTATION 'Sorting direction.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[pageSize]" string NOT NULL OPTIONS (ANNOTATION 'Page size.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit'), IN "searchCriteria[currentPage]" string NOT NULL OPTIONS (ANNOTATION 'Current page.', "teiid_rest:PARAMETER_TYPE" 'query', "teiid_rel:default_handling" 'omit')) RETURNS TABLE ("items_sales-data-transaction-interface_additional_information" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/additional_information'), "items_sales-data-transaction-interface_child_transactions_sales-data-transaction-interface_additional_information" string[] OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/child_transactions[]/sales-data-transaction-interface/additional_information'), "items_sales-data-transaction-interface_child_transactions_sales-data-transaction-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/child_transactions[]/sales-data-transaction-interface/created_at'), "items_sales-data-transaction-interface_child_transactions_sales-data-transaction-interface_is_closed" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/child_transactions[]/sales-data-transaction-interface/is_closed'), "items_sales-data-transaction-interface_child_transactions_sales-data-transaction-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/child_transactions[]/sales-data-transaction-interface/order_id'), "items_sales-data-transaction-interface_child_transactions_sales-data-transaction-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/child_transactions[]/sales-data-transaction-interface/parent_id'), "items_sales-data-transaction-interface_child_transactions_sales-data-transaction-interface_parent_txn_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/child_transactions[]/sales-data-transaction-interface/parent_txn_id'), "items_sales-data-transaction-interface_child_transactions_sales-data-transaction-interface_payment_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/child_transactions[]/sales-data-transaction-interface/payment_id'), "items_sales-data-transaction-interface_child_transactions_sales-data-transaction-interface_transaction_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/child_transactions[]/sales-data-transaction-interface/transaction_id'), "items_sales-data-transaction-interface_child_transactions_sales-data-transaction-interface_txn_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/child_transactions[]/sales-data-transaction-interface/txn_id'), "items_sales-data-transaction-interface_child_transactions_sales-data-transaction-interface_txn_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/child_transactions[]/sales-data-transaction-interface/txn_type'), "items_sales-data-transaction-interface_created_at" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/created_at'), "items_sales-data-transaction-interface_is_closed" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/is_closed'), "items_sales-data-transaction-interface_order_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/order_id'), "items_sales-data-transaction-interface_parent_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/parent_id'), "items_sales-data-transaction-interface_parent_txn_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/parent_txn_id'), "items_sales-data-transaction-interface_payment_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/payment_id'), "items_sales-data-transaction-interface_transaction_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/transaction_id'), "items_sales-data-transaction-interface_txn_id" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/txn_id'), "items_sales-data-transaction-interface_txn_type" string OPTIONS (NAMEINSOURCE 'items[]/sales-data-transaction-interface/txn_type'), search_criteria_current_page string OPTIONS (NAMEINSOURCE 'search_criteria/current_page'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_condition_type" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/condition_type'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_field" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/field'), "search_criteria_filter_groups_framework-search-filter-group_filters_framework-filter_value" string OPTIONS (NAMEINSOURCE 'search_criteria/filter_groups[]/framework-search-filter-group/filters[]/framework-filter/value'), search_criteria_page_size string OPTIONS (NAMEINSOURCE 'search_criteria/page_size'), "search_criteria_sort_orders_framework-sort-order_direction" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/direction'), "search_criteria_sort_orders_framework-sort-order_field" string OPTIONS (NAMEINSOURCE 'search_criteria/sort_orders[]/framework-sort-order/field'), total_count string)
OPTIONS (ANNOTATION 'Lists transactions that match specified search criteria. This call returns an array of objects, but detailed information about each object’s attributes might not be included. See http://devdocs.magento.com/codelinks/attributes.html#TransactionRepositoryInterface to determine which call to use to get detailed information about all attributes for an object.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/transactions');

CREATE FOREIGN PROCEDURE salesTransactionRepositoryV1GetGet(IN id string NOT NULL OPTIONS (ANNOTATION 'The transaction ID.', "teiid_rest:PARAMETER_TYPE" 'path')) RETURNS TABLE (additional_information string[], "child_transactions_sales-data-transaction-interface_additional_information" string[] OPTIONS (NAMEINSOURCE 'child_transactions[]/sales-data-transaction-interface/additional_information'), "child_transactions_sales-data-transaction-interface_created_at" string OPTIONS (NAMEINSOURCE 'child_transactions[]/sales-data-transaction-interface/created_at'), "child_transactions_sales-data-transaction-interface_is_closed" string OPTIONS (NAMEINSOURCE 'child_transactions[]/sales-data-transaction-interface/is_closed'), "child_transactions_sales-data-transaction-interface_order_id" string OPTIONS (NAMEINSOURCE 'child_transactions[]/sales-data-transaction-interface/order_id'), "child_transactions_sales-data-transaction-interface_parent_id" string OPTIONS (NAMEINSOURCE 'child_transactions[]/sales-data-transaction-interface/parent_id'), "child_transactions_sales-data-transaction-interface_parent_txn_id" string OPTIONS (NAMEINSOURCE 'child_transactions[]/sales-data-transaction-interface/parent_txn_id'), "child_transactions_sales-data-transaction-interface_payment_id" string OPTIONS (NAMEINSOURCE 'child_transactions[]/sales-data-transaction-interface/payment_id'), "child_transactions_sales-data-transaction-interface_transaction_id" string OPTIONS (NAMEINSOURCE 'child_transactions[]/sales-data-transaction-interface/transaction_id'), "child_transactions_sales-data-transaction-interface_txn_id" string OPTIONS (NAMEINSOURCE 'child_transactions[]/sales-data-transaction-interface/txn_id'), "child_transactions_sales-data-transaction-interface_txn_type" string OPTIONS (NAMEINSOURCE 'child_transactions[]/sales-data-transaction-interface/txn_type'), created_at string, is_closed string, order_id string, parent_id string, parent_txn_id string, payment_id string, transaction_id string, txn_id string, txn_type string)
OPTIONS (ANNOTATION 'Loads a specified transaction.', "teiid_rest:METHOD" 'GET', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/transactions/{id}');

CREATE FOREIGN PROCEDURE worldpayGuestPaymentInformationManagementProxyV1SavePaymentInformationAndPlaceOrderPost(OUT "return" string RESULT, IN cartId string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'path'), IN billingAddress_city string NOT NULL OPTIONS (ANNOTATION 'City name', NAMEINSOURCE 'billingAddress/city', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_company string NOT NULL OPTIONS (ANNOTATION 'Company', NAMEINSOURCE 'billingAddress/company', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_country_id string NOT NULL OPTIONS (ANNOTATION 'Country id', NAMEINSOURCE 'billingAddress/country_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN "billingAddress_custom_attributes_framework-attribute-interface_attribute_code" string NOT NULL OPTIONS (ANNOTATION 'Attribute code', NAMEINSOURCE 'billingAddress/custom_attributes[]/framework-attribute-interface/attribute_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN "billingAddress_custom_attributes_framework-attribute-interface_value" string NOT NULL OPTIONS (ANNOTATION 'Attribute value', NAMEINSOURCE 'billingAddress/custom_attributes[]/framework-attribute-interface/value', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_customer_address_id string NOT NULL OPTIONS (ANNOTATION 'Customer address id', NAMEINSOURCE 'billingAddress/customer_address_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_customer_id string NOT NULL OPTIONS (ANNOTATION 'Customer id', NAMEINSOURCE 'billingAddress/customer_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_email string NOT NULL OPTIONS (ANNOTATION 'Billing/shipping email', NAMEINSOURCE 'billingAddress/email', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_extension_attributes_gift_registry_id string NOT NULL OPTIONS (NAMEINSOURCE 'billingAddress/extension_attributes/gift_registry_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_fax string NOT NULL OPTIONS (ANNOTATION 'Fax number', NAMEINSOURCE 'billingAddress/fax', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_firstname string NOT NULL OPTIONS (ANNOTATION 'First name', NAMEINSOURCE 'billingAddress/firstname', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_id string NOT NULL OPTIONS (ANNOTATION 'Id', NAMEINSOURCE 'billingAddress/id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_lastname string NOT NULL OPTIONS (ANNOTATION 'Last name', NAMEINSOURCE 'billingAddress/lastname', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_middlename string NOT NULL OPTIONS (ANNOTATION 'Middle name', NAMEINSOURCE 'billingAddress/middlename', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_postcode string NOT NULL OPTIONS (ANNOTATION 'Postcode', NAMEINSOURCE 'billingAddress/postcode', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_prefix string NOT NULL OPTIONS (ANNOTATION 'Prefix', NAMEINSOURCE 'billingAddress/prefix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_region string NOT NULL OPTIONS (ANNOTATION 'Region name', NAMEINSOURCE 'billingAddress/region', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_region_code string NOT NULL OPTIONS (ANNOTATION 'Region code', NAMEINSOURCE 'billingAddress/region_code', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_region_id string NOT NULL OPTIONS (ANNOTATION 'Region id', NAMEINSOURCE 'billingAddress/region_id', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_same_as_billing string NOT NULL OPTIONS (ANNOTATION 'Same as billing flag', NAMEINSOURCE 'billingAddress/same_as_billing', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_save_in_address_book string NOT NULL OPTIONS (ANNOTATION 'Save in address book flag', NAMEINSOURCE 'billingAddress/save_in_address_book', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_street string[] NOT NULL OPTIONS (NAMEINSOURCE 'billingAddress/street', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_suffix string NOT NULL OPTIONS (ANNOTATION 'Suffix', NAMEINSOURCE 'billingAddress/suffix', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN billingAddress_telephone string NOT NULL OPTIONS (ANNOTATION 'Telephone number', NAMEINSOURCE 'billingAddress/telephone', "teiid_rest:PARAMETER_TYPE" 'body'), IN billingAddress_vat_id string NOT NULL OPTIONS (ANNOTATION 'Vat id', NAMEINSOURCE 'billingAddress/vat_id', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN email string NOT NULL OPTIONS ("teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_additional_data string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/additional_data', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_extension_attributes_agreement_ids string[] NOT NULL OPTIONS (NAMEINSOURCE 'paymentMethod/extension_attributes/agreement_ids', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit'), IN paymentMethod_method string NOT NULL OPTIONS (ANNOTATION 'Payment method code', NAMEINSOURCE 'paymentMethod/method', "teiid_rest:PARAMETER_TYPE" 'body'), IN paymentMethod_po_number string NOT NULL OPTIONS (ANNOTATION 'Purchase order number', NAMEINSOURCE 'paymentMethod/po_number', "teiid_rest:PARAMETER_TYPE" 'body', "teiid_rel:default_handling" 'omit')) RETURNS TABLE (code string, message string, trace string)
OPTIONS (ANNOTATION 'Proxy handler for guest place order', "teiid_rest:METHOD" 'POST', "teiid_rest:URI" 'http://t213.vg/rest/default/V1/worldpay-guest-carts/{cartId}/payment-information');